/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ie){for(var t=[],k=0,C=ie.length;k<C;k++)t[k]=be[ie[k]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Ct}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,k,C){return t.apply(k,C)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Ct||(Ct=function(t,k){return new t(...k)});const oi=ct(Array.prototype.forEach),Ht=ct(Array.prototype.pop),$t=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Pt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),pt=ui(TypeError);function ct(ie){return function(t){for(var k=arguments.length,C=new Array(k>1?k-1:0),s=1;s<k;s++)C[s-1]=arguments[s];return Nt(ie,t,C)}}function ui(ie){return function(){for(var t=arguments.length,k=new Array(t),C=0;C<t;C++)k[C]=arguments[C];return Ct(ie,k)}}function Ue(ie,t,k){var C;k=(C=k)!==null&&C!==void 0?C:yt,jt&&jt(ie,null);let s=t.length;for(;s--;){let j=t[s];if(typeof j=="string"){const E=k(j);E!==j&&(ii(t)||(t[s]=E),j=E)}ie[j]=!0}return ie}function mt(ie){const t=ri(null);for(const[k,C]of zt(ie))t[k]=C;return t}function Et(ie,t){for(;ie!==null;){const C=si(ie,t);if(C){if(C.get)return ct(C.get);if(typeof C.value=="function")return ct(C.value)}ie=ni(ie)}function k(C){return console.warn("fallback value for",C),null}return k}const Ut=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),kt=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),_t=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:_t});const vi=()=>typeof window>"u"?null:window,Di=function(t,k){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const s="data-tt-policy-suffix";k&&k.hasAttribute(s)&&(C=k.getAttribute(s));const j="dompurify"+(C?"#"+C:"");try{return t.createPolicy(j,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+j+" could not be created."),null}};function xt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>xt(ze);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const k=ie.document,C=k.currentScript;let{document:s}=ie;const{DocumentFragment:j,HTMLTemplateElement:E,Node:A,Element:b,NodeFilter:w,NamedNodeMap:y=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:I,DOMParser:o,trustedTypes:a}=ie,e=b.prototype,r=Et(e,"cloneNode"),d=Et(e,"nextSibling"),$=Et(e,"childNodes"),u=Et(e,"parentNode");if(typeof E=="function"){const ze=s.createElement("template");ze.content&&ze.content.ownerDocument&&(s=ze.content.ownerDocument)}let p,c="";const{implementation:f,createNodeIterator:h,createDocumentFragment:F,getElementsByTagName:M}=s,{importNode:R}=k;let O={};t.isSupported=typeof zt=="function"&&typeof u=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:N,TMPLIT_EXPR:V,DATA_ATTR:H,ARIA_ATTR:T,IS_SCRIPT_OR_DATA:L,ATTR_WHITESPACE:B}=Kt;let{IS_ALLOWED_URI:X}=Kt,Y=null;const de=Ue({},[...Ut,...Rt,...Lt,...It,...Wt]);let oe=null;const ee=Ue({},[...Vt,...Mt,...qt,...kt]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Pe=null,Te=null,Me=!0,re=!0,J=!1,le=!0,K=!1,W=!1,Z=!1,ce=!1,we=!1,ke=!1,Ae=!1,Le=!0,_=!1;const g="user-content-";let m=!0,i=!1,n={},l=null;const D=Ue({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let S=null;const z=Ue({},["audio","video","img","source","image","track"]);let P=null;const U=Ue({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),G="http://www.w3.org/1998/Math/MathML",ne="http://www.w3.org/2000/svg",he="http://www.w3.org/1999/xhtml";let ve=he,$e=!1,ue=null;const Fe=Ue({},[G,ne,he],Pt);let ye;const Oe=["application/xhtml+xml","text/html"],Be="text/html";let Ie,Je=null;const et=s.createElement("form"),Qe=function(ae){return ae instanceof RegExp||ae instanceof Function},x=function(ae){if(!(Je&&Je===ae)){if((!ae||typeof ae!="object")&&(ae={}),ae=mt(ae),ye=Oe.indexOf(ae.PARSER_MEDIA_TYPE)===-1?ye=Be:ye=ae.PARSER_MEDIA_TYPE,Ie=ye==="application/xhtml+xml"?Pt:yt,Y="ALLOWED_TAGS"in ae?Ue({},ae.ALLOWED_TAGS,Ie):de,oe="ALLOWED_ATTR"in ae?Ue({},ae.ALLOWED_ATTR,Ie):ee,ue="ALLOWED_NAMESPACES"in ae?Ue({},ae.ALLOWED_NAMESPACES,Pt):Fe,P="ADD_URI_SAFE_ATTR"in ae?Ue(mt(U),ae.ADD_URI_SAFE_ATTR,Ie):U,S="ADD_DATA_URI_TAGS"in ae?Ue(mt(z),ae.ADD_DATA_URI_TAGS,Ie):z,l="FORBID_CONTENTS"in ae?Ue({},ae.FORBID_CONTENTS,Ie):D,Pe="FORBID_TAGS"in ae?Ue({},ae.FORBID_TAGS,Ie):{},Te="FORBID_ATTR"in ae?Ue({},ae.FORBID_ATTR,Ie):{},n="USE_PROFILES"in ae?ae.USE_PROFILES:!1,Me=ae.ALLOW_ARIA_ATTR!==!1,re=ae.ALLOW_DATA_ATTR!==!1,J=ae.ALLOW_UNKNOWN_PROTOCOLS||!1,le=ae.ALLOW_SELF_CLOSE_IN_ATTR!==!1,K=ae.SAFE_FOR_TEMPLATES||!1,W=ae.WHOLE_DOCUMENT||!1,we=ae.RETURN_DOM||!1,ke=ae.RETURN_DOM_FRAGMENT||!1,Ae=ae.RETURN_TRUSTED_TYPE||!1,ce=ae.FORCE_BODY||!1,Le=ae.SANITIZE_DOM!==!1,_=ae.SANITIZE_NAMED_PROPS||!1,m=ae.KEEP_CONTENT!==!1,i=ae.IN_PLACE||!1,X=ae.ALLOWED_URI_REGEXP||Qt,ve=ae.NAMESPACE||he,me=ae.CUSTOM_ELEMENT_HANDLING||{},ae.CUSTOM_ELEMENT_HANDLING&&Qe(ae.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=ae.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ae.CUSTOM_ELEMENT_HANDLING&&Qe(ae.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=ae.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ae.CUSTOM_ELEMENT_HANDLING&&typeof ae.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=ae.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),K&&(re=!1),ke&&(we=!0),n&&(Y=Ue({},[...Wt]),oe=[],n.html===!0&&(Ue(Y,Ut),Ue(oe,Vt)),n.svg===!0&&(Ue(Y,Rt),Ue(oe,Mt),Ue(oe,kt)),n.svgFilters===!0&&(Ue(Y,Lt),Ue(oe,Mt),Ue(oe,kt)),n.mathMl===!0&&(Ue(Y,It),Ue(oe,qt),Ue(oe,kt))),ae.ADD_TAGS&&(Y===de&&(Y=mt(Y)),Ue(Y,ae.ADD_TAGS,Ie)),ae.ADD_ATTR&&(oe===ee&&(oe=mt(oe)),Ue(oe,ae.ADD_ATTR,Ie)),ae.ADD_URI_SAFE_ATTR&&Ue(P,ae.ADD_URI_SAFE_ATTR,Ie),ae.FORBID_CONTENTS&&(l===D&&(l=mt(l)),Ue(l,ae.FORBID_CONTENTS,Ie)),m&&(Y["#text"]=!0),W&&Ue(Y,["html","head","body"]),Y.table&&(Ue(Y,["tbody"]),delete Pe.tbody),ae.TRUSTED_TYPES_POLICY){if(typeof ae.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ae.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');p=ae.TRUSTED_TYPES_POLICY,c=p.createHTML("")}else p===void 0&&(p=Di(a,C)),p!==null&&typeof c=="string"&&(c=p.createHTML(""));ot&&ot(ae),Je=ae}},se=Ue({},["mi","mo","mn","ms","mtext"]),ge=Ue({},["foreignobject","desc","title","annotation-xml"]),Ee=Ue({},["title","style","font","a","script"]),Ne=Ue({},Rt);Ue(Ne,Lt),Ue(Ne,ci);const je=Ue({},It);Ue(je,fi);const Ve=function(ae){let Se=u(ae);(!Se||!Se.tagName)&&(Se={namespaceURI:ve,tagName:"template"});const Ce=yt(ae.tagName),We=yt(Se.tagName);return ue[ae.namespaceURI]?ae.namespaceURI===ne?Se.namespaceURI===he?Ce==="svg":Se.namespaceURI===G?Ce==="svg"&&(We==="annotation-xml"||se[We]):!!Ne[Ce]:ae.namespaceURI===G?Se.namespaceURI===he?Ce==="math":Se.namespaceURI===ne?Ce==="math"&&ge[We]:!!je[Ce]:ae.namespaceURI===he?Se.namespaceURI===ne&&!ge[We]||Se.namespaceURI===G&&!se[We]?!1:!je[Ce]&&(Ee[Ce]||!Ne[Ce]):!!(ye==="application/xhtml+xml"&&ue[ae.namespaceURI]):!1},_e=function(ae){$t(t.removed,{element:ae});try{ae.parentNode.removeChild(ae)}catch{ae.remove()}},Ze=function(ae,Se){try{$t(t.removed,{attribute:Se.getAttributeNode(ae),from:Se})}catch{$t(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(ae),ae==="is"&&!oe[ae])if(we||ke)try{_e(Se)}catch{}else try{Se.setAttribute(ae,"")}catch{}},tt=function(ae){let Se,Ce;if(ce)ae="<remove></remove>"+ae;else{const at=li(ae,/^[\r\n\t ]+/);Ce=at&&at[0]}ye==="application/xhtml+xml"&&ve===he&&(ae='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ae+"</body></html>");const We=p?p.createHTML(ae):ae;if(ve===he)try{Se=new o().parseFromString(We,ye)}catch{}if(!Se||!Se.documentElement){Se=f.createDocument(ve,"template",null);try{Se.documentElement.innerHTML=$e?c:We}catch{}}const it=Se.body||Se.documentElement;return ae&&Ce&&it.insertBefore(s.createTextNode(Ce),it.childNodes[0]||null),ve===he?M.call(Se,W?"html":"body")[0]:W?Se.documentElement:it},Ye=function(ae){return h.call(ae.ownerDocument||ae,ae,w.SHOW_ELEMENT|w.SHOW_COMMENT|w.SHOW_TEXT,null,!1)},nt=function(ae){return ae instanceof I&&(typeof ae.nodeName!="string"||typeof ae.textContent!="string"||typeof ae.removeChild!="function"||!(ae.attributes instanceof y)||typeof ae.removeAttribute!="function"||typeof ae.setAttribute!="function"||typeof ae.namespaceURI!="string"||typeof ae.insertBefore!="function"||typeof ae.hasChildNodes!="function")},st=function(ae){return typeof A=="object"?ae instanceof A:ae&&typeof ae=="object"&&typeof ae.nodeType=="number"&&typeof ae.nodeName=="string"},rt=function(ae,Se,Ce){O[ae]&&oi(O[ae],We=>{We.call(t,Se,Ce,Je)})},gt=function(ae){let Se;if(rt("beforeSanitizeElements",ae,null),nt(ae))return _e(ae),!0;const Ce=Ie(ae.nodeName);if(rt("uponSanitizeElement",ae,{tagName:Ce,allowedTags:Y}),ae.hasChildNodes()&&!st(ae.firstElementChild)&&(!st(ae.content)||!st(ae.content.firstElementChild))&&ht(/<[/\w]/g,ae.innerHTML)&&ht(/<[/\w]/g,ae.textContent))return _e(ae),!0;if(!Y[Ce]||Pe[Ce]){if(!Pe[Ce]&&St(Ce)&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,Ce)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Ce)))return!1;if(m&&!l[Ce]){const We=u(ae)||ae.parentNode,it=$(ae)||ae.childNodes;if(it&&We){const at=it.length;for(let Ke=at-1;Ke>=0;--Ke)We.insertBefore(r(it[Ke],!0),d(ae))}}return _e(ae),!0}return ae instanceof b&&!Ve(ae)||(Ce==="noscript"||Ce==="noembed"||Ce==="noframes")&&ht(/<\/no(script|embed|frames)/i,ae.innerHTML)?(_e(ae),!0):(K&&ae.nodeType===3&&(Se=ae.textContent,Se=dt(Se,v," "),Se=dt(Se,N," "),Se=dt(Se,V," "),ae.textContent!==Se&&($t(t.removed,{element:ae.cloneNode()}),ae.textContent=Se)),rt("afterSanitizeElements",ae,null),!1)},At=function(ae,Se,Ce){if(Le&&(Se==="id"||Se==="name")&&(Ce in s||Ce in et))return!1;if(!(re&&!Te[Se]&&ht(H,Se))){if(!(Me&&ht(T,Se))){if(!oe[Se]||Te[Se]){if(!(St(ae)&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,ae)||me.tagNameCheck instanceof Function&&me.tagNameCheck(ae))&&(me.attributeNameCheck instanceof RegExp&&ht(me.attributeNameCheck,Se)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(Se))||Se==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,Ce)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Ce))))return!1}else if(!P[Se]){if(!ht(X,dt(Ce,B,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&ae!=="script"&&ai(Ce,"data:")===0&&S[ae])){if(!(J&&!ht(L,dt(Ce,B,"")))){if(Ce)return!1}}}}}}return!0},St=function(ae){return ae.indexOf("-")>0},wt=function(ae){let Se,Ce,We,it;rt("beforeSanitizeAttributes",ae,null);const{attributes:at}=ae;if(!at)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:oe};for(it=at.length;it--;){Se=at[it];const{name:ut,namespaceURI:vt}=Se;if(Ce=ut==="value"?Se.value:hi(Se.value),We=Ie(ut),Ke.attrName=We,Ke.attrValue=Ce,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,rt("uponSanitizeAttribute",ae,Ke),Ce=Ke.attrValue,Ke.forceKeepAttr||(Ze(ut,ae),!Ke.keepAttr))continue;if(!le&&ht(/\/>/i,Ce)){Ze(ut,ae);continue}K&&(Ce=dt(Ce,v," "),Ce=dt(Ce,N," "),Ce=dt(Ce,V," "));const Ft=Ie(ae.nodeName);if(At(Ft,We,Ce)){if(_&&(We==="id"||We==="name")&&(Ze(ut,ae),Ce=g+Ce),p&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!vt)switch(a.getAttributeType(Ft,We)){case"TrustedHTML":{Ce=p.createHTML(Ce);break}case"TrustedScriptURL":{Ce=p.createScriptURL(Ce);break}}try{vt?ae.setAttributeNS(vt,ut,Ce):ae.setAttribute(ut,Ce),Ht(t.removed)}catch{}}}rt("afterSanitizeAttributes",ae,null)},Ot=function ze(ae){let Se;const Ce=Ye(ae);for(rt("beforeSanitizeShadowDOM",ae,null);Se=Ce.nextNode();)rt("uponSanitizeShadowNode",Se,null),!gt(Se)&&(Se.content instanceof j&&ze(Se.content),wt(Se));rt("afterSanitizeShadowDOM",ae,null)};return t.sanitize=function(ze){let ae=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Se,Ce,We,it;if($e=!ze,$e&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return ze;if(Z||x(ae),t.removed=[],typeof ze=="string"&&(i=!1),i){if(ze.nodeName){const ut=Ie(ze.nodeName);if(!Y[ut]||Pe[ut])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof A)Se=tt("<!---->"),Ce=Se.ownerDocument.importNode(ze,!0),Ce.nodeType===1&&Ce.nodeName==="BODY"||Ce.nodeName==="HTML"?Se=Ce:Se.appendChild(Ce);else{if(!we&&!K&&!W&&ze.indexOf("<")===-1)return p&&Ae?p.createHTML(ze):ze;if(Se=tt(ze),!Se)return we?null:Ae?c:""}Se&&ce&&_e(Se.firstChild);const at=Ye(i?ze:Se);for(;We=at.nextNode();)gt(We)||(We.content instanceof j&&Ot(We.content),wt(We));if(i)return ze;if(we){if(ke)for(it=F.call(Se.ownerDocument);Se.firstChild;)it.appendChild(Se.firstChild);else it=Se;return(oe.shadowroot||oe.shadowrootmode)&&(it=R.call(k,it,!0)),it}let Ke=W?Se.outerHTML:Se.innerHTML;return W&&Y["!doctype"]&&Se.ownerDocument&&Se.ownerDocument.doctype&&Se.ownerDocument.doctype.name&&ht(_t,Se.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+Se.ownerDocument.doctype.name+`>
`+Ke),K&&(Ke=dt(Ke,v," "),Ke=dt(Ke,N," "),Ke=dt(Ke,V," ")),p&&Ae?p.createHTML(Ke):Ke},t.setConfig=function(ze){x(ze),Z=!0},t.clearConfig=function(){Je=null,Z=!1},t.isValidAttribute=function(ze,ae,Se){Je||x({});const Ce=Ie(ze),We=Ie(ae);return At(Ce,We,Se)},t.addHook=function(ze,ae){typeof ae=="function"&&(O[ze]=O[ze]||[],$t(O[ze],ae))},t.removeHook=function(ze){if(O[ze])return Ht(O[ze])},t.removeHooks=function(ze){O[ze]&&(O[ze]=[])},t.removeAllHooks=function(){O={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=t.$2Q=void 0;class k{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const A=C(E);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(E){const A=C(E);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(E){const A=C(E);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(E){const A=C(E);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(E){const A=C(E);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(E){const A=C(E);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(E){const A=C(E);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(E){const A=C(E);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const A=C(E);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const A=C(E);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const A=C(E);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const A=C(E);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const A=C(E);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const A=C(E);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,A){this.domNode.classList.toggle(E,A),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,A){this.domNode.setAttribute(E,A)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$2Q=k;function C(j){return typeof j=="number"?`${j}px`:j}function s(j){return new k(j)}t.$3Q=s}),define(be[69],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iP=t.$hP=void 0;const k=new WeakMap;function C(A){if(!A.parent||A.parent===A)return null;try{const b=A.location,w=A.parent.location;if(b.origin!=="null"&&w.origin!=="null"&&b.origin!==w.origin)return null}catch{return null}return A.parent}class s{static a(b){let w=k.get(b);if(!w){w=[],k.set(b,w);let y=b,I;do I=C(y),I?w.push({window:new WeakRef(y),iframeElement:y.frameElement||null}):w.push({window:new WeakRef(y),iframeElement:null}),y=I;while(y)}return w.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,w){if(!w||b===w)return{top:0,left:0};let y=0,I=0;const o=this.a(b);for(const a of o){const e=a.window.deref();if(y+=e?.scrollY??0,I+=e?.scrollX??0,e===w||!a.iframeElement)break;const r=a.iframeElement.getBoundingClientRect();y+=r.top,I+=r.left}return{top:y,left:I}}}t.$hP=s;async function j(A,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const w=JSON.stringify({parentOrigin:A,salt:b}),I=new TextEncoder().encode(w),o=await crypto.subtle.digest("sha-256",I);return E(o)}t.$iP=j;function E(A){const w=Array.from(new Uint8Array(A)).map(y=>y.toString(16).padStart(2,"0")).join("");return BigInt(`0x${w}`).toString(32).padStart(52,"0")}}),define(be[70],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IR=t.$HR=t.$GR=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var k;(function(E){E[E.Copy=0]="Copy",E[E.Move=1]="Move"})(k||(t.ListDragOverEffectType=k={}));var C;(function(E){E.Over="drop-target",E.Before="drop-target-before",E.After="drop-target-after"})(C||(t.ListDragOverEffectPosition=C={})),t.$GR={reject(){return{accept:!1}},accept(){return{accept:!0}}};class s extends Error{constructor(A,b){super(`ListError [${A}] ${b}`)}}t.$HR=s;class j{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,b){b>0&&this.c.set(A,b)}}t.$IR=j}),define(be[71],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wR=void 0;class k{constructor(s){this.a=s}splice(s,j,E){this.a.forEach(A=>A.splice(s,j,E))}}t.$wR=k}),define(be[42],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=void 0;const k=20;class C{constructor(j,E,A,b,w,y){this.a=Math.round(E),this.b=Math.round(A),this.c=Math.round(j),this.d=b,this.e=w,this.f=y,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(j){const E=Math.round(j);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(j){const E=Math.round(j);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(j){const E=Math.round(j);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(j){this.a=Math.round(j)}setOppositeScrollbarSize(j){this.b=Math.round(j)}static l(j,E,A,b,w){const y=Math.max(0,A-j),I=Math.max(0,y-2*E),o=b>0&&b>A;if(!o)return{computedAvailableSize:Math.round(y),computedIsNeeded:o,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(k,Math.floor(A*I/b))),e=(I-a)/(b-A),r=w*e;return{computedAvailableSize:Math.round(y),computedIsNeeded:o,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(r)}}m(){const j=C.l(this.b,this.c,this.d,this.e,this.f);this.g=j.computedAvailableSize,this.h=j.computedIsNeeded,this.i=j.computedSliderSize,this.j=j.computedSliderRatio,this.k=j.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(j){if(!this.h)return 0;const E=j-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(j){if(!this.h)return 0;const E=j-this.c;let A=this.f;return E<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(j){if(!this.h)return 0;const E=this.k+j;return Math.round(E/this.j)}}t.$8Q=C}),define(be[26],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zT=t.$yT=t.$xT=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var k;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(k||(t.TreeVisibility=k={}));var C;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var s;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(s||(t.TreeMouseEventTarget=s={}));var j;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(j||(t.TreeDragOverBubble=j={})),t.$xT={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class E extends Error{constructor(w,y){super(`TreeError [${w}] ${y}`)}}t.$yT=E;class A{constructor(w){this.a=w,this.b=new WeakMap}map(w){let y=this.b.get(w);return y||(y=this.a(w),this.b.set(w,y)),y}}t.$zT=A}),define(be[21],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XO=t.$window=t.$VO=t.$UO=void 0;function k(s,j){const E=s;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>j})}t.$UO=k,t.$VO=window,t.$window=t.$VO;function C(s){return s===t.$VO?!1:typeof s?.vscodeWindowId=="number"}t.$XO=C}),define(be[72],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function k(r,d,$){const u=C(r,d);if(u!==-1)return r[u]}t.$fb=k;function C(r,d,$=r.length-1){for(let u=$;u>=0;u--){const p=r[u];if(d(p))return u}return-1}t.$gb=C;function s(r,d){const $=j(r,d);return $===-1?void 0:r[$]}t.$hb=s;function j(r,d,$=0,u=r.length){let p=$,c=u;for(;p<c;){const f=Math.floor((p+c)/2);d(r[f])?p=f+1:c=f}return p-1}t.$ib=j;function E(r,d){const $=A(r,d);return $===r.length?void 0:r[$]}t.$jb=E;function A(r,d,$=0,u=r.length){let p=$,c=u;for(;p<c;){const f=Math.floor((p+c)/2);d(r[f])?c=f:p=f+1}return p}t.$kb=A;function b(r,d,$=0,u=r.length){const p=A(r,d,$,u);return p===r.length?-1:p}t.$lb=b;class w{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(w.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!d(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const $=j(this.e,d,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}t.$mb=w;function y(r,d){if(r.length===0)return;let $=r[0];for(let u=1;u<r.length;u++){const p=r[u];d(p,$)>0&&($=p)}return $}t.$nb=y;function I(r,d){if(r.length===0)return;let $=r[0];for(let u=1;u<r.length;u++){const p=r[u];d(p,$)>=0&&($=p)}return $}t.$ob=I;function o(r,d){return y(r,($,u)=>-d($,u))}t.$pb=o;function a(r,d){if(r.length===0)return-1;let $=0;for(let u=1;u<r.length;u++){const p=r[u];d(p,r[$])>0&&($=u)}return $}t.$qb=a;function e(r,d){for(const $ of r){const u=d($);if(u!==void 0)return u}}t.$rb=e}),define(be[73],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function k(E,A){const b=Object.create(null);for(const w of E){const y=A(w);let I=b[y];I||(I=b[y]=[]),I.push(w)}return b}t.$K=k;function C(E,A){const b=[],w=[];for(const y of E)A.has(y)||b.push(y);for(const y of A)E.has(y)||w.push(y);return{removed:b,added:w}}t.$L=C;function s(E,A){const b=[],w=[];for(const[y,I]of E)A.has(y)||b.push(I);for(const[y,I]of A)E.has(y)||w.push(I);return{removed:b,added:w}}t.$M=s;function j(E,A){const b=new Set;for(const w of A)E.has(w)&&b.add(w);return b}t.$N=j}),define(be[74],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=t.$bt=t.$at=t.$_s=void 0;function k(A,b){const w=Math.pow(10,b);return Math.round(A*w)/w}class C{constructor(b,w,y,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=k(Math.max(Math.min(1,I),0),3)}static equals(b,w){return b.r===w.r&&b.g===w.g&&b.b===w.b&&b.a===w.a}}t.$_s=C;class s{constructor(b,w,y,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=k(Math.max(Math.min(1,w),0),3),this.l=k(Math.max(Math.min(1,y),0),3),this.a=k(Math.max(Math.min(1,I),0),3)}static equals(b,w){return b.h===w.h&&b.s===w.s&&b.l===w.l&&b.a===w.a}static fromRGBA(b){const w=b.r/255,y=b.g/255,I=b.b/255,o=b.a,a=Math.max(w,y,I),e=Math.min(w,y,I);let r=0,d=0;const $=(e+a)/2,u=a-e;if(u>0){switch(d=Math.min($<=.5?u/(2*$):u/(2-2*$),1),a){case w:r=(y-I)/u+(y<I?6:0);break;case y:r=(I-w)/u+2;break;case I:r=(w-y)/u+4;break}r*=60,r=Math.round(r)}return new s(r,d,$,o)}static i(b,w,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?b+(w-b)*6*y:y<1/2?w:y<2/3?b+(w-b)*(2/3-y)*6:b}static toRGBA(b){const w=b.h/360,{s:y,l:I,a:o}=b;let a,e,r;if(y===0)a=e=r=I;else{const d=I<.5?I*(1+y):I+y-I*y,$=2*I-d;a=s.i($,d,w+1/3),e=s.i($,d,w),r=s.i($,d,w-1/3)}return new C(Math.round(a*255),Math.round(e*255),Math.round(r*255),o)}}t.$at=s;class j{constructor(b,w,y,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=k(Math.max(Math.min(1,w),0),3),this.v=k(Math.max(Math.min(1,y),0),3),this.a=k(Math.max(Math.min(1,I),0),3)}static equals(b,w){return b.h===w.h&&b.s===w.s&&b.v===w.v&&b.a===w.a}static fromRGBA(b){const w=b.r/255,y=b.g/255,I=b.b/255,o=Math.max(w,y,I),a=Math.min(w,y,I),e=o-a,r=o===0?0:e/o;let d;return e===0?d=0:o===w?d=((y-I)/e%6+6)%6:o===y?d=(I-w)/e+2:d=(w-y)/e+4,new j(Math.round(d*60),r,o,b.a)}static toRGBA(b){const{h:w,s:y,v:I,a:o}=b,a=I*y,e=a*(1-Math.abs(w/60%2-1)),r=I-a;let[d,$,u]=[0,0,0];return w<60?(d=a,$=e):w<120?(d=e,$=a):w<180?($=a,u=e):w<240?($=e,u=a):w<300?(d=e,u=a):w<=360&&(d=a,u=e),d=Math.round((d+r)*255),$=Math.round(($+r)*255),u=Math.round((u+r)*255),new C(d,$,u,o)}}t.$bt=j;class E{static fromHex(b){return E.Format.CSS.parseHex(b)||E.red}static equals(b,w){return!b&&!w?!0:!b||!w?!1:b.equals(w)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof C)this.rgba=b;else if(b instanceof s)this.i=b,this.rgba=s.toRGBA(b);else if(b instanceof j)this.j=b,this.rgba=j.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&C.equals(this.rgba,b.rgba)&&s.equals(this.hsla,b.hsla)&&j.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=E.k(this.rgba.r),w=E.k(this.rgba.g),y=E.k(this.rgba.b),I=.2126*b+.7152*w+.0722*y;return k(I,4)}static k(b){const w=b/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w>y?(w+.05)/(y+.05):(y+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w>y}isDarkerThan(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w<y}lighten(b){return new E(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new E(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:w,g:y,b:I,a:o}=this.rgba;return new E(new C(w,y,I,o*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const w=b.rgba,y=this.rgba.a,I=w.a,o=y+I*(1-y);if(o<1e-6)return E.transparent;const a=this.rgba.r*y/o+w.r*I*(1-y)/o,e=this.rgba.g*y/o+w.g*I*(1-y)/o,r=this.rgba.b*y/o+w.b*I*(1-y)/o;return new E(new C(a,e,r,o))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:w,g:y,b:I,a:o}=this.rgba;return new E(new C(b.rgba.r-o*(b.rgba.r-w),b.rgba.g-o*(b.rgba.g-y),b.rgba.b-o*(b.rgba.b-I),1))}flatten(...b){const w=b.reduceRight((y,I)=>E.o(I,y));return E.o(this,w)}static o(b,w){const y=1-b.rgba.a;return new E(new C(y*w.rgba.r+b.rgba.a*b.rgba.r,y*w.rgba.g+b.rgba.a*b.rgba.g,y*w.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(b,w,y){if(b.isLighterThan(w))return b;y=y||.5;const I=b.getRelativeLuminance(),o=w.getRelativeLuminance();return y=y*(o-I)/o,b.lighten(y)}static getDarkerColor(b,w,y){if(b.isDarkerThan(w))return b;y=y||.5;const I=b.getRelativeLuminance(),o=w.getRelativeLuminance();return y=y*(I-o)/I,b.darken(y)}static{this.white=new E(new C(255,255,255,1))}static{this.black=new E(new C(0,0,0,1))}static{this.red=new E(new C(255,0,0,1))}static{this.blue=new E(new C(0,0,255,1))}static{this.green=new E(new C(0,255,0,1))}static{this.cyan=new E(new C(0,255,255,1))}static{this.lightgrey=new E(new C(211,211,211,1))}static{this.transparent=new E(new C(0,0,0,0))}}t.$ct=E,function(A){let b;(function(w){let y;(function(I){function o(h){return h.rgba.a===1?`rgb(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b})`:A.Format.CSS.formatRGBA(h)}I.formatRGB=o;function a(h){return`rgba(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b}, ${+h.rgba.a.toFixed(2)})`}I.formatRGBA=a;function e(h){return h.hsla.a===1?`hsl(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(h)}I.formatHSL=e;function r(h){return`hsla(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%, ${h.hsla.a.toFixed(2)})`}I.formatHSLA=r;function d(h){const F=h.toString(16);return F.length!==2?"0"+F:F}function $(h){return`#${d(h.rgba.r)}${d(h.rgba.g)}${d(h.rgba.b)}`}I.formatHex=$;function u(h,F=!1){return F&&h.rgba.a===1?A.Format.CSS.formatHex(h):`#${d(h.rgba.r)}${d(h.rgba.g)}${d(h.rgba.b)}${d(Math.round(h.rgba.a*255))}`}I.formatHexA=u;function p(h){return h.isOpaque()?A.Format.CSS.formatHex(h):A.Format.CSS.formatRGBA(h)}I.format=p;function c(h){const F=h.length;if(F===0||h.charCodeAt(0)!==35)return null;if(F===7){const M=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),R=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),O=16*f(h.charCodeAt(5))+f(h.charCodeAt(6));return new A(new C(M,R,O,1))}if(F===9){const M=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),R=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),O=16*f(h.charCodeAt(5))+f(h.charCodeAt(6)),v=16*f(h.charCodeAt(7))+f(h.charCodeAt(8));return new A(new C(M,R,O,v/255))}if(F===4){const M=f(h.charCodeAt(1)),R=f(h.charCodeAt(2)),O=f(h.charCodeAt(3));return new A(new C(16*M+M,16*R+R,16*O+O))}if(F===5){const M=f(h.charCodeAt(1)),R=f(h.charCodeAt(2)),O=f(h.charCodeAt(3)),v=f(h.charCodeAt(4));return new A(new C(16*M+M,16*R+R,16*O+O,(16*v+v)/255))}return null}I.parseHex=c;function f(h){switch(h){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=w.CSS||(w.CSS={}))})(b=A.Format||(A.Format={}))}(E||(t.$ct=E={}))}),define(be[27],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xh=t.$wh=t.$vh=void 0;function k(E){return(A,b,w)=>{let y=null,I=null;if(typeof w.value=="function"?(y="value",I=w.value):typeof w.get=="function"&&(y="get",I=w.get),!I)throw new Error("not supported");w[y]=E(I,b)}}function C(E,A,b){let w=null,y=null;if(typeof b.value=="function"?(w="value",y=b.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(w="get",y=b.get),!y)throw new Error("not supported");const I=`$memoize$${A}`;b[w]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,o)}),this[I]}}t.$vh=C;function s(E,A,b){return k((w,y)=>{const I=`$debounce$${y}`,o=`$debounce$result$${y}`;return function(...a){this[o]||(this[o]=b?b():void 0),clearTimeout(this[I]),A&&(this[o]=A(this[o],...a),a=[this[o]]),this[I]=setTimeout(()=>{w.apply(this,a),this[o]=b?b():void 0},E)}})}t.$wh=s;function j(E,A,b){return k((w,y)=>{const I=`$throttle$timer$${y}`,o=`$throttle$result$${y}`,a=`$throttle$lastRun$${y}`,e=`$throttle$pending$${y}`;return function(...r){if(this[o]||(this[o]=b?b():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),A&&(this[o]=A(this[o],...r)),this[e])return;const d=this[a]+E;d<=Date.now()?(this[a]=Date.now(),w.apply(this,[this[o]]),this[o]=b?b():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),w.apply(this,[this[o]]),this[o]=b?b():void 0},d-Date.now()))}})}t.$xh=j}),define(be[75],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=void 0;class k{constructor(s,j,E,A){this.originalStart=s,this.originalLength=j,this.modifiedStart=E,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Ns=k}),define(be[6],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class k{constructor(){this.b=[],this.a=function(h){setTimeout(()=>{throw h.stack?p.isErrorNoTelemetry(h)?new p(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.b.push(h),()=>{this.d(h)}}c(h){this.b.forEach(F=>{F(h)})}d(h){this.b.splice(this.b.indexOf(h),1)}setUnexpectedErrorHandler(h){this.a=h}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(h){this.a(h),this.c(h)}onUnexpectedExternalError(h){this.a(h)}}t.$W=k,t.$X=new k;function C(f){t.$X.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=C;function s(f){if(!f||typeof f!="object")return!1;const h=f;return h.code==="EPIPE"&&h.syscall?.toUpperCase()==="WRITE"}t.$Z=s;function j(f){w(f)||t.$X.onUnexpectedError(f)}t.$1=j;function E(f){w(f)||t.$X.onUnexpectedExternalError(f)}t.$2=E;function A(f){if(f instanceof Error){const{name:h,message:F}=f,M=f.stacktrace||f.stack;return{$isError:!0,name:h,message:F,stack:M,noTelemetry:p.isErrorNoTelemetry(f)}}return f}t.$3=A;const b="Canceled";function w(f){return f instanceof y?!0:f instanceof Error&&f.name===b&&f.message===b}t.$4=w;class y extends Error{constructor(){super(b),this.name=this.message}}t.$5=y;function I(){const f=new Error(b);return f.name=f.message,f}t.$6=I;function o(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$7=o;function a(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$8=a;class e extends TypeError{constructor(h){super(h?`${h} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function r(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$0=r;class d extends Error{constructor(h){super("NotImplemented"),h&&(this.message=h)}}t.$$=d;class $ extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}t.$_=$;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=u;class p extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof p)return h;const F=new p;return F.message=h.message,F.stack=h.stack,F}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}t.$bb=p;class c extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$cb=c}),define(be[12],pe([1,0,6,72]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function s(_,g=0){return _[_.length-(1+g)]}t.$sb=s;function j(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}t.$tb=j;function E(_,g,m=(i,n)=>i===n){if(_===g)return!0;if(!_||!g||_.length!==g.length)return!1;for(let i=0,n=_.length;i<n;i++)if(!m(_[i],g[i]))return!1;return!0}t.$ub=E;function A(_,g){const m=_.length-1;g<m&&(_[g]=_[m]),_.pop()}t.$vb=A;function b(_,g,m){return w(_.length,i=>m(_[i],g))}t.$wb=b;function w(_,g){let m=0,i=_-1;for(;m<=i;){const n=(m+i)/2|0,l=g(n);if(l<0)m=n+1;else if(l>0)i=n-1;else return n}return-(m+1)}t.$xb=w;function y(_,g,m){if(_=_|0,_>=g.length)throw new TypeError("invalid index");const i=g[Math.floor(g.length*Math.random())],n=[],l=[],D=[];for(const S of g){const z=m(S,i);z<0?n.push(S):z>0?l.push(S):D.push(S)}return _<n.length?y(_,n,m):_<n.length+D.length?D[0]:y(_-(n.length+D.length),l,m)}t.$yb=y;function I(_,g){const m=[];let i;for(const n of _.slice(0).sort(g))!i||g(i[0],n)!==0?(i=[n],m.push(i)):i.push(n);return m}t.$zb=I;function*o(_,g){let m,i;for(const n of _)i!==void 0&&g(i,n)?m.push(n):(m&&(yield m),m=[n]),i=n;m&&(yield m)}t.$Ab=o;function a(_,g){for(let m=0;m<=_.length;m++)g(m===0?void 0:_[m-1],m===_.length?void 0:_[m])}t.$Bb=a;function e(_,g){for(let m=0;m<_.length;m++)g(m===0?void 0:_[m-1],_[m],m+1===_.length?void 0:_[m+1])}t.$Cb=e;function r(_,g,m){const i=[];function n(S,z,P){if(z===0&&P.length===0)return;const U=i[i.length-1];U&&U.start+U.deleteCount===S?(U.deleteCount+=z,U.toInsert.push(...P)):i.push({start:S,deleteCount:z,toInsert:P})}let l=0,D=0;for(;;){if(l===_.length){n(l,0,g.slice(D));break}if(D===g.length){n(l,_.length-l,[]);break}const S=_[l],z=g[D],P=m(S,z);P===0?(l+=1,D+=1):P<0?(n(l,1,[]),l+=1):P>0&&(n(l,0,[z]),D+=1)}return i}t.$Db=r;function d(_,g,m){const i=r(_,g,m),n=[],l=[];for(const D of i)n.push(..._.slice(D.start,D.start+D.deleteCount)),l.push(...D.toInsert);return{removed:n,added:l}}t.$Eb=d;function $(_,g,m){if(m===0)return[];const i=_.slice(0,m).sort(g);return p(_,g,i,m,_.length),i}t.top=$;function u(_,g,m,i,n){return m===0?Promise.resolve([]):new Promise((l,D)=>{(async()=>{const S=_.length,z=_.slice(0,m).sort(g);for(let P=m,U=Math.min(m+i,S);P<S;P=U,U=Math.min(U+i,S)){if(P>m&&await new Promise(G=>setTimeout(G)),n&&n.isCancellationRequested)throw new k.$5;p(_,g,z,P,U)}return z})().then(l,D)})}t.$Gb=u;function p(_,g,m,i,n){for(const l=m.length;i<n;i++){const D=_[i];if(g(D,m[l-1])<0){m.pop();const S=(0,C.$kb)(m,z=>g(D,z)<0);m.splice(S,0,D)}}}function c(_){return _.filter(g=>!!g)}t.$Hb=c;function f(_){let g=0;for(let m=0;m<_.length;m++)_[m]&&(_[g]=_[m],g+=1);_.length=g}t.$Ib=f;function h(_,g,m){_.splice(m,0,_.splice(g,1)[0])}t.$Jb=h;function F(_){return!Array.isArray(_)||_.length===0}t.$Kb=F;function M(_){return Array.isArray(_)&&_.length>0}t.$Lb=M;function R(_,g=m=>m){const m=new Set;return _.filter(i=>{const n=g(i);return m.has(n)?!1:(m.add(n),!0)})}t.$Mb=R;function O(_){const g=new Set;return m=>{const i=_(m);return g.has(i)?!1:(g.add(i),!0)}}t.$Nb=O;function v(_,g){return _.length>0?_[0]:g}t.$Ob=v;function N(_,g){return _.length>0?_[_.length-1]:g}t.$Pb=N;function V(_,g,m=(i,n)=>i===n){let i=0;for(let n=0,l=Math.min(_.length,g.length);n<l&&m(_[n],g[n]);n++)i++;return i}t.$Qb=V;function H(_){return[].concat(..._)}t.$Rb=H;function T(_,g){let m=typeof g=="number"?_:0;typeof g=="number"?m=_:(m=0,g=_);const i=[];if(m<=g)for(let n=m;n<g;n++)i.push(n);else for(let n=m;n>g;n--)i.push(n);return i}t.$Sb=T;function L(_,g,m){return _.reduce((i,n)=>(i[g(n)]=m?m(n):n,i),Object.create(null))}t.$Tb=L;function B(_,g){return _.push(g),()=>X(_,g)}t.$Ub=B;function X(_,g){const m=_.indexOf(g);if(m>-1)return _.splice(m,1),g}t.$Vb=X;function Y(_,g,m){const i=_.slice(0,g),n=_.slice(g);return i.concat(m,n)}t.$Wb=Y;function de(_,g){let m;if(typeof g=="number"){let i=g;m=()=>{const n=Math.sin(i++)*179426549;return n-Math.floor(n)}}else m=Math.random;for(let i=_.length-1;i>0;i-=1){const n=Math.floor(m()*(i+1)),l=_[i];_[i]=_[n],_[n]=l}}t.$Xb=de;function oe(_,g){const m=_.indexOf(g);m>-1&&(_.splice(m,1),_.unshift(g))}t.$Yb=oe;function ee(_,g){const m=_.indexOf(g);m>-1&&(_.splice(m,1),_.push(g))}t.$Zb=ee;function me(_,g){for(const m of g)_.push(m)}t.$1b=me;function Pe(_,g){return Array.isArray(_)?_.map(g):g(_)}t.$2b=Pe;function Te(_){return Array.isArray(_)?_:[_]}t.$3b=Te;function Me(_){return _[Math.floor(Math.random()*_.length)]}t.$4b=Me;function re(_,g,m){const i=le(_,g),n=_.length,l=m.length;_.length=n+l;for(let D=n-1;D>=i;D--)_[D+l]=_[D];for(let D=0;D<l;D++)_[D+i]=m[D]}t.$5b=re;function J(_,g,m,i){const n=le(_,g);let l=_.splice(n,m);return l===void 0&&(l=[]),re(_,n,i),l}t.$6b=J;function le(_,g){return g<0?Math.max(g+_.length,0):Math.min(g,_.length)}var K;(function(_){function g(l){return l<0}_.isLessThan=g;function m(l){return l<=0}_.isLessThanOrEqual=m;function i(l){return l>0}_.isGreaterThan=i;function n(l){return l===0}_.isNeitherLessOrGreaterThan=n,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(K||(t.CompareResult=K={}));function W(_,g){return(m,i)=>g(_(m),_(i))}t.$7b=W;function Z(..._){return(g,m)=>{for(const i of _){const n=i(g,m);if(!K.isNeitherLessOrGreaterThan(n))return n}return K.neitherLessOrGreaterThan}}t.$8b=Z;const ce=(_,g)=>_-g;t.$9b=ce;const we=(_,g)=>(0,t.$9b)(_?1:0,g?1:0);t.$0b=we;function ke(_){return(g,m)=>-_(g,m)}t.$$b=ke;class Ae{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let m=this.c;for(;m<this.g.length&&g(this.g[m]);)m++;const i=m===this.c?null:this.g.slice(this.c,m);return this.c=m,i}takeFromEndWhile(g){let m=this.d;for(;m>=0&&g(this.g[m]);)m--;const i=m===this.d?null:this.g.slice(m+1,this.d+1);return this.d=m,i}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const m=this.g.slice(this.c,this.c+g);return this.c+=g,m}}t.$_b=Ae;class Le{static{this.empty=new Le(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(m=>(g(m),!0))}toArray(){const g=[];return this.iterate(m=>(g.push(m),!0)),g}filter(g){return new Le(m=>this.iterate(i=>g(i)?m(i):!0))}map(g){return new Le(m=>this.iterate(i=>m(g(i))))}some(g){let m=!1;return this.iterate(i=>(m=g(i),!m)),m}findFirst(g){let m;return this.iterate(i=>g(i)?(m=i,!1):!0),m}findLast(g){let m;return this.iterate(i=>(g(i)&&(m=i),!0)),m}findLastMaxBy(g){let m,i=!0;return this.iterate(n=>((i||K.isGreaterThan(g(n,m)))&&(i=!1,m=n),!0)),m}}t.$ac=Le}),define(be[76],pe([1,0,6]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function C(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=C;function s(b,w="Unreachable"){throw new Error(w)}t.$6c=s;function j(b){if(!b)throw new k.$cb("Assertion Failed")}t.$7c=j;function E(b){if(!b()){debugger;b(),(0,k.$1)(new k.$cb("Assertion Failed"))}}t.$8c=E;function A(b,w){let y=0;for(;y<b.length-1;){const I=b[y],o=b[y+1];if(!w(I,o))return!1;y++}return!0}t.$9c=A}),define(be[43],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function k(C,s){const j=this;let E=!1,A;return function(){if(E)return A;if(E=!0,s)try{A=C.apply(j,arguments)}finally{s()}else A=C.apply(j,arguments);return A}}t.$db=k}),define(be[77],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6M=t.$5M=void 0;class k{constructor(s){this.a=s,this.b=0}nextId(){return this.a+ ++this.b}}t.$5M=k,t.$6M=new k("id#")}),define(be[28],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(C){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}C.is=s;const j=Object.freeze([]);function E(){return j}C.empty=E;function*A(h){yield h}C.single=A;function b(h){return s(h)?h:A(h)}C.wrap=b;function w(h){return h||j}C.from=w;function*y(h){for(let F=h.length-1;F>=0;F--)yield h[F]}C.reverse=y;function I(h){return!h||h[Symbol.iterator]().next().done===!0}C.isEmpty=I;function o(h){return h[Symbol.iterator]().next().value}C.first=o;function a(h,F){for(const M of h)if(F(M))return!0;return!1}C.some=a;function e(h,F){for(const M of h)if(F(M))return M}C.find=e;function*r(h,F){for(const M of h)F(M)&&(yield M)}C.filter=r;function*d(h,F){let M=0;for(const R of h)yield F(R,M++)}C.map=d;function*$(...h){for(const F of h)yield*F}C.concat=$;function u(h,F,M){let R=M;for(const O of h)R=F(R,O);return R}C.reduce=u;function*p(h,F,M=h.length){for(F<0&&(F+=h.length),M<0?M+=h.length:M>h.length&&(M=h.length);F<M;F++)yield h[F]}C.slice=p;function c(h,F=Number.POSITIVE_INFINITY){const M=[];if(F===0)return[M,h];const R=h[Symbol.iterator]();for(let O=0;O<F;O++){const v=R.next();if(v.done)return[M,C.empty()];M.push(v.value)}return[M,{[Symbol.iterator](){return R}}]}C.consume=c;async function f(h){const F=[];for await(const M of h)F.push(M);return Promise.resolve(F)}C.asyncToArray=f})(k||(t.Iterable=k={}))}),define(be[44],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vq=t.KeyMod=t.KeyCodeUtils=t.$Uq=t.$Tq=t.$Sq=t.$Rq=t.$Qq=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class s{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(r,d){this._keyCodeToStr[r]=d,this._strToKeyCode[d.toLowerCase()]=r}keyCodeToStr(r){return this._keyCodeToStr[r]}strToKeyCode(r){return this._strToKeyCode[r.toLowerCase()]||0}}const j=new s,E=new s,A=new s;t.$Qq=new Array(230),t.$Rq={};const b=[],w=Object.create(null),y=Object.create(null);t.$Sq={lowerCaseToEnum:e=>y[e]||0,toEnum:e=>w[e]||0,toString:e=>b[e]||"None"},t.$Tq=[],t.$Uq=[];for(let e=0;e<=193;e++)t.$Tq[e]=-1;for(let e=0;e<=132;e++)t.$Uq[e]=-1;(function(){const e="",r=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],d=[],$=[];for(const u of r){const[p,c,f,h,F,M,R,O,v]=u;if($[c]||($[c]=!0,b[c]=f,w[f]=c,y[f.toLowerCase()]=c,p&&(t.$Tq[c]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(t.$Uq[h]=c))),!d[h]){if(d[h]=!0,!F)throw new Error(`String representation missing for key code ${h} around scan code ${f}`);j.define(h,F),E.define(h,O||F),A.define(h,v||O||F)}M&&(t.$Qq[M]=h),R&&(t.$Rq[R]=h)}t.$Uq[3]=46})();var I;(function(e){function r(f){return j.keyCodeToStr(f)}e.toString=r;function d(f){return j.strToKeyCode(f)}e.fromString=d;function $(f){return E.keyCodeToStr(f)}e.toUserSettingsUS=$;function u(f){return A.keyCodeToStr(f)}e.toUserSettingsGeneral=u;function p(f){return E.strToKeyCode(f)||A.strToKeyCode(f)}e.fromUserSettings=p;function c(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return j.keyCodeToStr(f)}e.toElectronAccelerator=c})(I||(t.KeyCodeUtils=I={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o||(t.KeyMod=o={}));function a(e,r){const d=(r&65535)<<16>>>0;return(e|d)>>>0}t.$Vq=a}),define(be[78],pe([1,0,6]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3q=t.$2q=t.$1q=t.$Zq=t.$Yq=t.$Xq=t.$Wq=void 0;var C;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(C||(C={}));function s(I,o){if(typeof I=="number"){if(I===0)return null;const a=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new b([j(a,o),j(e,o)]):new b([j(a,o)])}else{const a=[];for(let e=0;e<I.length;e++)a.push(j(I[e],o));return new b(a)}}t.$Wq=s;function j(I,o){const a=!!(I&2048),e=!!(I&256),r=o===2?e:a,d=!!(I&1024),$=!!(I&512),u=o===2?a:e,p=I&255;return new E(r,d,$,u,p)}t.$Xq=j;class E{constructor(o,a,e,r,d){this.ctrlKey=o,this.shiftKey=a,this.altKey=e,this.metaKey=r,this.keyCode=d}equals(o){return o instanceof E&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`K${o}${a}${e}${r}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Yq=E;class A{constructor(o,a,e,r,d){this.ctrlKey=o,this.shiftKey=a,this.altKey=e,this.metaKey=r,this.scanCode=d}equals(o){return o instanceof A&&this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}getHashCode(){const o=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`S${o}${a}${e}${r}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Zq=A;class b{constructor(o){if(o.length===0)throw(0,k.$7)("chords");this.chords=o}getHashCode(){let o="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(o+=";"),o+=this.chords[a].getHashCode();return o}equals(o){if(o===null||this.chords.length!==o.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(o.chords[a]))return!1;return!0}}t.$1q=b;class w{constructor(o,a,e,r,d,$){this.ctrlKey=o,this.shiftKey=a,this.altKey=e,this.metaKey=r,this.keyLabel=d,this.keyAriaLabel=$}}t.$2q=w;class y{}t.$3q=y}),define(be[23],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class k{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=k}),define(be[45],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class k{static{this.Undefined=new k(void 0)}constructor(j){this.element=j,this.next=k.Undefined,this.prev=k.Undefined}}class C{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let j=this.a;for(;j!==k.Undefined;){const E=j.next;j.prev=k.Undefined,j.next=k.Undefined,j=E}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,E){const A=new k(j);if(this.a===k.Undefined)this.a=A,this.b=A;else if(E){const w=this.b;this.b=A,A.prev=w,w.next=A}else{const w=this.a;this.a=A,A.next=w,w.prev=A}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(A))}}shift(){if(this.a!==k.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==k.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==k.Undefined&&j.next!==k.Undefined){const E=j.prev;E.next=j.next,j.next.prev=E}else j.prev===k.Undefined&&j.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):j.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):j.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==k.Undefined;)yield j.element,j=j.next}}t.$4c=C}),define(be[32],pe([1,0]),function(ie,t){"use strict";var k,C,s;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function j(p,c,f){let h=p.get(c);return h===void 0&&(h=f,p.set(c,h)),h}t.$xc=j;function E(p){const c=[];return p.forEach((f,h)=>{c.push(`${h} => ${f}`)}),`Map(${p.size}) {${c.join(", ")}}`}t.$yc=E;function A(p){const c=[];return p.forEach(f=>{c.push(f)}),`Set(${p.size}) {${c.join(", ")}}`}t.$zc=A;class b{constructor(c,f){this.uri=c,this.value=f}}function w(p){return Array.isArray(p)}class y{static{this.c=c=>c.toString()}constructor(c,f){if(this[k]="ResourceMap",c instanceof y)this.d=new Map(c.d),this.e=f??y.c;else if(w(c)){this.d=new Map,this.e=f??y.c;for(const[h,F]of c)this.set(h,F)}else this.d=new Map,this.e=c??y.c}set(c,f){return this.d.set(this.e(c),new b(c,f)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[h,F]of this.d)c(F.value,F.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}t.$Ac=y;class I{constructor(c,f){this[C]="ResourceSet",!c||typeof c=="function"?this.c=new y(c):(this.c=new y(f),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,f){this.c.forEach((h,F)=>c.call(f,F,F,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=I;var o;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(o||(t.Touch=o={}));class a{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,f=0){const h=this.c.get(c);if(h)return f!==0&&this.l(h,f),h.value}set(c,f,h=0){let F=this.c.get(c);if(F)F.value=f,h!==0&&this.l(F,h);else{switch(F={key:c,value:f,next:void 0,previous:void 0},h){case 0:this.j(F);break;case 1:this.i(F);break;case 2:this.j(F);break;default:this.j(F);break}this.c.set(c,F),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this.c.get(c);if(f)return this.c.delete(c),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,f){const h=this.g;let F=this.d;for(;F;){if(f?c.bind(f)(F.value,F.key,this):c(F.value,F.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");F=F.next}}keys(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.key,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return F}values(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.value,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return F}entries(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:[h.key,h.value],done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return F}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this.d,h=this.size;for(;f&&h>c;)this.c.delete(f.key),f=f.next,h--;this.d=f,this.f=h,f&&(f.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const f=c.next,h=c.previous;if(!f||!h)throw new Error("Invalid list");f.previous=h,h.next=f}c.next=void 0,c.previous=void 0,this.g++}l(c,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this.d)return;const h=c.next,F=c.previous;c===this.e?(F.next=void 0,this.e=F):(h.previous=F,F.next=h),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(f===2){if(c===this.e)return;const h=c.next,F=c.previous;c===this.d?(h.previous=void 0,this.d=h):(h.previous=F,F.next=h),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((f,h)=>{c.push([h,f])}),c}fromJSON(c){this.clear();for(const[f,h]of c)this.set(f,h)}}t.$Cc=a;class e extends a{constructor(c,f=1){super(),this.m=c,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class r{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let f=this.c.get(c)||0;return f===0?!1:(f--,f===0?this.c.delete(c):this.c.set(c,f),!0)}has(c){return this.c.has(c)}}t.$Ec=r;class d{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[f,h]of c)this.set(f,h)}clear(){this.c.clear(),this.d.clear()}set(c,f){this.c.set(c,f),this.d.set(f,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const f=this.c.get(c);return f===void 0?!1:(this.c.delete(c),this.d.delete(f),!0)}forEach(c,f){this.c.forEach((h,F)=>{c.call(f,h,F,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=d;class ${constructor(){this.c=new Map}add(c,f){let h=this.c.get(c);h||(h=new Set,this.c.set(c,h)),h.add(f)}delete(c,f){const h=this.c.get(c);h&&(h.delete(f),h.size===0&&this.c.delete(c))}forEach(c,f){const h=this.c.get(c);h&&h.forEach(f)}get(c){const f=this.c.get(c);return f||new Set}}t.$Gc=$;function u(p,c){if(p===c)return!0;if(p.size!==c.size)return!1;for(const[f,h]of p)if(!c.has(f)||c.get(f)!==h)return!1;for(const[f]of c)if(!p.has(f))return!1;return!0}t.$Hc=u}),define(be[2],pe([1,0,12,73,32,43,28]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const A=!1;let b=null;class w{constructor(){this.b=new Map}static{this.a=0}c(B){let X=this.b.get(B);return X||(X={parent:null,source:null,isSingleton:!1,value:B,idx:w.a++},this.b.set(B,X)),X}trackDisposable(B){const X=this.c(B);X.source||(X.source=new Error().stack)}setParent(B,X){const Y=this.c(B);Y.parent=X}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,X){const Y=X.get(B);if(Y)return Y;const de=B.parent?this.f(this.c(B.parent),X):B;return X.set(B,de),de}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,B).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(B=10,X){let Y;if(X)Y=X;else{const Pe=new Map,Te=[...this.b.values()].filter(re=>re.source!==null&&!this.f(re,Pe).isSingleton);if(Te.length===0)return;const Me=new Set(Te.map(re=>re.value));if(Y=Te.filter(re=>!(re.parent&&Me.has(re.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function de(Pe){function Te(re,J){for(;re.length>0&&J.some(le=>typeof le=="string"?le===re[0]:re[0].match(le));)re.shift()}const Me=Pe.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Te(Me,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Me.reverse()}const oe=new s.$Gc;for(const Pe of Y){const Te=de(Pe);for(let Me=0;Me<=Te.length;Me++)oe.add(Te.slice(0,Me).join(`
`),Pe)}Y.sort((0,k.$7b)(Pe=>Pe.idx,k.$9b));let ee="",me=0;for(const Pe of Y.slice(0,B)){me++;const Te=de(Pe),Me=[];for(let re=0;re<Te.length;re++){let J=Te[re];J=`(shared with ${oe.get(Te.slice(0,re+1).join(`
`)).size}/${Y.length} leaks) at ${J}`;const K=oe.get(Te.slice(0,re).join(`
`)),W=(0,C.$K)([...K].map(Z=>de(Z)[re]),Z=>Z);delete W[Te[re]];for(const[Z,ce]of Object.entries(W))Me.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${Z}`);Me.unshift(J)}ee+=`


==================== Leaking disposable ${me}/${Y.length}: ${Pe.value.constructor.name} ====================
${Me.join(`
`)}
============================================================

`}return Y.length>B&&(ee+=`


... and ${Y.length-B} more leaking disposables

`),{leaks:Y,details:ee}}}t.$Ic=w;function y(L){b=L}if(t.$Jc=y,A){const L="__is_disposable_tracked__";y(new class{trackDisposable(B){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[L]||console.log(X)},3e3)}setParent(B,X){if(B&&B!==h.None)try{B[L]=!0}catch{}}markAsDisposed(B){if(B&&B!==h.None)try{B[L]=!0}catch{}}markAsSingleton(B){}})}function I(L){return b?.trackDisposable(L),L}t.$Kc=I;function o(L){b?.markAsDisposed(L)}t.$Lc=o;function a(L,B){b?.setParent(L,B)}function e(L,B){if(b)for(const X of L)b.setParent(X,B)}function r(L){return b?.markAsSingleton(L),L}t.$Mc=r;function d(L){return typeof L.dispose=="function"&&L.dispose.length===0}t.$Nc=d;function $(L){if(E.Iterable.is(L)){const B=[];for(const X of L)if(X)try{X.dispose()}catch(Y){B.push(Y)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}t.$Oc=$;function u(L){for(const B of L)d(B)&&B.dispose();return[]}t.$Pc=u;function p(...L){const B=c(()=>$(L));return e(L,B),B}t.$Qc=p;function c(L){const B=I({dispose:(0,j.$db)(()=>{o(B),L()})});return B}t.$Rc=c;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(o(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return a(B,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),a(B,null))}}t.$Sc=f;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,I(this),a(this.q,this)}dispose(){o(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Tc=h;class F{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&a(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,o(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&a(B,null),B}}t.$Uc=F;class M{constructor(B){this.a=new F,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=M;class R{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=R;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(B){let X=B;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,o(this))},this}}t.$Xc=O;class v{constructor(){this.a=new Map}acquire(B,...X){let Y=this.a.get(B);Y||(Y={counter:0,object:this.b(B,...X)},this.a.set(B,Y));const{object:de}=Y,oe=(0,j.$db)(()=>{--Y.counter===0&&(this.c(B,Y.object),this.a.delete(B))});return Y.counter++,{object:de,dispose:oe}}}t.$Yc=v;class N{constructor(B){this.a=B}async acquire(B,...X){const Y=this.a.acquire(B,...X);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(de){throw Y.dispose(),de}}}t.$Zc=N;class V{constructor(B){this.object=B}dispose(){}}t.$1c=V;function H(L){const B=new f;try{L(B)}finally{B.dispose()}}t.$2c=H;class T{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,X,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(B)?.dispose(),this.a.set(B,X)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=T}),function(ie,t){typeof define=="function"&&define.amd?define(be[79],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(g,m){for(var i=0;i<m.length;i++){var n=m[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(g,n.key,n)}}function k(g,m,i){return m&&t(g.prototype,m),i&&t(g,i),Object.defineProperty(g,"prototype",{writable:!1}),g}function C(g,m){if(g){if(typeof g=="string")return s(g,m);var i=Object.prototype.toString.call(g).slice(8,-1);if(i==="Object"&&g.constructor&&(i=g.constructor.name),i==="Map"||i==="Set")return Array.from(g);if(i==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i))return s(g,m)}}function s(g,m){(m==null||m>g.length)&&(m=g.length);for(var i=0,n=new Array(m);i<m;i++)n[i]=g[i];return n}function j(g,m){var i=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(i)return(i=i.call(g)).next.bind(i);if(Array.isArray(g)||(i=C(g))||m&&g&&typeof g.length=="number"){i&&(g=i);var n=0;return function(){return n>=g.length?{done:!0}:{done:!1,value:g[n++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=E();function A(g){ie.defaults=g}var b=/[&<>"']/,w=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(m){return o[m]};function e(g,m){if(m){if(b.test(g))return g.replace(w,a)}else if(y.test(g))return g.replace(I,a);return g}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(g){return g.replace(r,function(m,i){return i=i.toLowerCase(),i==="colon"?":":i.charAt(0)==="#"?i.charAt(1)==="x"?String.fromCharCode(parseInt(i.substring(2),16)):String.fromCharCode(+i.substring(1)):""})}var $=/(^|[^\[])\^/g;function u(g,m){g=typeof g=="string"?g:g.source,m=m||"";var i={replace:function(l,D){return D=D.source||D,D=D.replace($,"$1"),g=g.replace(l,D),i},getRegex:function(){return new RegExp(g,m)}};return i}var p=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(g,m,i){if(g){var n;try{n=decodeURIComponent(d(i)).replace(p,"").toLowerCase()}catch{return null}if(n.indexOf("javascript:")===0||n.indexOf("vbscript:")===0||n.indexOf("data:")===0)return null}m&&!c.test(i)&&(i=O(m,i));try{i=encodeURI(i).replace(/%25/g,"%")}catch{return null}return i}var h={},F=/^[^:]+:\/*[^/]*$/,M=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function O(g,m){h[" "+g]||(F.test(g)?h[" "+g]=g+"/":h[" "+g]=H(g,"/",!0)),g=h[" "+g];var i=g.indexOf(":")===-1;return m.substring(0,2)==="//"?i?m:g.replace(M,"$1")+m:m.charAt(0)==="/"?i?m:g.replace(R,"$1")+m:g+m}var v={exec:function(){}};function N(g){for(var m=1,i,n;m<arguments.length;m++){i=arguments[m];for(n in i)Object.prototype.hasOwnProperty.call(i,n)&&(g[n]=i[n])}return g}function V(g,m){var i=g.replace(/\|/g,function(D,S,z){for(var P=!1,U=S;--U>=0&&z[U]==="\\";)P=!P;return P?"|":" |"}),n=i.split(/ \|/),l=0;if(n[0].trim()||n.shift(),n.length>0&&!n[n.length-1].trim()&&n.pop(),n.length>m)n.splice(m);else for(;n.length<m;)n.push("");for(;l<n.length;l++)n[l]=n[l].trim().replace(/\\\|/g,"|");return n}function H(g,m,i){var n=g.length;if(n===0)return"";for(var l=0;l<n;){var D=g.charAt(n-l-1);if(D===m&&!i)l++;else if(D!==m&&i)l++;else break}return g.slice(0,n-l)}function T(g,m){if(g.indexOf(m[1])===-1)return-1;for(var i=g.length,n=0,l=0;l<i;l++)if(g[l]==="\\")l++;else if(g[l]===m[0])n++;else if(g[l]===m[1]&&(n--,n<0))return l;return-1}function L(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(g,m){if(m<1)return"";for(var i="";m>1;)m&1&&(i+=g),m>>=1,g+=g;return i+g}function X(g,m,i,n){var l=m.href,D=m.title?e(m.title):null,S=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){n.state.inLink=!0;var z={type:"link",raw:i,href:l,title:D,text:S,tokens:n.inlineTokens(S)};return n.state.inLink=!1,z}return{type:"image",raw:i,href:l,title:D,text:e(S)}}function Y(g,m){var i=g.match(/^(\s+)(?:```)/);if(i===null)return m;var n=i[1];return m.split(`
`).map(function(l){var D=l.match(/^\s+/);if(D===null)return l;var S=D[0];return S.length>=n.length?l.slice(n.length):l}).join(`
`)}var de=function(){function g(i){this.options=i||ie.defaults}var m=g.prototype;return m.space=function(n){var l=this.rules.block.newline.exec(n);if(l&&l[0].length>0)return{type:"space",raw:l[0]}},m.code=function(n){var l=this.rules.block.code.exec(n);if(l){var D=l[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:l[0],codeBlockStyle:"indented",text:this.options.pedantic?D:H(D,`
`)}}},m.fences=function(n){var l=this.rules.block.fences.exec(n);if(l){var D=l[0],S=Y(D,l[3]||"");return{type:"code",raw:D,lang:l[2]?l[2].trim():l[2],text:S}}},m.heading=function(n){var l=this.rules.block.heading.exec(n);if(l){var D=l[2].trim();if(/#$/.test(D)){var S=H(D,"#");(this.options.pedantic||!S||/ $/.test(S))&&(D=S.trim())}return{type:"heading",raw:l[0],depth:l[1].length,text:D,tokens:this.lexer.inline(D)}}},m.hr=function(n){var l=this.rules.block.hr.exec(n);if(l)return{type:"hr",raw:l[0]}},m.blockquote=function(n){var l=this.rules.block.blockquote.exec(n);if(l){var D=l[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:l[0],tokens:this.lexer.blockTokens(D,[]),text:D}}},m.list=function(n){var l=this.rules.block.list.exec(n);if(l){var D,S,z,P,U,G,ne,he,ve,$e,ue,Fe,ye=l[1].trim(),Oe=ye.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Oe?"\\d{1,9}\\"+ye.slice(-1):"\\"+ye,this.options.pedantic&&(ye=Oe?ye:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+ye+")((?:[	 ][^\\n]*)?(?:\\n|$))");n&&(Fe=!1,!(!(l=Ie.exec(n))||this.rules.block.hr.test(n)));){if(D=l[0],n=n.substring(D.length),he=l[2].split(`
`,1)[0],ve=n.split(`
`,1)[0],this.options.pedantic?(P=2,ue=he.trimLeft()):(P=l[2].search(/[^ ]/),P=P>4?1:P,ue=he.slice(P),P+=l[1].length),G=!1,!he&&/^ *$/.test(ve)&&(D+=ve+`
`,n=n.substring(ve.length+1),Fe=!0),!Fe)for(var Je=new RegExp("^ {0,"+Math.min(3,P-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,P-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Qe=new RegExp("^ {0,"+Math.min(3,P-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,P-1)+"}#");n&&($e=n.split(`
`,1)[0],he=$e,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(he)||x.test(he)||Je.test(he)||et.test(n)));){if(he.search(/[^ ]/)>=P||!he.trim())ue+=`
`+he.slice(P);else if(!G)ue+=`
`+he;else break;!G&&!he.trim()&&(G=!0),D+=$e+`
`,n=n.substring($e.length+1)}Be.loose||(ne?Be.loose=!0:/\n *\n *$/.test(D)&&(ne=!0)),this.options.gfm&&(S=/^\[[ xX]\] /.exec(ue),S&&(z=S[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:D,task:!!S,checked:z,loose:!1,text:ue}),Be.raw+=D}Be.items[Be.items.length-1].raw=D.trimRight(),Be.items[Be.items.length-1].text=ue.trimRight(),Be.raw=Be.raw.trimRight();var se=Be.items.length;for(U=0;U<se;U++){this.lexer.state.top=!1,Be.items[U].tokens=this.lexer.blockTokens(Be.items[U].text,[]);var ge=Be.items[U].tokens.filter(function(Ne){return Ne.type==="space"}),Ee=ge.every(function(Ne){for(var je=Ne.raw.split(""),Ve=0,_e=j(je),Ze;!(Ze=_e()).done;){var tt=Ze.value;if(tt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Be.loose&&ge.length&&Ee&&(Be.loose=!0,Be.items[U].loose=!0)}return Be}},m.html=function(n){var l=this.rules.block.html.exec(n);if(l){var D={type:"html",raw:l[0],pre:!this.options.sanitizer&&(l[1]==="pre"||l[1]==="script"||l[1]==="style"),text:l[0]};if(this.options.sanitize){var S=this.options.sanitizer?this.options.sanitizer(l[0]):e(l[0]);D.type="paragraph",D.text=S,D.tokens=this.lexer.inline(S)}return D}},m.def=function(n){var l=this.rules.block.def.exec(n);if(l){l[3]&&(l[3]=l[3].substring(1,l[3].length-1));var D=l[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:D,raw:l[0],href:l[2],title:l[3]}}},m.table=function(n){var l=this.rules.block.table.exec(n);if(l){var D={type:"table",header:V(l[1]).map(function(ne){return{text:ne}}),align:l[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:l[3]&&l[3].trim()?l[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(D.header.length===D.align.length){D.raw=l[0];var S=D.align.length,z,P,U,G;for(z=0;z<S;z++)/^ *-+: *$/.test(D.align[z])?D.align[z]="right":/^ *:-+: *$/.test(D.align[z])?D.align[z]="center":/^ *:-+ *$/.test(D.align[z])?D.align[z]="left":D.align[z]=null;for(S=D.rows.length,z=0;z<S;z++)D.rows[z]=V(D.rows[z],D.header.length).map(function(ne){return{text:ne}});for(S=D.header.length,P=0;P<S;P++)D.header[P].tokens=this.lexer.inline(D.header[P].text);for(S=D.rows.length,P=0;P<S;P++)for(G=D.rows[P],U=0;U<G.length;U++)G[U].tokens=this.lexer.inline(G[U].text);return D}}},m.lheading=function(n){var l=this.rules.block.lheading.exec(n);if(l)return{type:"heading",raw:l[0],depth:l[2].charAt(0)==="="?1:2,text:l[1],tokens:this.lexer.inline(l[1])}},m.paragraph=function(n){var l=this.rules.block.paragraph.exec(n);if(l){var D=l[1].charAt(l[1].length-1)===`
`?l[1].slice(0,-1):l[1];return{type:"paragraph",raw:l[0],text:D,tokens:this.lexer.inline(D)}}},m.text=function(n){var l=this.rules.block.text.exec(n);if(l)return{type:"text",raw:l[0],text:l[0],tokens:this.lexer.inline(l[0])}},m.escape=function(n){var l=this.rules.inline.escape.exec(n);if(l)return{type:"escape",raw:l[0],text:e(l[1])}},m.tag=function(n){var l=this.rules.inline.tag.exec(n);if(l)return!this.lexer.state.inLink&&/^<a /i.test(l[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(l[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(l[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(l[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:l[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(l[0]):e(l[0]):l[0]}},m.link=function(n){var l=this.rules.inline.link.exec(n);if(l){var D=l[2].trim();if(!this.options.pedantic&&/^</.test(D)){if(!/>$/.test(D))return;var S=H(D.slice(0,-1),"\\");if((D.length-S.length)%2===0)return}else{var z=T(l[2],"()");if(z>-1){var P=l[0].indexOf("!")===0?5:4,U=P+l[1].length+z;l[2]=l[2].substring(0,z),l[0]=l[0].substring(0,U).trim(),l[3]=""}}var G=l[2],ne="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);he&&(G=he[1],ne=he[3])}else ne=l[3]?l[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(D)?G=G.slice(1):G=G.slice(1,-1)),X(l,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:ne&&ne.replace(this.rules.inline._escapes,"$1")},l[0],this.lexer)}},m.reflink=function(n,l){var D;if((D=this.rules.inline.reflink.exec(n))||(D=this.rules.inline.nolink.exec(n))){var S=(D[2]||D[1]).replace(/\s+/g," ");if(S=l[S.toLowerCase()],!S||!S.href){var z=D[0].charAt(0);return{type:"text",raw:z,text:z}}return X(D,S,D[0],this.lexer)}},m.emStrong=function(n,l,D){D===void 0&&(D="");var S=this.rules.inline.emStrong.lDelim.exec(n);if(S&&!(S[3]&&D.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=S[1]||S[2]||"";if(!z||z&&(D===""||this.rules.inline.punctuation.exec(D))){var P=S[0].length-1,U,G,ne=P,he=0,ve=S[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ve.lastIndex=0,l=l.slice(-1*n.length+P);(S=ve.exec(l))!=null;)if(U=S[1]||S[2]||S[3]||S[4]||S[5]||S[6],!!U){if(G=U.length,S[3]||S[4]){ne+=G;continue}else if((S[5]||S[6])&&P%3&&!((P+G)%3)){he+=G;continue}if(ne-=G,!(ne>0)){if(G=Math.min(G,G+ne+he),Math.min(P,G)%2){var $e=n.slice(1,P+S.index+G);return{type:"em",raw:n.slice(0,P+S.index+G+1),text:$e,tokens:this.lexer.inlineTokens($e)}}var ue=n.slice(2,P+S.index+G-1);return{type:"strong",raw:n.slice(0,P+S.index+G+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},m.codespan=function(n){var l=this.rules.inline.code.exec(n);if(l){var D=l[2].replace(/\n/g," "),S=/[^ ]/.test(D),z=/^ /.test(D)&&/ $/.test(D);return S&&z&&(D=D.substring(1,D.length-1)),D=e(D,!0),{type:"codespan",raw:l[0],text:D}}},m.br=function(n){var l=this.rules.inline.br.exec(n);if(l)return{type:"br",raw:l[0]}},m.del=function(n){var l=this.rules.inline.del.exec(n);if(l)return{type:"del",raw:l[0],text:l[2],tokens:this.lexer.inlineTokens(l[2])}},m.autolink=function(n,l){var D=this.rules.inline.autolink.exec(n);if(D){var S,z;return D[2]==="@"?(S=e(this.options.mangle?l(D[1]):D[1]),z="mailto:"+S):(S=e(D[1]),z=S),{type:"link",raw:D[0],text:S,href:z,tokens:[{type:"text",raw:S,text:S}]}}},m.url=function(n,l){var D;if(D=this.rules.inline.url.exec(n)){var S,z;if(D[2]==="@")S=e(this.options.mangle?l(D[0]):D[0]),z="mailto:"+S;else{var P;do P=D[0],D[0]=this.rules.inline._backpedal.exec(D[0])[0];while(P!==D[0]);S=e(D[0]),D[1]==="www."?z="http://"+S:z=S}return{type:"link",raw:D[0],text:S,href:z,tokens:[{type:"text",raw:S,text:S}]}}},m.inlineText=function(n,l){var D=this.rules.inline.text.exec(n);if(D){var S;return this.lexer.state.inRawBlock?S=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):e(D[0]):D[0]:S=e(this.options.smartypants?l(D[0]):D[0]),{type:"text",raw:D[0],text:S}}},g}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=u(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=u(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=u(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=u(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=u(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=u(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=N({},oe),oe.gfm=N({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=u(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=u(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=N({},oe.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:u(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=u(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=u(oe._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=u(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=u(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=u(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=u(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=u(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=u(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=u(ee.reflink).replace("label",ee._label).replace("ref",oe._label).getRegex(),ee.nolink=u(ee.nolink).replace("ref",oe._label).getRegex(),ee.reflinkSearch=u(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=N({},ee),ee.pedantic=N({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=N({},ee.normal,{escape:u(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=u(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=N({},ee.gfm,{br:u(ee.br).replace("{2,}","*").getRegex(),text:u(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Pe(g){var m="",i,n,l=g.length;for(i=0;i<l;i++)n=g.charCodeAt(i),Math.random()>.5&&(n="x"+n.toString(16)),m+="&#"+n+";";return m}var Te=function(){function g(i){this.tokens=[],this.tokens.links=Object.create(null),this.options=i||ie.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var n={block:oe.normal,inline:ee.normal};this.options.pedantic?(n.block=oe.pedantic,n.inline=ee.pedantic):this.options.gfm&&(n.block=oe.gfm,this.options.breaks?n.inline=ee.breaks:n.inline=ee.gfm),this.tokenizer.rules=n}g.lex=function(n,l){var D=new g(l);return D.lex(n)},g.lexInline=function(n,l){var D=new g(l);return D.inlineTokens(n)};var m=g.prototype;return m.lex=function(n){n=n.replace(/\r\n|\r/g,`
`),this.blockTokens(n,this.tokens);for(var l;l=this.inlineQueue.shift();)this.inlineTokens(l.src,l.tokens);return this.tokens},m.blockTokens=function(n,l){var D=this;l===void 0&&(l=[]),this.options.pedantic?n=n.replace(/\t/g,"    ").replace(/^ +$/gm,""):n=n.replace(/^( *)(\t+)/gm,function(ne,he,ve){return he+"    ".repeat(ve.length)});for(var S,z,P,U;n;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ne){return(S=ne.call({lexer:D},n,l))?(n=n.substring(S.raw.length),l.push(S),!0):!1}))){if(S=this.tokenizer.space(n)){n=n.substring(S.raw.length),S.raw.length===1&&l.length>0?l[l.length-1].raw+=`
`:l.push(S);continue}if(S=this.tokenizer.code(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+S.raw,z.text+=`
`+S.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):l.push(S);continue}if(S=this.tokenizer.fences(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.heading(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.hr(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.blockquote(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.list(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.html(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.def(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+S.raw,z.text+=`
`+S.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[S.tag]||(this.tokens.links[S.tag]={href:S.href,title:S.title});continue}if(S=this.tokenizer.table(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.lheading(n)){n=n.substring(S.raw.length),l.push(S);continue}if(P=n,this.options.extensions&&this.options.extensions.startBlock&&function(){var ne=1/0,he=n.slice(1),ve=void 0;D.options.extensions.startBlock.forEach(function($e){ve=$e.call({lexer:this},he),typeof ve=="number"&&ve>=0&&(ne=Math.min(ne,ve))}),ne<1/0&&ne>=0&&(P=n.substring(0,ne+1))}(),this.state.top&&(S=this.tokenizer.paragraph(P))){z=l[l.length-1],U&&z.type==="paragraph"?(z.raw+=`
`+S.raw,z.text+=`
`+S.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):l.push(S),U=P.length!==n.length,n=n.substring(S.raw.length);continue}if(S=this.tokenizer.text(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&z.type==="text"?(z.raw+=`
`+S.raw,z.text+=`
`+S.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):l.push(S);continue}if(n){var G="Infinite loop on byte: "+n.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,l},m.inline=function(n,l){return l===void 0&&(l=[]),this.inlineQueue.push({src:n,tokens:l}),l},m.inlineTokens=function(n,l){var D=this;l===void 0&&(l=[]);var S,z,P,U=n,G,ne,he;if(this.tokens.links){var ve=Object.keys(this.tokens.links);if(ve.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(U))!=null;)ve.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(U=U.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(U))!=null;)U=U.slice(0,G.index)+"["+B("a",G[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(U))!=null;)U=U.slice(0,G.index)+"++"+U.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;n;)if(ne||(he=""),ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(S=ue.call({lexer:D},n,l))?(n=n.substring(S.raw.length),l.push(S),!0):!1}))){if(S=this.tokenizer.escape(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.tag(n)){n=n.substring(S.raw.length),z=l[l.length-1],z&&S.type==="text"&&z.type==="text"?(z.raw+=S.raw,z.text+=S.text):l.push(S);continue}if(S=this.tokenizer.link(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.reflink(n,this.tokens.links)){n=n.substring(S.raw.length),z=l[l.length-1],z&&S.type==="text"&&z.type==="text"?(z.raw+=S.raw,z.text+=S.text):l.push(S);continue}if(S=this.tokenizer.emStrong(n,U,he)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.codespan(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.br(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.del(n)){n=n.substring(S.raw.length),l.push(S);continue}if(S=this.tokenizer.autolink(n,Pe)){n=n.substring(S.raw.length),l.push(S);continue}if(!this.state.inLink&&(S=this.tokenizer.url(n,Pe))){n=n.substring(S.raw.length),l.push(S);continue}if(P=n,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Fe=n.slice(1),ye=void 0;D.options.extensions.startInline.forEach(function(Oe){ye=Oe.call({lexer:this},Fe),typeof ye=="number"&&ye>=0&&(ue=Math.min(ue,ye))}),ue<1/0&&ue>=0&&(P=n.substring(0,ue+1))}(),S=this.tokenizer.inlineText(P,me)){n=n.substring(S.raw.length),S.raw.slice(-1)!=="_"&&(he=S.raw.slice(-1)),ne=!0,z=l[l.length-1],z&&z.type==="text"?(z.raw+=S.raw,z.text+=S.text):l.push(S);continue}if(n){var $e="Infinite loop on byte: "+n.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return l},k(g,null,[{key:"rules",get:function(){return{block:oe,inline:ee}}}]),g}(),Me=function(){function g(i){this.options=i||ie.defaults}var m=g.prototype;return m.code=function(n,l,D){var S=(l||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(n,S);z!=null&&z!==n&&(D=!0,n=z)}return n=n.replace(/\n$/,"")+`
`,S?'<pre><code class="'+this.options.langPrefix+e(S,!0)+'">'+(D?n:e(n,!0))+`</code></pre>
`:"<pre><code>"+(D?n:e(n,!0))+`</code></pre>
`},m.blockquote=function(n){return`<blockquote>
`+n+`</blockquote>
`},m.html=function(n){return n},m.heading=function(n,l,D,S){if(this.options.headerIds){var z=this.options.headerPrefix+S.slug(D);return"<h"+l+' id="'+z+'">'+n+"</h"+l+`>
`}return"<h"+l+">"+n+"</h"+l+`>
`},m.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},m.list=function(n,l,D){var S=l?"ol":"ul",z=l&&D!==1?' start="'+D+'"':"";return"<"+S+z+`>
`+n+"</"+S+`>
`},m.listitem=function(n){return"<li>"+n+`</li>
`},m.checkbox=function(n){return"<input "+(n?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},m.paragraph=function(n){return"<p>"+n+`</p>
`},m.table=function(n,l){return l&&(l="<tbody>"+l+"</tbody>"),`<table>
<thead>
`+n+`</thead>
`+l+`</table>
`},m.tablerow=function(n){return`<tr>
`+n+`</tr>
`},m.tablecell=function(n,l){var D=l.header?"th":"td",S=l.align?"<"+D+' align="'+l.align+'">':"<"+D+">";return S+n+("</"+D+`>
`)},m.strong=function(n){return"<strong>"+n+"</strong>"},m.em=function(n){return"<em>"+n+"</em>"},m.codespan=function(n){return"<code>"+n+"</code>"},m.br=function(){return this.options.xhtml?"<br/>":"<br>"},m.del=function(n){return"<del>"+n+"</del>"},m.link=function(n,l,D){if(n=f(this.options.sanitize,this.options.baseUrl,n),n===null)return D;var S='<a href="'+e(n)+'"';return l&&(S+=' title="'+l+'"'),S+=">"+D+"</a>",S},m.image=function(n,l,D){if(n=f(this.options.sanitize,this.options.baseUrl,n),n===null)return D;var S='<img src="'+n+'" alt="'+D+'"';return l&&(S+=' title="'+l+'"'),S+=this.options.xhtml?"/>":">",S},m.text=function(n){return n},g}(),re=function(){function g(){}var m=g.prototype;return m.strong=function(n){return n},m.em=function(n){return n},m.codespan=function(n){return n},m.del=function(n){return n},m.html=function(n){return n},m.text=function(n){return n},m.link=function(n,l,D){return""+D},m.image=function(n,l,D){return""+D},m.br=function(){return""},g}(),J=function(){function g(){this.seen={}}var m=g.prototype;return m.serialize=function(n){return n.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},m.getNextSafeSlug=function(n,l){var D=n,S=0;if(this.seen.hasOwnProperty(D)){S=this.seen[n];do S++,D=n+"-"+S;while(this.seen.hasOwnProperty(D))}return l||(this.seen[n]=S,this.seen[D]=0),D},m.slug=function(n,l){l===void 0&&(l={});var D=this.serialize(n);return this.getNextSafeSlug(D,l.dryrun)},g}(),le=function(){function g(i){this.options=i||ie.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new J}g.parse=function(n,l){var D=new g(l);return D.parse(n)},g.parseInline=function(n,l){var D=new g(l);return D.parseInline(n)};var m=g.prototype;return m.parse=function(n,l){l===void 0&&(l=!0);var D="",S,z,P,U,G,ne,he,ve,$e,ue,Fe,ye,Oe,Be,Ie,Je,et,Qe,x,se=n.length;for(S=0;S<se;S++){if(ue=n[S],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(x=this.options.extensions.renderers[ue.type].call({parser:this},ue),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){D+=x||"";continue}switch(ue.type){case"space":continue;case"hr":{D+=this.renderer.hr();continue}case"heading":{D+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,d(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{D+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(ve="",he="",U=ue.header.length,z=0;z<U;z++)he+=this.renderer.tablecell(this.parseInline(ue.header[z].tokens),{header:!0,align:ue.align[z]});for(ve+=this.renderer.tablerow(he),$e="",U=ue.rows.length,z=0;z<U;z++){for(ne=ue.rows[z],he="",G=ne.length,P=0;P<G;P++)he+=this.renderer.tablecell(this.parseInline(ne[P].tokens),{header:!1,align:ue.align[P]});$e+=this.renderer.tablerow(he)}D+=this.renderer.table(ve,$e);continue}case"blockquote":{$e=this.parse(ue.tokens),D+=this.renderer.blockquote($e);continue}case"list":{for(Fe=ue.ordered,ye=ue.start,Oe=ue.loose,U=ue.items.length,$e="",z=0;z<U;z++)Ie=ue.items[z],Je=Ie.checked,et=Ie.task,Be="",Ie.task&&(Qe=this.renderer.checkbox(Je),Oe?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=Qe+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=Qe+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:Qe}):Be+=Qe),Be+=this.parse(Ie.tokens,Oe),$e+=this.renderer.listitem(Be,et,Je);D+=this.renderer.list($e,Fe,ye);continue}case"html":{D+=this.renderer.html(ue.text);continue}case"paragraph":{D+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for($e=ue.tokens?this.parseInline(ue.tokens):ue.text;S+1<se&&n[S+1].type==="text";)ue=n[++S],$e+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);D+=l?this.renderer.paragraph($e):$e;continue}default:{var ge='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(ge);return}else throw new Error(ge)}}}return D},m.parseInline=function(n,l){l=l||this.renderer;var D="",S,z,P,U=n.length;for(S=0;S<U;S++){if(z=n[S],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(P=this.options.extensions.renderers[z.type].call({parser:this},z),P!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){D+=P||"";continue}switch(z.type){case"escape":{D+=l.text(z.text);break}case"html":{D+=l.html(z.text);break}case"link":{D+=l.link(z.href,z.title,this.parseInline(z.tokens,l));break}case"image":{D+=l.image(z.href,z.title,z.text);break}case"strong":{D+=l.strong(this.parseInline(z.tokens,l));break}case"em":{D+=l.em(this.parseInline(z.tokens,l));break}case"codespan":{D+=l.codespan(z.text);break}case"br":{D+=l.br();break}case"del":{D+=l.del(this.parseInline(z.tokens,l));break}case"text":{D+=l.text(z.text);break}default:{var G='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return D},g}();function K(g,m,i){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof m=="function"&&(i=m,m=null),m=N({},K.defaults,m||{}),L(m),i){var n=m.highlight,l;try{l=Te.lex(g,m)}catch(U){return i(U)}var D=function(G){var ne;if(!G)try{m.walkTokens&&K.walkTokens(l,m.walkTokens),ne=le.parse(l,m)}catch(he){G=he}return m.highlight=n,G?i(G):i(null,ne)};if(!n||n.length<3||(delete m.highlight,!l.length))return D();var S=0;K.walkTokens(l,function(U){U.type==="code"&&(S++,setTimeout(function(){n(U.text,U.lang,function(G,ne){if(G)return D(G);ne!=null&&ne!==U.text&&(U.text=ne,U.escaped=!0),S--,S===0&&D()})},0))}),S===0&&D();return}function z(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,m.silent)return"<p>An error occurred:</p><pre>"+e(U.message+"",!0)+"</pre>";throw U}try{var P=Te.lex(g,m);if(m.walkTokens){if(m.async)return Promise.all(K.walkTokens(P,m.walkTokens)).then(function(){return le.parse(P,m)}).catch(z);K.walkTokens(P,m.walkTokens)}return le.parse(P,m)}catch(U){z(U)}}K.options=K.setOptions=function(g){return N(K.defaults,g),A(K.defaults),K},K.getDefaults=E,K.defaults=ie.defaults,K.use=function(){for(var g=arguments.length,m=new Array(g),i=0;i<g;i++)m[i]=arguments[i];var n=N.apply(void 0,[{}].concat(m)),l=K.defaults.extensions||{renderers:{},childTokens:{}},D;m.forEach(function(S){if(S.extensions&&(D=!0,S.extensions.forEach(function(P){if(!P.name)throw new Error("extension name required");if(P.renderer){var U=l.renderers?l.renderers[P.name]:null;U?l.renderers[P.name]=function(){for(var G=arguments.length,ne=new Array(G),he=0;he<G;he++)ne[he]=arguments[he];var ve=P.renderer.apply(this,ne);return ve===!1&&(ve=U.apply(this,ne)),ve}:l.renderers[P.name]=P.renderer}if(P.tokenizer){if(!P.level||P.level!=="block"&&P.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");l[P.level]?l[P.level].unshift(P.tokenizer):l[P.level]=[P.tokenizer],P.start&&(P.level==="block"?l.startBlock?l.startBlock.push(P.start):l.startBlock=[P.start]:P.level==="inline"&&(l.startInline?l.startInline.push(P.start):l.startInline=[P.start]))}P.childTokens&&(l.childTokens[P.name]=P.childTokens)})),S.renderer&&function(){var P=K.defaults.renderer||new Me,U=function(he){var ve=P[he];P[he]=function(){for(var $e=arguments.length,ue=new Array($e),Fe=0;Fe<$e;Fe++)ue[Fe]=arguments[Fe];var ye=S.renderer[he].apply(P,ue);return ye===!1&&(ye=ve.apply(P,ue)),ye}};for(var G in S.renderer)U(G);n.renderer=P}(),S.tokenizer&&function(){var P=K.defaults.tokenizer||new de,U=function(he){var ve=P[he];P[he]=function(){for(var $e=arguments.length,ue=new Array($e),Fe=0;Fe<$e;Fe++)ue[Fe]=arguments[Fe];var ye=S.tokenizer[he].apply(P,ue);return ye===!1&&(ye=ve.apply(P,ue)),ye}};for(var G in S.tokenizer)U(G);n.tokenizer=P}(),S.walkTokens){var z=K.defaults.walkTokens;n.walkTokens=function(P){var U=[];return U.push(S.walkTokens.call(this,P)),z&&(U=U.concat(z.call(this,P))),U}}D&&(n.extensions=l),K.setOptions(n)})},K.walkTokens=function(g,m){for(var i=[],n=function(){var z=D.value;switch(i=i.concat(m.call(K,z)),z.type){case"table":{for(var P=j(z.header),U;!(U=P()).done;){var G=U.value;i=i.concat(K.walkTokens(G.tokens,m))}for(var ne=j(z.rows),he;!(he=ne()).done;)for(var ve=he.value,$e=j(ve),ue;!(ue=$e()).done;){var Fe=ue.value;i=i.concat(K.walkTokens(Fe.tokens,m))}break}case"list":{i=i.concat(K.walkTokens(z.items,m));break}default:K.defaults.extensions&&K.defaults.extensions.childTokens&&K.defaults.extensions.childTokens[z.type]?K.defaults.extensions.childTokens[z.type].forEach(function(ye){i=i.concat(K.walkTokens(z[ye],m))}):z.tokens&&(i=i.concat(K.walkTokens(z.tokens,m)))}},l=j(g),D;!(D=l()).done;)n();return i},K.parseInline=function(g,m){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");m=N({},K.defaults,m||{}),L(m);try{var i=Te.lexInline(g,m);return m.walkTokens&&K.walkTokens(i,m.walkTokens),le.parseInline(i,m)}catch(n){if(n.message+=`
Please report this to https://github.com/markedjs/marked.`,m.silent)return"<p>An error occurred:</p><pre>"+e(n.message+"",!0)+"</pre>";throw n}},K.Parser=le,K.parser=le.parse,K.Renderer=Me,K.TextRenderer=re,K.Lexer=Te,K.lexer=Te.lex,K.Tokenizer=de,K.Slugger=J,K.parse=K;var W=K.options,Z=K.setOptions,ce=K.use,we=K.walkTokens,ke=K.parseInline,Ae=K,Le=le.parse,_=Te.lex;ie.Lexer=Te,ie.Parser=le,ie.Renderer=Me,ie.Slugger=J,ie.TextRenderer=re,ie.Tokenizer=de,ie.getDefaults=E,ie.lexer=_,ie.marked=K,ie.options=W,ie.parse=Ae,ie.parseInline=ke,ie.parser=Le,ie.setOptions=Z,ie.use=ce,ie.walkTokens=we,Object.defineProperty(ie,"__esModule",{value:!0})}),define(be[80],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=void 0;function k(r){const d=j(r);if(d&&d.length>0)return new Uint32Array(d)}t.$Pj=k;let C=0;const s=new Uint32Array(10);function j(r){if(C=0,E(r,I,4352),C>0||(E(r,o,4449),C>0)||(E(r,a,4520),C>0)||(E(r,e,12593),C))return s.subarray(0,C);if(r>=44032&&r<=55203){const d=r-44032,$=d%588,u=Math.floor(d/588),p=Math.floor($/28),c=$%28-1;if(u<I.length?E(u,I,0):4352+u-12593<e.length&&E(4352+u,e,12593),p<o.length?E(p,o,0):4449+p-12593<e.length&&E(4449+p-12593,e,12593),c>=0&&(c<a.length?E(c,a,0):4520+c-12593<e.length&&E(4520+c-12593,e,12593)),C>0)return s.subarray(0,C)}}function E(r,d,$){r>=$&&r<$+d.length&&A(d[r-$])}function A(r){r!==0&&(s[C++]=r&255,r>>8&&(s[C++]=r>>8&255),r>>16&&(s[C++]=r>>16&255))}var b;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var y;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(y||(y={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),o=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),a=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QS=void 0;class k{constructor(s,j=0,E=s.length,A=j-1){this.a=s,this.b=j,this.c=E,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$QS=k}),define(be[82],pe([1,0,81]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SS=t.$RS=void 0;class C{constructor(E=[],A=10){this.h(E),this.b=A,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new k.$QS(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const A of E)this.a.add(A)}get j(){const E=[];return this.a.forEach(A=>E.push(A)),E}}t.$RS=C;class s{get size(){return this.f}constructor(E,A=10){if(this.g=A,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let b=1;b<E.length;b++)this.add(E[b])}add(E){const A={value:E,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const A=this.c.value;return this.a.delete(A),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),A}prepend(E){if(this.f===this.g||this.a.has(E))return;const A={value:E,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let A=this.b;for(;A!==this.c;)A.value===E&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$SS=s}),define(be[46],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9l=t.$8l=t.$7l=t.rot=t.$5l=void 0;function k(A,b,w){return Math.min(Math.max(A,b),w)}t.$5l=k;function C(A,b){return(b+A%b)%b}t.rot=C;class s{constructor(){this.a=0}getNext(){return this.a++}}t.$7l=s;class j{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$8l=j;class E{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const w=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$9l=E}),define(be[47],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var k;(function(C){function s(b,w){if(b.start>=w.end||w.start>=b.end)return{start:0,end:0};const y=Math.max(b.start,w.start),I=Math.min(b.end,w.end);return I-y<=0?{start:0,end:0}:{start:y,end:I}}C.intersect=s;function j(b){return b.end-b.start<=0}C.isEmpty=j;function E(b,w){return!j(s(b,w))}C.intersects=E;function A(b,w){const y=[],I={start:b.start,end:Math.min(w.start,b.end)},o={start:Math.max(w.end,b.start),end:b.end};return j(I)||y.push(I),j(o)||y.push(o),y}C.relativeComplement=A})(k||(t.Range=k={}))}),define(be[83],pe([1,0,47]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=t.$zR=t.$yR=t.$xR=void 0;function C(b,w){const y=[];for(const I of w){if(b.start>=I.range.end)continue;if(b.end<I.range.start)break;const o=k.Range.intersect(b,I.range);k.Range.isEmpty(o)||y.push({range:o,size:I.size})}return y}t.$xR=C;function s({start:b,end:w},y){return{start:b+y,end:w+y}}t.$yR=s;function j(b){const w=[];let y=null;for(const I of b){const o=I.range.start,a=I.range.end,e=I.size;if(y&&e===y.size){y.range.end=a;continue}y={range:{start:o,end:a},size:e},w.push(y)}return w}t.$zR=j;function E(...b){return j(b.reduce((w,y)=>w.concat(y),[]))}class A{get paddingTop(){return this.c}set paddingTop(w){this.b=this.b+w-this.c,this.c=w}constructor(w){this.a=[],this.b=0,this.c=0,this.c=w??0,this.b=this.c}splice(w,y,I=[]){const o=I.length-y,a=C({start:0,end:w},this.a),e=C({start:w+y,end:Number.POSITIVE_INFINITY},this.a).map(d=>({range:s(d.range,o),size:d.size})),r=I.map((d,$)=>({range:{start:w+$,end:w+$+1},size:d.size}));this.a=E(a,r,e),this.b=this.c+this.a.reduce((d,$)=>d+$.size*($.range.end-$.range.start),0)}get count(){const w=this.a.length;return w?this.a[w-1].range.end:0}get size(){return this.b}indexAt(w){if(w<0)return-1;if(w<this.c)return 0;let y=0,I=this.c;for(const o of this.a){const a=o.range.end-o.range.start,e=I+a*o.size;if(w<e)return y+Math.floor((w-I)/o.size);y+=a,I=e}return y}indexAfter(w){return Math.min(this.indexAt(w)+1,this.count)}positionAt(w){if(w<0)return-1;let y=0,I=0;for(const o of this.a){const a=o.range.end-o.range.start,e=I+a;if(w<e)return this.c+y+(w-I)*o.size;y+=a*o.size,I=e}return-1}}t.$AR=A}),define(be[84],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pd=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(j){return new C(j)}constructor(j){this.c=k&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Pd=C}),define(be[4],pe([1,0,6,43,2,45,84]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.Event=void 0;const A=!1,b=!1;var w;(function(H){H.None=()=>s.$Tc.None;function T(l){if(b){const{onDidAddListener:D}=l,S=e.create();let z=0;l.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),S.print()),D?.()}}}function L(l,D){return Me(l,()=>{},0,void 0,!0,void 0,D)}H.defer=L;function B(l){return(D,S=null,z)=>{let P=!1,U;return U=l(G=>{if(!P)return U?U.dispose():P=!0,D.call(S,G)},null,z),P&&U.dispose(),U}}H.once=B;function X(l,D,S){return Pe((z,P=null,U)=>l(G=>z.call(P,D(G)),null,U),S)}H.map=X;function Y(l,D,S){return Pe((z,P=null,U)=>l(G=>{D(G),z.call(P,G)},null,U),S)}H.forEach=Y;function de(l,D,S){return Pe((z,P=null,U)=>l(G=>D(G)&&z.call(P,G),null,U),S)}H.filter=de;function oe(l){return l}H.signal=oe;function ee(...l){return(D,S=null,z)=>{const P=(0,s.$Qc)(...l.map(U=>U(G=>D.call(S,G))));return Te(P,z)}}H.any=ee;function me(l,D,S,z){let P=S;return X(l,U=>(P=D(P,U),P),z)}H.reduce=me;function Pe(l,D){let S;const z={onWillAddFirstListener(){S=l(P.fire,P)},onDidRemoveLastListener(){S?.dispose()}};D||T(z);const P=new p(z);return D?.add(P),P.event}function Te(l,D){return D instanceof Array?D.push(l):D&&D.add(l),l}function Me(l,D,S=100,z=!1,P=!1,U,G){let ne,he,ve,$e=0,ue;const Fe={leakWarningThreshold:U,onWillAddFirstListener(){ne=l(Oe=>{$e++,he=D(he,Oe),z&&!ve&&(ye.fire(he),he=void 0),ue=()=>{const Be=he;he=void 0,ve=void 0,(!z||$e>1)&&ye.fire(Be),$e=0},typeof S=="number"?(clearTimeout(ve),ve=setTimeout(ue,S)):ve===void 0&&(ve=0,queueMicrotask(ue))})},onWillRemoveListener(){P&&$e>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,ne.dispose()}};G||T(Fe);const ye=new p(Fe);return G?.add(ye),ye.event}H.debounce=Me;function re(l,D=0,S){return H.debounce(l,(z,P)=>z?(z.push(P),z):[P],D,void 0,!0,void 0,S)}H.accumulate=re;function J(l,D=(z,P)=>z===P,S){let z=!0,P;return de(l,U=>{const G=z||!D(U,P);return z=!1,P=U,G},S)}H.latch=J;function le(l,D,S){return[H.filter(l,D,S),H.filter(l,z=>!D(z),S)]}H.split=le;function K(l,D=!1,S=[],z){let P=S.slice(),U=l(he=>{P?P.push(he):ne.fire(he)});z&&z.add(U);const G=()=>{P?.forEach(he=>ne.fire(he)),P=null},ne=new p({onWillAddFirstListener(){U||(U=l(he=>ne.fire(he)),z&&z.add(U))},onDidAddFirstListener(){P&&(D?setTimeout(G):G())},onDidRemoveLastListener(){U&&U.dispose(),U=null}});return z&&z.add(ne),ne.event}H.buffer=K;function W(l,D){return(z,P,U)=>{const G=D(new ce);return l(function(ne){const he=G.evaluate(ne);he!==Z&&z.call(P,he)},void 0,U)}}H.chain=W;const Z=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(D){return this.f.push(D),this}forEach(D){return this.f.push(S=>(D(S),S)),this}filter(D){return this.f.push(S=>D(S)?S:Z),this}reduce(D,S){let z=S;return this.f.push(P=>(z=D(z,P),z)),this}latch(D=(S,z)=>S===z){let S=!0,z;return this.f.push(P=>{const U=S||!D(P,z);return S=!1,z=P,U?P:Z}),this}evaluate(D){for(const S of this.f)if(D=S(D),D===Z)break;return D}}function we(l,D,S=z=>z){const z=(...ne)=>G.fire(S(...ne)),P=()=>l.on(D,z),U=()=>l.removeListener(D,z),G=new p({onWillAddFirstListener:P,onDidRemoveLastListener:U});return G.event}H.fromNodeEventEmitter=we;function ke(l,D,S=z=>z){const z=(...ne)=>G.fire(S(...ne)),P=()=>l.addEventListener(D,z),U=()=>l.removeEventListener(D,z),G=new p({onWillAddFirstListener:P,onDidRemoveLastListener:U});return G.event}H.fromDOMEventEmitter=ke;function Ae(l){return new Promise(D=>B(l)(D))}H.toPromise=Ae;function Le(l){const D=new p;return l.then(S=>{D.fire(S)},()=>{D.fire(void 0)}).finally(()=>{D.dispose()}),D.event}H.fromPromise=Le;function _(l,D,S){return D(S),l(z=>D(z))}H.runAndSubscribe=_;function g(l,D){let S=null;function z(U){S?.dispose(),S=new s.$Sc,D(U,S)}z(void 0);const P=l(U=>z(U));return(0,s.$Rc)(()=>{P.dispose(),S?.dispose()})}H.runAndSubscribeWithStore=g;class m{constructor(D,S){this._observable=D,this.f=0,this.g=!1;const z={onWillAddFirstListener:()=>{D.addObserver(this)},onDidRemoveLastListener:()=>{D.removeObserver(this)}};S||T(z),this.emitter=new p(z),S&&S.add(this.emitter)}beginUpdate(D){this.f++}handlePossibleChange(D){}handleChange(D,S){this.g=!0}endUpdate(D){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function i(l,D){return new m(l,D).emitter.event}H.fromObservable=i;function n(l){return(D,S,z)=>{let P=0,U=!1;const G={beginUpdate(){P++},endUpdate(){P--,P===0&&(l.reportChanges(),U&&(U=!1,D.call(S)))},handlePossibleChange(){},handleChange(){U=!0}};l.addObserver(G),l.reportChanges();const ne={dispose(){l.removeObserver(G)}};return z instanceof s.$Sc?z.add(ne):Array.isArray(z)&&z.push(ne),ne}}H.fromObservableLight=n})(w||(t.Event=w={}));class y{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${y.f++}`,y.all.add(this)}start(T){this.g=new E.$Pd,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}t.$Rd=y;let I=-1;function o(H){const T=I;return I=H,{dispose(){I=T}}}t.$Sd=o;class a{constructor(T,L=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=L,this.g=0}dispose(){this.f?.clear()}check(T,L){const B=this.threshold;if(B<=0||L<B)return;this.f||(this.f=new Map);const X=this.f.get(T.value)||0;if(this.f.set(T.value,X+1),this.g-=1,this.g<=0){this.g=B*.5;let Y,de=0;for(const[oe,ee]of this.f)(!Y||de<ee)&&(Y=oe,de=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${de}):`),console.warn(Y)}return()=>{const Y=this.f.get(T.value)||0;this.f.set(T.value,Y-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class d{constructor(T){this.value=T,this.id=r++}}const $=2,u=(H,T)=>{if(H instanceof d)T(H);else for(let L=0;L<H.length;L++){const B=H[L];B&&T(B)}};class p{constructor(T){this.w=0,this.f=T,this.g=I>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(A){const T=this.t;queueMicrotask(()=>{u(T,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,L,B)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;L&&(T=T.bind(L));const X=new d(T);let Y,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),Y=this.g.check(X.stack,this.w+1)),A&&(X.stack=de??e.create()),this.t?this.t instanceof d?(this.u??=new f,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const oe=(0,s.$Rc)(()=>{Y?.(),this.x(X)});return B instanceof s.$Sc?B.add(oe):Array.isArray(B)&&B.push(oe),oe},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,B=L.indexOf(T);if(B===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[B]=void 0;const X=this.u.current===this;if(this.w*$<=L.length){let Y=0;for(let de=0;de<L.length;de++)L[de]?L[Y++]=L[de]:X&&(this.u.end--,Y<this.u.i&&this.u.i--);L.length=Y}}y(T,L){if(!T)return;const B=this.f?.onListenerError||k.$1;if(!B){T.value(L);return}try{T.value(L)}catch(X){B(X)}}z(T){const L=T.current.t;for(;T.i<T.end;)this.y(L[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,T);else{const L=this.u;L.enqueue(this,T,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Td=p;const c=()=>new f;t.$Ud=c;class f{constructor(){this.i=-1,this.end=0}enqueue(T,L,B){this.i=0,this.end=B,this.current=T,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends p{async fireAsync(T,L,B){if(this.t)for(this.h||(this.h=new j.$4c),u(this.t,X=>this.h.push([X.value,T]));this.h.size>0&&!L.isCancellationRequested;){const[X,Y]=this.h.shift(),de=[],oe={...Y,token:L,waitUntil:ee=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");B&&(ee=B(ee,X)),de.push(ee)}};try{X(oe)}catch(ee){(0,k.$1)(ee);continue}Object.freeze(de),await Promise.allSettled(de).then(ee=>{for(const me of ee)me.status==="rejected"&&(0,k.$1)(me.reason)})}}}t.$Vd=h;class F extends p{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new j.$4c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}t.$Wd=F;class M extends F{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}t.$Xd=M;class R extends p{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}t.$Yd=R;class O{constructor(){this.g=!1,this.h=[],this.f=new p({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const L={event:T,listener:null};this.h.push(L),this.g&&this.m(L);const B=()=>{this.g&&this.o(L);const X=this.h.indexOf(L);this.h.splice(X,1)};return(0,s.$Rc)((0,C.$db)(B))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(L=>this.f.fire(L))}o(T){T.listener&&T.listener.dispose(),T.listener=null}dispose(){this.f.dispose()}}t.$Zd=O;class v{constructor(T,L,B,X){this.f=new s.$Sc;const Y=this.f.add(new O),de=this.f.add(new s.$3c);function oe(ee){de.set(ee,Y.add(X(ee)))}for(const ee of T)oe(ee);this.f.add(L(ee=>{oe(ee)})),this.f.add(B(ee=>{de.deleteAndDispose(ee)})),this.event=Y.event}dispose(){this.f.dispose()}}t.$1d=v;class N{constructor(){this.f=[]}wrapEvent(T){return(L,B,X)=>T(Y=>{const de=this.f[this.f.length-1];de?de.push(()=>L.call(B,Y)):L.call(B,Y)},void 0,X)}bufferEvents(T){const L=[];this.f.push(L);const B=T();return this.f.pop(),L.forEach(X=>X()),B}}t.$2d=N;class V{constructor(){this.f=!1,this.g=w.None,this.h=s.$Tc.None,this.j=new p({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$3d=V}),define(be[16],pe([1,0,21,4,2]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=void 0;class j{constructor(){this.a=new Map,this.b=new C.$Td,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$Td,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new j}getZoomLevel(f){return this.a.get(this.f(f))??0}setZoomLevel(f,h){if(this.getZoomLevel(h)===f)return;const F=this.f(h);this.a.set(F,f),this.b.fire(F)}getZoomFactor(f){return this.c.get(this.f(f))??1}setZoomFactor(f,h){this.c.set(this.f(h),f)}setFullscreen(f,h){if(this.isFullscreen(h)===f)return;const F=this.f(h);this.e.set(F,f),this.d.fire(F)}isFullscreen(f){return!!this.e.get(this.f(f))}f(f){return f.vscodeWindowId}}class E extends s.$Tc{constructor(){super(),this.a=this.B(new C.$Td),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(f){this.c?.removeEventListener("change",this.b),this.c=k.$window.matchMedia(`(resolution: ${k.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),f&&this.a.fire()}}class A extends s.$Tc{get value(){return this.b}constructor(){super(),this.a=this.B(new C.$Td),this.onDidChange=this.a.event,this.b=this.c();const f=this.B(new E);this.B(f.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const f=document.createElement("canvas").getContext("2d"),h=k.$window.devicePixelRatio||1,F=f.webkitBackingStorePixelRatio||f.mozBackingStorePixelRatio||f.msBackingStorePixelRatio||f.oBackingStorePixelRatio||f.backingStorePixelRatio||1;return h/F}}class b{constructor(){this.a=null}b(){return this.a||(this.a=(0,s.$Mc)(new A)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function w(c,f,h){typeof f=="string"&&(f=c.matchMedia(f)),f.addEventListener("change",h)}t.$ZO=w,t.$1O=new b;function y(c,f){j.INSTANCE.setZoomLevel(c,f)}t.$2O=y;function I(c){return j.INSTANCE.getZoomLevel(c)}t.$3O=I,t.$4O=j.INSTANCE.onDidChangeZoomLevel;function o(c){return j.INSTANCE.getZoomFactor(c)}t.$5O=o;function a(c,f){j.INSTANCE.setZoomFactor(c,f)}t.$6O=a;function e(c,f){j.INSTANCE.setFullscreen(c,f)}t.$7O=e;function r(c){return j.INSTANCE.isFullscreen(c)}t.$8O=r,t.$9O=j.INSTANCE.onDidChangeFullscreen;const d=navigator.userAgent;t.$0O=d.indexOf("Firefox")>=0,t.$$O=d.indexOf("AppleWebKit")>=0,t.$_O=d.indexOf("Chrome")>=0,t.$aP=!t.$_O&&d.indexOf("Safari")>=0,t.$bP=!t.$_O&&!t.$aP&&t.$$O,t.$cP=d.indexOf("Electron/")>=0,t.$dP=d.indexOf("Android")>=0;let $=!1;if(typeof k.$VO.matchMedia=="function"){const c=k.$VO.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),f=k.$VO.matchMedia("(display-mode: fullscreen)");$=c.matches,w(k.$VO,c,({matches:h})=>{$&&f.matches||($=h)})}function u(){return $}t.$eP=u;function p(){return navigator?.windowControlsOverlay?.visible}t.$fP=p}),define(be[22],pe([1,0,4]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sR=void 0;class C{get event(){return this.a.event}constructor(j,E,A){const b=w=>this.a.fire(w);this.a=new k.$Td({onWillAddFirstListener:()=>j.addEventListener(E,b,A),onDidRemoveLastListener:()=>j.removeEventListener(E,b,A)})}dispose(){this.a.dispose()}}t.$sR=C}),define(be[29],pe([1,0,4]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=t.CancellationToken=void 0;const C=Object.freeze(function(A,b){const w=setTimeout(A.bind(b),0);return{dispose(){clearTimeout(w)}}});var s;(function(A){function b(w){return w===A.None||w===A.Cancelled||w instanceof j?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}A.isCancellationToken=b,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(s||(t.CancellationToken=s={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new k.$Td),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=s.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=s.None}}t.$4d=E}),define(be[85],pe([1,0,29]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ee=t.$De=t.$Ce=void 0;class C{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new k.$4d,b=this.b(A.token);return this.a={promise:b,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$Ce=C;class s{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const b=JSON.stringify(A);return this.b!==b&&(this.b=b,this.a=this.c(A)),this.a}}t.$De=s;class j{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const b=this.b(A);return this.a.set(A,b),b}}t.$Ee=j}),define(be[48],pe([1,0,4,2]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cs=t.$bs=t.$as=t.$_r=t.ScrollbarVisibility=void 0;var s;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(s||(t.ScrollbarVisibility=s={}));class j{constructor(e,r,d,$,u,p,c){this.c=e,this._scrollStateBrand=void 0,this.c&&(r=r|0,d=d|0,$=$|0,u=u|0,p=p|0,c=c|0),this.rawScrollLeft=$,this.rawScrollTop=c,r<0&&(r=0),$+r>d&&($=d-r),$<0&&($=0),u<0&&(u=0),c+u>p&&(c=p-u),c<0&&(c=0),this.width=r,this.scrollWidth=d,this.scrollLeft=$,this.height=u,this.scrollHeight=p,this.scrollTop=c}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,r){return new j(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new j(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,r){const d=this.width!==e.width,$=this.scrollWidth!==e.scrollWidth,u=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,c=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:r,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:d,scrollWidthChanged:$,scrollLeftChanged:u,heightChanged:p,scrollHeightChanged:c,scrollTopChanged:f}}}t.$_r=j;class E extends C.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new k.$Td),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new j(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,r){const d=this.g.withScrollDimensions(e,r);this.n(d,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const r=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(e,r){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const d=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===d.scrollLeft&&this.h.to.scrollTop===d.scrollTop)return;let $;r?$=new y(this.h.from,d,this.h.startTime,this.h.duration):$=this.h.combine(this.g,d,this.c),this.h.dispose(),this.h=$}else{const d=this.g.withScrollPosition(e);this.h=y.start(this.g,d,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),r=this.g.withScrollPosition(e);if(this.n(r,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,r){const d=this.g;d.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(d,r)))}}t.$as=E;class A{constructor(e,r,d){this.scrollLeft=e,this.scrollTop=r,this.isDone=d}}t.$bs=A;function b(a,e){const r=e-a;return function(d){return a+r*o(d)}}function w(a,e,r){return function(d){return d<r?a(d/r):e((d-r)/(1-r))}}class y{constructor(e,r,d,$){this.from=e,this.to=r,this.duration=$,this.startTime=d,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,r,d){if(Math.abs(e-r)>2.5*d){let u,p;return e<r?(u=e+.75*d,p=r-.75*d):(u=e-.75*d,p=r+.75*d),w(b(e,u),b(p,r),.33)}return b(e,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const r=(e-this.startTime)/this.duration;if(r<1){const d=this.c(r),$=this.d(r);return new A(d,$,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,r,d){return y.start(e,r,d)}static start(e,r,d){d=d+10;const $=Date.now()-10;return new y(e,r,$,d)}}t.$cs=y;function I(a){return Math.pow(a,3)}function o(a){return 1-I(1-a)}}),define(be[86],pe([1,0,6,2]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=void 0;function s(c){const f=c;return f?typeof f.read=="function":!1}t.$5d=s;function j(c){const f=c;return f?[f.on,f.pause,f.resume,f.destroy].every(h=>typeof h=="function"):!1}t.$6d=j;function E(c){const f=c;return f?j(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}t.$7d=E;function A(c,f){return new b(c,f)}t.$8d=A;class b{constructor(f,h){this.e=f,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(h=>h(f))}h(f){this.c.error.length===0?(0,k.$1)(f):this.c.error.slice(0).forEach(h=>h(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,h){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(f,h){if(this.a.destroyed)return;let F;switch(f){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const M=F.indexOf(h);M>=0&&F.splice(M,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,f){const h=[];let F;for(;(F=c.read())!==null;)h.push(F);return f(h)}t.$9d=w;function y(c,f,h){const F=[];let M;for(;(M=c.read())!==null&&F.length<h;)F.push(M);return M===null&&F.length>0?f(F):{read:()=>{if(F.length>0)return F.shift();if(typeof M<"u"){const R=M;return M=void 0,R}return c.read()}}}t.$0d=y;function I(c,f){return new Promise((h,F)=>{const M=[];o(c,{onData:R=>{f&&M.push(R)},onError:R=>{f?F(R):h(void 0)},onEnd:()=>{h(f?f(M):void 0)}})})}t.$$d=I;function o(c,f,h){c.on("error",F=>{h?.isCancellationRequested||f.onError(F)}),c.on("end",()=>{h?.isCancellationRequested||f.onEnd()}),c.on("data",F=>{h?.isCancellationRequested||f.onData(F)})}t.$_d=o;function a(c,f){return new Promise((h,F)=>{const M=new C.$Sc,R=[],O=V=>{if(R.push(V),R.length>f)return M.dispose(),c.pause(),h({stream:c,buffer:R,ended:!1})},v=V=>(M.dispose(),F(V)),N=()=>(M.dispose(),h({stream:c,buffer:R,ended:!0}));M.add((0,C.$Rc)(()=>c.removeListener("error",v))),c.on("error",v),M.add((0,C.$Rc)(()=>c.removeListener("end",N))),c.on("end",N),M.add((0,C.$Rc)(()=>c.removeListener("data",O))),c.on("data",O)})}t.$ae=a;function e(c,f){const h=A(f);return h.end(c),h}t.$be=e;function r(){const c=A(()=>{throw new Error("not supported")});return c.end(),c}t.$ce=r;function d(c){let f=!1;return{read:()=>f?null:(f=!0,c)}}t.$de=d;function $(c,f,h){const F=A(h);return o(c,{onData:M=>F.write(f.data(M)),onError:M=>F.error(f.error?f.error(M):M),onEnd:()=>F.end()}),F}t.$ee=$;function u(c,f,h){let F=!1;return{read:()=>{const M=f.read();return F?M:(F=!0,M!==null?h([c,M]):c)}}}t.$fe=u;function p(c,f,h){let F=!1;const M=A(h);return o(f,{onData:R=>F?M.write(R):(F=!0,M.write(h([c,R]))),onError:R=>M.error(R),onEnd:()=>{F||(F=!0,M.write(c)),M.end()}}),M}t.$ge=p}),define(be[33],pe([1,0,23,86]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=void 0;const s=typeof Buffer<"u",j=new k.$V(()=>new Uint8Array(256));let E,A;class b{static alloc(L){return s?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return s&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,B){return!(B?.dontUseNodeBuffer||!1)&&s?new b(Buffer.from(L)):(E||(E=new TextEncoder),new b(E.encode(L)))}static fromByteArray(L){const B=b.alloc(L.length);for(let X=0,Y=L.length;X<Y;X++)B.buffer[X]=L[X];return B}static concat(L,B){if(typeof B>"u"){B=0;for(let de=0,oe=L.length;de<oe;de++)B+=L[de].byteLength}const X=b.alloc(B);let Y=0;for(let de=0,oe=L.length;de<oe;de++){const ee=L[de];X.set(ee,Y),Y+=ee.byteLength}return X}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return s?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(L,B){return new b(this.buffer.subarray(L,B))}set(L,B){if(L instanceof b)this.buffer.set(L.buffer,B);else if(L instanceof Uint8Array)this.buffer.set(L,B);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),B);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return o(this.buffer,L)}writeUInt32BE(L,B){a(this.buffer,L,B)}readUInt32LE(L){return e(this.buffer,L)}writeUInt32LE(L,B){r(this.buffer,L,B)}readUInt8(L){return d(this.buffer,L)}writeUInt8(L,B){$(this.buffer,L,B)}indexOf(L,B=0){return w(this.buffer,L instanceof b?L.buffer:L,B)}}t.$he=b;function w(T,L,B=0){const X=L.byteLength,Y=T.byteLength;if(X===0)return 0;if(X===1)return T.indexOf(L[0]);if(X>Y-B)return-1;const de=j.value;de.fill(L.length);for(let Pe=0;Pe<L.length;Pe++)de[L[Pe]]=L.length-Pe-1;let oe=B+L.length-1,ee=oe,me=-1;for(;oe<Y;)if(T[oe]===L[ee]){if(ee===0){me=oe;break}oe--,ee--}else oe+=Math.max(L.length-ee,de[T[oe]]),ee=L.length-1;return me}t.$ie=w;function y(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}t.$je=y;function I(T,L,B){T[B+0]=L&255,L=L>>>8,T[B+1]=L&255}t.$ke=I;function o(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}t.$le=o;function a(T,L,B){T[B+3]=L,L=L>>>8,T[B+2]=L,L=L>>>8,T[B+1]=L,L=L>>>8,T[B]=L}t.$me=a;function e(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}t.$ne=e;function r(T,L,B){T[B+0]=L&255,L=L>>>8,T[B+1]=L&255,L=L>>>8,T[B+2]=L&255,L=L>>>8,T[B+3]=L&255}t.$oe=r;function d(T,L){return T[L]}t.$pe=d;function $(T,L,B){T[B]=L}t.$qe=$;function u(T){return C.$9d(T,L=>b.concat(L))}t.$re=u;function p(T){return C.$de(T)}t.$se=p;function c(T){return C.$$d(T,L=>b.concat(L))}t.$te=c;async function f(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await c(T.stream)])}t.$ue=f;function h(T){return C.$be(T,L=>b.concat(L))}t.$ve=h;function F(T){return C.$ee(T,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}t.$we=F;function M(T){return C.$8d(L=>b.concat(L),T)}t.$xe=M;function R(T,L){return C.$fe(T,L,B=>b.concat(B))}t.$ye=R;function O(T,L){return C.$ge(T,L,B=>b.concat(B))}t.$ze=O;function v(T){let L=0,B=0,X=0;const Y=new Uint8Array(Math.floor(T.length/4*3)),de=ee=>{switch(B){case 3:Y[X++]=L|ee,B=0;break;case 2:Y[X++]=L|ee>>>2,L=ee<<6,B=3;break;case 1:Y[X++]=L|ee>>>4,L=ee<<4,B=2;break;default:L=ee<<2,B=1}};for(let ee=0;ee<T.length;ee++){const me=T.charCodeAt(ee);if(me>=65&&me<=90)de(me-65);else if(me>=97&&me<=122)de(me-97+26);else if(me>=48&&me<=57)de(me-48+52);else if(me===43||me===45)de(62);else if(me===47||me===95)de(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ee]}`)}}const oe=X;for(;B>0;)de(0);return b.wrap(Y).slice(0,oe)}t.$Ae=v;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",V="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function H({buffer:T},L=!0,B=!1){const X=B?V:N;let Y="";const de=T.byteLength%3;let oe=0;for(;oe<T.byteLength-de;oe+=3){const ee=T[oe+0],me=T[oe+1],Pe=T[oe+2];Y+=X[ee>>>2],Y+=X[(ee<<4|me>>>4)&63],Y+=X[(me<<2|Pe>>>6)&63],Y+=X[Pe&63]}if(de===1){const ee=T[oe+0];Y+=X[ee>>>2],Y+=X[ee<<4&63],L&&(Y+="==")}else if(de===2){const ee=T[oe+0],me=T[oe+1];Y+=X[ee>>>2],Y+=X[(ee<<4|me>>>4)&63],Y+=X[me<<2&63],L&&(Y+="=")}return Y}t.$Be=H}),define(be[10],pe([1,0,85,23]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ff=t.$Ef=t.$Df=t.$Cf=t.GraphemeBreakType=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=void 0;function s(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$He=s;const j=/{(\d+)}/g;function E(x,...se){return se.length===0?x:x.replace(j,function(ge,Ee){const Ne=parseInt(Ee,10);return isNaN(Ne)||Ne<0||Ne>=se.length?ge:se[Ne]})}t.$Ie=E;const A=/{([^}]+)}/g;function b(x,se){return Object.keys(se).length===0?x:x.replace(A,(ge,Ee)=>se[Ee]??ge)}t.$Je=b;function w(x){return x.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}t.$Ke=w;function y(x){return x.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}t.$Le=y;function I(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Me=I;function o(x,se){let ge=0;const Ee=se.charCodeAt(0);for(let Ne=x.length-1;Ne>=0;Ne--)x.charCodeAt(Ne)===Ee&&ge++;return ge}t.$Ne=o;function a(x,se,ge="\u2026"){return x.length<=se?x:`${x.substr(0,se)}${ge}`}t.$Oe=a;function e(x,se,ge="\u2026"){if(x.length<=se)return x;const Ee=Math.ceil(se/2)-ge.length/2,Ne=Math.floor(se/2)-ge.length/2;return`${x.substr(0,Ee)}${ge}${x.substr(x.length-Ne)}`}t.$Pe=e;function r(x,se=" "){const ge=d(x,se);return $(ge,se)}t.$Qe=r;function d(x,se){if(!x||!se)return x;const ge=se.length;if(ge===0||x.length===0)return x;let Ee=0;for(;x.indexOf(se,Ee)===Ee;)Ee=Ee+ge;return x.substring(Ee)}t.$Re=d;function $(x,se){if(!x||!se)return x;const ge=se.length,Ee=x.length;if(ge===0||Ee===0)return x;let Ne=Ee,je=-1;for(;je=x.lastIndexOf(se,Ne-1),!(je===-1||je+ge!==Ne);){if(je===0)return"";Ne=je}return x.substring(0,Ne)}t.$Se=$;function u(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Te=u;function p(x){return x.replace(/\*/g,"")}t.$Ue=p;function c(x,se,ge={}){if(!x)throw new Error("Cannot create regex from empty string");se||(x=I(x)),ge.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ee="";return ge.global&&(Ee+="g"),ge.matchCase||(Ee+="i"),ge.multiline&&(Ee+="m"),ge.unicode&&(Ee+="u"),new RegExp(x,Ee)}t.$Ve=c;function f(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$We=f;function h(x){return x.split(/\r\n|\r|\n/)}t.$Xe=h;function F(x){for(let se=0,ge=x.length;se<ge;se++){const Ee=x.charCodeAt(se);if(Ee!==32&&Ee!==9)return se}return-1}t.$Ye=F;function M(x,se=0,ge=x.length){for(let Ee=se;Ee<ge;Ee++){const Ne=x.charCodeAt(Ee);if(Ne!==32&&Ne!==9)return x.substring(se,Ee)}return x.substring(se,ge)}t.$Ze=M;function R(x,se=x.length-1){for(let ge=se;ge>=0;ge--){const Ee=x.charCodeAt(ge);if(Ee!==32&&Ee!==9)return ge}return-1}t.$1e=R;function O(x,se,ge){const Ee=[];let Ne=0;for(const je of x.matchAll(se)){if(Ee.push(x.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Ee.push(ge(je[0],...je.slice(1),je.index,x,je.groups))}return Ee.push(x.slice(Ne)),Promise.all(Ee).then(je=>je.join(""))}t.$2e=O;function v(x,se){return x<se?-1:x>se?1:0}t.$3e=v;function N(x,se,ge=0,Ee=x.length,Ne=0,je=se.length){for(;ge<Ee&&Ne<je;ge++,Ne++){const Ze=x.charCodeAt(ge),tt=se.charCodeAt(Ne);if(Ze<tt)return-1;if(Ze>tt)return 1}const Ve=Ee-ge,_e=je-Ne;return Ve<_e?-1:Ve>_e?1:0}t.$4e=N;function V(x,se){return H(x,se,0,x.length,0,se.length)}t.$5e=V;function H(x,se,ge=0,Ee=x.length,Ne=0,je=se.length){for(;ge<Ee&&Ne<je;ge++,Ne++){let Ze=x.charCodeAt(ge),tt=se.charCodeAt(Ne);if(Ze===tt)continue;if(Ze>=128||tt>=128)return N(x.toLowerCase(),se.toLowerCase(),ge,Ee,Ne,je);L(Ze)&&(Ze-=32),L(tt)&&(tt-=32);const Ye=Ze-tt;if(Ye!==0)return Ye}const Ve=Ee-ge,_e=je-Ne;return Ve<_e?-1:Ve>_e?1:0}t.$6e=H;function T(x){return x>=48&&x<=57}t.$7e=T;function L(x){return x>=97&&x<=122}t.$8e=L;function B(x){return x>=65&&x<=90}t.$9e=B;function X(x,se){return x.length===se.length&&H(x,se)===0}t.$0e=X;function Y(x,se){const ge=se.length;return se.length>x.length?!1:H(x,se,0,ge)===0}t.$$e=Y;function de(x,se){const ge=Math.min(x.length,se.length);let Ee;for(Ee=0;Ee<ge;Ee++)if(x.charCodeAt(Ee)!==se.charCodeAt(Ee))return Ee;return ge}t.$_e=de;function oe(x,se){const ge=Math.min(x.length,se.length);let Ee;const Ne=x.length-1,je=se.length-1;for(Ee=0;Ee<ge;Ee++)if(x.charCodeAt(Ne-Ee)!==se.charCodeAt(je-Ee))return Ee;return ge}t.$af=oe;function ee(x){return 55296<=x&&x<=56319}t.$bf=ee;function me(x){return 56320<=x&&x<=57343}t.$cf=me;function Pe(x,se){return(x-55296<<10)+(se-56320)+65536}t.$df=Pe;function Te(x,se,ge){const Ee=x.charCodeAt(ge);if(ee(Ee)&&ge+1<se){const Ne=x.charCodeAt(ge+1);if(me(Ne))return Pe(Ee,Ne)}return Ee}t.$ef=Te;function Me(x,se){const ge=x.charCodeAt(se-1);if(me(ge)&&se>1){const Ee=x.charCodeAt(se-2);if(ee(Ee))return Pe(Ee,ge)}return ge}class re{get offset(){return this.e}constructor(se,ge=0){this.c=se,this.d=se.length,this.e=ge}setOffset(se){this.e=se}prevCodePoint(){const se=Me(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=Te(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}t.$ff=re;class J{get offset(){return this.c.offset}constructor(se,ge=0){this.c=new re(se,ge)}nextGraphemeLength(){const se=Fe.getInstance(),ge=this.c,Ee=ge.offset;let Ne=se.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const je=ge.offset,Ve=se.getGraphemeBreakType(ge.nextCodePoint());if($e(Ne,Ve)){ge.setOffset(je);break}Ne=Ve}return ge.offset-Ee}prevGraphemeLength(){const se=Fe.getInstance(),ge=this.c,Ee=ge.offset;let Ne=se.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const je=ge.offset,Ve=se.getGraphemeBreakType(ge.prevCodePoint());if($e(Ve,Ne)){ge.setOffset(je);break}Ne=Ve}return Ee-ge.offset}eol(){return this.c.eol()}}t.$gf=J;function le(x,se){return new J(x,se).nextGraphemeLength()}t.$hf=le;function K(x,se){return new J(x,se).prevGraphemeLength()}t.$if=K;function W(x,se){se>0&&me(x.charCodeAt(se))&&se--;const ge=se+le(x,se);return[ge-K(x,ge),ge]}t.$jf=W;function Z(x){const se=new J(x);let ge=0;for(;!se.eol();)ge++,se.nextGraphemeLength();return ge}t.$kf=Z;let ce;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(x){return ce||(ce=we()),ce.test(x)}t.$lf=ke;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Le(x){return Ae.test(x)}t.$mf=Le,t.$nf=/[\u2028\u2029]/;function _(x){return t.$nf.test(x)}t.$of=_;function g(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$pf=g;function m(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$qf=m;function i(x,se,ge=""){const Ee=x.trimStart();if(Ee.length<se)return Ee;const Ne=/\b/g;let je=0;for(;Ne.test(Ee)&&!(Ee.length-Ne.lastIndex<se);)je=Ne.lastIndex,Ne.lastIndex+=1;return je===0?Ee:ge+Ee.substring(je).trimStart()}t.$rf=i;const n=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,l=/\x1b\].*?\x07/g;function D(x){return x&&(x=x.replace(n,"").replace(l,"")),x}t.$sf=D,t.$tf=String.fromCharCode(65279);function S(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$uf=S;function z(x){return S(x)?x.substr(1):x}t.$vf=z;function P(x,se){if(!x||!se||x.length<se.length)return!1;const ge=se.length,Ee=x.toLowerCase();let Ne=0,je=-1;for(;Ne<ge;){const Ve=Ee.indexOf(se[Ne],je+1);if(Ve<0)return!1;je=Ve,Ne++}return!0}t.$wf=P;function U(x,se=!1){return x?(se&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$xf=U;function G(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$yf=G;function ne(x,se=1){if(se===0)return"";let ge=-1;do ge=x.indexOf(`
`,ge+1),se--;while(se>0&&ge>=0);return ge===-1?x:(x[ge-1]==="\r"&&ge--,x.substr(0,ge))}t.$zf=ne;function he(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$Af=he;function ve(x){return Fe.getInstance().getGraphemeBreakType(x)}t.$Bf=ve;function $e(x,se){return x===0?se!==5&&se!==7:x===2&&se===3?!1:x===4||x===2||x===3||se===4||se===2||se===3?!0:!(x===8&&(se===8||se===9||se===11||se===12)||(x===11||x===9)&&(se===9||se===10)||(x===12||x===10)&&se===10||se===5||se===13||se===7||x===1||x===13&&se===14||x===6&&se===6)}var ue;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(ue||(t.GraphemeBreakType=ue={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=ye()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ge=this.d,Ee=ge.length/3;let Ne=1;for(;Ne<=Ee;)if(se<ge[3*Ne])Ne=2*Ne;else if(se>ge[3*Ne+1])Ne=2*Ne+1;else return ge[3*Ne+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(x,se){if(x===0)return 0;const ge=Be(x,se);if(ge!==void 0)return ge;const Ee=new re(se,x);return Ee.prevCodePoint(),Ee.offset}t.$Cf=Oe;function Be(x,se){const ge=new re(se,x);let Ee=ge.prevCodePoint();for(;Ie(Ee)||Ee===65039||Ee===8419;){if(ge.offset===0)return;Ee=ge.prevCodePoint()}if(!m(Ee))return;let Ne=ge.offset;return Ne>0&&ge.prevCodePoint()===8205&&(Ne=ge.offset),Ne}function Ie(x){return 127995<=x&&x<=127999}var Je;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),t.$Df="\xA0";class et{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$De(se=>{function ge(Ye){const nt=new Map;for(let st=0;st<Ye.length;st+=2)nt.set(Ye[st],Ye[st+1]);return nt}function Ee(Ye,nt){const st=new Map(Ye);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ne(Ye,nt){if(!Ye)return nt;const st=new Map;for(const[rt,gt]of Ye)nt.has(rt)&&st.set(rt,gt);return st}const je=this.c.value;let Ve=se.filter(Ye=>!Ye.startsWith("_")&&Ye in je);Ve.length===0&&(Ve=["_default"]);let _e;for(const Ye of Ve){const nt=ge(je[Ye]);_e=Ne(_e,nt)}const Ze=ge(je._common),tt=Ee(Ze,_e);return new et(tt)})}static getInstance(se){return et.d.get(Array.from(se))}static{this.e=new C.$V(()=>Object.keys(et.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return et.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Ef=et;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(se){return Qe.e().has(se)}static get codePoints(){return Qe.e()}}t.$Ff=Qe}),define(be[34],pe([1,0,32,80,10]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7j=t.$6j=t.$5j=t.$4j=t.FuzzyScore=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.or=void 0;function j(...P){return function(U,G){for(let ne=0,he=P.length;ne<he;ne++){const ve=P[ne](U,G);if(ve)return ve}return null}}t.or=j,t.$Rj=E.bind(void 0,!1),t.$Sj=E.bind(void 0,!0);function E(P,U,G){if(!G||G.length<U.length)return null;let ne;return P?ne=s.$$e(G,U):ne=G.indexOf(U)===0,ne?U.length>0?[{start:0,end:U.length}]:[]:null}function A(P,U){const G=U.toLowerCase().indexOf(P.toLowerCase());return G===-1?null:[{start:G,end:G+P.length}]}t.$Tj=A;function b(P,U){return w(P.toLowerCase(),U.toLowerCase(),0,0)}t.$Uj=b;function w(P,U,G,ne){if(G===P.length)return[];if(ne===U.length)return null;if(P[G]===U[ne]){let he=null;return(he=w(P,U,G+1,ne+1))?c({start:ne,end:ne+1},he):null}return w(P,U,G,ne+1)}function y(P){return 97<=P&&P<=122}function I(P){return 65<=P&&P<=90}t.$Vj=I;function o(P){return 48<=P&&P<=57}function a(P){return P===32||P===9||P===10||P===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(P=>e.add(P.charCodeAt(0)));function r(P){return a(P)||e.has(P)}function d(P,U){return P===U||r(P)&&r(U)}const $=new Map;function u(P){if($.has(P))return $.get(P);let U;const G=(0,C.$Pj)(P);return G&&(U=G),$.set(P,U),U}function p(P){return y(P)||I(P)||o(P)}function c(P,U){return U.length===0?U=[P]:P.end===U[0].start?U[0].start=P.start:U.unshift(P),U}function f(P,U){for(let G=U;G<P.length;G++){const ne=P.charCodeAt(G);if(I(ne)||o(ne)||G>0&&!p(P.charCodeAt(G-1)))return G}return P.length}function h(P,U,G,ne){if(G===P.length)return[];if(ne===U.length)return null;if(P[G]!==U[ne].toLowerCase())return null;{let he=null,ve=ne+1;for(he=h(P,U,G+1,ne+1);!he&&(ve=f(U,ve))<U.length;)he=h(P,U,G+1,ve),ve++;return he===null?null:c({start:ne,end:ne+1},he)}}function F(P){let U=0,G=0,ne=0,he=0,ve=0;for(let Oe=0;Oe<P.length;Oe++)ve=P.charCodeAt(Oe),I(ve)&&U++,y(ve)&&G++,p(ve)&&ne++,o(ve)&&he++;const $e=U/P.length,ue=G/P.length,Fe=ne/P.length,ye=he/P.length;return{upperPercent:$e,lowerPercent:ue,alphaPercent:Fe,numericPercent:ye}}function M(P){const{upperPercent:U,lowerPercent:G}=P;return G===0&&U>.6}function R(P){const{upperPercent:U,lowerPercent:G,alphaPercent:ne,numericPercent:he}=P;return G>.2&&U<.8&&ne>.6&&he<.2}function O(P){let U=0,G=0,ne=0,he=0;for(let ve=0;ve<P.length;ve++)ne=P.charCodeAt(ve),I(ne)&&U++,y(ne)&&G++,a(ne)&&he++;return(U===0||G===0)&&he===0?P.length<=30:U<=5}function v(P,U){if(!U||(U=U.trim(),U.length===0)||!O(P)||U.length>60)return null;const G=F(U);if(!R(G)){if(!M(G))return null;U=U.toLowerCase()}let ne=null,he=0;for(P=P.toLowerCase();he<U.length&&(ne=h(P,U,0,he))===null;)he=f(U,he+1);return ne}t.$Wj=v;function N(P,U,G=!1){if(!U||U.length===0)return null;let ne=null,he=0;for(P=P.toLowerCase(),U=U.toLowerCase();he<U.length&&(ne=V(P,U,0,he,G),ne===null);)he=H(U,he+1);return ne}t.$Xj=N;function V(P,U,G,ne,he){let ve=0;if(G===P.length)return[];if(ne===U.length)return null;if(!d(P.charCodeAt(G),U.charCodeAt(ne))){const Fe=u(P.charCodeAt(G));if(!Fe)return null;for(let ye=0;ye<Fe.length;ye++)if(!d(Fe[ye],U.charCodeAt(ne+ye)))return null;ve+=Fe.length-1}let $e=null,ue=ne+ve+1;if($e=V(P,U,G+1,ue,he),!he)for(;!$e&&(ue=H(U,ue))<U.length;)$e=V(P,U,G+1,ue,he),ue++;if(!$e)return null;if(P.charCodeAt(G)!==U.charCodeAt(ne)){const Fe=u(P.charCodeAt(G));if(!Fe)return $e;for(let ye=0;ye<Fe.length;ye++)if(Fe[ye]!==U.charCodeAt(ne+ye))return $e}return c({start:ne,end:ne+ve+1},$e)}function H(P,U){for(let G=U;G<P.length;G++)if(r(P.charCodeAt(G))||G>0&&r(P.charCodeAt(G-1)))return G;return P.length}const T=j(t.$Sj,v,A),L=j(t.$Sj,v,b),B=new k.$Dc(1e4);function X(P,U,G=!1){if(typeof P!="string"||typeof U!="string")return null;let ne=B.get(P);ne||(ne=new RegExp(s.$Te(P),"i"),B.set(P,ne));const he=ne.exec(U);return he?[{start:he.index,end:he.index+he[0].length}]:G?L(P,U):T(P,U)}t.$Yj=X;function Y(P,U){const G=m(P,P.toLowerCase(),0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?oe(G):null}t.$Zj=Y;function de(P,U,G,ne,he,ve){const $e=Math.min(13,P.length);for(;G<$e;G++){const ue=m(P,U,G,ne,he,ve,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ue)return ue}return[0,ve]}t.$1j=de;function oe(P){if(typeof P>"u")return[];const U=[],G=P[1];for(let ne=P.length-1;ne>1;ne--){const he=P[ne]+G,ve=U[U.length-1];ve&&ve.end===he?ve.end=he+1:U.push({start:he,end:he+1})}return U}t.$2j=oe;const ee=128;function me(){const P=[],U=[];for(let G=0;G<=ee;G++)U[G]=0;for(let G=0;G<=ee;G++)P.push(U.slice(0));return P}function Pe(P){const U=[];for(let G=0;G<=P;G++)U[G]=0;return U}const Te=Pe(2*ee),Me=Pe(2*ee),re=me(),J=me(),le=me(),K=!1;function W(P,U,G,ne,he){function ve(ue,Fe,ye=" "){for(;ue.length<Fe;)ue=ye+ue;return ue}let $e=` |   |${ne.split("").map(ue=>ve(ue,3)).join("|")}
`;for(let ue=0;ue<=G;ue++)ue===0?$e+=" |":$e+=`${U[ue-1]}|`,$e+=P[ue].slice(0,he+1).map(Fe=>ve(Fe.toString(),3)).join("|")+`
`;return $e}function Z(P,U,G,ne){P=P.substr(U),G=G.substr(ne),console.log(W(J,P,P.length,G,G.length)),console.log(W(le,P,P.length,G,G.length)),console.log(W(re,P,P.length,G,G.length))}function ce(P,U){if(U<0||U>=P.length)return!1;const G=P.codePointAt(U);switch(G){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!s.$qf(G)}}function we(P,U){if(U<0||U>=P.length)return!1;switch(P.charCodeAt(U)){case 32:case 9:return!0;default:return!1}}function ke(P,U,G){return U[P]!==G[P]}function Ae(P,U,G,ne,he,ve,$e=!1){for(;U<G&&he<ve;)P[U]===ne[he]&&($e&&(Te[U]=he),U+=1),he+=1;return U===G}t.$3j=Ae;var Le;(function(P){P[P.Diag=1]="Diag",P[P.Left=2]="Left",P[P.LeftLeft=3]="LeftLeft"})(Le||(Le={}));var _;(function(P){P.Default=[-100,0];function U(G){return!G||G.length===2&&G[0]===-100&&G[1]===0}P.isDefault=U})(_||(t.FuzzyScore=_={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(U,G){this.firstMatchCanBeWeak=U,this.boostFullMatch=G}}t.$4j=g;function m(P,U,G,ne,he,ve,$e=g.default){const ue=P.length>ee?ee:P.length,Fe=ne.length>ee?ee:ne.length;if(G>=ue||ve>=Fe||ue-G>Fe-ve||!Ae(U,G,ue,he,ve,Fe,!0))return;i(ue,Fe,G,ve,U,he);let ye=1,Oe=1,Be=G,Ie=ve;const Je=[!1];for(ye=1,Be=G;Be<ue;ye++,Be++){const ge=Te[Be],Ee=Me[Be],Ne=Be+1<ue?Me[Be+1]:Fe;for(Oe=ge-ve+1,Ie=ge;Ie<Ne;Oe++,Ie++){let je=Number.MIN_SAFE_INTEGER,Ve=!1;Ie<=Ee&&(je=n(P,U,Be,G,ne,he,Ie,Fe,ve,re[ye-1][Oe-1]===0,Je));let _e=0;je!==Number.MAX_SAFE_INTEGER&&(Ve=!0,_e=je+J[ye-1][Oe-1]);const Ze=Ie>ge,tt=Ze?J[ye][Oe-1]+(re[ye][Oe-1]>0?-5:0):0,Ye=Ie>ge+1&&re[ye][Oe-1]>0,nt=Ye?J[ye][Oe-2]+(re[ye][Oe-2]>0?-5:0):0;if(Ye&&(!Ze||nt>=tt)&&(!Ve||nt>=_e))J[ye][Oe]=nt,le[ye][Oe]=3,re[ye][Oe]=0;else if(Ze&&(!Ve||tt>=_e))J[ye][Oe]=tt,le[ye][Oe]=2,re[ye][Oe]=0;else if(Ve)J[ye][Oe]=_e,le[ye][Oe]=1,re[ye][Oe]=re[ye-1][Oe-1]+1;else throw new Error("not possible")}}if(K&&Z(P,G,ne,ve),!Je[0]&&!$e.firstMatchCanBeWeak)return;ye--,Oe--;const et=[J[ye][Oe],ve];let Qe=0,x=0;for(;ye>=1;){let ge=Oe;do{const Ee=le[ye][ge];if(Ee===3)ge=ge-2;else if(Ee===2)ge=ge-1;else break}while(ge>=1);Qe>1&&U[G+ye-1]===he[ve+Oe-1]&&!ke(ge+ve-1,ne,he)&&Qe+1>re[ye][ge]&&(ge=Oe),ge===Oe?Qe++:Qe=1,x||(x=ge),ye--,Oe=ge-1,et.push(Oe)}Fe===ue&&$e.boostFullMatch&&(et[0]+=2);const se=x-ue;return et[0]-=se,et}t.$5j=m;function i(P,U,G,ne,he,ve){let $e=P-1,ue=U-1;for(;$e>=G&&ue>=ne;)he[$e]===ve[ue]&&(Me[$e]=ue,$e--),ue--}function n(P,U,G,ne,he,ve,$e,ue,Fe,ye,Oe){if(U[G]!==ve[$e])return Number.MIN_SAFE_INTEGER;let Be=1,Ie=!1;return $e===G-ne?Be=P[G]===he[$e]?7:5:ke($e,he,ve)&&($e===0||!ke($e-1,he,ve))?(Be=P[G]===he[$e]?7:5,Ie=!0):ce(ve,$e)&&($e===0||!ce(ve,$e-1))?Be=5:(ce(ve,$e-1)||we(ve,$e-1))&&(Be=5,Ie=!0),Be>1&&G===ne&&(Oe[0]=!0),Ie||(Ie=ke($e,he,ve)||ce(ve,$e-1)||we(ve,$e-1)),G===ne?$e>Fe&&(Be-=Ie?3:5):ye?Be+=Ie?2:0:Be+=Ie?0:1,$e+1===ue&&(Be-=Ie?3:5),Be}function l(P,U,G,ne,he,ve,$e){return S(P,U,G,ne,he,ve,!0,$e)}t.$6j=l;function D(P,U,G,ne,he,ve,$e){return S(P,U,G,ne,he,ve,!1,$e)}t.$7j=D;function S(P,U,G,ne,he,ve,$e,ue){let Fe=m(P,U,G,ne,he,ve,ue);if(Fe&&!$e)return Fe;if(P.length>=3){const ye=Math.min(7,P.length-1);for(let Oe=G+1;Oe<ye;Oe++){const Be=z(P,Oe);if(Be){const Ie=m(Be,Be.toLowerCase(),G,ne,he,ve,ue);Ie&&(Ie[0]-=3,(!Fe||Ie[0]>Fe[0])&&(Fe=Ie))}}}return Fe}function z(P,U){if(U+1>=P.length)return;const G=P[U],ne=P[U+1];if(G!==ne)return P.slice(0,U)+ne+G+P.slice(U+2)}}),define(be[49],pe([1,0,10]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xi=t.$Wi=t.$Vi=t.$Ui=t.$Ti=t.$Si=t.$Ri=void 0;function C($){return s($,0)}t.$Ri=C;function s($,u){switch(typeof $){case"object":return $===null?j(349,u):Array.isArray($)?b($,u):w($,u);case"string":return A($,u);case"boolean":return E($,u);case"number":return j($,u);case"undefined":return j(937,u);default:return j(617,u)}}t.$Si=s;function j($,u){return(u<<5)-u+$|0}t.$Ti=j;function E($,u){return j($?433:863,u)}function A($,u){u=j(149417,u);for(let p=0,c=$.length;p<c;p++)u=j($.charCodeAt(p),u);return u}t.$Ui=A;function b($,u){return u=j(104579,u),$.reduce((p,c)=>s(c,p),u)}function w($,u){return u=j(181387,u),Object.keys($).sort().reduce((p,c)=>(p=A(c,p),s($[c],p)),u)}class y{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}t.$Vi=y;var I;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o($,u,p=32){const c=p-u,f=~((1<<c)-1);return($<<u|(f&$)>>>c)>>>0}function a($,u=0,p=$.byteLength,c=0){for(let f=0;f<p;f++)$[u+f]=c}function e($,u,p="0"){for(;$.length<u;)$=p+$;return $}function r($,u=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(p=>p.toString(16).padStart(2,"0")).join(""):e(($>>>0).toString(16),u/4)}t.$Wi=r;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const p=u.length;if(p===0)return;const c=this.p;let f=this.r,h=this.u,F,M;for(h!==0?(F=h,M=-1,h=0):(F=u.charCodeAt(0),M=0);;){let R=F;if(k.$bf(F))if(M+1<p){const O=u.charCodeAt(M+1);k.$cf(O)?(M++,R=k.$df(F,O)):R=65533}else{h=F;break}else k.$cf(F)&&(R=65533);if(f=this.w(c,f,R),M++,M<p)F=u.charCodeAt(M);else break}this.r=f,this.u=h}w(u,p,c){return c<128?u[p++]=c:c<2048?(u[p++]=192|(c&1984)>>>6,u[p++]=128|(c&63)>>>0):c<65536?(u[p++]=224|(c&61440)>>>12,u[p++]=128|(c&4032)>>>6,u[p++]=128|(c&63)>>>0):(u[p++]=240|(c&1835008)>>>18,u[p++]=128|(c&258048)>>>12,u[p++]=128|(c&4032)>>>6,u[p++]=128|(c&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),r(this.h)+r(this.l)+r(this.m)+r(this.n)+r(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=d.g,p=this.q;for(let N=0;N<64;N+=4)u.setUint32(N,p.getUint32(N,!1),!1);for(let N=64;N<320;N+=4)u.setUint32(N,o(u.getUint32(N-12,!1)^u.getUint32(N-32,!1)^u.getUint32(N-56,!1)^u.getUint32(N-64,!1),1),!1);let c=this.h,f=this.l,h=this.m,F=this.n,M=this.o,R,O,v;for(let N=0;N<80;N++)N<20?(R=f&h|~f&F,O=1518500249):N<40?(R=f^h^F,O=1859775393):N<60?(R=f&h|f&F|h&F,O=2400959708):(R=f^h^F,O=3395469782),v=o(c,5)+R+M+O+u.getUint32(N*4,!1)&4294967295,M=F,F=h,h=o(f,30),f=c,c=v;this.h=this.h+c&4294967295,this.l=this.l+f&4294967295,this.m=this.m+h&4294967295,this.n=this.n+F&4294967295,this.o=this.o+M&4294967295}}t.$Xi=d}),define(be[87],pe([1,0,75,49]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=t.$Ps=t.$Os=void 0;class s{constructor(o){this.a=o}getElements(){const o=this.a,a=new Int32Array(o.length);for(let e=0,r=o.length;e<r;e++)a[e]=o.charCodeAt(e);return a}}t.$Os=s;function j(I,o,a){return new y(new s(I),new s(o)).ComputeDiff(a).changes}t.$Ps=j;class E{static Assert(o,a){if(!o)throw new Error(a)}}class A{static Copy(o,a,e,r,d){for(let $=0;$<d;$++)e[r+$]=o[a+$]}static Copy2(o,a,e,r,d){for(let $=0;$<d;$++)e[r+$]=o[a+$]}}var b;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class w{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$Ns(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,a){this.b=Math.min(this.b,o),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(o,a){this.b=Math.min(this.b,o),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(o,a,e=null){this.a=e,this.b=o,this.c=a;const[r,d,$]=y.o(o),[u,p,c]=y.o(a);this.d=$&&c,this.e=r,this.f=d,this.g=u,this.h=p,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const a=o.getElements();if(y.n(a)){const e=new Int32Array(a.length);for(let r=0,d=a.length;r<d;r++)e[r]=(0,C.$Ui)(a[r],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(o,a){return this.f[o]!==this.h[a]?!1:this.d?this.e[o]===this.g[a]:!0}q(o,a){if(!this.p(o,a))return!1;const e=y.r(this.b,o),r=y.r(this.c,a);return e===r}static r(o,a){return typeof o.getStrictElement=="function"?o.getStrictElement(a):null}s(o,a){return this.f[o]!==this.f[a]?!1:this.d?this.e[o]===this.e[a]:!0}u(o,a){return this.h[o]!==this.h[a]?!1:this.d?this.g[o]===this.g[a]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,a,e,r,d){const $=[!1];let u=this.w(o,a,e,r,$);return d&&(u=this.z(u)),{quitEarly:$[0],changes:u}}w(o,a,e,r,d){for(d[0]=!1;o<=a&&e<=r&&this.p(o,e);)o++,e++;for(;a>=o&&r>=e&&this.p(a,r);)a--,r--;if(o>a||e>r){let h;return e<=r?(E.Assert(o===a+1,"originalStart should only be one more than originalEnd"),h=[new k.$Ns(o,0,e,r-e+1)]):o<=a?(E.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),h=[new k.$Ns(o,a-o+1,e,0)]):(E.Assert(o===a+1,"originalStart should only be one more than originalEnd"),E.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const $=[0],u=[0],p=this.y(o,a,e,r,$,u,d),c=$[0],f=u[0];if(p!==null)return p;if(!d[0]){const h=this.w(o,c,e,f,d);let F=[];return d[0]?F=[new k.$Ns(c+1,a-(c+1)+1,f+1,r-(f+1)+1)]:F=this.w(c+1,a,f+1,r,d),this.H(h,F)}return[new k.$Ns(o,a-o+1,e,r-e+1)]}x(o,a,e,r,d,$,u,p,c,f,h,F,M,R,O,v,N,V){let H=null,T=null,L=new w,B=a,X=e,Y=M[0]-v[0]-r,de=-1073741824,oe=this.k.length-1;do{const ee=Y+o;ee===B||ee<X&&c[ee-1]<c[ee+1]?(h=c[ee+1],R=h-Y-r,h<de&&L.MarkNextChange(),de=h,L.AddModifiedElement(h+1,R),Y=ee+1-o):(h=c[ee-1]+1,R=h-Y-r,h<de&&L.MarkNextChange(),de=h-1,L.AddOriginalElement(h,R+1),Y=ee-1-o),oe>=0&&(c=this.k[oe],o=c[0],B=1,X=c.length-1)}while(--oe>=-1);if(H=L.getReverseChanges(),V[0]){let ee=M[0]+1,me=v[0]+1;if(H!==null&&H.length>0){const Pe=H[H.length-1];ee=Math.max(ee,Pe.getOriginalEnd()),me=Math.max(me,Pe.getModifiedEnd())}T=[new k.$Ns(ee,F-ee+1,me,O-me+1)]}else{L=new w,B=$,X=u,Y=M[0]-v[0]-p,de=1073741824,oe=N?this.m.length-1:this.m.length-2;do{const ee=Y+d;ee===B||ee<X&&f[ee-1]>=f[ee+1]?(h=f[ee+1]-1,R=h-Y-p,h>de&&L.MarkNextChange(),de=h+1,L.AddOriginalElement(h+1,R+1),Y=ee+1-d):(h=f[ee-1],R=h-Y-p,h>de&&L.MarkNextChange(),de=h,L.AddModifiedElement(h+1,R+1),Y=ee-1-d),oe>=0&&(f=this.m[oe],d=f[0],B=1,X=f.length-1)}while(--oe>=-1);T=L.getChanges()}return this.H(H,T)}y(o,a,e,r,d,$,u){let p=0,c=0,f=0,h=0,F=0,M=0;o--,e--,d[0]=0,$[0]=0,this.k=[],this.m=[];const R=a-o+(r-e),O=R+1,v=new Int32Array(O),N=new Int32Array(O),V=r-e,H=a-o,T=o-e,L=a-r,X=(H-V)%2===0;v[V]=o,N[H]=a,u[0]=!1;for(let Y=1;Y<=R/2+1;Y++){let de=0,oe=0;f=this.J(V-Y,Y,V,O),h=this.J(V+Y,Y,V,O);for(let me=f;me<=h;me+=2){me===f||me<h&&v[me-1]<v[me+1]?p=v[me+1]:p=v[me-1]+1,c=p-(me-V)-T;const Pe=p;for(;p<a&&c<r&&this.p(p+1,c+1);)p++,c++;if(v[me]=p,p+c>de+oe&&(de=p,oe=c),!X&&Math.abs(me-H)<=Y-1&&p>=N[me])return d[0]=p,$[0]=c,Pe<=N[me]&&1447>0&&Y<=1447+1?this.x(V,f,h,T,H,F,M,L,v,N,p,a,d,c,r,$,X,u):null}const ee=(de-o+(oe-e)-Y)/2;if(this.a!==null&&!this.a(de,ee))return u[0]=!0,d[0]=de,$[0]=oe,ee>0&&1447>0&&Y<=1447+1?this.x(V,f,h,T,H,F,M,L,v,N,p,a,d,c,r,$,X,u):(o++,e++,[new k.$Ns(o,a-o+1,e,r-e+1)]);F=this.J(H-Y,Y,H,O),M=this.J(H+Y,Y,H,O);for(let me=F;me<=M;me+=2){me===F||me<M&&N[me-1]>=N[me+1]?p=N[me+1]-1:p=N[me-1],c=p-(me-H)-L;const Pe=p;for(;p>o&&c>e&&this.p(p,c);)p--,c--;if(N[me]=p,X&&Math.abs(me-V)<=Y&&p<=v[me])return d[0]=p,$[0]=c,Pe>=v[me]&&1447>0&&Y<=1447+1?this.x(V,f,h,T,H,F,M,L,v,N,p,a,d,c,r,$,X,u):null}if(Y<=1447){let me=new Int32Array(h-f+2);me[0]=V-f+1,A.Copy2(v,f,me,1,h-f+1),this.k.push(me),me=new Int32Array(M-F+2),me[0]=H-F+1,A.Copy2(N,F,me,1,M-F+1),this.m.push(me)}}return this.x(V,f,h,T,H,F,M,L,v,N,p,a,d,c,r,$,X,u)}z(o){for(let a=0;a<o.length;a++){const e=o[a],r=a<o.length-1?o[a+1].originalStart:this.f.length,d=a<o.length-1?o[a+1].modifiedStart:this.h.length,$=e.originalLength>0,u=e.modifiedLength>0;for(;e.originalStart+e.originalLength<r&&e.modifiedStart+e.modifiedLength<d&&(!$||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!u||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const p=[null];if(a<o.length-1&&this.I(o[a],o[a+1],p)){o[a]=p[0],o.splice(a+1,1),a--;continue}}for(let a=o.length-1;a>=0;a--){const e=o[a];let r=0,d=0;if(a>0){const h=o[a-1];r=h.originalStart+h.originalLength,d=h.modifiedStart+h.modifiedLength}const $=e.originalLength>0,u=e.modifiedLength>0;let p=0,c=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let h=1;;h++){const F=e.originalStart-h,M=e.modifiedStart-h;if(F<r||M<d||$&&!this.s(F,F+e.originalLength)||u&&!this.u(M,M+e.modifiedLength))break;const O=(F===r&&M===d?5:0)+this.G(F,e.originalLength,M,e.modifiedLength);O>c&&(c=O,p=h)}e.originalStart-=p,e.modifiedStart-=p;const f=[null];if(a>0&&this.I(o[a-1],o[a],f)){o[a-1]=f[0],o.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=o.length;a<e;a++){const r=o[a-1],d=o[a],$=d.originalStart-r.originalStart-r.originalLength,u=r.originalStart,p=d.originalStart+d.originalLength,c=p-u,f=r.modifiedStart,h=d.modifiedStart+d.modifiedLength,F=h-f;if($<5&&c<20&&F<20){const M=this.A(u,c,f,F,$);if(M){const[R,O]=M;(R!==r.originalStart+r.originalLength||O!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=R-r.originalStart,r.modifiedLength=O-r.modifiedStart,d.originalStart=R+$,d.modifiedStart=O+$,d.originalLength=p-d.originalStart,d.modifiedLength=h-d.modifiedStart)}}}return o}A(o,a,e,r,d){if(a<d||r<d)return null;const $=o+a-d+1,u=e+r-d+1;let p=0,c=0,f=0;for(let h=o;h<$;h++)for(let F=e;F<u;F++){const M=this.B(h,F,d);M>0&&M>p&&(p=M,c=h,f=F)}return p>0?[c,f]:null}B(o,a,e){let r=0;for(let d=0;d<e;d++){if(!this.p(o+d,a+d))return 0;r+=this.e[o+d].length}return r}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,a){if(this.C(o)||this.C(o-1))return!0;if(a>0){const e=o+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,a){if(this.E(o)||this.E(o-1))return!0;if(a>0){const e=o+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,a,e,r){const d=this.D(o,a)?1:0,$=this.F(e,r)?1:0;return d+$}H(o,a){const e=[];if(o.length===0||a.length===0)return a.length>0?a:o;if(this.I(o[o.length-1],a[0],e)){const r=new Array(o.length+a.length-1);return A.Copy(o,0,r,0,o.length-1),r[o.length-1]=e[0],A.Copy(a,1,r,o.length,a.length-1),r}else{const r=new Array(o.length+a.length);return A.Copy(o,0,r,0,o.length),A.Copy(a,0,r,o.length,a.length),r}}I(o,a,e){if(E.Assert(o.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),E.Assert(o.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=a.originalStart||o.modifiedStart+o.modifiedLength>=a.modifiedStart){const r=o.originalStart;let d=o.originalLength;const $=o.modifiedStart;let u=o.modifiedLength;return o.originalStart+o.originalLength>=a.originalStart&&(d=a.originalStart+a.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=a.modifiedStart&&(u=a.modifiedStart+a.modifiedLength-o.modifiedStart),e[0]=new k.$Ns(r,d,$,u),!0}else return e[0]=null,!1}J(o,a,e,r){if(o>=0&&o<r)return o;const d=e,$=r-e-1,u=a%2===0;if(o<0){const p=d%2===0;return u===p?0:1}else{const p=$%2===0;return u===p?r-1:r-2}}}t.$Qs=y}),define(be[50],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qd=void 0,t.$Qd=Symbol("MicrotaskDelay")}),define(be[88],pe([1,0,12,10]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=t.$9h=t.$8h=t.$7h=t.$6h=void 0;class s{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),r=this.b.charCodeAt(this.c);return e-r}value(){return this.b[this.c]}}t.$6h=s;class j{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,C.$4e)(a,this.b,0,a.length,this.c,this.d):(0,C.$6e)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$7h=j;class E{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const r=this.b.charCodeAt(e);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,C.$4e)(a,this.b,0,a.length,this.d,this.e):(0,C.$6e)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$8h=E;var A;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(A||(A={}));class b{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,C.$5e)(a,this.c.scheme);if(this.d[this.e]===2)return(0,C.$5e)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,C.$3e)(a,this.c.query);if(this.d[this.e]===5)return(0,C.$3e)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$9h=b;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(y||(y={}));class I{static forUris(a=()=>!1,e=()=>!1){return new I(new b(a,e))}static forPaths(a=!1){return new I(new E(void 0,!a))}static forStrings(){return new I(new s)}static forConfigKeys(){return new I(new j)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const r=e.slice(0);(0,k.$Xb)(r);for(const d of r)this.set(d,a)}else{const r=a.slice(0);(0,k.$Xb)(r);for(const d of r)this.set(d[0],d[1])}}set(a,e){const r=this.b.reset(a);let d;this.c||(this.c=new w,this.c.segment=r.value());const $=[];for(d=this.c;;){const p=r.cmp(d.segment);if(p>0)d.left||(d.left=new w,d.left.segment=r.value()),$.push([-1,d]),d=d.left;else if(p<0)d.right||(d.right=new w,d.right.segment=r.value()),$.push([1,d]),d=d.right;else if(r.hasNext())r.next(),d.mid||(d.mid=new w,d.mid.segment=r.value()),$.push([0,d]),d=d.mid;else break}const u=d.value;d.value=e,d.key=a;for(let p=$.length-1;p>=0;p--){const c=$[p][1];c.updateHeight();const f=c.balanceFactor();if(f<-1||f>1){const h=$[p][0],F=$[p+1][0];if(h===1&&F===1)$[p][1]=c.rotateLeft();else if(h===-1&&F===-1)$[p][1]=c.rotateRight();else if(h===1&&F===-1)c.right=$[p+1][1]=$[p+1][1].rotateRight(),$[p][1]=c.rotateLeft();else if(h===-1&&F===1)c.left=$[p+1][1]=$[p+1][1].rotateLeft(),$[p][1]=c.rotateRight();else throw new Error;if(p>0)switch($[p-1][0]){case-1:$[p-1][1].left=$[p][1];break;case 1:$[p-1][1].right=$[p][1];break;case 0:$[p-1][1].mid=$[p][1];break}else this.c=$[0][1]}}return u}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let r=this.c;for(;r;){const d=e.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(e.hasNext())e.next(),r=r.mid;else break}return r}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const r=this.b.reset(a),d=[];let $=this.c;for(;$;){const u=r.cmp($.segment);if(u>0)d.push([-1,$]),$=$.left;else if(u<0)d.push([1,$]),$=$.right;else if(r.hasNext())r.next(),d.push([0,$]),$=$.mid;else break}if($){if(e?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const u=this.f($.right);if(u.key){const{key:p,value:c,segment:f}=u;this.e(u.key,!1),$.key=p,$.value=c,$.segment=f}}else{const u=$.left??$.right;if(d.length>0){const[p,c]=d[d.length-1];switch(p){case-1:c.left=u;break;case 0:c.mid=u;break;case 1:c.right=u;break}}else this.c=u}for(let u=d.length-1;u>=0;u--){const p=d[u][1];p.updateHeight();const c=p.balanceFactor();if(c>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),d[u][1]=p.rotateLeft()):c<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),d[u][1]=p.rotateRight()),u>0)switch(d[u-1][0]){case-1:d[u-1][1].left=d[u][1];break;case 1:d[u-1][1].right=d[u][1];break;case 0:d[u-1][1].mid=d[u][1];break}else this.c=d[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let r=this.c,d;for(;r;){const $=e.cmp(r.segment);if($>0)r=r.left;else if($<0)r=r.right;else if(e.hasNext())e.next(),d=r.value||d,r=r.mid;else break}return r&&r.value||d}findSuperstr(a){return this.g(a,!1)}g(a,e){const r=this.b.reset(a);let d=this.c;for(;d;){const $=r.cmp(d.segment);if($>0)d=d.left;else if($<0)d=d.right;else if(r.hasNext())r.next(),d=d.mid;else return d.mid?this.h(d.mid):e?d.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,r]of this)a(r,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const r=e.balanceFactor();return r<-1||r>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$0h=I}),define(be[7],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=void 0;function k(f){return typeof f=="string"}t.$Gf=k;function C(f){return Array.isArray(f)&&f.every(h=>k(h))}t.$Hf=C;function s(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$If=s;function j(f){const h=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof h}t.$Jf=j;function E(f){return typeof f=="number"&&!isNaN(f)}t.$Kf=E;function A(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Lf=A;function b(f){return f===!0||f===!1}t.$Mf=b;function w(f){return typeof f>"u"}t.$Nf=w;function y(f){return!I(f)}t.$Of=y;function I(f){return w(f)||f===null}t.$Pf=I;function o(f,h){if(!f)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}t.$Qf=o;function a(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$Rf=a;function e(...f){const h=[];for(let F=0;F<f.length;F++){const M=f[F];if(I(M))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);h.push(M)}return h}t.$Sf=e;const r=Object.prototype.hasOwnProperty;function d(f){if(!s(f))return!1;for(const h in f)if(r.call(f,h))return!1;return!0}t.$Tf=d;function $(f){return typeof f=="function"}t.$Uf=$;function u(...f){return f.length>0&&f.every($)}t.$Vf=u;function p(f,h){const F=Math.min(f.length,h.length);for(let M=0;M<F;M++)c(f[M],h[M])}t.$Wf=p;function c(f,h){if(k(h)){if(typeof f!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if($(h)){try{if(f instanceof h)return}catch{}if(!I(f)&&f.constructor===h||h.length===1&&h.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Xf=c}),define(be[17],pe([1,0,7]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0j=t.$9j=t.$8j=void 0;const C=Object.create(null);function s(A,b){if((0,k.$Gf)(b)){const w=C[b];if(w===void 0)throw new Error(`${A} references an unknown codicon: ${b}`);b=w}return C[A]=b,{id:A}}function j(){return C}t.$8j=j;function E(){return Object.values(t.$0j)}t.$9j=E,t.$0j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(be[51],pe([1,0,7]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vn=t.$un=t.$tn=t.$sn=t.$rn=t.$qn=t.$pn=t.$on=t.$nn=t.$mn=t.$ln=t.$kn=void 0;function C($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const u=Array.isArray($)?[]:{};return Object.entries($).forEach(([p,c])=>{u[p]=c&&typeof c=="object"?C(c):c}),u}t.$kn=C;function s($){if(!$||typeof $!="object")return $;const u=[$];for(;u.length>0;){const p=u.shift();Object.freeze(p);for(const c in p)if(j.call(p,c)){const f=p[c];typeof f=="object"&&!Object.isFrozen(f)&&!(0,k.$Jf)(f)&&u.push(f)}}return $}t.$ln=s;const j=Object.prototype.hasOwnProperty;function E($,u){return A($,u,new Set)}t.$mn=E;function A($,u,p){if((0,k.$Pf)($))return $;const c=u($);if(typeof c<"u")return c;if(Array.isArray($)){const f=[];for(const h of $)f.push(A(h,u,p));return f}if((0,k.$If)($)){if(p.has($))throw new Error("Cannot clone recursive data-structure");p.add($);const f={};for(const h in $)j.call($,h)&&(f[h]=A($[h],u,p));return p.delete($),f}return $}function b($,u,p=!0){return(0,k.$If)($)?((0,k.$If)(u)&&Object.keys(u).forEach(c=>{c in $?p&&((0,k.$If)($[c])&&(0,k.$If)(u[c])?b($[c],u[c],p):$[c]=u[c]):$[c]=u[c]}),$):u}t.$nn=b;function w($,u){if($===u)return!0;if($==null||u===null||u===void 0||typeof $!=typeof u||typeof $!="object"||Array.isArray($)!==Array.isArray(u))return!1;let p,c;if(Array.isArray($)){if($.length!==u.length)return!1;for(p=0;p<$.length;p++)if(!w($[p],u[p]))return!1}else{const f=[];for(c in $)f.push(c);f.sort();const h=[];for(c in u)h.push(c);if(h.sort(),!w(f,h))return!1;for(p=0;p<f.length;p++)if(!w($[f[p]],u[f[p]]))return!1}return!0}t.$on=w;function y($){const u=new Set;return JSON.stringify($,(p,c)=>{if((0,k.$If)(c)||Array.isArray(c)){if(u.has(c))return"[Circular]";u.add(c)}return c})}t.$pn=y;function I($,u){const p=Object.create(null);return!$||!u||Object.keys(u).forEach(f=>{const h=$[f],F=u[f];w(h,F)||(p[f]=F)}),p}t.$qn=I;function o($,u){const p=u.toLowerCase(),c=Object.keys($).find(f=>f.toLowerCase()===p);return c?$[c]:$[u]}t.$rn=o;function a($,u){const p=Object.create(null);for(const[c,f]of Object.entries($))u(c,f)&&(p[c]=f);return p}t.$sn=a;function e($){let u=[];for(;Object.prototype!==$;)u=u.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return u}t.$tn=e;function r($){const u=[];for(const p of e($))typeof $[p]=="function"&&u.push(p);return u}t.$un=r;function d($,u){const p=f=>function(){const h=Array.prototype.slice.call(arguments,0);return u(f,h)},c={};for(const f of $)c[f]=p(f);return c}t.$vn=d}),define(be[18],pe([1,0,17]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$$j=t.ThemeColor=void 0;var C;(function(E){function A(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=A})(C||(t.ThemeColor=C={}));function s(E){return{id:E}}t.$$j=s;var j;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function b(u){const p=A.exec(u.id);if(!p)return b(k.$0j.error);const[,c,f]=p,h=["codicon","codicon-"+c];return f&&h.push("codicon-modifier-"+f.substring(1)),h}E.asClassNameArray=b;function w(u){return b(u).join(" ")}E.asClassName=w;function y(u){return"."+b(u).join(".")}E.asCSSSelector=y;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||C.isThemeColor(u.color))}E.isThemeIcon=I;const o=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function a(u){const p=o.exec(u);if(!p)return;const[,c]=p;return{id:c}}E.fromString=a;function e(u){return{id:u}}E.fromId=e;function r(u,p){let c=u.id;const f=c.lastIndexOf("~");return f!==-1&&(c=c.substring(0,f)),p&&(c=`${c}~${p}`),{id:c}}E.modify=r;function d(u){const p=u.id.lastIndexOf("~");if(p!==-1)return u.id.substring(p+1)}E.getModifier=d;function $(u,p){return u.id===p.id&&u.color?.id===p.color?.id}E.isEqual=$})(j||(t.ThemeIcon=j={}))}),define(be[35],pe([1,0,34,10,18]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.$_j=void 0;const j="$(",E=new RegExp(`\\$\\(${s.ThemeIcon.iconNameExpression}(?:${s.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${E.source}`,"g");function b($){return $.replace(A,(u,p)=>p?u:`\\${u}`)}t.$_j=b;const w=new RegExp(`\\\\${E.source}`,"g");function y($){return $.replace(w,u=>`\\${u}`)}t.$ak=y;const I=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function o($){return $.indexOf(j)===-1?$:$.replace(I,(u,p,c,f)=>c?u:p||f||"")}t.$bk=o;function a($){return $?$.replace(/\$\((.*?)\)/g,(u,p)=>` ${p} `).trim():""}t.$ck=a;const e=new RegExp(`\\$\\(${s.ThemeIcon.iconNameCharacter}+\\)`,"g");function r($){e.lastIndex=0;let u="";const p=[];let c=0;for(;;){const f=e.lastIndex,h=e.exec($),F=$.substring(f,h?.index);if(F.length>0){u+=F;for(let M=0;M<F.length;M++)p.push(c)}if(!h)break;c+=h[0].length}return{text:u,iconOffsets:p}}t.$dk=r;function d($,u,p=!1){const{text:c,iconOffsets:f}=u;if(!f||f.length===0)return(0,k.$Yj)($,c,p);const h=(0,C.$Re)(c," "),F=c.length-h.length,M=(0,k.$Yj)($,h,p);if(M)for(const R of M){const O=f[R.start+F]+F;R.start+=O,R.end+=O}return M}t.$ek=d}),define(be[89],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pU=t.$oU=void 0,t.$oU="vscode:contextmenu",t.$pU="vscode:onCloseContextMenu"}),define(be[90],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wU=void 0;class k{constructor(s,j){this.a=s,this.onMessage=j}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$wU=k}),define(be[30],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const k=globalThis.vscode;t.$O=k.ipcRenderer,t.$P=k.ipcMessagePort,t.$Q=k.webFrame,t.$R=k.process,t.$S=k.context}),define(be[91],pe([1,0,89,30]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sU=void 0;let s=0;function j(A,b,w){const y=[],I=s++,o=`vscode:onContextMenu${I}`,a=(e,r,d)=>{y[r].click?.(d)};C.$O.once(o,a),C.$O.once(k.$pU,(e,r)=>{r===I&&(C.$O.removeListener(o,a),w?.())}),C.$O.send(k.$oU,I,A.map(e=>E(e,y)),o,b)}t.$sU=j;function E(A,b){const w={id:b.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return b.push(A),Array.isArray(A.submenu)&&(w.submenu=A.submenu.map(y=>E(y,b))),w}}),define(be[52],pe([8]),{}),define(be[92],pe([8]),{}),define(be[93],pe([8]),{}),define(be[94],pe([8]),{}),define(be[95],pe([1,0,93,94]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],pe([8]),{}),define(be[97],pe([8]),{}),define(be[98],pe([8]),{}),define(be[99],pe([8]),{}),define(be[100],pe([8]),{}),define(be[101],pe([8]),{}),define(be[102],pe([8]),{}),define(be[103],pe([8]),{}),define(be[104],pe([8]),{}),define(be[105],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],pe([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(be[36],pe([1,0,4,2,112]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ni=t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=void 0;class j extends C.$Tc{constructor(o,a="",e="",r=!0,d){super(),this.h=this.B(new k.$Td),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=a,this.u=e,this.w=r,this.C=d}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,a){this.C&&await this.C(o)}}t.$Ii=j;class E extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new k.$Td),this.onWillRun=this.f.event,this.m=this.B(new k.$Td),this.onDidRun=this.m.event}async run(o,a){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.u(o,a)}catch(r){e=r}this.m.fire({action:o,error:e})}async u(o,a){await o.run(a)}}t.$Ji=E;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let a=[];for(const e of o)e.length&&(a.length?a=[...a,new A,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$Ki=A;class b{get actions(){return this.a}constructor(o,a,e,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=a,this.class=r,this.a=e}async run(){}}t.$Li=b;class w extends j{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,s.localize(0,null),void 0,!1)}}t.$Mi=w;function y(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...o)=>I.run(...o),tooltip:I.label}}t.$Ni=y}),define(be[113],pe([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,113]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let C=!1,s=!1,j=!1,E=!1,A=!1,b=!1,w=!1,y=!1,I=!1,o=!1,a,e=t.$g,r=t.$g,d,$;const u=globalThis;let p;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?p=u.vscode.process:typeof process<"u"&&(p=process);const c=typeof p?.versions?.electron=="string",f=c&&p?.type==="renderer";if(typeof p=="object"){C=p.platform==="win32",s=p.platform==="darwin",j=p.platform==="linux",E=j&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,w=c,I=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const T=p.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),B=L.availableLanguages["*"];a=L.locale,r=L.osLocale,e=B||t.$g,d=L._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!f?($=navigator.userAgent,C=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,y=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=$.indexOf("Linux")>=0,o=$?.indexOf("Mobi")>=0,b=!0,a=k.getConfiguredDefaultLocale(k.localize(0,null))||t.$g,e=a,r=navigator.language):console.error("Unable to resolve platform.");var h;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(h||(t.Platform=h={}));function F(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=F;let M=0;s?M=1:C?M=3:j&&(M=2),t.$i=C,t.$j=s,t.$k=j,t.$l=E,t.$m=A,t.$n=w,t.$o=b,t.$p=b&&typeof u.importScripts=="function",t.$q=t.$p?u.origin:void 0,t.$r=y,t.$s=o,t.$t=I,t.$u=M,t.$v=$,t.$w=e;var R;(function(T){function L(){return t.$w}T.value=L;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}T.isDefaultVariant=B;function X(){return t.$w==="en"}T.isDefault=X})(R||(t.Language=R={})),t.$x=a,t.$y=r,t.$z=d,t.$A=typeof u.postMessage=="function"&&!u.importScripts,t.$B=(()=>{if(t.$A){const T=[];u.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let X=0,Y=T.length;X<Y;X++){const de=T[X];if(de.id===B.data.vscodeScheduleAsyncWork){T.splice(X,1),de.callback();return}}});let L=0;return B=>{const X=++L;T.push({id:X,callback:B}),u.postMessage({vscodeScheduleAsyncWork:X},"*")}}return T=>setTimeout(T)})();var O;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(O||(t.OperatingSystem=O={})),t.OS=s||y?2:C?1:3;let v=!0,N=!1;function V(){if(!N){N=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,v=new Uint16Array(T.buffer)[0]===(2<<8)+1}return v}t.$D=V,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function H(T){return parseFloat(T)>=20}t.$J=H}),define(be[114],pe([1,0,16,21,5]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gP=t.KeyboardSupport=void 0;var j;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(j||(t.KeyboardSupport=j={})),t.$gP={clipboard:{writeText:s.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:s.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>s.$m||k.$eP()?0:navigator.keyboard||k.$aP?1:2)(),touch:"ontouchstart"in C.$VO||navigator.maxTouchPoints>0,pointerEvents:C.$VO.PointerEvent&&("ontouchstart"in C.$VO||navigator.maxTouchPoints>0)}}),define(be[14],pe([1,0,16,44,78,5]),function(ie,t,k,C,s,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oP=t.$nP=t.$mP=void 0;function E(e){if(e.charCode){const d=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(d)}const r=e.keyCode;if(r===3)return 7;if(k.$0O)switch(r){case 59:return 85;case 60:if(j.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(j.$j)return 57;break}else if(k.$$O){if(j.$j&&r===93)return 57;if(!j.$j&&r===92)return 57}return C.$Qq[r]||0}const A=j.$j?256:2048,b=512,w=1024,y=j.$j?2048:256;function I(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$mP=I;function o(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}t.$nP=o;class a{constructor(r){this._standardKeyboardEventBrand=!0;const d=r;this.browserEvent=d,this.target=d.target,this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,this.altGraphKey=d.getModifierState("AltGraph"),this.keyCode=E(d),this.code=d.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(r){return this.a===r}c(){let r=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode);let d=0;return this.ctrlKey&&(d|=A),this.altKey&&(d|=b),this.shiftKey&&(d|=w),this.metaKey&&(d|=y),d|=r,d}d(){let r=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode),new s.$Yq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,r)}}t.$oP=a}),define(be[19],pe([1,0,16,69,5]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lP=t.$kP=t.$jP=void 0;class j{constructor(w,y){this.timestamp=Date.now(),this.browserEvent=y,this.leftButton=y.button===0,this.middleButton=y.button===1,this.rightButton=y.button===2,this.buttons=y.buttons,this.target=y.target,this.detail=y.detail||1,y.type==="dblclick"&&(this.detail=2),this.ctrlKey=y.ctrlKey,this.shiftKey=y.shiftKey,this.altKey=y.altKey,this.metaKey=y.metaKey,typeof y.pageX=="number"?(this.posx=y.pageX,this.posy=y.pageY):(this.posx=y.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=y.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const I=C.$hP.getPositionOfChildWindowRelativeToAncestorWindow(w,y.view);this.posx-=I.left,this.posy-=I.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$jP=j;class E extends j{constructor(w,y){super(w,y),this.dataTransfer=y.dataTransfer}}t.$kP=E;class A{constructor(w,y=0,I=0){if(this.browserEvent=w||null,this.target=w?w.target||w.targetNode||w.srcElement:null,this.deltaY=I,this.deltaX=y,w){const o=w,a=w;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(w.type==="wheel"){const e=w;e.deltaMode===e.DOM_DELTA_LINE?k.$0O&&!s.$j?this.deltaY=-w.deltaY/3:this.deltaY=-w.deltaY:this.deltaY=-w.deltaY/40}if(typeof o.wheelDeltaX<"u")k.$aP&&s.$i?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-w.detail/3;else if(w.type==="wheel"){const e=w;e.deltaMode===e.DOM_DELTA_LINE?k.$0O&&!s.$j?this.deltaX=-w.deltaX/3:this.deltaX=-w.deltaX:this.deltaX=-w.deltaX/40}this.deltaY===0&&this.deltaX===0&&w.wheelDelta&&(this.deltaY=w.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$lP=A}),define(be[115],pe([1,0,5]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let C;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const j=s.process;C={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$dc=C.platform,t.$ec=C.arch}),define(be[24],pe([1,0,115]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const C=65,s=97,j=90,E=122,A=46,b=47,w=92,y=58,I=63;class o extends Error{constructor(F,M,R){let O;typeof M=="string"&&M.indexOf("not ")===0?(O="must not be",M=M.replace(/^not /,"")):O="must be";const v=F.indexOf(".")!==-1?"property":"argument";let N=`The "${F}" ${v} ${O} of type ${M}`;N+=`. Received type ${typeof R}`,super(N),this.code="ERR_INVALID_ARG_TYPE"}}function a(h,F){if(h===null||typeof h!="object")throw new o(F,"Object",h)}function e(h,F){if(typeof h!="string")throw new o(F,"string",h)}const r=k.$dc==="win32";function d(h){return h===b||h===w}function $(h){return h===b}function u(h){return h>=C&&h<=j||h>=s&&h<=E}function p(h,F,M,R){let O="",v=0,N=-1,V=0,H=0;for(let T=0;T<=h.length;++T){if(T<h.length)H=h.charCodeAt(T);else{if(R(H))break;H=b}if(R(H)){if(!(N===T-1||V===1))if(V===2){if(O.length<2||v!==2||O.charCodeAt(O.length-1)!==A||O.charCodeAt(O.length-2)!==A){if(O.length>2){const L=O.lastIndexOf(M);L===-1?(O="",v=0):(O=O.slice(0,L),v=O.length-1-O.lastIndexOf(M)),N=T,V=0;continue}else if(O.length!==0){O="",v=0,N=T,V=0;continue}}F&&(O+=O.length>0?`${M}..`:"..",v=2)}else O.length>0?O+=`${M}${h.slice(N+1,T)}`:O=h.slice(N+1,T),v=T-N-1;N=T,V=0}else H===A&&V!==-1?++V:V=-1}return O}function c(h,F){a(F,"pathObject");const M=F.dir||F.root,R=F.base||`${F.name||""}${F.ext||""}`;return M?M===F.root?`${M}${R}`:`${M}${h}${R}`:R}t.$fc={resolve(...h){let F="",M="",R=!1;for(let O=h.length-1;O>=-1;O--){let v;if(O>=0){if(v=h[O],e(v,"path"),v.length===0)continue}else F.length===0?v=k.cwd():(v=k.env[`=${F}`]||k.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==F.toLowerCase()&&v.charCodeAt(2)===w)&&(v=`${F}\\`));const N=v.length;let V=0,H="",T=!1;const L=v.charCodeAt(0);if(N===1)d(L)&&(V=1,T=!0);else if(d(L))if(T=!0,d(v.charCodeAt(1))){let B=2,X=B;for(;B<N&&!d(v.charCodeAt(B));)B++;if(B<N&&B!==X){const Y=v.slice(X,B);for(X=B;B<N&&d(v.charCodeAt(B));)B++;if(B<N&&B!==X){for(X=B;B<N&&!d(v.charCodeAt(B));)B++;(B===N||B!==X)&&(H=`\\\\${Y}\\${v.slice(X,B)}`,V=B)}}}else V=1;else u(L)&&v.charCodeAt(1)===y&&(H=v.slice(0,2),V=2,N>2&&d(v.charCodeAt(2))&&(T=!0,V=3));if(H.length>0)if(F.length>0){if(H.toLowerCase()!==F.toLowerCase())continue}else F=H;if(R){if(F.length>0)break}else if(M=`${v.slice(V)}\\${M}`,R=T,T&&F.length>0)break}return M=p(M,!R,"\\",d),R?`${F}\\${M}`:`${F}${M}`||"."},normalize(h){e(h,"path");const F=h.length;if(F===0)return".";let M=0,R,O=!1;const v=h.charCodeAt(0);if(F===1)return $(v)?"\\":h;if(d(v))if(O=!0,d(h.charCodeAt(1))){let V=2,H=V;for(;V<F&&!d(h.charCodeAt(V));)V++;if(V<F&&V!==H){const T=h.slice(H,V);for(H=V;V<F&&d(h.charCodeAt(V));)V++;if(V<F&&V!==H){for(H=V;V<F&&!d(h.charCodeAt(V));)V++;if(V===F)return`\\\\${T}\\${h.slice(H)}\\`;V!==H&&(R=`\\\\${T}\\${h.slice(H,V)}`,M=V)}}}else M=1;else u(v)&&h.charCodeAt(1)===y&&(R=h.slice(0,2),M=2,F>2&&d(h.charCodeAt(2))&&(O=!0,M=3));let N=M<F?p(h.slice(M),!O,"\\",d):"";return N.length===0&&!O&&(N="."),N.length>0&&d(h.charCodeAt(F-1))&&(N+="\\"),R===void 0?O?`\\${N}`:N:O?`${R}\\${N}`:`${R}${N}`},isAbsolute(h){e(h,"path");const F=h.length;if(F===0)return!1;const M=h.charCodeAt(0);return d(M)||F>2&&u(M)&&h.charCodeAt(1)===y&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let F,M;for(let v=0;v<h.length;++v){const N=h[v];e(N,"path"),N.length>0&&(F===void 0?F=M=N:F+=`\\${N}`)}if(F===void 0)return".";let R=!0,O=0;if(typeof M=="string"&&d(M.charCodeAt(0))){++O;const v=M.length;v>1&&d(M.charCodeAt(1))&&(++O,v>2&&(d(M.charCodeAt(2))?++O:R=!1))}if(R){for(;O<F.length&&d(F.charCodeAt(O));)O++;O>=2&&(F=`\\${F.slice(O)}`)}return t.$fc.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F)return"";const M=t.$fc.resolve(h),R=t.$fc.resolve(F);if(M===R||(h=M.toLowerCase(),F=R.toLowerCase(),h===F))return"";let O=0;for(;O<h.length&&h.charCodeAt(O)===w;)O++;let v=h.length;for(;v-1>O&&h.charCodeAt(v-1)===w;)v--;const N=v-O;let V=0;for(;V<F.length&&F.charCodeAt(V)===w;)V++;let H=F.length;for(;H-1>V&&F.charCodeAt(H-1)===w;)H--;const T=H-V,L=N<T?N:T;let B=-1,X=0;for(;X<L;X++){const de=h.charCodeAt(O+X);if(de!==F.charCodeAt(V+X))break;de===w&&(B=X)}if(X!==L){if(B===-1)return R}else{if(T>L){if(F.charCodeAt(V+X)===w)return R.slice(V+X+1);if(X===2)return R.slice(V+X)}N>L&&(h.charCodeAt(O+X)===w?B=X:X===2&&(B=3)),B===-1&&(B=0)}let Y="";for(X=O+B+1;X<=v;++X)(X===v||h.charCodeAt(X)===w)&&(Y+=Y.length===0?"..":"\\..");return V+=B,Y.length>0?`${Y}${R.slice(V,H)}`:(R.charCodeAt(V)===w&&++V,R.slice(V,H))},toNamespacedPath(h){if(typeof h!="string"||h.length===0)return h;const F=t.$fc.resolve(h);if(F.length<=2)return h;if(F.charCodeAt(0)===w){if(F.charCodeAt(1)===w){const M=F.charCodeAt(2);if(M!==I&&M!==A)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(u(F.charCodeAt(0))&&F.charCodeAt(1)===y&&F.charCodeAt(2)===w)return`\\\\?\\${F}`;return h},dirname(h){e(h,"path");const F=h.length;if(F===0)return".";let M=-1,R=0;const O=h.charCodeAt(0);if(F===1)return d(O)?h:".";if(d(O)){if(M=R=1,d(h.charCodeAt(1))){let V=2,H=V;for(;V<F&&!d(h.charCodeAt(V));)V++;if(V<F&&V!==H){for(H=V;V<F&&d(h.charCodeAt(V));)V++;if(V<F&&V!==H){for(H=V;V<F&&!d(h.charCodeAt(V));)V++;if(V===F)return h;V!==H&&(M=R=V+1)}}}}else u(O)&&h.charCodeAt(1)===y&&(M=F>2&&d(h.charCodeAt(2))?3:2,R=M);let v=-1,N=!0;for(let V=F-1;V>=R;--V)if(d(h.charCodeAt(V))){if(!N){v=V;break}}else N=!1;if(v===-1){if(M===-1)return".";v=M}return h.slice(0,v)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let M=0,R=-1,O=!0,v;if(h.length>=2&&u(h.charCodeAt(0))&&h.charCodeAt(1)===y&&(M=2),F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let N=F.length-1,V=-1;for(v=h.length-1;v>=M;--v){const H=h.charCodeAt(v);if(d(H)){if(!O){M=v+1;break}}else V===-1&&(O=!1,V=v+1),N>=0&&(H===F.charCodeAt(N)?--N===-1&&(R=v):(N=-1,R=V))}return M===R?R=V:R===-1&&(R=h.length),h.slice(M,R)}for(v=h.length-1;v>=M;--v)if(d(h.charCodeAt(v))){if(!O){M=v+1;break}}else R===-1&&(O=!1,R=v+1);return R===-1?"":h.slice(M,R)},extname(h){e(h,"path");let F=0,M=-1,R=0,O=-1,v=!0,N=0;h.length>=2&&h.charCodeAt(1)===y&&u(h.charCodeAt(0))&&(F=R=2);for(let V=h.length-1;V>=F;--V){const H=h.charCodeAt(V);if(d(H)){if(!v){R=V+1;break}continue}O===-1&&(v=!1,O=V+1),H===A?M===-1?M=V:N!==1&&(N=1):M!==-1&&(N=-1)}return M===-1||O===-1||N===0||N===1&&M===O-1&&M===R+1?"":h.slice(M,O)},format:c.bind(null,"\\"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const M=h.length;let R=0,O=h.charCodeAt(0);if(M===1)return d(O)?(F.root=F.dir=h,F):(F.base=F.name=h,F);if(d(O)){if(R=1,d(h.charCodeAt(1))){let B=2,X=B;for(;B<M&&!d(h.charCodeAt(B));)B++;if(B<M&&B!==X){for(X=B;B<M&&d(h.charCodeAt(B));)B++;if(B<M&&B!==X){for(X=B;B<M&&!d(h.charCodeAt(B));)B++;B===M?R=B:B!==X&&(R=B+1)}}}}else if(u(O)&&h.charCodeAt(1)===y){if(M<=2)return F.root=F.dir=h,F;if(R=2,d(h.charCodeAt(2))){if(M===3)return F.root=F.dir=h,F;R=3}}R>0&&(F.root=h.slice(0,R));let v=-1,N=R,V=-1,H=!0,T=h.length-1,L=0;for(;T>=R;--T){if(O=h.charCodeAt(T),d(O)){if(!H){N=T+1;break}continue}V===-1&&(H=!1,V=T+1),O===A?v===-1?v=T:L!==1&&(L=1):v!==-1&&(L=-1)}return V!==-1&&(v===-1||L===0||L===1&&v===V-1&&v===N+1?F.base=F.name=h.slice(N,V):(F.name=h.slice(N,v),F.base=h.slice(N,V),F.ext=h.slice(v,V))),N>0&&N!==R?F.dir=h.slice(0,N-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(r){const h=/\\/g;return()=>{const F=k.cwd().replace(h,"/");return F.slice(F.indexOf("/"))}}return()=>k.cwd()})();t.$gc={resolve(...h){let F="",M=!1;for(let R=h.length-1;R>=-1&&!M;R--){const O=R>=0?h[R]:f();e(O,"path"),O.length!==0&&(F=`${O}/${F}`,M=O.charCodeAt(0)===b)}return F=p(F,!M,"/",$),M?`/${F}`:F.length>0?F:"."},normalize(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===b,M=h.charCodeAt(h.length-1)===b;return h=p(h,!F,"/",$),h.length===0?F?"/":M?"./":".":(M&&(h+="/"),F?`/${h}`:h)},isAbsolute(h){return e(h,"path"),h.length>0&&h.charCodeAt(0)===b},join(...h){if(h.length===0)return".";let F;for(let M=0;M<h.length;++M){const R=h[M];e(R,"path"),R.length>0&&(F===void 0?F=R:F+=`/${R}`)}return F===void 0?".":t.$gc.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F||(h=t.$gc.resolve(h),F=t.$gc.resolve(F),h===F))return"";const M=1,R=h.length,O=R-M,v=1,N=F.length-v,V=O<N?O:N;let H=-1,T=0;for(;T<V;T++){const B=h.charCodeAt(M+T);if(B!==F.charCodeAt(v+T))break;B===b&&(H=T)}if(T===V)if(N>V){if(F.charCodeAt(v+T)===b)return F.slice(v+T+1);if(T===0)return F.slice(v+T)}else O>V&&(h.charCodeAt(M+T)===b?H=T:T===0&&(H=0));let L="";for(T=M+H+1;T<=R;++T)(T===R||h.charCodeAt(T)===b)&&(L+=L.length===0?"..":"/..");return`${L}${F.slice(v+H)}`},toNamespacedPath(h){return h},dirname(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===b;let M=-1,R=!0;for(let O=h.length-1;O>=1;--O)if(h.charCodeAt(O)===b){if(!R){M=O;break}}else R=!1;return M===-1?F?"/":".":F&&M===1?"//":h.slice(0,M)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let M=0,R=-1,O=!0,v;if(F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let N=F.length-1,V=-1;for(v=h.length-1;v>=0;--v){const H=h.charCodeAt(v);if(H===b){if(!O){M=v+1;break}}else V===-1&&(O=!1,V=v+1),N>=0&&(H===F.charCodeAt(N)?--N===-1&&(R=v):(N=-1,R=V))}return M===R?R=V:R===-1&&(R=h.length),h.slice(M,R)}for(v=h.length-1;v>=0;--v)if(h.charCodeAt(v)===b){if(!O){M=v+1;break}}else R===-1&&(O=!1,R=v+1);return R===-1?"":h.slice(M,R)},extname(h){e(h,"path");let F=-1,M=0,R=-1,O=!0,v=0;for(let N=h.length-1;N>=0;--N){const V=h.charCodeAt(N);if(V===b){if(!O){M=N+1;break}continue}R===-1&&(O=!1,R=N+1),V===A?F===-1?F=N:v!==1&&(v=1):F!==-1&&(v=-1)}return F===-1||R===-1||v===0||v===1&&F===R-1&&F===M+1?"":h.slice(F,R)},format:c.bind(null,"/"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const M=h.charCodeAt(0)===b;let R;M?(F.root="/",R=1):R=0;let O=-1,v=0,N=-1,V=!0,H=h.length-1,T=0;for(;H>=R;--H){const L=h.charCodeAt(H);if(L===b){if(!V){v=H+1;break}continue}N===-1&&(V=!1,N=H+1),L===A?O===-1?O=H:T!==1&&(T=1):O!==-1&&(T=-1)}if(N!==-1){const L=v===0&&M?1:v;O===-1||T===0||T===1&&O===N-1&&O===v+1?F.base=F.name=h.slice(L,N):(F.name=h.slice(L,O),F.base=h.slice(L,N),F.ext=h.slice(O,N))}return v>0?F.dir=h.slice(0,v-1):M&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=r?t.$fc.normalize:t.$gc.normalize,t.$ic=r?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=r?t.$fc.join:t.$gc.join,t.$kc=r?t.$fc.resolve:t.$gc.resolve,t.$lc=r?t.$fc.relative:t.$gc.relative,t.$mc=r?t.$fc.dirname:t.$gc.dirname,t.$nc=r?t.$fc.basename:t.$gc.basename,t.$oc=r?t.$fc.extname:t.$gc.extname,t.$pc=r?t.$fc.format:t.$gc.format,t.$qc=r?t.$fc.parse:t.$gc.parse,t.$rc=r?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=r?t.$fc.sep:t.$gc.sep,t.$tc=r?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],pe([1,0,24,5,10,7]),function(ie,t,k,C,s,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=void 0;function E(v){return v===47||v===92}t.$Yf=E;function A(v){return v.replace(/[\\/]/g,k.$gc.sep)}t.$Zf=A;function b(v){return v.indexOf("/")===-1&&(v=A(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$1f=b;function w(v,N=k.$gc.sep){if(!v)return"";const V=v.length,H=v.charCodeAt(0);if(E(H)){if(E(v.charCodeAt(1))&&!E(v.charCodeAt(2))){let L=3;const B=L;for(;L<V&&!E(v.charCodeAt(L));L++);if(B!==L&&!E(v.charCodeAt(L+1))){for(L+=1;L<V;L++)if(E(v.charCodeAt(L)))return v.slice(0,L+1).replace(/[\\/]/g,N)}}return N}else if($(H)&&v.charCodeAt(1)===58)return E(v.charCodeAt(2))?v.slice(0,2)+N:v.slice(0,2);let T=v.indexOf("://");if(T!==-1){for(T+=3;T<V;T++)if(E(v.charCodeAt(T)))return v.slice(0,T+1)}return""}t.$2f=w;function y(v){if(!C.$i||!v||v.length<5)return!1;let N=v.charCodeAt(0);if(N!==92||(N=v.charCodeAt(1),N!==92))return!1;let V=2;const H=V;for(;V<v.length&&(N=v.charCodeAt(V),N!==92);V++);return!(H===V||(N=v.charCodeAt(V+1),isNaN(N)||N===92))}t.$3f=y;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,N=C.$i){const V=N?I:o;return!(!v||v.length===0||/^\s+$/.test(v)||(V.lastIndex=0,V.test(v))||N&&a.test(v)||v==="."||v===".."||N&&v[v.length-1]==="."||N&&v.length!==v.trim().length||v.length>255)}t.$4f=e;function r(v,N,V){const H=v===N;return!V||H?H:!v||!N?!1:(0,s.$0e)(v,N)}t.$5f=r;function d(v,N,V,H=k.sep){if(v===N)return!0;if(!v||!N||N.length>v.length)return!1;if(V){if(!(0,s.$$e)(v,N))return!1;if(N.length===v.length)return!0;let L=N.length;return N.charAt(N.length-1)===H&&L--,v.charAt(L)===H}return N.charAt(N.length-1)!==H&&(N+=H),v.indexOf(N)===0}t.$6f=d;function $(v){return v>=65&&v<=90||v>=97&&v<=122}t.$7f=$;function u(v,N){return C.$i&&v.endsWith(":")&&(v+=k.sep),(0,k.$ic)(v)||(v=(0,k.$jc)(N,v)),v=(0,k.$hc)(v),C.$i?(v=(0,s.$Se)(v,k.sep),v.endsWith(":")&&(v+=k.sep)):(v=(0,s.$Se)(v,k.sep),v||(v=k.sep)),v}t.$8f=u;function p(v){const N=(0,k.$hc)(v);return C.$i?v.length>3?!1:c(N)&&(v.length===2||N.charCodeAt(2)===92):N===k.$gc.sep}t.$9f=p;function c(v,N=C.$i){return N?$(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$0f=c;function f(v,N=C.$i){return c(v,N)?v[0]:void 0}t.$$f=f;function h(v,N,V){return N.length>v.length?-1:v===N?0:(V&&(v=v.toLowerCase(),N=N.toLowerCase()),v.indexOf(N))}t.$_f=h;function F(v){const N=v.split(":");let V,H,T;for(const L of N){const B=Number(L);(0,j.$Kf)(B)?H===void 0?H=B:T===void 0&&(T=B):V=V?[V,L].join(":"):L}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:H!==void 0?H:void 0,column:T!==void 0?T:H!==void 0?1:void 0}}t.$ag=F;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function O(v,N,V=8){let H="";for(let L=0;L<V;L++){let B;L===0&&C.$i&&!N&&(V===3||V===4)?B=R:B=M,H+=B.charAt(Math.floor(Math.random()*B.length))}let T;return N?T=`${N}-${H}`:T=H,v?(0,k.$jc)(v,T):T}t.$bg=O}),define(be[117],pe([1,0,24]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=t.$0r=t.$9r=t.$8r=t.$7r=void 0,t.$7r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(y){const I=(0,k.$oc)(y),o=C[I.toLowerCase()];return o!==void 0?o:E(y)}t.$8r=j;function E(y){const I=(0,k.$oc)(y);return s[I.toLowerCase()]}t.$9r=E;function A(y){for(const I in s)if(s[I]===y)return I}t.$0r=A;const b=/^(.+)\/(.+?)(;.+)?$/;function w(y,I){const o=b.exec(y);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:I?void 0:y}t.$$r=w}),define(be[15],pe([1,0,24,5]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const s=/^\w[\w\d+.-]*$/,j=/^\//,E=/^\/\//;function A(R,O){if(!R.scheme&&O)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!s.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!j.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(R,O){return!R&&!O?"file":R}function w(R,O){switch(R){case"https":case"http":case"file":O?O[0]!==I&&(O=I+O):O=I;break}return O}const y="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(O){return O instanceof a?!0:O?typeof O.authority=="string"&&typeof O.fragment=="string"&&typeof O.path=="string"&&typeof O.query=="string"&&typeof O.scheme=="string"&&typeof O.fsPath=="string"&&typeof O.with=="function"&&typeof O.toString=="function":!1}constructor(O,v,N,V,H,T=!1){typeof O=="object"?(this.scheme=O.scheme||y,this.authority=O.authority||y,this.path=O.path||y,this.query=O.query||y,this.fragment=O.fragment||y):(this.scheme=b(O,T),this.authority=v||y,this.path=w(this.scheme,N||y),this.query=V||y,this.fragment=H||y,A(this,T))}get fsPath(){return c(this,!1)}with(O){if(!O)return this;let{scheme:v,authority:N,path:V,query:H,fragment:T}=O;return v===void 0?v=this.scheme:v===null&&(v=y),N===void 0?N=this.authority:N===null&&(N=y),V===void 0?V=this.path:V===null&&(V=y),H===void 0?H=this.query:H===null&&(H=y),T===void 0?T=this.fragment:T===null&&(T=y),v===this.scheme&&N===this.authority&&V===this.path&&H===this.query&&T===this.fragment?this:new d(v,N,V,H,T)}static parse(O,v=!1){const N=o.exec(O);return N?new d(N[2]||y,M(N[4]||y),M(N[5]||y),M(N[7]||y),M(N[9]||y),v):new d(y,y,y,y,y)}static file(O){let v=y;if(C.$i&&(O=O.replace(/\\/g,I)),O[0]===I&&O[1]===I){const N=O.indexOf(I,2);N===-1?(v=O.substring(2),O=I):(v=O.substring(2,N),O=O.substring(N)||I)}return new d("file",v,O,y,y)}static from(O,v){return new d(O.scheme,O.authority,O.path,O.query,O.fragment,v)}static joinPath(O,...v){if(!O.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return C.$i&&O.scheme==="file"?N=a.file(k.$fc.join(c(O,!0),...v)).path:N=k.$gc.join(O.path,...v),O.with({path:N})}toString(O=!1){return f(this,O)}toJSON(){return this}static revive(O){if(O){if(O instanceof a)return O;{const v=new d(O);return v._formatted=O.external??null,v._fsPath=O._sep===r?O.fsPath??null:null,v}}else return O}}t.URI=a;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const r=C.$i?1:void 0;class d extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(O=!1){return O?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const O={$mid:1};return this._fsPath&&(O.fsPath=this._fsPath,O._sep=r),this._formatted&&(O.external=this._formatted),this.path&&(O.path=this.path),this.scheme&&(O.scheme=this.scheme),this.authority&&(O.authority=this.authority),this.query&&(O.query=this.query),this.fragment&&(O.fragment=this.fragment),O}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(R,O,v){let N,V=-1;for(let H=0;H<R.length;H++){const T=R.charCodeAt(H);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||O&&T===47||v&&T===91||v&&T===93||v&&T===58)V!==-1&&(N+=encodeURIComponent(R.substring(V,H)),V=-1),N!==void 0&&(N+=R.charAt(H));else{N===void 0&&(N=R.substr(0,H));const L=$[T];L!==void 0?(V!==-1&&(N+=encodeURIComponent(R.substring(V,H)),V=-1),N+=L):V===-1&&(V=H)}}return V!==-1&&(N+=encodeURIComponent(R.substring(V))),N!==void 0?N:R}function p(R){let O;for(let v=0;v<R.length;v++){const N=R.charCodeAt(v);N===35||N===63?(O===void 0&&(O=R.substr(0,v)),O+=$[N]):O!==void 0&&(O+=R[v])}return O!==void 0?O:R}function c(R,O){let v;return R.authority&&R.path.length>1&&R.scheme==="file"?v=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?O?v=R.path.substr(1):v=R.path[1].toLowerCase()+R.path.substr(2):v=R.path,C.$i&&(v=v.replace(/\//g,"\\")),v}t.$wc=c;function f(R,O){const v=O?p:u;let N="",{scheme:V,authority:H,path:T,query:L,fragment:B}=R;if(V&&(N+=V,N+=":"),(H||V==="file")&&(N+=I,N+=I),H){let X=H.indexOf("@");if(X!==-1){const Y=H.substr(0,X);H=H.substr(X+1),X=Y.lastIndexOf(":"),X===-1?N+=v(Y,!1,!1):(N+=v(Y.substr(0,X),!1,!1),N+=":",N+=v(Y.substr(X+1),!1,!0)),N+="@"}H=H.toLowerCase(),X=H.lastIndexOf(":"),X===-1?N+=v(H,!1,!0):(N+=v(H.substr(0,X),!1,!0),N+=H.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}N+=v(T,!0,!1)}return L&&(N+="?",N+=v(L,!1,!1)),B&&(N+="#",N+=O?B:u(B,!1,!1)),N}function h(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+h(R.substr(3)):R}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function M(R){return R.match(F)?R.replace(F,O=>h(O)):R}}),define(be[53],pe([1,0,33,15]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ah=t.$zh=t.$yh=void 0;function s(b){return JSON.stringify(b,E)}t.$yh=s;function j(b){let w=JSON.parse(b);return w=A(w),w}t.$zh=j;function E(b,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function A(b,w=0){if(!b||w>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return C.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof k.$he||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=A(b[y],w+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=A(b[y],w+1))}return b}t.$Ah=A}),define(be[31],pe([1,0,6,5,10,15]),function(ie,t,k,C,s,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.Schemas=void 0;var E;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(E||(t.Schemas=E={}));function A(o,a){return j.URI.isUri(o)?(0,s.$0e)(o.scheme,a):(0,s.$$e)(o,a+":")}t.$cg=A;function b(o,...a){return a.some(e=>A(o,e))}t.$dg=b,t.$eg="vscode-tkn",t.$fg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${E.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${E.vscodeRemoteResource}`}set(a,e,r){this.a[a]=e,this.b[a]=r}setConnectionToken(a,e){this.c[a]=e}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(p){return k.$1(p),a}const e=a.authority;let r=this.a[e];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const d=this.b[e],$=this.c[e];let u=`path=${encodeURIComponent(a.path)}`;return typeof $=="string"&&(u+=`&${t.$fg}=${encodeURIComponent($)}`),j.URI.from({scheme:C.$o?this.d:E.vscodeRemoteResource,authority:`${r}:${d}`,path:this.f,query:u})}}t.$gg=new w,t.$hg="vs/../../extensions",t.$ig="vs/../../node_modules",t.$jg="vs/../../node_modules.asar",t.$kg="vs/../../node_modules.asar.unpacked",t.$lg="vscode-app";class y{static{this.a=t.$lg}asBrowserUri(a){const e=this.b(a,ie);return this.uriToBrowserUri(e)}uriToBrowserUri(a){return a.scheme===E.vscodeRemote?t.$gg.rewrite(a):a.scheme===E.file&&(C.$m||C.$q===`${E.vscodeFileResource}://${y.a}`)?a.with({scheme:E.vscodeFileResource,authority:a.authority||y.a,query:null,fragment:null}):a}asFileUri(a){const e=this.b(a,ie);return this.uriToFileUri(e)}uriToFileUri(a){return a.scheme===E.vscodeFileResource?a.with({scheme:E.file,authority:a.authority!==y.a?a.authority:null,query:null,fragment:null}):a}b(a,e){return j.URI.isUri(a)?a:j.URI.parse(e.toUrl(a))}}t.$mg=new y;var I;(function(o){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(a.get("3"));const e="vscode-coi";function r($){let u;typeof $=="string"?u=new URL($).searchParams:$ instanceof URL?u=$.searchParams:j.URI.isUri($)&&(u=new URL($.toString(!0)).searchParams);const p=u?.get(e);if(p)return a.get(p)}o.getHeadersFromQuery=r;function d($,u,p){if(!globalThis.crossOriginIsolated)return;const c=u&&p?"3":p?"2":"1";$ instanceof URLSearchParams?$.set(e,c):$[e]=c}o.addSearchParam=d})(I||(t.COI=I={}))}),define(be[37],pe([1,0,116,31,24,5,10,15]),function(ie,t,k,C,s,j,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pg=t.DataUri=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=void 0;function b(a){return(0,A.$wc)(a,!0)}t.$tg=b;class w{constructor(e){this.a=e}compare(e,r,d=!1){return e===r?0:(0,E.$3e)(this.getComparisonKey(e,d),this.getComparisonKey(r,d))}isEqual(e,r,d=!1){return e===r?!0:!e||!r?!1:this.getComparisonKey(e,d)===this.getComparisonKey(r,d)}getComparisonKey(e,r=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,r,d=!1){if(e.scheme===r.scheme){if(e.scheme===C.Schemas.file)return k.$6f(b(e),b(r),this.a(e))&&e.query===r.query&&(d||e.fragment===r.fragment);if((0,t.$Kg)(e.authority,r.authority))return k.$6f(e.path,r.path,this.a(e),"/")&&e.query===r.query&&(d||e.fragment===r.fragment)}return!1}joinPath(e,...r){return A.URI.joinPath(e,...r)}basenameOrAuthority(e){return(0,t.$Cg)(e)||e.authority}basename(e){return s.$gc.basename(e.path)}extname(e){return s.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let r;return e.scheme===C.Schemas.file?r=A.URI.file(s.$mc(b(e))).path:(r=s.$gc.dirname(e.path),e.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),r="/")),e.with({path:r})}normalizePath(e){if(!e.path.length)return e;let r;return e.scheme===C.Schemas.file?r=A.URI.file(s.$hc(b(e))).path:r=s.$gc.normalize(e.path),e.with({path:r})}relativePath(e,r){if(e.scheme!==r.scheme||!(0,t.$Kg)(e.authority,r.authority))return;if(e.scheme===C.Schemas.file){const u=s.$lc(b(e),b(r));return j.$i?k.$Zf(u):u}let d=e.path||"/";const $=r.path||"/";if(this.a(e)){let u=0;for(const p=Math.min(d.length,$.length);u<p&&!(d.charCodeAt(u)!==$.charCodeAt(u)&&d.charAt(u).toLowerCase()!==$.charAt(u).toLowerCase());u++);d=$.substr(0,u)+d.substr(u)}return s.$gc.relative(d,$)}resolvePath(e,r){if(e.scheme===C.Schemas.file){const d=A.URI.file(s.$kc(b(e),r));return e.with({authority:d.authority,path:d.path})}return r=k.$1f(r),e.with({path:s.$gc.resolve(e.path,r)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,r){return e===r||e!==void 0&&r!==void 0&&(0,E.$0e)(e,r)}hasTrailingPathSeparator(e,r=s.sep){if(e.scheme===C.Schemas.file){const d=b(e);return d.length>k.$2f(d).length&&d[d.length-1]===r}else{const d=e.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,r=s.sep){return(0,t.$Lg)(e,r)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,r=s.sep){let d=!1;if(e.scheme===C.Schemas.file){const $=b(e);d=$!==void 0&&$.length===k.$2f($).length&&$[$.length-1]===r}else{r="/";const $=e.path;d=$.length===1&&$.charCodeAt($.length-1)===47}return!d&&!(0,t.$Lg)(e,r)?e.with({path:e.path+"/"}):e}}t.$ug=w,t.$vg=new w(()=>!1),t.$wg=new w(a=>a.scheme===C.Schemas.file?!j.$k:!0),t.$xg=new w(a=>!0),t.$yg=t.$vg.isEqual.bind(t.$vg),t.$zg=t.$vg.isEqualOrParent.bind(t.$vg),t.$Ag=t.$vg.getComparisonKey.bind(t.$vg),t.$Bg=t.$vg.basenameOrAuthority.bind(t.$vg),t.$Cg=t.$vg.basename.bind(t.$vg),t.$Dg=t.$vg.extname.bind(t.$vg),t.$Eg=t.$vg.dirname.bind(t.$vg),t.$Fg=t.$vg.joinPath.bind(t.$vg),t.$Gg=t.$vg.normalizePath.bind(t.$vg),t.$Hg=t.$vg.relativePath.bind(t.$vg),t.$Ig=t.$vg.resolvePath.bind(t.$vg),t.$Jg=t.$vg.isAbsolutePath.bind(t.$vg),t.$Kg=t.$vg.isEqualAuthority.bind(t.$vg),t.$Lg=t.$vg.hasTrailingPathSeparator.bind(t.$vg),t.$Mg=t.$vg.removeTrailingPathSeparator.bind(t.$vg),t.$Ng=t.$vg.addTrailingPathSeparator.bind(t.$vg);function y(a,e){const r=[];for(let d=0;d<a.length;d++){const $=e(a[d]);a.some((u,p)=>p===d?!1:(0,t.$zg)($,e(u)))||r.push(a[d])}return r}t.$Og=y;var I;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(r){const d=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,f]=p.split(":");c&&f&&d.set(c,f)});const u=r.path.substring(0,r.path.indexOf(";"));return u&&d.set(a.META_DATA_MIME,u),d}a.parseMetaData=e})(I||(t.DataUri=I={}));function o(a,e,r){if(e){let d=a.path;return d&&d[0]!==s.$gc.sep&&(d=s.$gc.sep+d),a.with({scheme:r,authority:e,path:d})}return a.with({scheme:r})}t.$Pg=o}),define(be[9],pe([1,0,29,6,4,2,37,5,50,23]),function(ie,t,k,C,s,j,E,A,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.Promises=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=void 0;function y(m){return!!m&&typeof m.then=="function"}t.$Qg=y;function I(m){const i=new k.$4d,n=m(i.token),l=new Promise((D,S)=>{const z=i.token.onCancellationRequested(()=>{z.dispose(),S(new C.$5)});Promise.resolve(n).then(P=>{z.dispose(),i.dispose(),D(P)},P=>{z.dispose(),i.dispose(),S(P)})});return new class{cancel(){i.cancel(),i.dispose()}then(D,S){return l.then(D,S)}catch(D){return this.then(void 0,D)}finally(D){return l.finally(D)}}}t.$Rg=I;function o(m,i,n){return new Promise((l,D)=>{const S=i.onCancellationRequested(()=>{S.dispose(),l(n)});m.then(l,D).finally(()=>S.dispose())})}t.$Sg=o;function a(m,i){return new Promise((n,l)=>{const D=i.onCancellationRequested(()=>{D.dispose(),l(new C.$5)});m.then(n,l).finally(()=>D.dispose())})}t.$Tg=a;async function e(m){let i=-1;const n=m.map((l,D)=>l.then(S=>(i=D,S)));try{return await Promise.race(n)}finally{m.forEach((l,D)=>{D!==i&&l.cancel()})}}t.$Ug=e;function r(m,i,n){let l;const D=setTimeout(()=>{l?.(void 0),n?.()},i);return Promise.race([m.finally(()=>clearTimeout(D)),new Promise(S=>l=S)])}t.$Vg=r;function d(m){return new Promise((i,n)=>{const l=m();y(l)?l.then(i,n):i(l)})}t.$Wg=d;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(i){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=i,!this.b){const n=()=>{if(this.b=null,this.f)return;const l=this.queue(this.d);return this.d=null,l};this.b=new Promise(l=>{this.a.then(n,n).then(l)})}return new Promise((n,l)=>{this.b.then(n,l)})}return this.a=i(),new Promise((n,l)=>{this.a.then(D=>{this.a=null,n(D)},D=>{this.a=null,l(D)})})}dispose(){this.f=!0}}t.$Xg=$;class u{constructor(){this.a=Promise.resolve(null)}queue(i){return this.a=this.a.then(()=>i(),()=>i())}}t.$Yg=u;class p{constructor(){this.a=new Map}queue(i,n){const D=(this.a.get(i)??Promise.resolve()).catch(()=>{}).then(n).finally(()=>{this.a.get(i)===D&&this.a.delete(i)});return this.a.set(i,D),D}}t.$Zg=p;const c=(m,i)=>{let n=!0;const l=setTimeout(()=>{n=!1,i()},m);return{isTriggered:()=>n,dispose:()=>{clearTimeout(l),n=!1}}},f=m=>{let i=!0;return queueMicrotask(()=>{i&&(i=!1,m())}),{isTriggered:()=>i,dispose:()=>{i=!1}}};class h{constructor(i){this.defaultDelay=i,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(i,n=this.defaultDelay){this.g=i,this.h(),this.b||(this.b=new Promise((D,S)=>{this.d=D,this.f=S}).then(()=>{if(this.b=null,this.d=null,this.g){const D=this.g;return this.g=null,D()}}));const l=()=>{this.a=null,this.d?.(null)};return this.a=n===b.$Qd?f(l):c(n,l),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$1g=h;class F{constructor(i){this.a=new h(i),this.b=new $}trigger(i,n){return this.a.trigger(()=>this.b.queue(i),n)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$2g=F;class M{constructor(){this.a=!1,this.b=new Promise((i,n)=>{this.d=i})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$3g=M;class R extends M{constructor(i){super(),this.f=setTimeout(()=>this.open(),i)}open(){clearTimeout(this.f),super.open()}}t.$4g=R;function O(m,i){return i?new Promise((n,l)=>{const D=setTimeout(()=>{S.dispose(),n()},m),S=i.onCancellationRequested(()=>{clearTimeout(D),S.dispose(),l(new C.$5)})}):I(n=>O(m,n))}t.$5g=O;function v(m,i=0,n){const l=setTimeout(()=>{m(),n&&D.dispose()},i),D=(0,j.$Rc)(()=>{clearTimeout(l),n?.deleteAndLeak(D)});return n?.add(D),D}t.$6g=v;function N(m){const i=[];let n=0;const l=m.length;function D(){return n<l?m[n++]():null}function S(z){z!=null&&i.push(z);const P=D();return P?P.then(S):Promise.resolve(i)}return Promise.resolve(null).then(S)}t.$7g=N;function V(m,i=l=>!!l,n=null){let l=0;const D=m.length,S=()=>{if(l>=D)return Promise.resolve(n);const z=m[l++];return Promise.resolve(z()).then(U=>i(U)?Promise.resolve(U):S())};return S()}t.$8g=V;function H(m,i=l=>!!l,n=null){if(m.length===0)return Promise.resolve(n);let l=m.length;const D=()=>{l=-1;for(const S of m)S.cancel?.()};return new Promise((S,z)=>{for(const P of m)P.then(U=>{--l>=0&&i(U)?(D(),S(U)):l===0&&S(n)}).catch(U=>{--l>=0&&(D(),z(U))})})}t.$9g=H;class T{constructor(i){this.a=0,this.d=i,this.f=[],this.b=0,this.g=new s.$Td}get onDrained(){return this.g.event}get size(){return this.a}queue(i){return this.a++,new Promise((n,l)=>{this.f.push({factory:i,c:n,e:l}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const i=this.f.shift();this.b++;const n=i.factory();n.then(i.c,i.e),n.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$0g=T;class L extends T{constructor(){super(1)}}t.$$g=L;class B{constructor(){this.a=new J,this.b=0}queue(i){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,i())):this.a.run(this.b++,i())}}t.$_g=B;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const i=new W;return this.b.add(i),i.p}g(){for(const[,i]of this.a)if(i.size>0)return!1;return!0}queueFor(i,n=E.$vg){const l=n.getComparisonKey(i);let D=this.a.get(l);if(!D){D=new L;const S=this.f++,z=s.Event.once(D.onDrained)(()=>{D?.dispose(),this.a.delete(l),this.h(),this.d?.deleteAndDispose(S),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$3c),this.d.set(S,z),this.a.set(l,D)}return D}h(){this.g()&&this.j()}j(){for(const i of this.b)i.complete();this.b.clear()}dispose(){for(const[,i]of this.a)i.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$ah=X;class Y{constructor(i,n){this.a=-1,typeof i=="function"&&typeof n=="number"&&this.setIfNotSet(i,n)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(i,n){this.cancel(),this.a=setTimeout(()=>{this.a=-1,i()},n)}setIfNotSet(i,n){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,i()},n))}}t.$bh=Y;class de{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(i,n,l=globalThis){this.cancel();const D=l.setInterval(()=>{i()},n);this.d=(0,j.$Rc)(()=>{l.clearInterval(D),this.d=void 0})}dispose(){this.cancel()}}t.$ch=de;class oe{constructor(i,n){this.b=-1,this.a=i,this.d=n,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(i=this.d){this.cancel(),this.b=setTimeout(this.f,i)}get delay(){return this.d}set delay(i){this.d=i}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$dh=oe;class ee{constructor(i,n){n%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${n}ms is not a multiple of 1000ms.`),this.a=i,this.b=n,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(i=this.b){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(i/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$eh=ee;class me extends oe{constructor(i,n){super(i,n),this.j=[]}work(i){this.j.push(i),this.isScheduled()||this.schedule()}h(){const i=this.j;this.j=[],this.a?.(i)}dispose(){this.j=[],super.dispose()}}t.$fh=me;class Pe extends j.$Tc{constructor(i,n){super(),this.g=i,this.h=n,this.a=[],this.b=this.B(new j.$Uc),this.f=!1}get pending(){return this.a.length}work(i){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+i.length>this.g.maxBufferedWork)return!1}else if(this.pending+i.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const n of i)this.a.push(n);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new oe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$gh=Pe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$ih=(m,i)=>{(0,A.$B)(()=>{if(n)return;const l=Date.now()+15;i(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,l-Date.now())}}))});let n=!1;return{dispose(){n||(n=!0)}}}:t.$ih=(m,i,n)=>{const l=m.requestIdleCallback(i,typeof n=="number"?{timeout:n}:void 0);let D=!1;return{dispose(){D||(D=!0,m.cancelIdleCallback(l))}}},t.$hh=m=>(0,t.$ih)(globalThis,m)}();class Te{constructor(i,n){this.g=!1,this.d=()=>{try{this.j=n()}catch(l){this.l=l}finally{this.g=!0}},this.f=(0,t.$ih)(i,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$jh=Te;class Me extends Te{constructor(i){super(globalThis,i)}}t.$kh=Me;async function re(m,i,n){let l;for(let D=0;D<n;D++)try{return await m()}catch(S){l=S,await O(i)}throw l}t.$lh=re;class J{isRunning(i){return typeof i=="number"?this.a?.taskId===i:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(i,n,l){return this.a={taskId:i,cancel:()=>l?.(),promise:n},n.then(()=>this.d(i),()=>this.d(i)),n}d(i){this.a&&i===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const i=this.b;this.b=void 0,i.run().then(i.promiseResolve,i.promiseReject)}}queue(i){if(this.b)this.b.run=i;else{let n,l;const D=new Promise((S,z)=>{n=S,l=z});this.b={run:i,promise:D,promiseResolve:n,promiseReject:l}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$mh=J;class le{constructor(i,n=()=>Date.now()){this.d=i,this.f=n,this.a=0,this.b=0}increment(){const i=this.f();return i-this.a>this.d&&(this.a=i,this.b=0),this.b++,this.b}}t.$nh=le;var K;(function(m){m[m.Resolved=0]="Resolved",m[m.Rejected=1]="Rejected"})(K||(K={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((i,n)=>{this.a=i,this.b=n})}complete(i){return new Promise(n=>{this.a(i),this.d={outcome:0,value:i},n()})}error(i){return new Promise(n=>{this.b(i),this.d={outcome:1,value:i},n()})}cancel(){return this.error(new C.$5)}}t.$oh=W;var Z;(function(m){async function i(l){let D;const S=await Promise.all(l.map(z=>z.then(P=>P,P=>{D||(D=P)})));if(typeof D<"u")throw D;return S}m.settled=i;function n(l){return new Promise(async(D,S)=>{try{await l(D,S)}catch(z){S(z)}})}m.withAsyncBody=n})(Z||(t.Promises=Z={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(i){this.a=void 0,this.b=void 0,this.d=!1,this.promise=i.then(n=>(this.a=n,this.d=!0,n),n=>{throw this.b=n,this.d=!0,n})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$ph=ce;class we{constructor(i){this.b=i,this.a=new w.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}t.$qh=we;var ke;(function(m){m[m.Initial=0]="Initial",m[m.DoneOK=1]="DoneOK",m[m.DoneError=2]="DoneError"})(ke||(ke={}));class Ae{static fromArray(i){return new Ae(n=>{n.emitMany(i)})}static fromPromise(i){return new Ae(async n=>{n.emitMany(await i)})}static fromPromises(i){return new Ae(async n=>{await Promise.all(i.map(async l=>n.emitOne(await l)))})}static merge(i){return new Ae(async n=>{await Promise.all(i.map(async l=>{for await(const D of l)n.emitOne(D)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(i){this.a=0,this.b=[],this.d=null,this.f=new s.$Td,queueMicrotask(async()=>{const n={emitOne:l=>this.g(l),emitMany:l=>this.h(l),reject:l=>this.k(l)};try{await Promise.resolve(i(n)),this.j()}catch(l){this.k(l)}finally{n.emitOne=void 0,n.emitMany=void 0,n.reject=void 0}})}[Symbol.asyncIterator](){let i=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(i<this.b.length)return{done:!1,value:this.b[i++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(i,n){return new Ae(async l=>{for await(const D of i)l.emitOne(n(D))})}map(i){return Ae.map(this,i)}static filter(i,n){return new Ae(async l=>{for await(const D of i)n(D)&&l.emitOne(D)})}filter(i){return Ae.filter(this,i)}static coalesce(i){return Ae.filter(i,n=>!!n)}coalesce(){return Ae.coalesce(this)}static async toPromise(i){const n=[];for await(const l of i)n.push(l);return n}toPromise(){return Ae.toPromise(this)}g(i){this.a===0&&(this.b.push(i),this.f.fire())}h(i){this.a===0&&(this.b=this.b.concat(i),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(i){this.a===0&&(this.a=2,this.d=i,this.f.fire())}}t.$rh=Ae;class Le extends Ae{constructor(i,n){super(n),this.l=i}cancel(){this.l.cancel()}}t.$sh=Le;function _(m){const i=new k.$4d,n=m(i.token);return new Le(i,async l=>{const D=i.token.onCancellationRequested(()=>{D.dispose(),i.dispose(),l.reject(new C.$5)});try{for await(const S of n){if(i.token.isCancellationRequested)return;l.emitOne(S)}D.dispose(),i.dispose()}catch(S){D.dispose(),i.dispose(),l.reject(S)}})}t.$th=_;class g{constructor(){this.a=new W,this.b=new Ae(l=>{if(i){l.reject(i);return}return n&&l.emitMany(n),this.d=D=>l.reject(D),this.f=D=>l.emitOne(D),this.a.p});let i,n;this.f=l=>{n||(n=[]),n.push(l)},this.d=l=>{i||(i=l)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(i){this.d(i),this.a.complete()}emitOne(i){this.f(i)}}t.$uh=g}),define(be[3],pe([1,0,16,114,14,19,9,6,4,118,2,31,5,15,49,21]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a,e,r){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),t.$WQ=t.$VQ=t.h=t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.DetectedFullscreenMode=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$=t.Namespace=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,d=function(){const q=new Map;(0,r.$UO)(r.$VO,1),q.set(r.$VO.vscodeWindowId,{window:r.$VO,disposables:new y.$Sc});const Q=new b.$Td,te=new b.$Td,fe=new b.$Td;return{onDidRegisterWindow:Q.event,onWillUnregisterWindow:fe.event,onDidUnregisterWindow:te.event,registerWindow(De){if(q.has(De.vscodeWindowId))return y.$Tc.None;const Re=new y.$Sc,He={window:De,disposables:Re.add(new y.$Sc)};return q.set(De.vscodeWindowId,He),Re.add((0,y.$Rc)(()=>{q.delete(De.vscodeWindowId),te.fire(De)})),Re.add(p(De,t.$kQ.BEFORE_UNLOAD,()=>{fe.fire(De)})),Q.fire(He),Re},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(De){return De.vscodeWindowId},hasWindow(De){return q.has(De)},getWindowById(De){return q.get(De)},getWindow(De){const Re=De;if(Re?.ownerDocument?.defaultView)return Re.ownerDocument.defaultView.window;const He=De;return He?.view?He.view.window:r.$VO},getDocument(De){const Re=De;return(0,t.getWindow)(Re).document}}}(),t.registerWindow=d.registerWindow,t.getWindow=d.getWindow,t.getDocument=d.getDocument,t.getWindows=d.getWindows,t.getWindowsCount=d.getWindowsCount,t.getWindowId=d.getWindowId,t.getWindowById=d.getWindowById,t.hasWindow=d.hasWindow,t.onDidRegisterWindow=d.onDidRegisterWindow,t.onWillUnregisterWindow=d.onWillUnregisterWindow,t.onDidUnregisterWindow=d.onDidUnregisterWindow;function $(q){for(;q.firstChild;)q.firstChild.remove()}t.$qP=$;class u{constructor(Q,te,fe,De){this.f=Q,this.g=te,this.d=fe,this.j=De||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function p(q,Q,te,fe){return new u(q,Q,te,fe)}t.$rP=p;function c(q,Q){return function(te){return Q(new j.$jP(q,te))}}function f(q){return function(Q){return q(new s.$oP(Q))}}const h=function(Q,te,fe,De){let Re=fe;return te==="click"||te==="mousedown"?Re=c((0,t.getWindow)(Q),fe):(te==="keydown"||te==="keypress"||te==="keyup")&&(Re=f(fe)),p(Q,te,Re,De)};t.$sP=h;const F=function(Q,te,fe){const De=c((0,t.getWindow)(Q),te);return R(Q,De,fe)};t.$tP=F;const M=function(Q,te,fe){const De=c((0,t.getWindow)(Q),te);return v(Q,De,fe)};t.$uP=M;function R(q,Q,te){return p(q,o.$r&&C.$gP.pointerEvents?t.$kQ.POINTER_DOWN:t.$kQ.MOUSE_DOWN,Q,te)}t.$vP=R;function O(q,Q,te){return p(q,o.$r&&C.$gP.pointerEvents?t.$kQ.POINTER_MOVE:t.$kQ.MOUSE_MOVE,Q,te)}t.$wP=O;function v(q,Q,te){return p(q,o.$r&&C.$gP.pointerEvents?t.$kQ.POINTER_UP:t.$kQ.MOUSE_UP,Q,te)}t.$xP=v;function N(q,Q,te){return(0,E.$ih)(q,Q,te)}t.$yP=N;class V extends E.$jh{constructor(Q,te){super(Q,te)}}t.$zP=V;function H(q,Q,te,fe){let De=0;const Re=q.setInterval(()=>{De++,(typeof fe=="number"&&De>=fe||Q()===!0)&&He.dispose()},te),He=(0,y.$Rc)(()=>{q.clearInterval(Re)});return He}t.$CP=H;class T extends E.$ch{cancelAndSet(Q,te,fe){return super.cancelAndSet(Q,te,fe)}}t.$DP=T;class L{constructor(Q,te=0){this.d=Q,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,A.$1)(Q)}}static sort(Q,te){return te.priority-Q.priority}}(function(){const q=new Map,Q=new Map,te=new Map,fe=new Map,De=Re=>{te.set(Re,!1);const He=q.get(Re)??[];for(Q.set(Re,He),q.set(Re,[]),fe.set(Re,!0);He.length>0;)He.sort(L.sort),He.shift().execute();fe.set(Re,!1)};t.$BP=(Re,He,xe=0)=>{const Ge=(0,t.getWindowId)(Re),qe=new L(He,xe);let lt=q.get(Ge);return lt||(lt=[],q.set(Ge,lt)),lt.push(qe),te.get(Ge)||(te.set(Ge,!0),Re.requestAnimationFrame(()=>De(Ge))),qe},t.$AP=(Re,He,xe)=>{const Ge=(0,t.getWindowId)(Re);if(fe.get(Ge)){const qe=new L(He,xe);let lt=Q.get(Ge);return lt||(lt=[],Q.set(Ge,lt)),lt.push(qe),qe}else return(0,t.$BP)(Re,He,xe)}})();function B(q,Q){return(0,t.$BP)(q,Q,1e4)}t.$EP=B;function X(q,Q){return(0,t.$BP)(q,Q,-1e4)}t.$FP=X;const Y=8,de=function(q,Q){return Q};class oe extends y.$Tc{constructor(Q,te,fe,De=de,Re=Y){super();let He=null,xe=0;const Ge=this.B(new E.$bh),qe=()=>{xe=new Date().getTime(),fe(He),He=null};this.B(p(Q,te,lt=>{He=De(He,lt);const Tt=new Date().getTime()-xe;Tt>=Re?(Ge.cancel(),qe()):Ge.setIfNotSet(qe,Re-Tt)}))}}function ee(q,Q,te,fe,De){return new oe(q,Q,te,fe,De)}t.$GP=ee;function me(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}t.$HP=me;function Pe(q,Q){const te=(0,t.getWindow)(q),fe=te.document;if(q!==fe.body)return new Me(q.clientWidth,q.clientHeight);if(o.$r&&te?.visualViewport)return new Me(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Me(te.innerWidth,te.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Me(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Me(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(Q)return Pe(Q);throw new Error("Unable to figure out browser width and height")}t.$IP=Pe;class Te{static d(Q,te){return parseFloat(te)||0}static f(Q,te,fe){const De=me(Q),Re=De?De.getPropertyValue(te):"0";return Te.d(Q,Re)}static getBorderLeftWidth(Q){return Te.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Te.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Te.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Te.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Te.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Te.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Te.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Te.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Te.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Te.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Te.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Te.f(Q,"margin-bottom","marginBottom")}}class Me{static{this.None=new Me(0,0)}constructor(Q,te){this.width=Q,this.height=te}with(Q=this.width,te=this.height){return Q!==this.width||te!==this.height?new Me(Q,te):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Me?Q:new Me(Q.width,Q.height)}static equals(Q,te){return Q===te?!0:!Q||!te?!1:Q.width===te.width&&Q.height===te.height}}t.$JP=Me;function re(q){let Q=q.offsetParent,te=q.offsetTop,fe=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){te-=q.scrollTop;const De=z(q)?null:me(q);De&&(fe-=De.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===Q&&(fe+=Te.getBorderLeftWidth(q),te+=Te.getBorderTopWidth(q),te+=q.offsetTop,fe+=q.offsetLeft,Q=q.offsetParent)}return{left:fe,top:te}}t.$KP=re;function J(q,Q,te){typeof Q=="number"&&(q.style.width=`${Q}px`),typeof te=="number"&&(q.style.height=`${te}px`)}t.$LP=J;function le(q,Q,te,fe,De,Re="absolute"){typeof Q=="number"&&(q.style.top=`${Q}px`),typeof te=="number"&&(q.style.right=`${te}px`),typeof fe=="number"&&(q.style.bottom=`${fe}px`),typeof De=="number"&&(q.style.left=`${De}px`),q.style.position=Re}t.$MP=le;function K(q){const Q=q.getBoundingClientRect(),te=(0,t.getWindow)(q);return{left:Q.left+te.scrollX,top:Q.top+te.scrollY,width:Q.width,height:Q.height}}t.$NP=K;function W(q){let Q=q,te=1;do{const fe=me(Q).zoom;fe!=null&&fe!=="1"&&(te*=fe),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return te}t.$OP=W;function Z(q){const Q=Te.getMarginLeft(q)+Te.getMarginRight(q);return q.offsetWidth+Q}t.$PP=Z;function ce(q){const Q=Te.getBorderLeftWidth(q)+Te.getBorderRightWidth(q),te=Te.getPaddingLeft(q)+Te.getPaddingRight(q);return q.offsetWidth-Q-te}t.$QP=ce;function we(q){const Q=Te.getMarginLeft(q)+Te.getMarginRight(q);return q.scrollWidth+Q}t.$RP=we;function ke(q){const Q=Te.getBorderTopWidth(q)+Te.getBorderBottomWidth(q),te=Te.getPaddingTop(q)+Te.getPaddingBottom(q);return q.offsetHeight-Q-te}t.$SP=ke;function Ae(q){const Q=Te.getMarginTop(q)+Te.getMarginBottom(q);return q.offsetHeight+Q}t.$TP=Ae;function Le(q,Q){if(q===null)return 0;const te=re(q),fe=re(Q);return te.left-fe.left}function _(q,Q){const te=Q.map(De=>Math.max(we(De),Z(De))+Le(De,q)||0);return Math.max(...te)}t.$UP=_;function g(q,Q){return!!Q?.contains(q)}t.$VP=g;const m="parentFlowToElementId";function i(q,Q){q.dataset[m]=Q.id}t.$WP=i;function n(q){const Q=q.dataset[m];return typeof Q=="string"?q.ownerDocument.getElementById(Q):null}function l(q,Q){let te=q;for(;te;){if(te===Q)return!0;if(te instanceof HTMLElement){const fe=n(te);if(fe){te=fe;continue}}te=te.parentNode}return!1}t.$XP=l;function D(q,Q,te){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(Q))return q;if(te){if(typeof te=="string"){if(q.classList.contains(te))return null}else if(q===te)return null}q=q.parentNode}return null}t.$YP=D;function S(q,Q,te){return!!D(q,Q,te)}t.$ZP=S;function z(q){return q&&!!q.host&&!!q.mode}t.$1P=z;function P(q){return!!U(q)}t.$2P=P;function U(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return z(q)?q:null}t.$3P=U;function G(){let q=$e().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}t.$4P=G;function ne(q){return G()===q}t.$5P=ne;function he(q){return g(G(),q)}t.$6P=he;function ve(q){return q.ownerDocument===$e()}t.$7P=ve;function $e(){return(0,t.getWindowsCount)()<=1?r.$VO.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??r.$VO.document}t.$8P=$e;function ue(){return $e().defaultView?.window??r.$VO}t.$9P=ue;function Fe(q){const Q=(0,t.getWindow)(q);Q.document.hasFocus()||Q.focus()}t.$0P=Fe;const ye=new Map;function Oe(q){return ye.has(q)}t.$$P=Oe;function Be(q=r.$VO.document.head,Q,te){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",Q?.(fe),q.appendChild(fe),te&&te.add((0,y.$Rc)(()=>q.removeChild(fe))),q===r.$VO.document.head){const De=new Set;ye.set(fe,De);for(const{window:Re,disposables:He}of(0,t.getWindows)()){if(Re===r.$VO)continue;const xe=He.add(Je(fe,De,Re));te?.add(xe)}}return fe}t.$_P=Be;function Ie(q){const Q=new y.$Sc;for(const[te,fe]of ye)Q.add(Je(te,fe,q));return Q}t.$aQ=Ie;function Je(q,Q,te){const fe=new y.$Sc,De=q.cloneNode(!0);te.document.head.appendChild(De),fe.add((0,y.$Rc)(()=>te.document.head.removeChild(De)));for(const Re of Ee(q))De.sheet?.insertRule(Re.cssText,De.sheet?.cssRules.length);return fe.add(t.$bQ.observe(q,fe,{childList:!0})(()=>{De.textContent=q.textContent})),Q.add(De),fe.add((0,y.$Rc)(()=>Q.delete(De))),fe}t.$bQ=new class{constructor(){this.mutationObservers=new Map}observe(q,Q,te){let fe=this.mutationObservers.get(q);fe||(fe=new Map,this.mutationObservers.set(q,fe));const De=(0,e.$Ri)(te);let Re=fe.get(De);if(Re)Re.users+=1;else{const He=new b.$Td,xe=new MutationObserver(qe=>He.fire(qe));xe.observe(q,te);const Ge=Re={users:1,observer:xe,onDidMutate:He.event};Q.add((0,y.$Rc)(()=>{Ge.users-=1,Ge.users===0&&(He.dispose(),xe.disconnect(),fe?.delete(De),fe?.size===0&&this.mutationObservers.delete(q))})),fe.set(De,Re)}return Re.onDidMutate}};function et(q=r.$VO.document.head){return x("meta",q)}t.$cQ=et;function Qe(q=r.$VO.document.head){return x("link",q)}t.$dQ=Qe;function x(q,Q=r.$VO.document.head){const te=document.createElement(q);return Q.appendChild(te),te}let se=null;function ge(){return se||(se=Be()),se}function Ee(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Ne(q,Q,te=ge()){if(!(!te||!Q)){te.sheet?.insertRule(`${q} {${Q}}`,0);for(const fe of ye.get(te)??[])Ne(q,Q,fe)}}t.$eQ=Ne;function je(q,Q=ge()){if(!Q)return;const te=Ee(Q),fe=[];for(let De=0;De<te.length;De++){const Re=te[De];Ve(Re)&&Re.selectorText.indexOf(q)!==-1&&fe.push(De)}for(let De=fe.length-1;De>=0;De--)Q.sheet?.deleteRule(fe[De]);for(const De of ye.get(Q)??[])je(q,De)}t.$fQ=je;function Ve(q){return typeof q.selectorText=="string"}function _e(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}t.$gQ=_e;function Ze(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}t.$hQ=Ze;function tt(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}t.$iQ=tt;function Ye(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$jQ=Ye,t.$kQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:k.$$O?"webkitAnimationStart":"animationstart",ANIMATION_END:k.$$O?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:k.$$O?"webkitAnimationIteration":"animationiteration"};function nt(q){const Q=q;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$lQ=nt,t.$mQ={stop:(q,Q)=>(q.preventDefault(),Q&&q.stopPropagation(),q)};function st(q){const Q=[];for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)Q[te]=q.scrollTop,q=q.parentNode;return Q}t.$nQ=st;function rt(q,Q){for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)q.scrollTop!==Q[te]&&(q.scrollTop=Q[te]),q=q.parentNode}t.$oQ=rt;class gt extends y.$Tc{static m(Q){if(Q instanceof HTMLElement){const te=U(Q),fe=te?te.activeElement:Q.ownerDocument.activeElement;return g(fe,Q)}else{const te=Q;return g(te.document.activeElement,te.document)}}constructor(Q){super(),this.f=this.B(new b.$Td),this.onDidFocus=this.f.event,this.g=this.B(new b.$Td),this.onDidBlur=this.g.event;let te=gt.m(Q),fe=!1;const De=()=>{fe=!1,te||(te=!0,this.f.fire())},Re=()=>{te&&(fe=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{fe&&(fe=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(Q)!==te&&(te?Re():De())},this.B(p(Q,t.$kQ.FOCUS,De,!0)),this.B(p(Q,t.$kQ.BLUR,Re,!0)),Q instanceof HTMLElement&&(this.B(p(Q,t.$kQ.FOCUS_IN,()=>this.j())),this.B(p(Q,t.$kQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(q){return new gt(q)}t.$pQ=At;function St(q,Q){return q.after(Q),Q}t.$qQ=St;function wt(q,...Q){if(q.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$rQ=wt;function Ot(q,Q){return q.insertBefore(Q,q.firstChild),Q}t.$sQ=Ot;function ze(q,...Q){q.innerText="",wt(q,...Q)}t.$tQ=ze;const ae=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Se;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(Se||(t.Namespace=Se={}));function Ce(q,Q,te,...fe){const De=ae.exec(Q);if(!De)throw new Error("Bad use of emmet");const Re=De[1]||"div";let He;return q!==Se.HTML?He=document.createElementNS(q,Re):He=document.createElement(Re),De[3]&&(He.id=De[3]),De[4]&&(He.className=De[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([xe,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(xe)?He[xe]=Ge:xe==="selected"?Ge&&He.setAttribute(xe,"true"):He.setAttribute(xe,Ge))}),He.append(...fe),He}function We(q,Q,...te){return Ce(Se.HTML,q,Q,...te)}t.$=We,We.SVG=function(q,Q,...te){return Ce(Se.SVG,q,Q,...te)};function it(q,Q){const te=[];return q.forEach((fe,De)=>{De>0&&(Q instanceof Node?te.push(Q.cloneNode()):te.push(document.createTextNode(Q))),te.push(fe)}),te}t.$vQ=it;function at(q,...Q){q?Ke(...Q):ut(...Q)}t.$wQ=at;function Ke(...q){for(const Q of q)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$xQ=Ke;function ut(...q){for(const Q of q)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$yQ=ut;function vt(q,Q){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(Q))return q;q=q.parentNode}return null}function Ft(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&vt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}t.$zQ=Ft;function Gt(q){return Q=>{Q.preventDefault(),Q.stopPropagation(),q(Q)}}t.$AQ=Gt;function ki(q){return new Promise(Q=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)Q(void 0);else{const fe=()=>{q.window.removeEventListener("DOMContentLoaded",fe,!1),Q()};q.window.addEventListener("DOMContentLoaded",fe,!1)}})}t.$BQ=ki;function Ai(q,Q){const te=q.devicePixelRatio*Q;return Math.max(1,Math.floor(te))/q.devicePixelRatio}t.$CQ=Ai;function Si(q){r.$VO.open(q,"_blank","noopener")}t.$DQ=Si;const Xt=780,Yt=640;function Fi(q){const Q=Math.floor(r.$VO.screenLeft+r.$VO.innerWidth/2-Xt/2),te=Math.floor(r.$VO.screenTop+r.$VO.innerHeight/2-Yt/2);r.$VO.open(q,"_blank",`width=${Xt},height=${Yt},top=${te},left=${Q}`)}t.$EQ=Fi;function Ti(q,Q=!0){const te=r.$VO.open();return te?(Q&&(te.opener=null),te.location.href=q,!0):!1}t.$FQ=Ti;function Ni(q,Q){const te=()=>{Q(),fe=(0,t.$BP)(q,te)};let fe=(0,t.$BP)(q,te);return(0,y.$Rc)(()=>fe.dispose())}t.$GQ=Ni,I.$gg.setPreferredWebSchema(/^https:/.test(r.$VO.location.href)?"https":"http");function Ci(q){return q?`url('${I.$mg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$HQ=Ci;function Pi(q){return`'${q.replace(/'/g,"%27")}'`}t.$IQ=Pi;function Jt(q,Q){if(q!==void 0){const te=q.match(/^\s*var\((.+)\)$/);if(te){const fe=te[1].split(",",2);return fe.length===2&&(Q=Jt(fe[1].trim(),Q)),`var(${fe[0]}, ${Q})`}return q}return Q}t.$JQ=Jt;function Ri(q,Q){let te;if(a.URI.isUri(q))te=q.toString(!0);else{const Re=new Blob([q]);te=URL.createObjectURL(Re),setTimeout(()=>URL.revokeObjectURL(te))}const fe=ue(),De=document.createElement("a");fe.document.body.appendChild(De),De.download=Q,De.href=te,De.click(),setTimeout(()=>fe.document.body.removeChild(De))}t.$KQ=Ri;function Li(){return new Promise(q=>{const Q=ue(),te=document.createElement("input");Q.document.body.appendChild(te),te.type="file",te.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(te,"input"))(()=>{q(te.files??void 0)}),te.click(),setTimeout(()=>Q.document.body.removeChild(te))})}t.$LQ=Li;var Dt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Ii(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:Dt.BROWSER,guess:!1}:(o.$j||o.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}t.$MQ=Ii;function Zt(q,Q=!1){const te=document.createElement("a");return w.addHook("afterSanitizeAttributes",fe=>{for(const De of["href","src"])if(fe.hasAttribute(De)){const Re=fe.getAttribute(De);if(De==="href"&&Re.startsWith("#"))continue;if(te.href=Re,!q.includes(te.protocol.replace(/:$/,""))){if(Q&&De==="src"&&te.href.startsWith("data:"))continue;fe.removeAttribute(De)}}}),(0,y.$Rc)(()=>{w.removeHook("afterSanitizeAttributes")})}t.$NQ=Zt;const Mi=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.$OQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Oi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(q,Q){const te=Zt(Mi);try{const fe=w.sanitize(Q,Oi);q.innerHTML=fe}finally{te.dispose()}}t.$PQ=Bi;function zi(q){const Q=new Uint16Array(q.length);for(let De=0;De<Q.length;De++)Q[De]=q.charCodeAt(De);let te="";const fe=new Uint8Array(Q.buffer);for(let De=0;De<fe.length;De++)te+=String.fromCharCode(fe[De]);return te}function ji(q){return btoa(zi(q))}t.$QQ=ji;class bt extends b.$Td{constructor(){super(),this.o=new y.$Sc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:te})=>this.B(Q,te),{window:r.$VO,disposables:this.o}))}B(Q,te){te.add(p(Q,"keydown",fe=>{if(fe.defaultPrevented)return;const De=new s.$oP(fe);if(!(De.keyCode===6&&fe.repeat)){if(fe.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(fe.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(fe.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(fe.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(De.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=fe.altKey,this.s.ctrlKey=fe.ctrlKey,this.s.metaKey=fe.metaKey,this.s.shiftKey=fe.shiftKey,this.s.lastKeyPressed&&(this.s.event=fe,this.fire(this.s))}},!0)),te.add(p(Q,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!fe.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!fe.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!fe.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=fe.altKey,this.s.ctrlKey=fe.ctrlKey,this.s.metaKey=fe.metaKey,this.s.shiftKey=fe.shiftKey,this.s.lastKeyReleased&&(this.s.event=fe,this.fire(this.s)))},!0)),te.add(p(Q.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),te.add(p(Q.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),te.add(p(Q.document.body,"mousemove",fe=>{fe.buttons&&(this.s.lastKeyPressed=void 0)},!0)),te.add(p(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$RQ=bt;function Hi(q){const Q=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$SQ=Hi;class Ui extends y.$Tc{constructor(Q,te){super(),this.j=Q,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(p(this.j,t.$kQ.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B(p(this.j,t.$kQ.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B(p(this.j,t.$kQ.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B(p(this.j,t.$kQ.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B(p(this.j,t.$kQ.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B(p(this.j,t.$kQ.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B(p(this.j,t.$kQ.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$TQ=Ui;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Vi(q,...Q){let te,fe;Array.isArray(Q[0])?(te={},fe=Q[0]):(te=Q[0]||{},fe=Q[1]);const De=Wi.exec(q);if(!De||!De.groups)throw new Error("Bad use of h");const Re=De.groups.tag||"div",He=document.createElement(Re);De.groups.id&&(He.id=De.groups.id);const xe=[];if(De.groups.class)for(const qe of De.groups.class.split("."))qe!==""&&xe.push(qe);if(te.className!==void 0)for(const qe of te.className.split("."))qe!==""&&xe.push(qe);xe.length>0&&(He.className=xe.join(" "));const Ge={};if(De.groups.name&&(Ge[De.groups.name]=He),fe)for(const qe of fe)qe instanceof HTMLElement?He.appendChild(qe):typeof qe=="string"?He.append(qe):"root"in qe&&(Object.assign(Ge,qe),He.appendChild(qe.root));for(const[qe,lt]of Object.entries(te))if(qe!=="className")if(qe==="style")for(const[Tt,Bt]of Object.entries(lt))He.style.setProperty(ei(Tt),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?He.tabIndex=lt:He.setAttribute(ei(qe),lt.toString());return Ge.root=He,Ge}t.h=Vi;function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,Q){for(const{name:te,value:fe}of q.attributes)Q.setAttribute(te,fe)}t.$VQ=ti;function qi(q,Q,te){const fe=q.getAttribute(te);fe?Q.setAttribute(te,fe):Q.removeAttribute(te)}function Qi(q,Q,te){ti(q,Q);const fe=new y.$Sc;return fe.add(t.$bQ.observe(q,fe,{attributes:!0,attributeFilter:te})(De=>{for(const Re of De)Re.type==="attributes"&&Re.attributeName&&qi(q,Q,Re.attributeName)})),fe}t.$WQ=Qi}),define(be[54],pe([1,0,3,2,117]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=t.$YQ=t.$XQ=void 0;class j extends C.$Tc{constructor(b,w){super(),this.B((0,k.$rP)(b,"dragover",y=>{y.preventDefault(),this.a||(this.a=setTimeout(()=>{w(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(y=>{this.B((0,k.$rP)(b,y,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$XQ=j,t.$YQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:s.$7r.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(A,b,w,y,I){const o=document.createElement("div");if(o.className=w,o.textContent=b,I&&(o.style.color=I),y&&(o.style.background=y),A.dataTransfer){const a=(0,k.getWindow)(A).document;a.body.appendChild(o),A.dataTransfer.setDragImage(o,-10,-10),setTimeout(()=>a.body.removeChild(o),0)}}t.$ZQ=E}),define(be[55],pe([1,0,3]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=t.$qR=t.$pR=void 0;function C(o,a={}){const e=j(a);return e.textContent=o,e}t.$pR=C;function s(o,a={}){const e=j(a);return b(e,w(o,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$qR=s;function j(o){const a=o.inline?"span":"div",e=document.createElement(a);return o.className&&(e.className=o.className),e}t.$rR=j;class E{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(A||(A={}));function b(o,a,e,r){let d;if(a.type===2)d=document.createTextNode(a.content||"");else if(a.type===3)d=document.createElement("b");else if(a.type===4)d=document.createElement("i");else if(a.type===7&&r)d=document.createElement("code");else if(a.type===5&&e){const $=document.createElement("a");e.disposables.add(k.$sP($,"click",u=>{e.callback(String(a.index),u)})),d=$}else a.type===8?d=document.createElement("br"):a.type===1&&(d=o);d&&o!==d&&o.appendChild(d),d&&Array.isArray(a.children)&&a.children.forEach($=>{b(d,$,e,r)})}function w(o,a){const e={type:1,children:[]};let r=0,d=e;const $=[],u=new E(o);for(;!u.eos();){let p=u.next();const c=p==="\\"&&I(u.peek(),a)!==0;if(c&&(p=u.next()),!c&&y(p,a)&&p===u.peek()){u.advance(),d.type===2&&(d=$.pop());const f=I(p,a);if(d.type===f||d.type===5&&f===6)d=$.pop();else{const h={type:f,children:[]};f===5&&(h.index=r,r++),d.children.push(h),$.push(d),d=h}}else if(p===`
`)d.type===2&&(d=$.pop()),d.children.push({type:8});else if(d.type!==2){const f={type:2,content:p};d.children.push(f),$.push(d),d=f}else d.content+=p}return d.type===2&&(d=$.pop()),$.length,e}function y(o,a){return I(o,a)!==0}function I(o,a){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[56],pe([1,0,3,2]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=void 0;class s{constructor(){this.a=new C.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,E&&b&&b(A)}isMonitoring(){return!!this.b}startMonitoring(E,A,b,w,y){this.isMonitoring()&&this.stopMonitoring(!1),this.b=w,this.c=y;let I=E;try{E.setPointerCapture(A),this.a.add((0,C.$Rc)(()=>{try{E.releasePointerCapture(A)}catch{}}))}catch{I=k.getWindow(E)}this.a.add(k.$rP(I,k.$kQ.POINTER_MOVE,o=>{if(o.buttons!==b){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(k.$rP(I,k.$kQ.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.$4Q=s});var Xe=this&&this.__decorate||function(ie,t,k,C){var s=arguments.length,j=s<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,k):C,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ie,t,k,C);else for(var A=ie.length-1;A>=0;A--)(E=ie[A])&&(j=(s<3?E(j):s>3?E(t,k,j):E(t,k))||j);return s>3&&j&&Object.defineProperty(t,k,j),j};define(be[25],pe([1,0,3,21,12,27,4,2,45]),function(ie,t,k,C,s,j,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Q=t.EventType=void 0;var w;(function(I){I.Tap="-monaco-gesturetap",I.Change="-monaco-gesturechange",I.Start="-monaco-gesturestart",I.End="-monaco-gesturesend",I.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class y extends A.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$4c,this.h=new b.$4c,this.m={},this.j=null,this.n=0,this.B(E.Event.runAndSubscribe(k.onDidRegisterWindow,({window:o,disposables:a})=>{a.add(k.$rP(o.document,"touchstart",e=>this.s(e),{passive:!1})),a.add(k.$rP(o.document,"touchend",e=>this.u(o,e))),a.add(k.$rP(o.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:C.$VO,disposables:this.q}))}static addTarget(o){if(!y.isTouchDevice())return A.$Tc.None;y.b||(y.b=(0,A.$Mc)(new y));const a=y.b.g.push(o);return(0,A.$Rc)(a)}static ignoreTarget(o){if(!y.isTouchDevice())return A.$Tc.None;y.b||(y.b=(0,A.$Mc)(new y));const a=y.b.h.push(o);return(0,A.$Rc)(a)}static isTouchDevice(){return"ontouchstart"in C.$VO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(o){const a=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,r=o.targetTouches.length;e<r;e++){const d=o.targetTouches.item(e);this.m[d.identifier]={id:d.identifier,initialTarget:d.target,initialTimeStamp:a,initialPageX:d.pageX,initialPageY:d.pageY,rollingTimestamps:[a],rollingPageX:[d.pageX],rollingPageY:[d.pageY]};const $=this.w(w.Start,d.target);$.pageX=d.pageX,$.pageY=d.pageY,this.z($)}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}u(o,a){const e=Date.now(),r=Object.keys(this.m).length;for(let d=0,$=a.changedTouches.length;d<$;d++){const u=a.changedTouches.item(d);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const p=this.m[u.identifier],c=Date.now()-p.initialTimeStamp;if(c<y.c&&Math.abs(p.initialPageX-s.$sb(p.rollingPageX))<30&&Math.abs(p.initialPageY-s.$sb(p.rollingPageY))<30){const f=this.w(w.Tap,p.initialTarget);f.pageX=s.$sb(p.rollingPageX),f.pageY=s.$sb(p.rollingPageY),this.z(f)}else if(c>=y.c&&Math.abs(p.initialPageX-s.$sb(p.rollingPageX))<30&&Math.abs(p.initialPageY-s.$sb(p.rollingPageY))<30){const f=this.w(w.Contextmenu,p.initialTarget);f.pageX=s.$sb(p.rollingPageX),f.pageY=s.$sb(p.rollingPageY),this.z(f)}else if(r===1){const f=s.$sb(p.rollingPageX),h=s.$sb(p.rollingPageY),F=s.$sb(p.rollingTimestamps)-p.rollingTimestamps[0],M=f-p.rollingPageX[0],R=h-p.rollingPageY[0],O=[...this.g].filter(v=>p.initialTarget instanceof Node&&v.contains(p.initialTarget));this.C(o,O,e,Math.abs(M)/F,M>0?1:-1,f,Math.abs(R)/F,R>0?1:-1,h)}this.z(this.w(w.End,p.initialTarget)),delete this.m[u.identifier]}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}w(o,a){const e=document.createEvent("CustomEvent");return e.initEvent(o,!1,!0),e.initialTarget=a,e.tapCount=0,e}z(o){if(o.type===w.Tap){const a=new Date().getTime();let e=0;a-this.n>y.r?e=1:e=2,this.n=a,o.tapCount=e}else(o.type===w.Change||o.type===w.Contextmenu)&&(this.n=0);if(o.initialTarget instanceof Node){for(const a of this.h)if(a.contains(o.initialTarget))return;for(const a of this.g)a.contains(o.initialTarget)&&(a.dispatchEvent(o),this.f=!0)}}C(o,a,e,r,d,$,u,p,c){this.j=k.$BP(o,()=>{const f=Date.now(),h=f-e;let F=0,M=0,R=!0;r+=y.a*h,u+=y.a*h,r>0&&(R=!1,F=d*r*h),u>0&&(R=!1,M=p*u*h);const O=this.w(w.Change);O.translationX=F,O.translationY=M,a.forEach(v=>v.dispatchEvent(O)),R||this.C(o,a,f,r,d,$+F,u,p,c+M)})}D(o){const a=Date.now();for(let e=0,r=o.changedTouches.length;e<r;e++){const d=o.changedTouches.item(e);if(!this.m.hasOwnProperty(String(d.identifier))){console.warn("end of an UNKNOWN touch",d);continue}const $=this.m[d.identifier],u=this.w(w.Change,$.initialTarget);u.translationX=d.pageX-s.$sb($.rollingPageX),u.translationY=d.pageY-s.$sb($.rollingPageY),u.pageX=d.pageX,u.pageY=d.pageY,this.z(u),$.rollingPageX.length>3&&($.rollingPageX.shift(),$.rollingPageY.shift(),$.rollingTimestamps.shift()),$.rollingPageX.push(d.pageX),$.rollingPageY.push(d.pageY),$.rollingTimestamps.push(a)}this.f&&(o.preventDefault(),o.stopPropagation(),this.f=!1)}}t.$1Q=y,Xe([j.$vh],y,"isTouchDevice",null)}),define(be[57],pe([1,0,3,92]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vR=t.$uR=t.$tR=void 0;const C=2e4;let s,j,E,A,b;function w(a){s=document.createElement("div"),s.className="monaco-aria-container";const e=()=>{const d=document.createElement("div");return d.className="monaco-alert",d.setAttribute("role","alert"),d.setAttribute("aria-atomic","true"),s.appendChild(d),d};j=e(),E=e();const r=()=>{const d=document.createElement("div");return d.className="monaco-status",d.setAttribute("aria-live","polite"),d.setAttribute("aria-atomic","true"),s.appendChild(d),d};A=r(),b=r(),a.appendChild(s)}t.$tR=w;function y(a){s&&(j.textContent!==a?(k.$qP(E),o(j,a)):(k.$qP(j),o(E,a)))}t.$uR=y;function I(a){s&&(A.textContent!==a?(k.$qP(b),o(A,a)):(k.$qP(A),o(b,a)))}t.$vR=I;function o(a,e){k.$qP(a),e.length>C&&(e=e.substr(0,C)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[119],pe([1,0,3,18]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZR=t.$YR=void 0;const s=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function j(A){const b=new Array;let w,y=0,I=0;for(;(w=s.exec(A))!==null;){I=w.index||0,y<I&&b.push(A.substring(y,I)),y=(w.index||0)+w[0].length;const[,o,a]=w;b.push(o?`$(${a})`:E({id:a}))}return y<A.length&&b.push(A.substring(y)),b}t.$YR=j;function E(A){const b=k.$("span");return b.classList.add(...C.ThemeIcon.asClassNameArray(A)),b}t.$ZR=E}),define(be[120],pe([1,0,3]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BR=void 0;function C(j){try{j.parentElement?.removeChild(j)}catch{}}class s{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let A=this.h(E).pop(),b=!1;if(A)b=this.b.has(A.domNode),b&&this.b.delete(A.domNode);else{const w=(0,k.$)(".monaco-list-row"),I=this.i(E).renderTemplate(w);A={domNode:w,templateId:E,templateData:I}}return{row:A,isReusingConnectedDomNode:b}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(E){const{domNode:A,templateId:b}=E;A&&(this.c?this.b.add(A):this.g(A)),this.h(b).push(E)}g(E){E.classList.remove("scrolling"),C(E)}h(E){let A=this.a.get(E);return A||(A=[],this.a.set(E,A)),A}dispose(){this.a.forEach((E,A)=>{for(const b of E)this.i(A).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(E){const A=this.d.get(E);if(!A)throw new Error(`No renderer found for ${E}`);return A}}t.$BR=s}),define(be[121],pe([1,0,9,2]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=void 0;class s extends C.$Tc{constructor(E,A,b){super(),this.a=E,this.b=A,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new k.$bh)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$9Q=s}),define(be[122],pe([1,0,3,25,12,4,2,5]),function(ie,t,k,C,s,j,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7R=void 0;class b extends E.$Tc{constructor(y,I,o,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new j.$Td),this.h=o,this.j(),this.setOptions(y,I)}j(){this.B(C.$1Q.addTarget(this.a)),[C.EventType.Tap].forEach(y=>{this.B(k.$rP(this.a,y,I=>{this.a.focus()}))}),this.B(k.$sP(this.a,"click",y=>{k.$mQ.stop(y,!0)})),this.B(k.$sP(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(k.$sP(this.a,"keydown",y=>{let I=!1;A.$j?(y.keyCode===18||y.keyCode===16||y.keyCode===10)&&(I=!0):(y.keyCode===18&&y.altKey||y.keyCode===10||y.keyCode===3)&&(I=!0),I&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,I){(!this.c||!s.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((o,a)=>{this.a.add(this.m(o.text,a,o.isDisabled))})),I!==void 0&&this.select(I)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,I,o){const a=document.createElement("option");return a.value=y,a.text=y,a.disabled=!!o,a}}t.$7R=b}),define(be[58],pe([1,0,26,12,9,50,87,4,28]),function(ie,t,k,C,s,j,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CT=t.$BT=t.$AT=void 0;function w(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$AT=w;function y(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$BT=y;function I(a){return typeof a.collapsible=="boolean"}class o{constructor(e,r,d,$={}){this.o=e,this.p=r,this.rootRef=[],this.d=new A.$2d,this.f=new A.$Td,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$Td,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.$Td,this.onDidSplice=this.l.event,this.m=new s.$1g(j.$Qd),this.h=typeof $.collapseByDefault>"u"?!1:$.collapseByDefault,this.j=$.filter,this.k=typeof $.autoExpandSingleChildren>"u"?!1:$.autoExpandSingleChildren,this.c={parent:void 0,element:d,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,r,d=b.Iterable.empty(),$={}){if(e.length===0)throw new k.$yT(this.o,"Invalid tree location");$.diffIdentityProvider?this.q($.diffIdentityProvider,e,r,d,$):this.s(e,r,d,$)}q(e,r,d,$=b.Iterable.empty(),u,p=u.diffDepth??0){const{parentNode:c}=this.G(r);if(!c.lastDiffIds)return this.s(r,d,$,u);const f=[...$],h=r[r.length-1],F=new E.$Qs({getElements:()=>c.lastDiffIds},{getElements:()=>[...c.children.slice(0,h),...f,...c.children.slice(h+d)].map(N=>e.getId(N.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return c.lastDiffIds=void 0,this.s(r,d,f,u);const M=r.slice(0,-1),R=(N,V,H)=>{if(p>0)for(let T=0;T<H;T++)N--,V--,this.q(e,[...M,N,0],Number.MAX_SAFE_INTEGER,f[V].children,u,p-1)};let O=Math.min(c.children.length,h+d),v=f.length;for(const N of F.changes.sort((V,H)=>H.originalStart-V.originalStart))R(O,v,O-(N.originalStart+N.originalLength)),O=N.originalStart,v=N.modifiedStart-h,this.s([...M,O],N.originalLength,b.Iterable.slice(f,v,v+N.modifiedLength),u);R(O,v,O)}s(e,r,d=b.Iterable.empty(),{onDidCreateNode:$,onDidDeleteNode:u,diffIdentityProvider:p}){const{parentNode:c,listIndex:f,revealed:h,visible:F}=this.G(e),M=[],R=b.Iterable.map(d,X=>this.w(X,c,c.visible?1:0,h,M,$)),O=e[e.length-1];let v=0;for(let X=O;X>=0&&X<c.children.length;X--){const Y=c.children[X];if(Y.visible){v=Y.visibleChildIndex;break}}const N=[];let V=0,H=0;for(const X of R)N.push(X),H+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=v+V++);const T=(0,C.$6b)(c.children,O,r,N);p?c.lastDiffIds?(0,C.$6b)(c.lastDiffIds,O,r,N.map(X=>p.getId(X.element).toString())):c.lastDiffIds=c.children.map(X=>p.getId(X.element).toString()):c.lastDiffIds=void 0;let L=0;for(const X of T)X.visible&&L++;if(L!==0)for(let X=O+N.length;X<c.children.length;X++){const Y=c.children[X];Y.visible&&(Y.visibleChildIndex-=L)}if(c.visibleChildrenCount+=V-L,h&&F){const X=T.reduce((Y,de)=>Y+(de.visible?de.renderNodeCount:0),0);this.B(c,H-X),this.p.splice(f,X,M)}if(T.length>0&&u){const X=Y=>{u(Y),Y.children.forEach(X)};T.forEach(X)}this.l.fire({insertedNodes:N,deletedNodes:T});let B=c;for(;B;){if(B.visibility===2){this.m.trigger(()=>this.refilter());break}B=B.parent}}rerender(e){if(e.length===0)throw new k.$yT(this.o,"Invalid tree location");const{node:r,listIndex:d,revealed:$}=this.F(e);r.visible&&$&&this.p.splice(d,1,[r])}updateElementHeight(e,r){if(e.length===0)throw new k.$yT(this.o,"Invalid tree location");const{listIndex:d}=this.F(e);this.p.updateElementHeight(d,r)}has(e){return this.D(e)}getListIndex(e){const{listIndex:r,visible:d,revealed:$}=this.F(e);return d&&$?r:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,r){const d=this.E(e);typeof r>"u"&&(r=!d.collapsible);const $={collapsible:r};return this.d.bufferEvents(()=>this.t(e,$))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,r,d){const $=this.E(e);typeof r>"u"&&(r=!$.collapsed);const u={collapsed:r,recursive:d||!1};return this.d.bufferEvents(()=>this.t(e,u))}t(e,r){const{node:d,listIndex:$,revealed:u}=this.F(e),p=this.u(d,$,u,r);if(d!==this.c&&this.k&&p&&!I(r)&&d.collapsible&&!d.collapsed&&!r.recursive){let c=-1;for(let f=0;f<d.children.length;f++)if(d.children[f].visible)if(c>-1){c=-1;break}else c=f;c>-1&&this.t([...e,c],r)}return p}u(e,r,d,$){const u=this.v(e,$,!1);if(!d||!e.visible||!u)return u;const p=e.renderNodeCount,c=this.x(e),f=p-(r===-1?0:1);return this.p.splice(r+1,f,c.slice(1)),u}v(e,r,d){let $;if(e===this.c?$=!1:(I(r)?($=e.collapsible!==r.collapsible,e.collapsible=r.collapsible):e.collapsible?($=e.collapsed!==r.collapsed,e.collapsed=r.collapsed):$=!1,$&&this.f.fire({node:e,deep:d})),!I(r)&&r.recursive)for(const u of e.children)$=this.v(u,r,!0)||$;return $}expandTo(e){this.d.bufferEvents(()=>{let r=this.E(e);for(;r.parent;)r=r.parent,e=e.slice(0,e.length-1),r.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,r=this.z(this.c);this.p.splice(0,e,r),this.m.cancel()}w(e,r,d,$,u,p){const c={parent:r,element:e.element,children:[],depth:r.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this.C(c,d);c.visibility=f,$&&u.push(c);const h=e.children||b.Iterable.empty(),F=$&&f!==0&&!c.collapsed;let M=0,R=1;for(const O of h){const v=this.w(O,c,f,F,u,p);c.children.push(v),R+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=M++)}return c.collapsible=c.collapsible||c.children.length>0,c.visibleChildrenCount=M,c.visible=f===2?M>0:f===1,c.visible?c.collapsed||(c.renderNodeCount=R):(c.renderNodeCount=0,$&&u.pop()),p?.(c),c}x(e){const r=e.renderNodeCount,d=[];return this.y(e,d),this.B(e.parent,d.length-r),d}y(e,r){if(e.visible===!1)return 0;if(r.push(e),e.renderNodeCount=1,!e.collapsed)for(const d of e.children)e.renderNodeCount+=this.y(d,r);return this.g.fire(e),e.renderNodeCount}z(e){const r=e.renderNodeCount,d=[];return this.A(e,e.visible?1:0,d),this.B(e.parent,d.length-r),d}A(e,r,d,$=!0){let u;if(e!==this.c){if(u=this.C(e,r),u===0)return e.visible=!1,e.renderNodeCount=0,!1;$&&d.push(e)}const p=d.length;e.renderNodeCount=e===this.c?0:1;let c=!1;if(!e.collapsed||u!==0){let f=0;for(const h of e.children)c=this.A(h,u,d,$&&!e.collapsed)||c,h.visible&&(h.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=u===2?c:u===1,e.visibility=u),e.visible?e.collapsed||(e.renderNodeCount+=d.length-p):(e.renderNodeCount=0,$&&d.pop()),this.g.fire(e),e.visible}B(e,r){if(r!==0)for(;e;)e.renderNodeCount+=r,this.g.fire(e),e=e.parent}C(e,r){const d=this.j?this.j.filter(e.element,r):1;return typeof d=="boolean"?(e.filterData=void 0,d?1:0):w(d)?(e.filterData=d.data,y(d.visibility)):(e.filterData=void 0,y(d))}D(e,r=this.c){if(!e||e.length===0)return!0;const[d,...$]=e;return d<0||d>r.children.length?!1:this.D($,r.children[d])}E(e,r=this.c){if(!e||e.length===0)return r;const[d,...$]=e;if(d<0||d>r.children.length)throw new k.$yT(this.o,"Invalid tree location");return this.E($,r.children[d])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:r,listIndex:d,revealed:$,visible:u}=this.G(e),p=e[e.length-1];if(p<0||p>r.children.length)throw new k.$yT(this.o,"Invalid tree location");const c=r.children[p];return{node:c,listIndex:d,revealed:$,visible:u&&c.visible}}G(e,r=this.c,d=0,$=!0,u=!0){const[p,...c]=e;if(p<0||p>r.children.length)throw new k.$yT(this.o,"Invalid tree location");for(let f=0;f<p;f++)d+=r.children[f].renderNodeCount;return $=$&&!r.collapsed,u=u&&r.visible,c.length===0?{parentNode:r,listIndex:d,revealed:$,visible:u}:this.G(c,r.children[p],d+1,$,u)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const r=[];let d=e;for(;d.parent;)r.push(d.parent.children.indexOf(d)),d=d.parent;return r.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const r=this.E(e);if(r.children.length!==0)return r.children[0].element}getLastElementAncestor(e=[]){const r=this.E(e);if(r.children.length!==0)return this.H(r)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$CT=o}),define(be[123],pe([1,0,58,26,28]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=void 0;class j{get size(){return this.d.size}constructor(A,b,w={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new k.$CT(A,b,null,w),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,w.sorter&&(this.j={compare(y,I){return w.sorter.compare(y.element,I.element)}}),this.h=w.identityProvider}setChildren(A,b=s.Iterable.empty(),w={}){const y=this.o(A);this.l(y,this.m(b),w)}l(A,b=s.Iterable.empty(),w){const y=new Set,I=new Set,o=e=>{if(e.element===null)return;const r=e;if(y.add(r.element),this.d.set(r.element,r),this.h){const d=this.h.getId(r.element).toString();I.add(d),this.f.set(d,r)}w.onDidCreateNode?.(r)},a=e=>{if(e.element===null)return;const r=e;if(y.has(r.element)||this.d.delete(r.element),this.h){const d=this.h.getId(r.element).toString();I.has(d)||this.f.delete(d)}w.onDidDeleteNode?.(r)};this.c.splice([...A,0],Number.MAX_VALUE,b,{...w,onDidCreateNode:o,onDidDeleteNode:a})}m(A=s.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),s.Iterable.map(A,b=>{let w=this.d.get(b.element);if(!w&&this.h){const o=this.h.getId(b.element).toString();w=this.f.get(o)}if(!w){let o;return typeof b.collapsed>"u"?o=void 0:b.collapsed===C.ObjectTreeElementCollapseState.Collapsed||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?o=!0:b.collapsed===C.ObjectTreeElementCollapseState.Expanded||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?o=!1:o=!!b.collapsed,{...b,children:this.m(b.children),collapsed:o}}const y=typeof b.collapsible=="boolean"?b.collapsible:w.collapsible;let I;return typeof b.collapsed>"u"||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?I=w.collapsed:b.collapsed===C.ObjectTreeElementCollapseState.Collapsed?I=!0:b.collapsed===C.ObjectTreeElementCollapseState.Expanded?I=!1:I=!!b.collapsed,{...b,collapsible:y,collapsed:I,children:this.m(b.children)}})}rerender(A){const b=this.o(A);this.c.rerender(b)}updateElementHeight(A,b){const w=this.o(A);this.c.updateElementHeight(w,b)}resort(A=null,b=!0){if(!this.j)return;const w=this.o(A),y=this.c.getNode(w);this.l(w,this.n(y,b),{})}n(A,b,w=!0){let y=[...A.children];return(b||w)&&(y=y.sort(this.j.compare.bind(this.j))),s.Iterable.map(y,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.n(I,b,!1)}))}getFirstElementChild(A=null){const b=this.o(A);return this.c.getFirstElementChild(b)}getLastElementAncestor(A=null){const b=this.o(A);return this.c.getLastElementAncestor(b)}has(A){return this.d.has(A)}getListIndex(A){const b=this.o(A);return this.c.getListIndex(b)}getListRenderCount(A){const b=this.o(A);return this.c.getListRenderCount(b)}isCollapsible(A){const b=this.o(A);return this.c.isCollapsible(b)}setCollapsible(A,b){const w=this.o(A);return this.c.setCollapsible(w,b)}isCollapsed(A){const b=this.o(A);return this.c.isCollapsed(b)}setCollapsed(A,b,w){const y=this.o(A);return this.c.setCollapsed(y,b,w)}expandTo(A){const b=this.o(A);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(A);if(!b)throw new C.$yT(this.k,`Tree element not found: ${A}`);return b}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new C.$yT(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(A);if(!b)throw new C.$yT(this.k,`Tree element not found: ${A}`);const w=this.c.getNodeLocation(b),y=this.c.getParentNodeLocation(w);return this.c.getNode(y).element}o(A){if(A===null)return[];const b=this.d.get(A);if(!b)throw new C.$yT(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(b)}}t.$JT=j}),define(be[20],pe([1,0,3,14,19,25,2]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=void 0;class A extends E.$Tc{f(w,y){this.B(k.$rP(w,k.$kQ.CLICK,I=>y(new s.$jP(k.getWindow(w),I))))}j(w,y){this.B(k.$rP(w,k.$kQ.MOUSE_DOWN,I=>y(new s.$jP(k.getWindow(w),I))))}m(w,y){this.B(k.$rP(w,k.$kQ.MOUSE_OVER,I=>y(new s.$jP(k.getWindow(w),I))))}u(w,y){this.B(k.$rP(w,k.$kQ.MOUSE_LEAVE,I=>y(new s.$jP(k.getWindow(w),I))))}z(w,y){this.B(k.$rP(w,k.$kQ.KEY_DOWN,I=>y(new C.$oP(I))))}C(w,y){this.B(k.$rP(w,k.$kQ.KEY_UP,I=>y(new C.$oP(I))))}D(w,y){this.B(k.$rP(w,k.$kQ.INPUT,y))}F(w,y){this.B(k.$rP(w,k.$kQ.BLUR,y))}G(w,y){this.B(k.$rP(w,k.$kQ.FOCUS,y))}H(w,y){this.B(k.$rP(w,k.$kQ.CHANGE,y))}I(w){return j.$1Q.ignoreTarget(w)}}t.$5Q=A}),define(be[38],pe([1,0,56,20,9,18,3]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=t.$6Q=void 0,t.$6Q=11;class A extends C.$5Q{constructor(w){super(),this.a=w.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=w.bgWidth+"px",this.bgDomNode.style.height=w.bgHeight+"px",typeof w.top<"u"&&(this.bgDomNode.style.top="0px"),typeof w.left<"u"&&(this.bgDomNode.style.left="0px"),typeof w.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof w.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=w.className,this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(w.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$6Q+"px",this.domNode.style.height=t.$6Q+"px",typeof w.top<"u"&&(this.domNode.style.top=w.top+"px"),typeof w.left<"u"&&(this.domNode.style.left=w.left+"px"),typeof w.bottom<"u"&&(this.domNode.style.bottom=w.bottom+"px"),typeof w.right<"u"&&(this.domNode.style.right=w.right+"px"),this.g=this.B(new k.$4Q),this.B(E.$sP(this.bgDomNode,E.$kQ.POINTER_DOWN,y=>this.h(y))),this.B(E.$sP(this.domNode,E.$kQ.POINTER_DOWN,y=>this.h(y))),this.b=this.B(new E.$DP),this.c=this.B(new s.$bh)}h(w){if(!w.target||!(w.target instanceof Element))return;const y=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow(w))};this.a(),this.b.cancel(),this.c.cancelAndSet(y,200),this.g.startMonitoring(w.target,w.pointerId,w.buttons,I=>{},()=>{this.b.cancel(),this.c.cancel()}),w.preventDefault()}}t.$7Q=A}),define(be[59],pe([1,0,3,41,56,38,121,20,5]),function(ie,t,k,C,s,j,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=void 0;const w=140;class y extends A.$5Q{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.n=this.B(new E.$9Q(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new s.$4Q),this.s=!0,this.domNode=(0,C.$3Q)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(k.$rP(this.domNode.domNode,k.$kQ.POINTER_DOWN,a=>this.M(a)))}t(o){const a=this.B(new j.$7Q(o));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(o,a,e,r){this.slider=(0,C.$3Q)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof r=="number"&&this.slider.setHeight(r),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(k.$rP(this.slider.domNode,k.$kQ.POINTER_DOWN,d=>{d.button===0&&(d.preventDefault(),this.O(d))})),this.f(this.slider.domNode,d=>{d.leftButton&&d.stopPropagation()})}y(o){return this.h.setVisibleSize(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(o){return this.h.setScrollSize(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(o){return this.h.setScrollPosition(o)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(o){o.target===this.domNode.domNode&&this.N(o)}delegatePointerDown(o){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),r=a+this.h.getSliderPosition()+this.h.getSliderSize(),d=this.U(o);e<=d&&d<=r?o.button===0&&(o.preventDefault(),this.O(o)):this.N(o)}N(o){let a,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")a=o.offsetX,e=o.offsetY;else{const d=k.$NP(this.domNode.domNode);a=o.pageX-d.left,e=o.pageY-d.top}const r=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(r):this.h.getDesiredScrollPositionFromOffset(r)),o.button===0&&(o.preventDefault(),this.O(o))}O(o){if(!o.target||!(o.target instanceof Element))return;const a=this.U(o),e=this.W(o),r=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(o.target,o.pointerId,o.buttons,d=>{const $=this.W(d),u=Math.abs($-e);if(b.$i&&u>w){this.P(r.getScrollPosition());return}const c=this.U(d)-a;this.P(r.getDesiredScrollPositionFromDelta(c))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(o){const a={};this.writeScrollPosition(a,o),this.b.setScrollPositionNow(a)}updateScrollbarSize(o){this.X(o),this.h.setScrollbarSize(o),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$0Q=y}),define(be[124],pe([1,0,19,59,38,42,17]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=void 0;class A extends C.$0Q{constructor(w,y,I){const o=w.getScrollDimensions(),a=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:I,scrollbarState:new j.$8Q(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===2?0:y.horizontalScrollbarSize,y.vertical===2?0:y.verticalScrollbarSize,o.width,o.scrollWidth,a.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:w,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const e=(y.arrowSize-s.$6Q)/2,r=(y.horizontalScrollbarSize-s.$6Q)/2;this.t({className:"scra",icon:E.$0j.scrollbarButtonLeft,top:r,left:e,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new k.$lP(null,1,0))}),this.t({className:"scra",icon:E.$0j.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:e,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new k.$lP(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(w,y){this.slider.setWidth(w),this.slider.setLeft(y)}Q(w,y){this.domNode.setWidth(w),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(w){return this.s=this.J(w.scrollWidth)||this.s,this.s=this.L(w.scrollLeft)||this.s,this.s=this.y(w.width)||this.s,this.s}S(w,y){return w}U(w){return w.pageX}W(w){return w.pageY}X(w){this.slider.setHeight(w)}writeScrollPosition(w,y){w.scrollLeft=y}updateOptions(w){this.updateScrollbarSize(w.horizontal===2?0:w.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.n.setVisibility(w.horizontal),this.c=w.scrollByPage}}t.$$Q=A}),define(be[125],pe([1,0,19,59,38,42,17]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=void 0;class A extends C.$0Q{constructor(w,y,I){const o=w.getScrollDimensions(),a=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:I,scrollbarState:new j.$8Q(y.verticalHasArrows?y.arrowSize:0,y.vertical===2?0:y.verticalScrollbarSize,0,o.height,o.scrollHeight,a.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:w,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const e=(y.arrowSize-s.$6Q)/2,r=(y.verticalScrollbarSize-s.$6Q)/2;this.t({className:"scra",icon:E.$0j.scrollbarButtonUp,top:e,left:r,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new k.$lP(null,0,1))}),this.t({className:"scra",icon:E.$0j.scrollbarButtonDown,top:void 0,left:r,bottom:e,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new k.$lP(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(w,y){this.slider.setHeight(w),this.slider.setTop(y)}Q(w,y){this.domNode.setWidth(y),this.domNode.setHeight(w),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(w){return this.s=this.J(w.scrollHeight)||this.s,this.s=this.L(w.scrollTop)||this.s,this.s=this.y(w.height)||this.s,this.s}S(w,y){return y}U(w){return w.pageY}W(w){return w.pageX}X(w){this.slider.setWidth(w)}writeScrollPosition(w,y){w.scrollTop=y}updateOptions(w){this.updateScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(w.vertical),this.c=w.scrollByPage}}t.$_Q=A}),define(be[60],pe([1,0,16,3,41,19,124,125,20,9,4,2,5,48,99]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=t.$dR=t.$cR=t.$bR=t.$aR=void 0;const e=500,r=50,d=!0;class ${constructor(R,O,v){this.timestamp=R,this.deltaX=O,this.deltaY=v,this.score=0}}class u{static{this.INSTANCE=new u}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,O=0,v=1,N=this.d;do{const V=N===this.c?R:Math.pow(2,-v);if(R-=V,O+=this.b[N].score*V,N===this.c)break;N=(this.a+N-1)%this.a,v++}while(!0);return O<=.5}acceptStandardWheelEvent(R){const O=C.getWindow(R.browserEvent),v=O.devicePixelRatio/(0,k.$5O)(O);o.$i||o.$k?this.accept(Date.now(),R.deltaX/v,R.deltaY/v):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,O,v){const N=new $(R,O,v);N.score=this.f(N),this.c===-1&&this.d===-1?(this.b[0]=N,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=N)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let O=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(O+=.25),Math.min(Math.max(O,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$aR=u;class p extends b.$5Q{get options(){return this.a}constructor(R,O,v){super(),this.O=this.B(new y.$Td),this.onScroll=this.O.event,this.P=this.B(new y.$Td),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=F(O),this.b=v,this.B(this.b.onScroll(V=>{this.P.fire(V),this.S(V),this.O.fire(V)}));const N={onMouseWheel:V=>this.R(V),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$_Q(this.b,this.a,N)),this.g=this.B(new E.$$Q(this.b,this.a,N)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,s.$3Q)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,s.$3Q)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,s.$3Q)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,V=>this.Z(V)),this.u(this.t,V=>this.Y(V)),this.L=this.B(new w.$bh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,I.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,o.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new j.$lP(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,I.$Oc)(this.w),R)){const v=N=>{this.R(new j.$lP(N))};this.w.push(C.$rP(this.t,C.$kQ.MOUSE_WHEEL,v,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const O=u.INSTANCE;d&&O.acceptStandardWheelEvent(R);let v=!1;if(R.deltaY||R.deltaX){let V=R.deltaY*this.a.mouseWheelScrollSensitivity,H=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&H+V===0?H=V=0:Math.abs(V)>=Math.abs(H)?H=0:V=0),this.a.flipAxes&&([V,H]=[H,V]);const T=!o.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||T)&&!H&&(H=V,V=0),R.browserEvent&&R.browserEvent.altKey&&(H=H*this.a.fastScrollSensitivity,V=V*this.a.fastScrollSensitivity);const L=this.b.getFutureScrollPosition();let B={};if(V){const X=r*V,Y=L.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(B,Y)}if(H){const X=r*H,Y=L.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(B,Y)}B=this.b.validateScrollPosition(B),(L.scrollLeft!==B.scrollLeft||L.scrollTop!==B.scrollTop)&&(d&&this.a.mouseWheelSmoothScroll&&O.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),v=!0)}let N=v;!N&&this.a.alwaysConsumeMouseWheel&&(N=!0),!N&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(N=!0),N&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),O=R.scrollTop>0,v=R.scrollLeft>0,N=v?" left":"",V=O?" top":"",H=v||O?" top-left-corner":"";this.n.setClassName(`shadow${N}`),this.r.setClassName(`shadow${V}`),this.s.setClassName(`shadow${H}${V}${N}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$bR=p;class c extends p{constructor(R,O){O=O||{},O.mouseWheelSmoothScroll=!1;const v=new a.$as({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:N=>C.$BP(C.getWindow(R),N)});super(R,O,v),this.B(v)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$cR=c;class f extends p{constructor(R,O,v){super(R,O,v)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$dR=f;class h extends p{constructor(R,O){O=O||{},O.mouseWheelSmoothScroll=!1;const v=new a.$as({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:N=>C.$BP(C.getWindow(R),N)});super(R,O,v),this.B(v),this.cb=R,this.B(this.onScroll(N=>{N.scrollTopChanged&&(this.cb.scrollTop=N.scrollTop),N.scrollLeftChanged&&(this.cb.scrollLeft=N.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$eR=h;function F(M){const R={lazyRender:typeof M.lazyRender<"u"?M.lazyRender:!1,className:typeof M.className<"u"?M.className:"",useShadows:typeof M.useShadows<"u"?M.useShadows:!0,handleMouseWheel:typeof M.handleMouseWheel<"u"?M.handleMouseWheel:!0,flipAxes:typeof M.flipAxes<"u"?M.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof M.consumeMouseWheelIfScrollbarIsNeeded<"u"?M.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof M.alwaysConsumeMouseWheel<"u"?M.alwaysConsumeMouseWheel:!1,scrollYToX:typeof M.scrollYToX<"u"?M.scrollYToX:!1,mouseWheelScrollSensitivity:typeof M.mouseWheelScrollSensitivity<"u"?M.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof M.fastScrollSensitivity<"u"?M.fastScrollSensitivity:5,scrollPredominantAxis:typeof M.scrollPredominantAxis<"u"?M.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof M.mouseWheelSmoothScroll<"u"?M.mouseWheelSmoothScroll:!0,arrowSize:typeof M.arrowSize<"u"?M.arrowSize:11,listenOnDomNode:typeof M.listenOnDomNode<"u"?M.listenOnDomNode:null,horizontal:typeof M.horizontal<"u"?M.horizontal:1,horizontalScrollbarSize:typeof M.horizontalScrollbarSize<"u"?M.horizontalScrollbarSize:10,horizontalSliderSize:typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:0,horizontalHasArrows:typeof M.horizontalHasArrows<"u"?M.horizontalHasArrows:!1,vertical:typeof M.vertical<"u"?M.vertical:1,verticalScrollbarSize:typeof M.verticalScrollbarSize<"u"?M.verticalScrollbarSize:10,verticalHasArrows:typeof M.verticalHasArrows<"u"?M.verticalHasArrows:!1,verticalSliderSize:typeof M.verticalSliderSize<"u"?M.verticalSliderSize:0,scrollByPage:typeof M.scrollByPage<"u"?M.scrollByPage:!1};return R.horizontalSliderSize=typeof M.horizontalSliderSize<"u"?M.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof M.verticalSliderSize<"u"?M.verticalSliderSize:R.verticalScrollbarSize,o.$j&&(R.className+=" mac"),R}}),define(be[61],pe([1,0,54,3,22,25,60,12,9,27,4,2,47,48,83,120,6]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a,e,r,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=t.$ER=t.$DR=t.$CR=t.ListViewTargetSector=void 0;const $={CurrentDragAndDropData:void 0};var u;(function(O){O[O.TOP=0]="TOP",O[O.CENTER_TOP=1]="CENTER_TOP",O[O.CENTER_BOTTOM=2]="CENTER_BOTTOM",O[O.BOTTOM=3]="BOTTOM"})(u||(t.ListViewTargetSector=u={}));const p={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(O){return[O]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class c{get context(){return this.d}set context(v){this.d=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$CR=c;class f{constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$DR=f;class h{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let N=0;N<v.files.length;N++){const V=v.files.item(N);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$ER=h;function F(O,v){return Array.isArray(O)&&Array.isArray(v)?(0,A.$ub)(O,v):O===v}class M{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(N,V,H)=>H,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(N,V)=>V+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=N=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=N=>{}}}class R{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(v){if(v!==this.P){if(v&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=v,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const N of this.d)this.Z(N);this.W(),this.q.setScrollDimensions({width:(0,C.$QP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(v,N,V,H=p){if(this.R=N,this.domId=`list_id_${++R.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$1g(50),this.v=!1,this.x=I.$Tc.None,this.y=0,this.G=!1,this.K=I.$Tc.None,this.L=I.$Tc.None,this.M=new I.$Sc,this.N=new y.$Td,this.O=new y.$Td,this.onDidChangeContentHeight=y.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=y.Event.latch(this.O.event,void 0,this.M),this.P=!1,H.horizontalScrolling&&H.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$AR(H.paddingTop??0);for(const L of V)this.j.set(L.templateId,L);this.h=this.M.add(new r.$BR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof H.mouseSupport=="boolean"?H.mouseSupport:!0),this.P=H.horizontalScrolling??p.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof H.paddingBottom>"u"?0:H.paddingBottom,this.D=new M(H.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(H.transformOptimization??p.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(j.$1Q.addTarget(this.o)),this.p=this.M.add(new a.$as({forceIntegerValues:!0,smoothScrollDuration:H.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,C.$BP)((0,C.getWindow)(this.domNode),L)})),this.q=this.M.add(new E.$dR(this.o,{alwaysConsumeMouseWheel:H.alwaysConsumeMouseWheel??p.alwaysConsumeMouseWheel,horizontal:1,vertical:H.verticalScrollMode??p.verticalScrollMode,useShadows:H.useShadows??p.useShadows,mouseWheelScrollSensitivity:H.mouseWheelScrollSensitivity,fastScrollSensitivity:H.fastScrollSensitivity,scrollByPage:H.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),v.appendChild(this.domNode),this.q.onScroll(this.hb,this,this.M),this.M.add((0,C.$rP)(this.o,j.EventType.Change,L=>this.ib(L))),this.M.add((0,C.$rP)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,C.$rP)(this.domNode,"dragover",L=>this.kb(this.gb(L)))),this.M.add((0,C.$rP)(this.domNode,"drop",L=>this.mb(this.gb(L)))),this.M.add((0,C.$rP)(this.domNode,"dragleave",L=>this.lb(this.gb(L)))),this.M.add((0,C.$rP)(this.domNode,"dragend",L=>this.nb(L))),this.z=H.setRowLineHeight??p.setRowLineHeight,this.A=H.setRowHeight??p.setRowHeight,this.B=H.supportDynamicHeights??p.supportDynamicHeights,this.F=H.dnd??this.M.add(p.dnd),this.layout(H.initialSize?.height,H.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.C=v.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.Q=v.horizontalScrolling);let N;if(v.scrollByPage!==void 0&&(N={...N??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(N={...N??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(N={...N??{},fastScrollSensitivity:v.fastScrollSensitivity}),N&&this.q.updateOptions(N),v.paddingTop!==void 0&&v.paddingTop!==this.g.paddingTop){const V=this.ub(this.k,this.m),H=v.paddingTop-this.g.paddingTop;this.g.paddingTop=v.paddingTop,this.X(V,Math.max(0,this.k+H),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(v){this.q.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.q.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,N,V){if(v<0||v>=this.d.length)return;const H=this.d[v].size;if(typeof N>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[v].lastDynamicHeightWidth=void 0,N=H+this.wb(v)}if(H===N)return;const T=this.ub(this.k,this.m);let L=0;v<T.start||V!==null&&V>v&&V<T.end?L=N-H:L=0,this.g.splice(v,1,[{size:N}]),this.d[v].size=N,this.X(T,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}splice(v,N,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.S(v,N,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}S(v,N,V=[]){const H=this.ub(this.k,this.m),T={start:v,end:v+N},L=o.Range.intersect(H,T),B=new Map;for(let Z=L.end-1;Z>=L.start;Z--){const ce=this.d[Z];if(ce.dragStartDisposable.dispose(),ce.checkedDisposable.dispose(),ce.row){let we=B.get(ce.templateId);we||(we=[],B.set(ce.templateId,we));const ke=this.j.get(ce.templateId);ke&&ke.disposeElement&&ke.disposeElement(ce.element,Z,ce.row.templateData,ce.size),we.push(ce.row)}ce.row=null}const X={start:v+N,end:this.d.length},Y=o.Range.intersect(X,H),de=o.Range.relativeComplement(X,H),oe=V.map(Z=>({id:String(this.f++),element:Z,templateId:this.R.getTemplateId(Z),size:this.R.getHeight(Z),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(Z),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.$Tc.None,checkedDisposable:I.$Tc.None}));let ee;v===0&&N>=this.d.length?(this.g=new e.$AR(this.g.paddingTop),this.g.splice(0,0,oe),ee=this.d,this.d=oe):(this.g.splice(v,N,oe),ee=this.d.splice(v,N,...oe));const me=V.length-N,Pe=this.ub(this.k,this.m),Te=(0,e.$yR)(Y,me),Me=o.Range.intersect(Pe,Te);for(let Z=Me.start;Z<Me.end;Z++)this.ab(this.d[Z],Z);const re=o.Range.relativeComplement(Te,Pe);for(const Z of re)for(let ce=Z.start;ce<Z.end;ce++)this.bb(ce);const J=de.map(Z=>(0,e.$yR)(Z,me)),K=[{start:v,end:v+V.length},...J].map(Z=>o.Range.intersect(Pe,Z)),W=this.xb(K);for(const Z of K)for(let ce=Z.start;ce<Z.end;ce++){const we=this.d[ce],Ae=B.get(we.templateId)?.pop();this.Y(ce,W,Ae)}for(const Z of B.values())for(const ce of Z)this.h.release(ce);return this.U(),this.B&&this.vb(this.scrollTop,this.renderHeight),ee.map(Z=>Z.element)}U(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$BP)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.W(),this.t=null}))}V(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.W())}W(){if(!this.Q)return;let v=0;for(const N of this.d)typeof N.width<"u"&&(v=Math.max(v,N.width));this.E=v,this.q.setScrollDimensions({scrollWidth:v===0?0:v+10}),this.O.fire(this.E)}updateWidth(v){if(!this.Q||typeof this.E>"u")return;const N=this.d[v];this.Z(N),typeof N.width<"u"&&N.width>this.E&&(this.E=N.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const v of this.d)v.lastDynamicHeightWidth=void 0;this.vb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.ub(this.k,this.m).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,N=this.g.positionAt(v),V=this.g.positionAt(v+1);return V!==-1&&(V-N)/2+N<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.ub(this.k,this.m).end-1}element(v){return this.d[v].element}indexOf(v){return this.d.findIndex(N=>N.element===v)}domElement(v){const N=this.d[v].row;return N&&N.domNode}elementHeight(v){return this.d[v].size}elementTop(v){return this.g.positionAt(v)}indexAt(v){return this.g.indexAt(v)}indexAfter(v){return this.g.indexAfter(v)}layout(v,N){const V={height:typeof v=="number"?v:(0,C.$SP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof N<"u"&&(this.n=N,this.B&&this.vb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof N=="number"?N:(0,C.$QP)(this.domNode)})}X(v,N,V,H,T,L=!1){const B=this.ub(N,V),X=o.Range.relativeComplement(B,v),Y=o.Range.relativeComplement(v,B),de=this.xb(X);if(L){const oe=o.Range.intersect(v,B);for(let ee=oe.start;ee<oe.end;ee++)this.ab(this.d[ee],ee)}this.h.transact(()=>{for(const oe of Y)for(let ee=oe.start;ee<oe.end;ee++)this.bb(ee);for(const oe of X)for(let ee=oe.start;ee<oe.end;ee++)this.Y(ee,de)}),H!==void 0&&(this.o.style.left=`-${H}px`),this.o.style.top=`-${N}px`,this.Q&&T!==void 0&&(this.o.style.width=`${Math.max(T,this.n)}px`),this.k=N,this.m=V}Y(v,N,V){const H=this.d[v];let T=!1;if(!H.row)if(V)H.row=V;else{const de=this.h.alloc(H.templateId);H.row=de.row,T=de.isReusingConnectedDomNode}const L=this.D.getRole(H.element)||"listitem";H.row.domNode.setAttribute("role",L);const B=this.D.isChecked(H.element);if(typeof B=="boolean")H.row.domNode.setAttribute("aria-checked",String(!!B));else if(B){const de=oe=>H.row.domNode.setAttribute("aria-checked",String(!!oe));de(B.value),H.checkedDisposable=B.onDidChange(de)}(T||!H.row.domNode.parentElement)&&(N?this.o.insertBefore(H.row.domNode,N):this.o.appendChild(H.row.domNode)),this.ab(H,v);const X=this.j.get(H.templateId);if(!X)throw new Error(`No renderer found for template id ${H.templateId}`);X?.renderElement(H.element,v,H.row.templateData,H.size);const Y=this.F.getDragURI(H.element);H.dragStartDisposable.dispose(),H.row.domNode.draggable=!!Y,Y&&(H.dragStartDisposable=(0,C.$rP)(H.row.domNode,"dragstart",de=>this.jb(H.element,Y,de))),this.Q&&(this.Z(H),this.V())}Z(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,C.$QP)(v.row.domNode);const N=(0,C.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);N.paddingLeft&&(v.width+=parseFloat(N.paddingLeft)),N.paddingRight&&(v.width+=parseFloat(N.paddingRight)),v.row.domNode.style.width=""}ab(v,N){v.row.domNode.style.top=`${this.elementTop(N)}px`,this.A&&(v.row.domNode.style.height=`${v.size}px`),this.z&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${N}`),v.row.domNode.setAttribute("data-last-element",N===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",N%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(v.element,N,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(v.element,N))),v.row.domNode.setAttribute("id",this.getElementDomId(N)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}bb(v){const N=this.d[v];if(N.dragStartDisposable.dispose(),N.checkedDisposable.dispose(),N.row){const V=this.j.get(N.templateId);V&&V.disposeElement&&V.disposeElement(N.element,v,N.row.templateData,N.size),this.h.release(N.row),N.row=null}this.Q&&this.V()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(v,N){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:v,reuseAnimation:N})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"click")).event,v=>this.db(v),this.M)}get onMouseDblClick(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"dblclick")).event,v=>this.db(v),this.M)}get onMouseMiddleClick(){return y.Event.filter(y.Event.map(this.M.add(new s.$sR(this.domNode,"auxclick")).event,v=>this.db(v),this.M),v=>v.browserEvent.button===1,this.M)}get onMouseUp(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"mouseup")).event,v=>this.db(v),this.M)}get onMouseDown(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"mousedown")).event,v=>this.db(v),this.M)}get onMouseOver(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"mouseover")).event,v=>this.db(v),this.M)}get onMouseMove(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"mousemove")).event,v=>this.db(v),this.M)}get onMouseOut(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"mouseout")).event,v=>this.db(v),this.M)}get onContextMenu(){return y.Event.any(y.Event.map(this.M.add(new s.$sR(this.domNode,"contextmenu")).event,v=>this.db(v),this.M),y.Event.map(this.M.add(new s.$sR(this.domNode,j.EventType.Contextmenu)).event,v=>this.fb(v),this.M))}get onTouchStart(){return y.Event.map(this.M.add(new s.$sR(this.domNode,"touchstart")).event,v=>this.eb(v),this.M)}get onTap(){return y.Event.map(this.M.add(new s.$sR(this.o,j.EventType.Tap)).event,v=>this.fb(v),this.M)}db(v){const N=this.tb(v.target||null),V=typeof N>"u"?void 0:this.d[N],H=V&&V.element;return{browserEvent:v,index:N,element:H}}eb(v){const N=this.tb(v.target||null),V=typeof N>"u"?void 0:this.d[N],H=V&&V.element;return{browserEvent:v,index:N,element:H}}fb(v){const N=this.tb(v.initialTarget||null),V=typeof N>"u"?void 0:this.d[N],H=V&&V.element;return{browserEvent:v,index:N,element:H}}gb(v){const N=this.tb(v.target||null),V=typeof N>"u"?void 0:this.d[N],H=V&&V.element,T=this.sb(v,N);return{browserEvent:v,index:N,element:H,sector:T}}hb(v){try{const N=this.ub(this.k,this.m);this.X(N,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.B&&this.vb(v.scrollTop,v.height,v.inSmoothScrolling)}catch(N){throw console.error("Got bad scroll event:",v),N}}ib(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}jb(v,N,V){if(!V.dataTransfer)return;const H=this.F.getDragElements(v);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(k.$YQ.TEXT,N),V.dataTransfer.setDragImage){let T;this.F.getDragLabel&&(T=this.F.getDragLabel(H,V)),typeof T>"u"&&(T=String(H.length));const L=(0,C.$)(".monaco-drag-image");L.textContent=T;const X=(Y=>{for(;Y&&!Y.classList.contains("monaco-workbench");)Y=Y.parentElement;return Y||this.domNode.ownerDocument})(this.domNode);X.appendChild(L),V.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>X.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new c(H),$.CurrentDragAndDropData=new f(H),this.F.onDragStart?.(this.H,V)}kb(v){if(v.browserEvent.preventDefault(),this.L.dispose(),$.CurrentDragAndDropData&&$.CurrentDragAndDropData.getData()==="vscode-ui"||(this.pb(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.H)if($.CurrentDragAndDropData)this.H=$.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.H=new h}const N=this.F.onDragOver(this.H,v.element,v.index,v.sector,v.browserEvent);if(this.G=typeof N=="boolean"?N:N.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof N!="boolean"&&N.effect?.type===0?"copy":"move";let V;typeof N!="boolean"&&N.feedback?V=N.feedback:typeof v.index>"u"?V=[-1]:V=[v.index],V=(0,A.$Mb)(V).filter(T=>T>=-1&&T<this.length).sort((T,L)=>T-L),V=V[0]===-1?[-1]:V;const H=typeof N!="boolean"&&N.effect&&N.effect.position?N.effect.position:"drop-target";if(F(this.I,V)&&this.J===H)return!0;if(this.I=V,this.J=H,this.K.dispose(),V[0]===-1)this.domNode.classList.add(H),this.o.classList.add(H),this.K=(0,I.$Rc)(()=>{this.domNode.classList.remove(H),this.o.classList.remove(H)});else{if(V.length>1&&H!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");for(const T of V){const L=this.d[T];L.dropTarget=!0,L.row?.domNode.classList.add(H)}this.K=(0,I.$Rc)(()=>{for(const T of V){const L=this.d[T];L.dropTarget=!1,L.row?.domNode.classList.remove(H)}})}return!0}lb(v){this.L.dispose(),this.L=(0,b.$6g)(()=>this.ob(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,v.element,v.index,v.browserEvent)}mb(v){if(!this.G)return;const N=this.H;this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,!(!N||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),N.update(v.browserEvent.dataTransfer),this.F.drop(N,v.element,v.index,v.sector,v.browserEvent))}nb(v){this.G=!1,this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,$.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(v)}ob(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=I.$Tc.None}pb(v){if(!this.w){const N=(0,C.$KP)(this.domNode).top;this.w=(0,C.$GQ)((0,C.getWindow)(this.domNode),this.qb.bind(this,N))}this.x.dispose(),this.x=(0,b.$6g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=v.pageY}qb(v){if(this.y===void 0)return;const N=this.y-v,V=this.renderHeight-35;N<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(N-35))):N>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(N-V))))}rb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}sb(v,N){if(N===void 0)return;const V=v.offsetY/this.d[N].size;return Math.floor(V/.25)}tb(v){const N=this.q.getDomNode();let V=v;for(;V instanceof HTMLElement&&V!==this.o&&N.contains(V);){const H=V.getAttribute("data-index");if(H){const T=Number(H);if(!isNaN(T))return T}V=V.parentElement}}ub(v,N){return{start:this.g.indexAt(v),end:this.g.indexAfter(v+N-1)}}vb(v,N,V){const H=this.ub(v,N);let T,L;v===this.elementTop(H.start)?(T=H.start,L=0):H.end-H.start>1&&(T=H.start+1,L=this.elementTop(T)-v);let B=0;for(;;){const X=this.ub(v,N);let Y=!1;for(let de=X.start;de<X.end;de++){const oe=this.wb(de);oe!==0&&this.g.splice(de,1,[this.d[de]]),B+=oe,Y=Y||oe!==0}if(!Y){B!==0&&this.U();const de=o.Range.relativeComplement(H,X);for(const ee of de)for(let me=ee.start;me<ee.end;me++)this.d[me].row&&this.bb(me);const oe=o.Range.relativeComplement(X,H);for(const ee of oe)for(let me=ee.start;me<ee.end;me++){const Pe=me+1,Te=Pe<this.d.length?this.d[Pe].row:null,Me=Te?Te.domNode:null;this.Y(me,Me)}for(let ee=X.start;ee<X.end;ee++)this.d[ee].row&&this.ab(this.d[ee],ee);if(typeof T=="number"){const ee=this.p.getFutureScrollPosition().scrollTop-v,me=this.elementTop(T)-L+ee;this.setScrollTop(me,V)}this.N.fire(this.contentHeight);return}}}wb(v){const N=this.d[v];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(N.element);if(L!==null){const B=N.size;return N.size=L,N.lastDynamicHeightWidth=this.n,L-B}}if(!N.hasDynamicHeight||N.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(N.element))return 0;const V=N.size;if(N.row)return N.row.domNode.style.height="",N.size=N.row.domNode.offsetHeight,N.lastDynamicHeightWidth=this.n,N.size-V;const{row:H}=this.h.alloc(N.templateId);H.domNode.style.height="",this.o.appendChild(H.domNode);const T=this.j.get(N.templateId);if(!T)throw new d.$cb("Missing renderer for templateId: "+N.templateId);return T.renderElement(N.element,v,H.templateData,void 0),N.size=H.domNode.offsetHeight,T.disposeElement?.(N.element,v,H.templateData,void 0),this.R.setDynamicHeight?.(N.element,N.size),N.lastDynamicHeightWidth=this.n,this.o.removeChild(H.domNode),this.h.release(H),N.size-V}xb(v){const N=v[v.length-1];if(!N)return null;const V=this.d[N.end];return!V||!V.row?null:V.row.domNode}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.d)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const N=this.j.get(v.row.templateId);N&&(N.disposeElement?.(v.element,-1,v.row.templateData,void 0),N.disposeTemplate(v.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$FR=R,Xe([w.$vh],R.prototype,"onMouseClick",null),Xe([w.$vh],R.prototype,"onMouseDblClick",null),Xe([w.$vh],R.prototype,"onMouseMiddleClick",null),Xe([w.$vh],R.prototype,"onMouseUp",null),Xe([w.$vh],R.prototype,"onMouseDown",null),Xe([w.$vh],R.prototype,"onMouseOver",null),Xe([w.$vh],R.prototype,"onMouseMove",null),Xe([w.$vh],R.prototype,"onMouseOut",null),Xe([w.$vh],R.prototype,"onContextMenu",null),Xe([w.$vh],R.prototype,"onTouchStart",null),Xe([w.$vh],R.prototype,"onTap",null)}),define(be[39],pe([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,98]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a,e,r,d,$,u,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XR=t.$WR=t.$VR=t.$UR=t.$TR=t.$SR=t.$RR=t.TypeNavigationMode=t.$QR=t.$PR=t.$OR=t.$NR=t.$MR=t.$LR=t.$KR=t.$JR=void 0;class f{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,m,i){const n=this.c.findIndex(l=>l.templateData===i);if(n>=0){const l=this.c[n];this.d.unrender(i),l.index=m}else{const l={index:m,templateData:i};this.c.push(l)}this.d.renderIndex(m,i)}splice(g,m,i){const n=[];for(const l of this.c)l.index<g?n.push(l):l.index>=g+m&&n.push({index:l.index+i-m,templateData:l.templateData});this.c=n}renderIndexes(g){for(const{index:m,templateData:i}of this.c)g.indexOf(m)>-1&&this.d.renderIndex(m,i)}disposeTemplate(g){const m=this.c.findIndex(i=>i.templateData===g);m<0||this.c.splice(m,1)}}class h{get name(){return this.g}get renderer(){return new f(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new o.$Td,this.onChange=this.f.event}splice(g,m,i){const n=i.length-m,l=g+m,D=[];let S=0;for(;S<this.d.length&&this.d[S]<g;)D.push(this.d[S++]);for(let z=0;z<i.length;z++)i[z]&&D.push(z+g);for(;S<this.d.length&&this.d[S]>=l;)D.push(this.d[S++]+n);this.renderer.splice(g,m,i.length),this.h(D,D)}renderIndex(g,m){m.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,m){return this.h(g,[...g].sort(ce),m)}h(g,m,i){const n=this.c,l=this.d;this.c=g,this.d=m;const D=W(l,g);return this.renderer.renderIndexes(D),this.f.fire({indexes:g,browserEvent:i}),n}get(){return this.c}contains(g){return(0,b.$wb)(this.d,g,ce)>=0}dispose(){(0,e.$Oc)(this.f)}}Xe([I.$vh],h.prototype,"renderer",null);class F extends h{constructor(g){super("selected"),this.k=g}renderIndex(g,m){super.renderIndex(g,m),this.k&&(this.contains(g)?m.setAttribute("aria-selected","true"):m.setAttribute("aria-selected","false"))}}class M{constructor(g,m,i){this.c=g,this.d=m,this.f=i}splice(g,m,i){if(!this.f)return this.c.splice(g,m,new Array(i.length).fill(!1));const n=this.c.get().map(S=>this.f.getId(this.d.element(S)).toString());if(n.length===0)return this.c.splice(g,m,new Array(i.length).fill(!1));const l=new Set(n),D=i.map(S=>l.has(this.f.getId(S).toString()));this.c.splice(g,m,D)}}function R(_){return _.tagName==="INPUT"||_.tagName==="TEXTAREA"}t.$JR=R;function O(_,g){return _.classList.contains(g)?!0:_.classList.contains("monaco-list")||!_.parentElement?!1:O(_.parentElement,g)}function v(_){return O(_,"monaco-editor")}t.$KR=v;function N(_){return O(_,"monaco-custom-toggle")}t.$LR=N;function V(_){return O(_,"action-item")}t.$MR=V;function H(_){return O(_,"monaco-tl-twistie")}t.$NR=H;function T(_){return O(_,"monaco-tree-sticky-row")}t.$OR=T;function L(_){return _.classList.contains("monaco-tree-sticky-container")}t.$PR=L;function B(_){return _.tagName==="A"&&_.classList.contains("monaco-button")||_.tagName==="DIV"&&_.classList.contains("monaco-button-dropdown")?!0:_.classList.contains("monaco-list")||!_.parentElement?!1:B(_.parentElement)}t.$QR=B;class X{get g(){return o.Event.chain(this.c.add(new C.$sR(this.k.domNode,"keydown")).event,g=>g.filter(m=>!R(m.target)).map(m=>new s.$oP(m)))}constructor(g,m,i){this.h=g,this.k=m,this.c=new e.$Sc,this.d=new e.$Sc,this.f=i.multipleSelectionSupport,this.c.add(this.g(n=>{switch(n.keyCode){case 3:return this.l(n);case 16:return this.o(n);case 18:return this.p(n);case 11:return this.q(n);case 12:return this.s(n);case 9:return this.u(n);case 31:this.f&&(d.$j?n.metaKey:n.ctrlKey)&&this.t(n)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const m=this.h.getFocus()[0];this.h.setAnchor(m),this.h.reveal(m),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([I.$vh],X.prototype,"g",null);var Y;(function(_){_[_.Automatic=0]="Automatic",_[_.Trigger=1]="Trigger"})(Y||(t.TypeNavigationMode=Y={}));var de;(function(_){_[_.Idle=0]="Idle",_[_.Typing=1]="Typing"})(de||(de={})),t.$RR=new class{mightProducePrintableCharacter(_){return _.ctrlKey||_.metaKey||_.altKey?!1:_.keyCode>=31&&_.keyCode<=56||_.keyCode>=21&&_.keyCode<=30||_.keyCode>=98&&_.keyCode<=107||_.keyCode>=85&&_.keyCode<=95}};class oe{constructor(g,m,i,n,l){this.o=g,this.p=m,this.q=i,this.s=n,this.t=l,this.c=!1,this.d=de.Idle,this.f=Y.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??Y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const m=o.Event.chain(this.k.add(new C.$sR(this.p.domNode,"keydown")).event,l=>l.filter(D=>!R(D.target)).filter(()=>this.f===Y.Automatic||this.g).map(D=>new s.$oP(D)).filter(D=>g||this.s(D)).filter(D=>this.t.mightProducePrintableCharacter(D)).forEach(D=>k.$mQ.stop(D,!0)).map(D=>D.browserEvent.key)),i=o.Event.debounce(m,()=>null,800,void 0,void 0,void 0,this.k);o.Event.reduce(o.Event.any(m,i),(l,D)=>D===null?null:(l||"")+D,void 0,this.k)(this.x,this,this.k),i(this.w,this,this.k),m(()=>g=!0,void 0,this.k),i(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const m=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));m&&(0,E.$uR)(m)}this.h=-1}x(g){if(!g){this.d=de.Idle,this.g=!1;return}const m=this.o.getFocus(),i=m.length>0?m[0]:0,n=this.d===de.Idle?1:0;this.d=de.Typing;for(let l=0;l<this.o.length;l++){const D=(i+l+n)%this.o.length,S=this.q.getKeyboardNavigationLabel(this.p.element(D)),z=S&&S.toString();if(this.o.options.typeNavigationEnabled){if(typeof z<"u"){if((0,a.$Sj)(g,z)){this.h=i,this.o.setFocus([D]),this.o.reveal(D);return}const P=(0,a.$Zj)(g,z);if(P&&P[0].end-P[0].start>1&&P.length===1){this.h=i,this.o.setFocus([D]),this.o.reveal(D);return}}}else if(typeof z>"u"||(0,a.$Sj)(g,z)){this.h=i,this.o.setFocus([D]),this.o.reveal(D);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ee{constructor(g,m){this.d=g,this.f=m,this.c=new e.$Sc;const i=o.Event.chain(this.c.add(new C.$sR(m.domNode,"keydown")).event,l=>l.filter(D=>!R(D.target)).map(D=>new s.$oP(D)));o.Event.chain(i,l=>l.filter(D=>D.keyCode===2&&!D.ctrlKey&&!D.metaKey&&!D.shiftKey&&!D.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const m=this.d.getFocus();if(m.length===0)return;const i=this.f.domElement(m[0]);if(!i)return;const n=i.querySelector("[tabIndex]");if(!n||!(n instanceof HTMLElement)||n.tabIndex===-1)return;const l=(0,k.getWindow)(n).getComputedStyle(n);l.visibility==="hidden"||l.display==="none"||(g.preventDefault(),g.stopPropagation(),n.focus())}dispose(){this.c.dispose()}}function me(_){return d.$j?_.browserEvent.metaKey:_.browserEvent.ctrlKey}t.$SR=me;function Pe(_){return _.browserEvent.shiftKey}t.$TR=Pe;function Te(_){return(0,k.$gQ)(_)&&_.button===2}const Me={isSelectionSingleChangeEvent:me,isSelectionRangeChangeEvent:Pe};class re{constructor(g){this.k=g,this.f=new e.$Sc,this.g=new o.$Td,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Me),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(j.$1Q.addTarget(g.getHTMLElement()))),o.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Me))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){v(g.browserEvent.target)||(0,k.$4P)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(R(g.browserEvent.target)||v(g.browserEvent.target))return;const m=typeof g.index>"u"?[]:[g.index];this.k.setFocus(m,g.browserEvent)}u(g){if(!this.d||R(g.browserEvent.target)||v(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const m=g.index;if(typeof m>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([m],g.browserEvent),this.k.setAnchor(m),Te(g.browserEvent)||this.k.setSelection([m],g.browserEvent),this.g.fire(g)}v(g){if(R(g.browserEvent.target)||v(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const m=this.k.getFocus();this.k.setSelection(m,g.browserEvent)}w(g){const m=g.index;let i=this.k.getAnchor();if(this.p(g)){typeof i>"u"&&(i=this.k.getFocus()[0]??m,this.k.setAnchor(i));const n=Math.min(i,m),l=Math.max(i,m),D=(0,b.$Sb)(n,l+1),S=this.k.getSelection(),z=K(W(S,[i]),i);if(z.length===0)return;const P=W(D,Z(S,z));this.k.setSelection(P,g.browserEvent),this.k.setFocus([m],g.browserEvent)}else if(this.o(g)){const n=this.k.getSelection(),l=n.filter(D=>D!==m);this.k.setFocus([m]),this.k.setAnchor(m),n.length===l.length?this.k.setSelection([...l,m],g.browserEvent):this.k.setSelection(l,g.browserEvent)}}dispose(){this.f.dispose()}}t.$UR=re;class J{constructor(g,m){this.c=g,this.d=m}style(g){const m=this.d&&`.${this.d}`,i=[];g.listBackground&&i.push(`.monaco-list${m} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(i.push(`.monaco-list${m}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),i.push(`.monaco-list${m}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&i.push(`.monaco-list${m}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(i.push(`.monaco-list${m}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),i.push(`.monaco-list${m}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&i.push(`.monaco-list${m}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&i.push(`.monaco-list${m}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&i.push(`
				.monaco-drag-image,
				.monaco-list${m}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&i.push(`
				.monaco-drag-image,
				.monaco-list${m}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(i.push(`.monaco-list${m} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),i.push(`.monaco-list${m} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&i.push(`.monaco-list${m} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(i.push(`.monaco-list${m} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),i.push(`.monaco-list${m} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(i.push(`.monaco-list${m} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),i.push(`.monaco-list${m} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&i.push(`.monaco-list${m} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&i.push(`.monaco-list${m}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&i.push(`.monaco-list${m}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const n=(0,k.$JQ)(g.listFocusAndSelectionOutline,(0,k.$JQ)(g.listSelectionOutline,g.listFocusOutline??""));n&&i.push(`.monaco-list${m}:focus .monaco-list-row.focused.selected { outline: 1px solid ${n}; outline-offset: -1px;}`),g.listFocusOutline&&i.push(`
				.monaco-drag-image,
				.monaco-list${m}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${m}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const l=(0,k.$JQ)(g.listSelectionOutline,g.listInactiveFocusOutline??"");l&&i.push(`.monaco-list${m} .monaco-list-row.focused.selected { outline: 1px dotted ${l}; outline-offset: -1px; }`),g.listSelectionOutline&&i.push(`.monaco-list${m} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&i.push(`.monaco-list${m} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&i.push(`.monaco-list${m} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&i.push(`
				.monaco-list${m}.drop-target,
				.monaco-list${m} .monaco-list-rows.drop-target,
				.monaco-list${m} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(i.push(`
			.monaco-list${m} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${m} .monaco-list-row.drop-target-after + .monaco-list-row::before,
			.monaco-list${m} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),i.push(`
			.monaco-list${m} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${m} .monaco-list-row:last-child.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&i.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&i.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=i.join(`
`)}}t.$VR=J,t.$WR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:y.$ct.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:y.$ct.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:y.$ct.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function K(_,g){const m=_.indexOf(g);if(m===-1)return[];const i=[];let n=m-1;for(;n>=0&&_[n]===g-(m-n);)i.push(_[n--]);for(i.reverse(),n=m;n<_.length&&_[n]===g+(n-m);)i.push(_[n++]);return i}function W(_,g){const m=[];let i=0,n=0;for(;i<_.length||n<g.length;)if(i>=_.length)m.push(g[n++]);else if(n>=g.length)m.push(_[i++]);else if(_[i]===g[n]){m.push(_[i]),i++,n++;continue}else _[i]<g[n]?m.push(_[i++]):m.push(g[n++]);return m}function Z(_,g){const m=[];let i=0,n=0;for(;i<_.length||n<g.length;)if(i>=_.length)m.push(g[n++]);else if(n>=g.length)m.push(_[i++]);else if(_[i]===g[n]){i++,n++;continue}else _[i]<g[n]?m.push(_[i++]):n++;return m}const ce=(_,g)=>_-g;class we{constructor(g,m){this.c=g,this.d=m}get templateId(){return this.c}renderTemplate(g){return this.d.map(m=>m.renderTemplate(g))}renderElement(g,m,i,n){let l=0;for(const D of this.d)D.renderElement(g,m,i[l++],n)}disposeElement(g,m,i,n){let l=0;for(const D of this.d)D.disposeElement?.(g,m,i[l],n),l+=1}disposeTemplate(g){let m=0;for(const i of this.d)i.disposeTemplate(g[m++])}}class ke{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,m,i){const n=this.c.getAriaLabel(g);n?i.setAttribute("aria-label",n):i.removeAttribute("aria-label");const l=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof l=="number"?i.setAttribute("aria-level",`${l}`):i.removeAttribute("aria-level")}disposeTemplate(g){}}class Ae{constructor(g,m){this.c=g,this.d=m}getDragElements(g){const m=this.c.getSelectedElements();return m.indexOf(g)>-1?m:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,m){if(this.d.getDragLabel)return this.d.getDragLabel(g,m)}onDragStart(g,m){this.d.onDragStart?.(g,m)}onDragOver(g,m,i,n,l){return this.d.onDragOver(g,m,i,n,l)}onDragLeave(g,m,i,n){this.d.onDragLeave?.(g,m,i,n)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,m,i,n,l){this.d.drop(g,m,i,n,l)}dispose(){this.d.dispose()}}class Le{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const m=o.Event.chain(this.y.add(new C.$sR(this.k.domNode,"keydown")).event,l=>l.map(D=>new s.$oP(D)).filter(D=>g=D.keyCode===58||D.shiftKey&&D.keyCode===68).map(D=>k.$mQ.stop(D,!0)).filter(()=>!1)),i=o.Event.chain(this.y.add(new C.$sR(this.k.domNode,"keyup")).event,l=>l.forEach(()=>g=!1).map(D=>new s.$oP(D)).filter(D=>D.keyCode===58||D.shiftKey&&D.keyCode===68).map(D=>k.$mQ.stop(D,!0)).map(({browserEvent:D})=>{const S=this.getFocus(),z=S.length?S[0]:void 0,P=typeof z<"u"?this.k.element(z):void 0,U=typeof z<"u"?this.k.domElement(z):this.k.domNode;return{index:z,element:P,anchor:U,browserEvent:D}})),n=o.Event.chain(this.k.onContextMenu,l=>l.filter(D=>!g).map(({element:D,index:S,browserEvent:z})=>({element:D,index:S,anchor:new c.$jP((0,k.getWindow)(this.k.domNode),z),browserEvent:z})));return o.Event.any(m,i,n)}get onKeyDown(){return this.y.add(new C.$sR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$sR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$sR(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.y.add(new C.$sR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.y.add(new C.$sR(this.k.domNode,"blur",!0)).event)}constructor(g,m,i,n,l=le){this.A=g,this.B=l,this.c=new h("focused"),this.f=new h("anchor"),this.g=new o.$2d,this.x="",this.y=new e.$Sc,this.z=new o.$Td,this.onDidDispose=this.z.event;const D=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(D!=="listbox");const S=[this.c.renderer,this.d.renderer];this.u=l.accessibilityProvider,this.u&&(S.push(new ke(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),n=n.map(P=>new we(P.templateId,[...S,P]));const z={...l,dnd:l.dnd&&new Ae(this,l.dnd)};if(this.k=this.C(m,i,n,z),this.k.domNode.setAttribute("role",D),l.styleController)this.q=l.styleController(this.k.domId);else{const P=(0,k.$_P)(this.k.domNode);this.q=new J(P,this.k.domId)}if(this.o=new A.$wR([new M(this.c,this.k,l.identityProvider),new M(this.d,this.k,l.identityProvider),new M(this.f,this.k,l.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ee(this,this.k)),(typeof l.keyboardSupport!="boolean"||l.keyboardSupport)&&(this.v=new X(this,this.k,l),this.y.add(this.v)),l.keyboardNavigationLabelProvider){const P=l.keyboardNavigationDelegate||t.$RR;this.t=new oe(this,this.k,l.keyboardNavigationLabelProvider,l.keyboardNavigationEventFilter??(()=>!0),P),this.y.add(this.t)}this.w=this.D(l),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,m,i,n){return new p.$FR(g,m,i,n)}D(g){return new re(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,m,i=[]){if(g<0||g>this.k.length)throw new u.$HR(this.A,`Invalid start index: ${g}`);if(m<0)throw new u.$HR(this.A,`Invalid delete count: ${m}`);m===0&&i.length===0||this.g.bufferEvents(()=>this.o.splice(g,m,i))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,m){this.k.updateElementHeight(g,m,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,m){this.k.layout(g,m)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,m){for(const i of g)if(i<0||i>=this.length)throw new u.$HR(this.A,`Invalid index ${i}`);this.d.set(g,m)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new u.$HR(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,m){for(const i of g)if(i<0||i>=this.length)throw new u.$HR(this.A,`Invalid index ${i}`);this.c.set(g,m)}focusNext(g=1,m=!1,i,n){if(this.length===0)return;const l=this.c.get(),D=this.E(l.length>0?l[0]+g:0,m,n);D>-1&&this.setFocus([D],i)}focusPrevious(g=1,m=!1,i,n){if(this.length===0)return;const l=this.c.get(),D=this.F(l.length>0?l[0]-g:0,m,n);D>-1&&this.setFocus([D],i)}async focusNextPage(g,m){let i=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);i=i===0?0:i-1;const n=this.getFocus()[0];if(n!==i&&(n===void 0||i>n)){const l=this.F(i,!1,m);l>-1&&n!==l?this.setFocus([l],g):this.setFocus([i],g)}else{const l=this.k.getScrollTop();let D=l+this.k.renderHeight;i>n&&(D-=this.k.elementHeight(i)),this.k.setScrollTop(D),this.k.getScrollTop()!==l&&(this.setFocus([]),await(0,w.$5g)(0),await this.focusNextPage(g,m))}}async focusPreviousPage(g,m){let i;const n=this.k.getScrollTop();n===0?i=this.k.indexAt(n):i=this.k.indexAfter(n-1);const l=this.getFocus()[0];if(l!==i&&(l===void 0||l>=i)){const D=this.E(i,!1,m);D>-1&&l!==D?this.setFocus([D],g):this.setFocus([i],g)}else{const D=n;this.k.setScrollTop(n-this.k.renderHeight),this.k.getScrollTop()!==D&&(this.setFocus([]),await(0,w.$5g)(0),await this.focusPreviousPage(g,m))}}focusLast(g,m){if(this.length===0)return;const i=this.F(this.length-1,!1,m);i>-1&&this.setFocus([i],g)}focusFirst(g,m){this.focusNth(0,g,m)}focusNth(g,m,i){if(this.length===0)return;const n=this.E(g,!1,i);n>-1&&this.setFocus([n],m)}E(g,m=!1,i){for(let n=0;n<this.length;n++){if(g>=this.length&&!m)return-1;if(g=g%this.length,!i||i(this.element(g)))return g;g++}return-1}F(g,m=!1,i){for(let n=0;n<this.length;n++){if(g<0&&!m)return-1;if(g=(this.length+g%this.length)%this.length,!i||i(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,m,i=0){if(g<0||g>=this.length)throw new u.$HR(this.A,`Invalid index ${g}`);const n=this.k.getScrollTop(),l=this.k.elementTop(g),D=this.k.elementHeight(g);if((0,$.$Kf)(m)){const S=D-this.k.renderHeight+i;this.k.setScrollTop(S*(0,r.$5l)(m,0,1)+l-i)}else{const S=l+D,z=n+this.k.renderHeight;l<n+i&&S>=z||(l<n+i||S>=z&&D>=this.k.renderHeight?this.k.setScrollTop(l-i):S>=z&&this.k.setScrollTop(S-this.k.renderHeight))}}getRelativeTop(g,m=0){if(g<0||g>=this.length)throw new u.$HR(this.A,`Invalid index ${g}`);const i=this.k.getScrollTop(),n=this.k.elementTop(g),l=this.k.elementHeight(g);if(n<i+m||n+l>i+this.k.renderHeight)return null;const D=l-this.k.renderHeight+m;return Math.abs((i+m-n)/D)}isDOMFocused(){return(0,k.$5P)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:m}){return{indexes:g,elements:g.map(i=>this.k.element(i)),browserEvent:m}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let m;this.u?.getActiveDescendantId&&(m=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",m||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$XR=Le,Xe([I.$vh],Le.prototype,"onDidChangeFocus",null),Xe([I.$vh],Le.prototype,"onDidChangeSelection",null),Xe([I.$vh],Le.prototype,"onContextMenu",null),Xe([I.$vh],Le.prototype,"onKeyDown",null),Xe([I.$vh],Le.prototype,"onKeyUp",null),Xe([I.$vh],Le.prototype,"onKeyPress",null),Xe([I.$vh],Le.prototype,"onDidFocus",null),Xe([I.$vh],Le.prototype,"onDidBlur",null)}),define(be[62],pe([1,0,6,35,37,10,15]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.MarkdownStringTextNewlineStyle=void 0;var A;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class b{constructor(u="",p=!1){if(this.value=u,typeof this.value!="string")throw(0,k.$7)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(u,p=0){return this.value+=o(this.supportThemeIcons?(0,C.$_j)(u):u).replace(/([ \t]+)/g,(c,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,p){return this.value+=`
${a(p,u)}
`,this}appendLink(u,p,c){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(u),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(u,p){const c=new RegExp((0,j.$Me)(p),"g");return u.replace(c,(f,h)=>u.charAt(h-1)!=="\\"?`\\${f}`:f)}}t.$fk=b;function w($){return y($)?!$.value:Array.isArray($)?$.every(w):!0}t.$gk=w;function y($){return $ instanceof b?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}t.$hk=y;function I($,u){return $===u?!0:!$||!u?!1:$.value===u.value&&$.isTrusted===u.isTrusted&&$.supportThemeIcons===u.supportThemeIcons&&$.supportHtml===u.supportHtml&&($.baseUri===u.baseUri||!!$.baseUri&&!!u.baseUri&&(0,s.$yg)(E.URI.from($.baseUri),E.URI.from(u.baseUri)))}t.$ik=I;function o($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$jk=o;function a($,u){const p=$.match(/^`+/gm)?.reduce((f,h)=>f.length>h.length?f:h).length??0,c=p>=3?p+1:3;return[`${"`".repeat(c)}${u}`,$,`${"`".repeat(c)}`].join(`
`)}t.$kk=a;function e($){return $.replace(/"/g,"&quot;")}t.$lk=e;function r($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$mk=r;function d($){const u=[],p=$.split("|").map(f=>f.trim());$=p[0];const c=p[1];if(c){const f=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),F=f?f[1]:"",M=h?h[1]:"",R=isFinite(parseInt(M)),O=isFinite(parseInt(F));R&&u.push(`width="${M}"`),O&&u.push(`height="${F}"`)}return{href:$,dimensions:u}}t.$nk=d}),define(be[126],pe([1,0,3,118,22,55,14,19,119,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a,e,r,d,$,u,p,c,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5R=t.$4R=t.$3R=t.$2R=t.$1R=void 0;const F=Object.freeze({image:(K,W,Z)=>{let ce=[],we=[];return K&&({href:K,dimensions:ce}=(0,I.$nk)(K),we.push(`src="${(0,I.$lk)(K)}"`)),Z&&we.push(`alt="${(0,I.$lk)(Z)}"`),W&&we.push(`title="${(0,I.$lk)(W)}"`),ce.length&&(we=we.concat(ce)),"<img "+we.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,W,Z)=>typeof K!="string"?"":(K===Z&&(Z=(0,I.$mk)(Z)),W=typeof W=="string"?(0,I.$lk)((0,I.$mk)(W)):"",K=(0,I.$mk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${W||K}" draggable="false">${Z}</a>`)});function M(K,W={},Z={}){const ce=new r.$Sc;let we=!1;const ke=(0,j.$rR)(W),Ae=function(S){let z;try{z=(0,$.$zh)(decodeURIComponent(S))}catch{}return z?(z=(0,p.$mn)(z,P=>{if(K.uris&&K.uris[P])return h.URI.revive(K.uris[P])}),encodeURIComponent(JSON.stringify(z))):S},Le=function(S,z){const P=K.uris&&K.uris[S];let U=h.URI.revive(P);return z?S.startsWith(u.Schemas.data+":")?S:(U||(U=h.URI.parse(S)),u.$mg.uriToBrowserUri(U).toString(!0)):!U||h.URI.parse(S).toString()===U.toString()?S:(U.query&&(U=U.with({query:Ae(U.query)})),U.toString())},_=new d.marked.Renderer;_.image=F.image,_.link=F.link,_.paragraph=F.paragraph;const g=[],m=[];if(W.codeBlockRendererSync?_.code=(S,z)=>{const P=a.$6M.nextId(),U=W.codeBlockRendererSync(R(z),S);return m.push([P,U]),`<div class="code" data-code="${P}">${(0,f.$Le)(S)}</div>`}:W.codeBlockRenderer&&(_.code=(S,z)=>{const P=a.$6M.nextId(),U=W.codeBlockRenderer(R(z),S);return g.push(U.then(G=>[P,G])),`<div class="code" data-code="${P}">${(0,f.$Le)(S)}</div>`}),W.actionHandler){const S=function(U){let G=U.target;if(!(G.tagName!=="A"&&(G=G.parentElement,!G||G.tagName!=="A")))try{let ne=G.dataset.href;ne&&(K.baseUri&&(ne=O(h.URI.from(K.baseUri),ne)),W.actionHandler.callback(ne,U))}catch(ne){(0,w.$1)(ne)}finally{U.preventDefault()}},z=W.actionHandler.disposables.add(new s.$sR(ke,"click")),P=W.actionHandler.disposables.add(new s.$sR(ke,"auxclick"));W.actionHandler.disposables.add(y.Event.any(z.event,P.event)(U=>{const G=new A.$jP(k.getWindow(ke),U);!G.leftButton&&!G.middleButton||S(G)})),W.actionHandler.disposables.add(k.$rP(ke,"keydown",U=>{const G=new E.$oP(U);!G.equals(10)&&!G.equals(3)||S(G)}))}K.supportHtml||(Z.sanitizer=S=>(K.isTrusted?S.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?S:"",Z.sanitize=!0,Z.silent=!0),Z.renderer=_;let i=K.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(i=(0,o.$ak)(i));let n;if(W.fillInIncompleteTokens){const S={...d.marked.defaults,...Z},z=d.marked.lexer(i,S),P=Y(z);n=d.marked.parser(P,S)}else n=d.marked.parse(i,Z);K.supportThemeIcons&&(n=(0,b.$YR)(n).map(z=>typeof z=="string"?z:z.outerHTML).join(""));const D=new DOMParser().parseFromString(v(K,n),"text/html");if(D.body.querySelectorAll("img").forEach(S=>{const z=S.getAttribute("src");if(z){let P=z;try{K.baseUri&&(P=O(h.URI.from(K.baseUri),P))}catch{}S.src=Le(P,!0)}}),D.body.querySelectorAll("a").forEach(S=>{const z=S.getAttribute("href");if(S.setAttribute("href",""),!z||/^data:|javascript:/i.test(z)||/^command:/i.test(z)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(z))S.replaceWith(...S.childNodes);else{let P=Le(z,!1);K.baseUri&&(P=O(h.URI.from(K.baseUri),z)),S.dataset.href=P}}),ke.innerHTML=v(K,D.body.innerHTML),g.length>0)Promise.all(g).then(S=>{if(we)return;const z=new Map(S),P=ke.querySelectorAll("div[data-code]");for(const U of P){const G=z.get(U.dataset.code??"");G&&k.$tQ(U,G)}W.asyncRenderCallback?.()});else if(m.length>0){const S=new Map(m),z=ke.querySelectorAll("div[data-code]");for(const P of z){const U=S.get(P.dataset.code??"");U&&k.$tQ(P,U)}}if(W.asyncRenderCallback)for(const S of ke.getElementsByTagName("img")){const z=ce.add(k.$rP(S,"load",()=>{z.dispose(),W.asyncRenderCallback()}))}return{element:ke,dispose:()=>{we=!0,ce.dispose()}}}t.$1R=M;function R(K){if(!K)return"";const W=K.split(/[\s+|:|,|\{|\?]/,1);return W.length?W[0]:K}function O(K,W){return/^\w[\w\d+.-]*:/.test(W)?W:K.path.endsWith("/")?(0,c.$Ig)(K,W).toString():(0,c.$Ig)((0,c.$Eg)(K),W).toString()}function v(K,W){const{config:Z,allowedSchemes:ce}=N(K);C.addHook("uponSanitizeAttribute",(ke,Ae)=>{if(Ae.attrName==="style"||Ae.attrName==="class"){if(ke.tagName==="SPAN"){if(Ae.attrName==="style"){Ae.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ae.attrValue);return}else if(Ae.attrName==="class"){Ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ae.attrValue);return}}Ae.keepAttr=!1;return}else if(ke.tagName==="INPUT"&&ke.attributes.getNamedItem("type")?.value==="checkbox"){if(Ae.attrName==="type"&&Ae.attrValue==="checkbox"||Ae.attrName==="disabled"||Ae.attrName==="checked"){Ae.keepAttr=!0;return}Ae.keepAttr=!1}}),C.addHook("uponSanitizeElement",(ke,Ae)=>{Ae.tagName==="input"&&(ke.attributes.getNamedItem("type")?.value==="checkbox"?ke.setAttribute("disabled",""):ke.parentElement?.removeChild(ke))});const we=k.$NQ(ce);try{return C.sanitize(W,{...Z,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),we.dispose()}}t.$2R=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function N(K){const W=[u.Schemas.http,u.Schemas.https,u.Schemas.mailto,u.Schemas.data,u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemote,u.Schemas.vscodeRemoteResource];return K.isTrusted&&W.push(u.Schemas.command),{config:{ALLOWED_TAGS:[...k.$OQ],ALLOWED_ATTR:t.$2R,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:W}}function V(K){return typeof K=="string"?K:H(K)}t.$3R=V;function H(K){let W=K.value??"";W.length>1e5&&(W=`${W.substr(0,1e5)}\u2026`);const Z=d.marked.parse(W,{renderer:L.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ce=>T.get(ce)??ce);return v({isTrusted:!1},Z).toString()}t.$4R=H;const T=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),L=new e.$V(()=>{const K=new d.marked.Renderer;return K.code=W=>W,K.blockquote=W=>W,K.html=W=>"",K.heading=(W,Z,ce)=>W+`
`,K.hr=()=>"",K.list=(W,Z)=>W,K.listitem=W=>W+`
`,K.paragraph=W=>W+`
`,K.table=(W,Z)=>W+Z+`
`,K.tablerow=W=>W,K.tablecell=(W,Z)=>W+" ",K.strong=W=>W,K.em=W=>W,K.codespan=W=>W,K.br=()=>`
`,K.del=W=>W,K.image=(W,Z,ce)=>"",K.text=W=>W,K.link=(W,Z,ce)=>ce,K});function B(K){let W="";return K.forEach(Z=>{W+=Z.raw}),W}function X(K){for(const W of K.tokens)if(W.type==="text"){const Z=W.raw.split(`
`),ce=Z[Z.length-1];if(ce.includes("`"))return oe(K);if(ce.includes("**"))return Me(K);if(ce.match(/\*\w/))return ee(K);if(ce.match(/(^|\s)__\w/))return re(K);if(ce.match(/(^|\s)_\w/))return me(K);if(ce.match(/(^|\s)\[.*\]\(\w*/))return Pe(K);if(ce.match(/(^|\s)\[\w/))return Te(K)}}function Y(K){let W,Z;for(W=0;W<K.length;W++){const ce=K[W];if(ce.type==="paragraph"&&ce.raw.match(/(\n|^)```/)){Z=de(K.slice(W));break}if(ce.type==="paragraph"&&ce.raw.match(/(\n|^)\|/)){Z=le(K.slice(W));break}if(W===K.length-1&&ce.type==="paragraph"){const we=X(ce);if(we){Z=[we];break}}}if(Z){const ce=[...K.slice(0,W),...Z];return ce.links=K.links,ce}return K}t.$5R=Y;function de(K){const W=B(K);return d.marked.lexer(W+"\n```")}function oe(K){return J(K,"`")}function ee(K){return J(K,"*")}function me(K){return J(K,"_")}function Pe(K){return J(K,")")}function Te(K){return J(K,"](about:blank)")}function Me(K){return J(K,"**")}function re(K){return J(K,"__")}function J(K,W){const Z=B(Array.isArray(K)?K:[K]);return d.marked.lexer(Z+W)[0]}function le(K){const W=B(K),Z=W.split(`
`);let ce,we=!1;for(let ke=0;ke<Z.length;ke++){const Ae=Z[ke].trim();if(typeof ce>"u"&&Ae.match(/^\s*\|/)){const Le=Ae.match(/(\|[^\|]+)(?=\||$)/g);Le&&(ce=Le.length)}else if(typeof ce=="number")if(Ae.match(/^\s*\|/)){if(ke!==Z.length-1)return;we=!0}else return}if(typeof ce=="number"&&ce>0){const ke=we?Z.slice(0,-1).join(`
`):W,Ae=!!ke.match(/\|\s*$/),Le=ke+(Ae?"":"|")+`
|${" --- |".repeat(ce)}`;return d.marked.lexer(Le)}}}),define(be[127],pe([1,0,3,9,29,62,35,2,7,108]),function(ie,t,k,C,s,j,E,A,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=t.$iR=void 0;function y(a,e){(0,b.$Gf)(e)?a.title=(0,E.$bk)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$iR=y;class I{constructor(e,r,d){this.c=e,this.d=r,this.f=d}async update(e,r,d){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let $;if(e===void 0||(0,b.$Gf)(e)||e instanceof HTMLElement)$=e;else if(!(0,b.$Uf)(e.markdown))$=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,w.localize)(0,null),r),this.b=new s.$4d;const u=this.b.token;if($=await e.markdown(u),$===void 0&&($=e.markdownNotSupportedFallback),this.isDisposed||u.isCancellationRequested)return}this.g($,r,d)}g(e,r,d){const $=this.a;if(this.h(e)){const u={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!$},position:{hoverPosition:2},...d};this.a=this.c.showHover(u,r)}$?.dispose()}h(e){return e?(0,j.$hk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(a,e,r,d){let $,u;const p=(H,T)=>{const L=u!==void 0;H&&(u?.dispose(),u=void 0),T&&($?.dispose(),$=void 0),L&&a.onDidHideHover?.()},c=(H,T,L)=>new C.$bh(async()=>{(!u||u.isDisposed)&&(u=new I(a,L||e,H>0),await u.update(r,T,d))},H);let f=!1;const h=k.$rP(e,k.$kQ.MOUSE_DOWN,()=>{f=!0,p(!0,!0)},!0),F=k.$rP(e,k.$kQ.MOUSE_UP,()=>{f=!1},!0),M=k.$rP(e,k.$kQ.MOUSE_LEAVE,H=>{f=!1,p(!1,H.fromElement===e)},!0),R=()=>{if($)return;const H=new A.$Sc,T={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const L=B=>{T.x=B.x+10,B.target instanceof HTMLElement&&B.target.classList.contains("action-label")&&p(!0,!0)};H.add(k.$rP(e,k.$kQ.MOUSE_MOVE,L,!0))}H.add(c(a.delay,!1,T)),$=H},O=k.$rP(e,k.$kQ.MOUSE_OVER,R,!0),v=()=>{if(f||$)return;const H={targetElements:[e],dispose:()=>{}},T=new A.$Sc,L=()=>p(!0,!0);T.add(k.$rP(e,k.$kQ.BLUR,L,!0)),T.add(c(a.delay,!1,H)),$=T},N=k.$rP(e,k.$kQ.FOCUS,v,!0);return{show:H=>{p(!1,!0),c(0,H)},hide:()=>{p(!0,!0)},update:async(H,T)=>{r=H,await u?.update(r,void 0,T)},dispose:()=>{O.dispose(),M.dispose(),h.dispose(),F.dispose(),N.dispose(),p(!0,!0)}}}t.$jR=o}),define(be[128],pe([1,0,3,22,14,126,39,12,4,44,2,5,110,101]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6R=void 0;const a=k.$,e="selectOption.entry.template";class r{get templateId(){return e}renderTemplate(u){const p=Object.create(null);return p.root=u,p.text=k.$rQ(u,a(".option-text")),p.detail=k.$rQ(u,a(".option-detail")),p.decoratorRight=k.$rQ(u,a(".option-decorator-right")),p}renderElement(u,p,c){const f=c,h=u.text,F=u.detail,M=u.decoratorRight,R=u.isDisabled;f.text.textContent=h,f.detail.textContent=F||"",f.decoratorRight.innerText=M||"",R?f.root.classList.add("option-disabled"):f.root.classList.remove("option-disabled")}disposeTemplate(u){}}class d extends y.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(u,p,c,f,h){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=f,this.g=h||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=d.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new b.$Td,this.B(this.r),this.O(),this.N(c),this.n=p||0,u&&this.setOptions(u,p),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(u){this.u=u,this.w=k.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=k.$rQ(this.w,a(".select-box-details-pane"));const p=k.$rQ(this.w,a(".select-box-dropdown-container-width-control")),c=k.$rQ(p,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",k.$rQ(c,this.D),this.G=0,this.y=k.$_P(this.w),this.w.setAttribute("draggable","true"),this.B(k.$rP(this.w,k.$kQ.DRAG_START,f=>{k.$mQ.stop(f,!0)}))}O(){this.B(k.$sP(this.h,"change",p=>{this.n=p.target.selectedIndex,this.r.fire({index:p.target.selectedIndex,selected:p.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(k.$rP(this.h,k.$kQ.CLICK,p=>{k.$mQ.stop(p),this.f?this.X(!0):this.W()})),this.B(k.$rP(this.h,k.$kQ.MOUSE_DOWN,p=>{k.$mQ.stop(p)}));let u;this.B(k.$rP(this.h,"touchstart",p=>{u=this.f})),this.B(k.$rP(this.h,"touchend",p=>{k.$mQ.stop(p),u?this.X(!0):this.W()})),this.B(k.$rP(this.h,k.$kQ.KEY_DOWN,p=>{const c=new s.$oP(p);let f=!1;I.$j?(c.keyCode===18||c.keyCode===16||c.keyCode===10||c.keyCode===3)&&(f=!0):(c.keyCode===18&&c.altKey||c.keyCode===16&&c.altKey||c.keyCode===10||c.keyCode===3)&&(f=!0),f&&(this.W(),k.$mQ.stop(p,!0))}))}get onDidSelect(){return this.r.event}setOptions(u,p){A.$ub(this.m,u)||(this.m=u,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((c,f)=>{this.h.add(this.U(c.text,f,c.isDisabled)),typeof c.description=="string"&&(this.H=!0)})),p!==void 0&&(this.select(p),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(u){u>=0&&u<this.m.length?this.n=u:u>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(u){this.g.ariaLabel=u,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(u){this.h.tabIndex=u?0:-1}render(u){this.j=u,u.classList.add("select-container"),u.appendChild(this.h),this.R()}Q(){const u=[];this.s.listFocusBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(u.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=u.join(`
`)}R(){const u=this.s.selectBackground??"",p=this.s.selectForeground??"",c=this.s.selectBorder??"";this.h.style.backgroundColor=u,this.h.style.color=p,this.h.style.borderColor=c}S(){const u=this.s.selectBackground??"",p=k.$JQ(this.s.selectListBackground,u);this.C.style.backgroundColor=p,this.I.style.backgroundColor=p;const c=this.s.focusBorder??"";this.w.style.outlineColor=c,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(u,p,c){const f=document.createElement("option");return f.value=u,f.text=u,f.disabled=!!c,f}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:u=>this.Y(u,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:u=>this.Y(u),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(u){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),u&&this.h.focus(),this.u.hideContextView())}Y(u,p){return u.appendChild(this.w),this.ab(p),{dispose:()=>{try{u.removeChild(this.w)}catch{}}}}Z(){let u=0;return this.m.forEach((p,c)=>{this.hb(c),this.I.offsetHeight>u&&(u=this.I.offsetHeight)}),u}ab(u){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const p=k.getWindow(this.h),c=k.$NP(this.h),f=k.getWindow(this.h).getComputedStyle(this.h),h=parseFloat(f.getPropertyValue("--dropdown-padding-top"))+parseFloat(f.getPropertyValue("--dropdown-padding-bottom")),F=p.innerHeight-c.top-c.height-(this.g.minBottomMargin||0),M=c.top-d.b,R=this.h.offsetWidth,O=this.bb(this.D),v=Math.max(O,Math.round(R)).toString()+"px";this.w.style.width=v,this.z.getHTMLElement().style.height="",this.z.layout();let N=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const V=this.H?this.L:0,H=N+h+V,T=Math.floor((F-h-V)/this.getHeight()),L=Math.floor((M-h-V)/this.getHeight());if(u)return c.top+c.height>p.innerHeight-22||c.top<d.b||T<1&&L<1?!1:(T<d.c&&L>T&&this.m.length>T?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(c.top+c.height>p.innerHeight-22||c.top<d.b||this.G===0&&T<1||this.G===1&&L<1)return this.X(!0),!1;if(this.G===0){if(this.f&&T+L<1)return this.X(!0),!1;H>F&&(N=T*this.getHeight())}else H>M&&(N=L*this.getHeight());return this.z.layout(N),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=N+h+"px",this.w.style.height=""):this.w.style.height=N+h+"px",this.hb(this.n),this.w.style.width=v,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(u){let p=0;if(u){let c=0,f=0;this.m.forEach((h,F)=>{const M=h.detail?h.detail.length:0,R=h.decoratorRight?h.decoratorRight.length:0,O=h.text.length+M+R;O>f&&(c=F,f=O)}),u.textContent=this.m[c].text+(this.m[c].decoratorRight?this.m[c].decoratorRight+" ":""),p=k.$PP(u)}return p}cb(u){if(this.z)return;this.C=k.$rQ(u,a(".select-box-dropdown-list-container")),this.t=new r,this.z=new E.$XR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:f=>{let h=f.text;return f.detail&&(h+=`. ${f.detail}`),f.decoratorRight&&(h+=`. ${f.decoratorRight}`),f.description&&(h+=`. ${f.description}`),h},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>I.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const p=this.B(new C.$sR(this.C,"keydown")),c=b.Event.chain(p.event,f=>f.filter(()=>this.z.length>0).map(h=>new s.$oP(h)));this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===3))(this.jb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===2))(this.jb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===9))(this.ib,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===16))(this.lb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===18))(this.kb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===12))(this.nb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===11))(this.mb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===14))(this.ob,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===13))(this.pb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode>=21&&h.keyCode<=56||h.keyCode>=85&&h.keyCode<=113))(this.qb,this)),this.B(k.$rP(this.z.getHTMLElement(),k.$kQ.POINTER_UP,f=>this.db(f))),this.B(this.z.onMouseOver(f=>typeof f.index<"u"&&this.z.setFocus([f.index]))),this.B(this.z.onDidChangeFocus(f=>this.gb(f))),this.B(k.$rP(this.w,k.$kQ.FOCUS_OUT,f=>{!this.f||k.$VP(f.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(u){if(!this.z.length)return;k.$mQ.stop(u);const p=u.target;if(!p||p.classList.contains("slider"))return;const c=p.closest(".monaco-list-row");if(!c)return;const f=Number(c.getAttribute("data-index")),h=c.classList.contains("option-disabled");f>=0&&f<this.m.length&&!h&&(this.n=f,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(u,p){const c=h=>{for(let F=0;F<h.childNodes.length;F++){const M=h.childNodes.item(F);(M.tagName&&M.tagName.toLowerCase())==="img"?h.removeChild(M):c(M)}},f=(0,j.$1R)({value:u,supportThemeIcons:!0},{actionHandler:p});return f.element.classList.add("select-box-description-markdown"),c(f.element),f.element}gb(u){!this.f||!this.H||this.hb(u.indexes[0])}hb(u){this.I.innerText="";const p=this.m[u],c=p?.description??"",f=p?.descriptionIsMarkdown??!1;if(c){if(f){const h=p.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(c,h))}else this.I.innerText=c;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(u){k.$mQ.stop(u),this.select(this.F),this.X(!0)}jb(u){k.$mQ.stop(u),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(u){if(this.n<this.m.length-1){k.$mQ.stop(u,!0);const p=this.m[this.n+1].isDisabled;if(p&&this.m.length>this.n+2)this.n+=2;else{if(p)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(u){this.n>0&&(k.$mQ.stop(u,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(u){k.$mQ.stop(u),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(u){k.$mQ.stop(u),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(u){k.$mQ.stop(u),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(u){k.$mQ.stop(u),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(u){const p=w.KeyCodeUtils.toString(u.keyCode);let c=-1;for(let f=0;f<this.m.length-1;f++)if(c=(f+this.n+1)%this.m.length,this.m[c].text.charAt(0).toUpperCase()===p&&!this.m[c].isDisabled){this.select(c),this.z.setFocus([c]),this.z.reveal(this.z.getFocus()[0]),k.$mQ.stop(u);break}}dispose(){this.X(!1),super.dispose()}}t.$6R=d}),define(be[129],pe([1,0,39,128,122,20,5,100]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9R=t.$8R=void 0,t.$8R={...k.$WR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends j.$5Q{constructor(w,y,I,o,a){super(),E.$j&&!a?.useCustomDrawn?this.a=new s.$7R(w,y,o,a):this.a=new C.$6R(w,y,I,o,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(w,y){this.a.setOptions(w,y)}select(w){this.a.select(w)}setAriaLabel(w){this.a.setAriaLabel(w)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(w){this.a.setFocusable(w)}render(w){this.a.render(w)}}t.$9R=A}),define(be[63],pe([1,0,16,54,3,25,127,129,36,2,5,7,105,52]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eS=t.$dS=t.$cS=void 0;class a extends w.$Tc{get action(){return this._action}constructor($,u,p={}){super(),this.m=p,this._context=$||this,this._action=u,u instanceof b.$Ii&&this.B(u.onDidChange(c=>{this.element&&this.t(c)}))}t($){$.enabled!==void 0&&this.u(),$.checked!==void 0&&this.H(),$.class!==void 0&&this.G(),$.label!==void 0&&(this.w(),this.D()),$.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new b.$Ji)),this.j}set actionRunner($){this.j=$}isEnabled(){return this._action.enabled}setActionContext($){this._context=$}render($){const u=this.element=$;this.B(j.$1Q.addTarget($));const p=this.m&&this.m.draggable;p&&($.draggable=!0,k.$0O&&this.B((0,s.$rP)($,s.$kQ.DRAG_START,c=>c.dataTransfer?.setData(C.$YQ.TEXT,this._action.label)))),this.B((0,s.$rP)(u,j.EventType.Tap,c=>this.onClick(c,!0))),this.B((0,s.$rP)(u,s.$kQ.MOUSE_DOWN,c=>{p||s.$mQ.stop(c,!0),this._action.enabled&&c.button===0&&u.classList.add("active")})),y.$j&&this.B((0,s.$rP)(u,s.$kQ.CONTEXT_MENU,c=>{c.button===0&&c.ctrlKey===!0&&this.onClick(c)})),this.B((0,s.$rP)(u,s.$kQ.CLICK,c=>{s.$mQ.stop(c,!0),this.m&&this.m.isMenu||this.onClick(c)})),this.B((0,s.$rP)(u,s.$kQ.DBLCLICK,c=>{s.$mQ.stop(c,!0)})),[s.$kQ.MOUSE_UP,s.$kQ.MOUSE_OUT].forEach(c=>{this.B((0,s.$rP)(u,c,f=>{s.$mQ.stop(f),u.classList.remove("active")}))})}onClick($,u=!1){s.$mQ.stop($,!0);const p=I.$Pf(this._context)?this.m?.useEventAsContext?$:{preserveFocus:u}:this._context;this.actionRunner.run(this._action,p)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable($){this.element&&(this.element.tabIndex=$?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const $=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update($):(this.f=(0,E.$jR)(this.m.hoverDelegate,this.element,$),this.q.add(this.f))):this.element.title=$}F(){if(this.element){const $=this.C()??"";this.element.setAttribute("aria-label",$)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$cS=a;class e extends a{constructor($,u,p){super($,u,p),this.m=p,this.m.icon=p.icon!==void 0?p.icon:!1,this.m.label=p.label!==void 0?p.label:!0,this.L=""}render($){super.render($),I.$Qf(this.element);const u=document.createElement("a");if(u.classList.add("action-label"),u.setAttribute("role",this.M()),this.I=u,this.element.appendChild(u),this.m.label&&this.m.keybinding){const p=document.createElement("span");p.classList.add("keybinding"),p.textContent=this.m.keybinding,this.element.appendChild(p)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===b.$Ki.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable($){this.I&&(this.I.tabIndex=$?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let $=null;return this.action.tooltip?$=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&($=this.action.label,this.m.keybinding&&($=o.localize(0,null,$,this.m.keybinding))),$??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const $=this.C()??"";this.I.setAttribute("aria-label",$)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$dS=e;class r extends a{constructor($,u,p,c,f,h,F){super($,u),this.b=new A.$9R(p,c,f,h,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions($,u){this.b.setOptions($,u)}select($){this.b.select($)}g(){this.B(this.b.onDidSelect($=>this.n($.selected,$.index)))}n($,u){this.actionRunner.run(this._action,this.r($,u))}r($,u){return $}setFocusable($){this.b.setFocusable($)}focus(){this.b?.focus()}blur(){this.b?.blur()}render($){this.b.render($)}}t.$eS=r}),define(be[64],pe([1,0,3,14,63,36,4,2,7,52]),function(ie,t,k,C,s,j,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=t.ActionsOrientation=void 0;var w;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class y extends A.$Tc{constructor(a,e={}){super(),this.g=this.B(new A.$Sc),this.r=this.B(new A.$3c),this.w=!1,this.y=!0,this.C=this.B(new E.$Td),this.onDidBlur=this.C.event,this.D=this.B(new E.$Td({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new E.$Td),this.onDidRun=this.G.event,this.H=this.B(new E.$Td),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new j.$Ji,this.g.add(this.f)),this.g.add(this.f.onDidRun($=>this.G.fire($))),this.g.add(this.f.onWillRun($=>this.H.fire($))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let r,d;switch(this.m){case 0:r=[15],d=[17];break;case 1:r=[16],d=[18],this.domNode.className+=" vertical";break}this.B(k.$rP(this.domNode,k.$kQ.KEY_DOWN,$=>{const u=new C.$oP($);let p=!0;const c=typeof this.t=="number"?this.viewItems[this.t]:void 0;r&&(u.equals(r[0])||u.equals(r[1]))?p=this.P():d&&(u.equals(d[0])||u.equals(d[1]))?p=this.O():u.equals(9)&&this.F?this.D.fire():u.equals(14)?p=this.M():u.equals(13)?p=this.N():u.equals(2)&&c instanceof s.$cS&&c.trapsArrowNavigation?p=this.O():this.J(u)?this.n.keyDown?this.R(u):this.w=!0:p=!1,p&&(u.preventDefault(),u.stopPropagation())})),this.B(k.$rP(this.domNode,k.$kQ.KEY_UP,$=>{const u=new C.$oP($);this.J(u)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(u)),u.preventDefault(),u.stopPropagation()):(u.equals(2)||u.equals(1026)||u.equals(16)||u.equals(18)||u.equals(15)||u.equals(17))&&this.L()})),this.u=this.B(k.$pQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(k.$4P()===this.domNode||!k.$VP(k.$4P(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(r=>r instanceof s.$cS&&r.isEnabled());e instanceof s.$cS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof s.$cS&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(r=>{e=e||a.equals(r)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(k.$VP(k.$4P(),e)){this.t=a,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const r=Array.isArray(a)?a:[a];let d=b.$Kf(e.index)?e.index:null;r.forEach($=>{const u=document.createElement("li");u.className="action-item",u.setAttribute("role","presentation");let p;const c={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(p=this.b.actionViewItemProvider($,c)),p||(p=new s.$dS(this.context,$,c)),this.b.allowContextMenu||this.r.set(p,k.$rP(u,k.$kQ.CONTEXT_MENU,f=>{k.$mQ.stop(f,!0)})),p.actionRunner=this.f,p.setActionContext(this.context),p.render(u),this.y&&p instanceof s.$cS&&this.viewItems.length===0&&p.setFocusable(!0),d===null||d<0||d>=this.z.children.length?(this.z.appendChild(u),this.viewItems.push(p)):(this.z.insertBefore(u,this.z.children[d]),this.viewItems.splice(d,0,p),d++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,A.$Oc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,A.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),k.$qP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,r;if(a===void 0?e=!0:typeof a=="number"?r=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const d=this.viewItems.findIndex($=>$.isEnabled());this.t=d===-1?void 0:d,this.Q(void 0,void 0,!0)}else r!==void 0&&(this.t=r),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let r;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,r=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===j.$Ki.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let r;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}r=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===j.$Ki.ID));return this.Q(!0),!0}Q(a,e,r=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const d=this.t!==void 0?this.viewItems[this.t]:void 0;if(d){let $=!0;b.$Uf(d.focus)||($=!1),this.b.focusOnlyEnabledItems&&b.$Uf(d.isEnabled)&&!d.isEnabled()&&($=!1),d.action.id===j.$Ki.ID&&($=!1),$?(r||this.s!==this.t)&&(d.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),$&&d.showHover?.()}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof s.$cS){const r=e._context===null||e._context===void 0?a:e._context;this.run(e._action,r)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,A.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$kR=y;function I(o){if(!o.length)return o;let a=-1;for(let r=0;r<o.length;r++)if(o[r].id!==j.$Ki.ID){a=r;break}if(a===-1)return[];o=o.slice(a);for(let r=o.length-1;r>=0&&o[r].id===j.$Ki.ID;r--)o.splice(r,1);let e=!1;for(let r=o.length-1;r>=0;r--){const d=o[r].id===j.$Ki.ID;d&&!e?o.splice(r,1):d?d&&(e=!1):e=!0}return o}t.$lR=I}),define(be[65],pe([1,0,3,22,55,64,57,60,20,4,82,51,109,97]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VS=t.$US=t.$TS=t.MessageType=void 0;const a=k.$;var e;(function($){$[$.INFO=1]="INFO",$[$.WARNING=2]="WARNING",$[$.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$TS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class r extends b.$5Q{constructor(u,p,c){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new w.$Td),this.onDidChange=this.O.event,this.P=this.B(new w.$Td),this.onDidHeightChange=this.P.event,this.a=p,this.g=c,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=k.$rQ(u,a(".monaco-inputbox.idle"));const f=this.g.flexibleHeight?"textarea":"input",h=k.$rQ(this.element,a(".ibwrapper"));if(this.b=k.$rQ(h,a(f+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=k.$rQ(h,a("div.mirror")),this.y.innerText="\xA0",this.N=new A.$cR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),k.$rQ(u,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const F=this.B(new C.$sR(u.ownerDocument,"selectionchange")),M=w.Event.filter(F.event,()=>u.ownerDocument.getSelection()?.anchorNode===h);this.B(M(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new j.$kR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(u){this.n=u,this.b.setAttribute("placeholder",u)}setTooltip(u){this.r=u,this.b.title=u}setAriaLabel(u){this.s=u,u?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(u){this.b.value!==u&&(this.b.value=u,this.Y())}get step(){return this.b.step}set step(u){this.b.step=u}get height(){return typeof this.J=="number"?this.J:k.$TP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return k.$5P(this.b)}select(u=null){this.b.select(),u&&(this.b.setSelectionRange(u.start,u.end),u.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(u){u?this.enable():this.disable()}get width(){return k.$PP(this.b)}set width(u){if(this.g.flexibleHeight&&this.g.flexibleWidth){let p=0;if(this.y){const c=parseFloat(this.y.style.paddingLeft||"")||0,f=parseFloat(this.y.style.paddingRight||"")||0;p=c+f}this.b.style.width=u-p+"px"}else this.b.style.width=u+"px";this.y&&(this.y.style.width=u+"px")}set paddingRight(u){this.b.style.width=`calc(100% - ${u}px)`,this.y&&(this.y.style.paddingRight=u+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const u=this.L,p=this.J,c=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:u,height:p}),this.N.setScrollPosition({scrollTop:c})}showMessage(u,p){if(this.w==="open"&&(0,I.$on)(this.h,u))return;this.h=u,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(u.type));const c=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${k.$JQ(c.border,"transparent")}`,this.h.content&&(this.hasFocus()||p)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let u=null;return this.t&&(u=this.t(this.value),u?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(u)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),u?.type}stylesForType(u){const p=this.g.inputBoxStyles;switch(u){case 1:return{border:p.inputValidationInfoBorder,background:p.inputValidationInfoBackground,foreground:p.inputValidationInfoForeground};case 2:return{border:p.inputValidationWarningBorder,background:p.inputValidationWarningBackground,foreground:p.inputValidationWarningForeground};default:return{border:p.inputValidationErrorBorder,background:p.inputValidationErrorBackground,foreground:p.inputValidationErrorForeground}}}U(u){switch(u){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let u;const p=()=>u.style.width=k.$PP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:f=>{if(!this.h)return null;u=k.$rQ(f,a(".monaco-inputbox-container")),p();const h={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,s.$qR)(this.h.content,h):(0,s.$pR)(this.h.content,h);F.classList.add(this.U(this.h.type));const M=this.stylesForType(this.h.type);return F.style.backgroundColor=M.background??"",F.style.color=M.foreground??"",F.style.border=M.border?`1px solid ${M.border}`:"",k.$rQ(u,F),null},onHide:()=>{this.w="closed"},layout:p});let c;this.h.type===3?c=o.localize(0,null,this.h.content):this.h.type===2?c=o.localize(1,null,this.h.content):c=o.localize(2,null,this.h.content),E.$uR(c),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const u=this.value,c=u.charCodeAt(u.length-1)===10?" ":"";(u+c).replace(/\u000c/g,"")?this.y.textContent=u+c:this.y.innerText="\xA0",this.layout()}ab(){const u=this.g.inputBoxStyles,p=u.inputBackground??"",c=u.inputForeground??"",f=u.inputBorder??"";this.element.style.backgroundColor=p,this.element.style.color=c,this.b.style.backgroundColor="inherit",this.b.style.color=c,this.element.style.border=`1px solid ${k.$JQ(f,"transparent")}`}layout(){if(!this.y)return;const u=this.L;this.L=k.$TP(this.y),u!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(u){const p=this.inputElement,c=p.selectionStart,f=p.selectionEnd,h=p.value;c!==null&&f!==null&&(this.value=h.substr(0,c)+u+h.substr(f),p.setSelectionRange(c+1,c+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$US=r;class d extends r{constructor(u,p,c){const f=o.localize(3,null,"\u21C5"),h=o.localize(4,null,"\u21C5");super(u,p,c),this.db=this.B(new w.$Td),this.onDidFocus=this.db.event,this.eb=this.B(new w.$Td),this.onDidBlur=this.eb.event,this.bb=new y.$RS(c.history,100);const F=()=>{if(c.showHistoryHint&&c.showHistoryHint()&&!this.n.endsWith(f)&&!this.n.endsWith(h)&&this.bb.getHistory().length){const M=this.n.endsWith(")")?f:h,R=this.n+M;c.showPlaceholderOnFocus&&!k.$5P(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((M,R)=>{M.forEach(O=>{O.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const M=R=>{if(this.n.endsWith(R)){const O=this.n.slice(0,this.n.length-R.length);return c.showPlaceholderOnFocus?this.n=O:this.setPlaceHolder(O),!0}else return!1};M(h)||M(f)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(u){this.value&&(u||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(u){const p=this.getHistory();this.clearHistory(),u.forEach(c=>{this.bb.add(c)}),p.forEach(c=>{this.bb.add(c)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let u=this.jb();u&&(u=u===this.value?this.jb():u),this.value=u??"",E.$vR(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let u=this.ib();u&&(u=u===this.value?this.ib():u),u&&(this.value=u,E.$vR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(u){super.setPlaceHolder(u),this.setTooltip(u)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let u=this.bb.current();return u||(u=this.bb.last(),this.bb.next()),u}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$VS=d}),define(be[66],pe([1,0,63,20,17,18,4,3,102]),function(ie,t,k,C,s,j,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=t.$aS=t.$_R=t.$$R=t.$0R=void 0,t.$0R={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class b extends k.$cS{constructor(a,e,r){super(a,e,r),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:r.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:r.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:r.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(a){this.element=a,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(a){this.a.domNode.tabIndex=a?0:-1}}t.$$R=b;class w extends C.$5Q{constructor(a){super(),this.a=this.B(new E.$Td),this.onChange=this.a.event,this.b=this.B(new E.$Td),this.onKeyDown=this.b.event,this.c=a,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...j.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,r=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),r.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,r=>{if(r.keyCode===10||r.keyCode===3){this.checked=!this.s,this.a.fire(!0),r.preventDefault(),r.stopPropagation();return}this.b.fire(r)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(a){this.s=a,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(a){this.g&&this.domNode.classList.remove(...j.ThemeIcon.asClassNameArray(this.g)),this.g=a,this.g&&this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(a){this.domNode.title=a,this.domNode.setAttribute("aria-label",a)}}t.$_R=w;class y extends C.$5Q{constructor(a,e,r){super(),this.g=a,this.h=e,this.a=this.B(new E.$Td),this.onChange=this.a.event,this.b=new w({title:this.g,isChecked:this.h,icon:s.$0j.check,actionClassName:"monaco-checkbox",...t.$0R}),this.domNode=this.b.domNode,this.c=r,this.n(),this.B(this.b.onChange(d=>{this.n(),this.a.fire(d)}))}get checked(){return this.b.checked}set checked(a){this.b.checked=a,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$5P)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$aS=y;class I extends k.$cS{constructor(a,e,r){super(a,e,r),this.a=this.B(new y(this._action.label,!!this._action.checked,r.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(a){if(this.element=a,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this.B((0,A.$rP)(e,A.$kQ.CLICK,r=>{this.a.checked=!this.a.checked,r.stopPropagation(),r.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(a){this.a.domNode.tabIndex=a?0:-1}}t.$bS=I}),define(be[130],pe([1,0,66,17,107]),function(ie,t,k,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9S=t.$8S=t.$7S=void 0;const j=s.localize(0,null),E=s.localize(1,null),A=s.localize(2,null);class b extends k.$_R{constructor(o){super({icon:C.$0j.caseSensitive,title:j+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$7S=b;class w extends k.$_R{constructor(o){super({icon:C.$0j.wholeWord,title:E+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$8S=w;class y extends k.$_R{constructor(o){super({icon:C.$0j.regex,title:A+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.$9S=y}),define(be[131],pe([1,0,3,130,65,20,4,106,2,96]),function(ie,t,k,C,s,j,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0S=void 0;const w=A.localize(0,null);class y extends j.$5Q{static{this.OPTION_CHANGE="optionChange"}constructor(o,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Uc),this.N=[],this.O=this.B(new E.$Td),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$Td),this.onKeyDown=this.P.event,this.Q=this.B(new E.$Td),this.onMouseDown=this.Q.event,this.R=this.B(new E.$Td),this.onInput=this.R.event,this.S=this.B(new E.$Td),this.onKeyUp=this.S.event,this.U=this.B(new E.$Td),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$Td),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||w,this.h=!!e.showCommonFindToggles;const r=e.appendCaseSensitiveLabel||"",d=e.appendWholeWordsLabel||"",$=e.appendRegexLabel||"",u=e.history||[],p=!!e.flexibleHeight,c=!!e.flexibleWidth,f=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new s.$VS(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:u,showHistoryHint:e.showHistoryHint,flexibleHeight:p,flexibleWidth:c,flexibleMaxHeight:f,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new C.$9S({appendTitle:$,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new C.$8S({appendTitle:d,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$7S({appendTitle:r,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const h=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const M=h.indexOf(this.domNode.ownerDocument.activeElement);if(M>=0){let R=-1;F.equals(17)?R=(M+1)%h.length:F.equals(15)&&(M===0?R=h.length-1:R=M-1),F.equals(9)?(h[M].blur(),this.inputBox.focus()):R>=0&&h[R].focus(),k.$mQ.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),o?.appendChild(this.domNode),this.B(k.$rP(this.inputBox.inputElement,"compositionstart",h=>{this.s=!0})),this.B(k.$rP(this.inputBox.inputElement,"compositionend",h=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,h=>this.P.fire(h)),this.C(this.inputBox.inputElement,h=>this.S.fire(h)),this.D(this.inputBox.inputElement,h=>this.R.fire()),this.j(this.inputBox.inputElement,h=>this.Q.fire(h))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(o){this.inputBox.layout(),this.X(o.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const o of this.N)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const o of this.N)o.disable()}setFocusInputOnOptionClick(o){this.n=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new b.$Sc;for(const a of o??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(o=!1){o?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(o){this.M&&(this.M.checked=o)}getWholeWords(){return this.L?.checked??!1}setWholeWords(o){this.L&&(this.L.checked=o)}getRegex(){return this.J?.checked??!1}setRegex(o){this.J&&(this.J.checked=o,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$0S=y}),define(be[132],pe([1,0,3,22,14,64,131,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,111,103]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a,e,r,d,$,u,p,c,f,h,F,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$HT=t.$GT=t.$FT=t.RenderIndentGuides=t.$ET=t.$DT=void 0;class R extends b.$CR{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(n=>n.element)),this.c=i}}function O(m){return m instanceof b.$CR?new R(m):m}class v{constructor(i,n){this.d=i,this.f=n,this.b=f.$Tc.None,this.c=new f.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,n){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(l=>l.element),n)}onDragStart(i,n){this.f.onDragStart?.(O(i),n)}onDragOver(i,n,l,D,S,z=!0){const P=this.f.onDragOver(O(i),n&&n.element,l,D,S),U=this.a!==n;if(U&&(this.b.dispose(),this.a=n),typeof n>"u")return P;if(U&&typeof P!="boolean"&&P.autoExpand&&(this.b=(0,r.$6g)(()=>{const $e=this.d(),ue=$e.getNodeLocation(n);$e.isCollapsed(ue)&&$e.setCollapsed(ue,!1),this.a=void 0},500,this.c)),typeof P=="boolean"||!P.accept||typeof P.bubble>"u"||P.feedback){if(!z){const $e=typeof P=="boolean"?P:P.accept,ue=typeof P=="boolean"?void 0:P.effect;return{accept:$e,effect:ue,feedback:[l]}}return P}if(P.bubble===1){const $e=this.d(),ue=$e.getNodeLocation(n),Fe=$e.getParentNodeLocation(ue),ye=$e.getNode(Fe),Oe=Fe&&$e.getListIndex(Fe);return this.onDragOver(i,ye,Oe,D,S,!1)}const G=this.d(),ne=G.getNodeLocation(n),he=G.getListIndex(ne),ve=G.getListRenderCount(ne);return{...P,feedback:(0,e.$Sb)(he,he+ve)}}drop(i,n,l,D,S){this.b.dispose(),this.a=void 0,this.f.drop(O(i),n&&n.element,l,D,S)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function N(m,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(n){return i.identityProvider.getId(n.element)}},dnd:i.dnd&&new v(m,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(n){return i.multipleSelectionController.isSelectionSingleChangeEvent({...n,element:n.element})},isSelectionRangeChangeEvent(n){return i.multipleSelectionController.isSelectionRangeChangeEvent({...n,element:n.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(n){const l=m(),D=l.getNodeLocation(n),S=l.getParentNodeLocation(D);return l.getNode(S).visibleChildrenCount},getPosInSet(n){return n.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?n=>i.accessibilityProvider.isChecked(n.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?n=>i.accessibilityProvider.getRole(n.element):()=>"treeitem",getAriaLabel(n){return i.accessibilityProvider.getAriaLabel(n.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?n=>i.accessibilityProvider.getAriaLevel(n.element):n=>n.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(n=>i.accessibilityProvider.getActiveDescendantId(n.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(n){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(n.element)}}}}class V{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,n){this.a.setDynamicHeight?.(i.element,n)}}t.$DT=V;class H{static lift(i){return i instanceof H?i:new H(i)}static empty(i=0){return new H({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const n of i.expanded)this.expanded[n]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$ET=H;var T;(function(m){m.None="none",m.OnHover="onHover",m.Always="always"})(T||(t.RenderIndentGuides=T={}));class L{get elements(){return this.b}constructor(i,n=[]){this.b=n,this.a=new f.$Sc,this.onDidChange=p.Event.forEach(i,l=>this.b=l,this.a)}dispose(){this.a.dispose()}}class B{static{this.a=8}constructor(i,n,l,D,S,z={}){this.o=i,this.p=n,this.q=D,this.s=S,this.b=new Map,this.c=new Map,this.d=B.a,this.f=!1,this.g=!1,this.j=new Set,this.k=f.$Tc.None,this.m=new f.$Sc,this.templateId=i.templateId,this.updateOptions(z),p.Event.map(l,P=>P.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const n=(0,h.$5l)(i.indent,0,40);if(n!==this.d){this.d=n;for(const[l,D]of this.c)this.v(l,D)}}if(typeof i.renderIndentGuides<"u"){const n=i.renderIndentGuides!==T.None;if(n!==this.g){this.g=n;for(const[l,D]of this.c)this.w(l,D);if(this.k.dispose(),n){const l=new f.$Sc;this.q.onDidChange(this.x,this,l),this.k=l,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const n=(0,k.$rQ)(i,(0,k.$)(".monaco-tl-row")),l=(0,k.$rQ)(n,(0,k.$)(".monaco-tl-indent")),D=(0,k.$rQ)(n,(0,k.$)(".monaco-tl-twistie")),S=(0,k.$rQ)(n,(0,k.$)(".monaco-tl-contents")),z=this.o.renderTemplate(S);return{container:i,indent:l,twistie:D,indentGuidesDisposable:f.$Tc.None,templateData:z}}renderElement(i,n,l,D){this.c.set(i,l),this.b.set(i.element,i),this.v(i,l),this.o.renderElement(i,n,l.templateData,D)}disposeElement(i,n,l,D){l.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,n,l.templateData,D),typeof D=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const n=this.b.get(i);n&&this.u(n)}u(i){const n=this.c.get(i);n&&(this.x(this.q.elements),this.v(i,n))}v(i,n){const l=B.a+(i.depth-1)*this.d;n.twistie.style.paddingLeft=`${l}px`,n.indent.style.width=`${l+this.d-16}px`,i.collapsible?n.container.setAttribute("aria-expanded",String(!i.collapsed)):n.container.removeAttribute("aria-expanded"),n.twistie.classList.remove(...$.ThemeIcon.asClassNameArray(d.$0j.treeItemExpanded));let D=!1;this.o.renderTwistie&&(D=this.o.renderTwistie(i.element,n.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(D||n.twistie.classList.add(...$.ThemeIcon.asClassNameArray(d.$0j.treeItemExpanded)),n.twistie.classList.add("collapsible"),n.twistie.classList.toggle("collapsed",i.collapsed)):n.twistie.classList.remove("collapsible","collapsed"),this.w(i,n)}w(i,n){if((0,k.$qP)(n.indent),n.indentGuidesDisposable.dispose(),!this.g)return;const l=new f.$Sc,D=this.p();for(;;){const S=D.getNodeLocation(i),z=D.getParentNodeLocation(S);if(!z)break;const P=D.getNode(z),U=(0,k.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(P)&&U.classList.add("active"),n.indent.childElementCount===0?n.indent.appendChild(U):n.indent.insertBefore(U,n.indent.firstElementChild),this.s.add(P,U),l.add((0,f.$Rc)(()=>this.s.delete(P,U))),i=P}n.indentGuidesDisposable=l}x(i){if(!this.g)return;const n=new Set,l=this.p();i.forEach(D=>{const S=l.getNodeLocation(D);try{const z=l.getParentNodeLocation(S);D.collapsible&&D.children.length>0&&!D.collapsed?n.add(D):z&&n.add(l.getNode(z))}catch{}}),this.j.forEach(D=>{n.has(D)||this.s.forEach(D,S=>S.classList.remove("active"))}),n.forEach(D=>{this.j.has(D)||this.s.forEach(D,S=>S.classList.add("active"))}),this.j=n}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,f.$Oc)(this.m)}}t.$FT=B;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,n,l){this.g=i,this.j=n,this.k=l,this.a=0,this.b=0,this.c="",this.d="",this.f=new f.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,n){let l=1;if(this.k){const z=this.k.filter(i,n);if(typeof z=="boolean"?l=z?1:0:(0,I.$AT)(z)?l=(0,I.$BT)(z.visibility):l=z,l===0)return!1}if(this.a++,!this.c)return this.b++,{data:c.FuzzyScore.Default,visibility:l};const D=this.j.getKeyboardNavigationLabel(i),S=Array.isArray(D)?D:[D];for(const z of S){const P=z&&z.toString();if(typeof P>"u")return{data:c.FuzzyScore.Default,visibility:l};let U;if(this.g.findMatchType===me.Contiguous){const G=P.toLowerCase().indexOf(this.d);if(G>-1){U=[Number.MAX_SAFE_INTEGER,0];for(let ne=this.d.length;ne>0;ne--)U.push(G+ne-1)}}else U=(0,c.$5j)(this.c,this.d,0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(U)return this.b++,S.length===1?{data:U,visibility:l}:{data:{label:P,score:U},visibility:l}}return this.g.findMode===ee.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:c.FuzzyScore.Default,visibility:l}}m(){this.a=0,this.b=0}dispose(){(0,f.$Oc)(this.f)}}class Y extends y.$_R{constructor(i){super({icon:d.$0j.listFilter,title:(0,M.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$GT=Y;class de extends y.$_R{constructor(i){super({icon:d.$0j.searchFuzzy,title:(0,M.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$HT=de;const oe={inputBoxStyles:A.$TS,toggleStyles:y.$0R,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ee;(function(m){m[m.Highlight=0]="Highlight",m[m.Filter=1]="Filter"})(ee||(t.TreeFindMode=ee={}));var me;(function(m){m[m.Fuzzy=0]="Fuzzy",m[m.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class Pe extends f.$Tc{set mode(i){this.b.checked=i===ee.Filter,this.f.inputBox.setPlaceHolder(i===ee.Filter?(0,M.localize)(2,null):(0,M.localize)(3,null))}set matchType(i){this.c.checked=i===me.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,n,l,D,S,z){super(),this.t=n,this.a=(0,k.h)(".monaco-tree-type-filter",[(0,k.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,k.h)(".monaco-tree-type-filter-input@findInput"),(0,k.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new p.$Td,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,f.$Rc)(()=>i.removeChild(this.a.root)));const P=z?.styles??oe;P.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=P.listFilterWidgetBackground),P.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${P.listFilterWidgetShadow}`),this.b=this.B(new Y({...P.toggleStyles,isChecked:D===ee.Filter})),this.c=this.B(new de({...P.toggleStyles,isChecked:S===me.Fuzzy})),this.onDidChangeMode=p.Event.map(this.b.onChange,()=>this.b.checked?ee.Filter:ee.Highlight,this.q),this.onDidChangeMatchType=p.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new E.$0S(this.a.findInput,l,{label:(0,M.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:P.inputBoxStyles,toggleStyles:P.toggleStyles,history:z?.history})),this.g=this.B(new j.$kR(this.a.actionbar)),this.mode=D;const U=this.B(new C.$sR(this.f.inputBox.inputElement,"keydown")),G=p.Event.chain(U.event,$e=>$e.map(ue=>new s.$oP(ue)));this.B(G($e=>{if($e.equals(3)){$e.preventDefault(),$e.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if($e.equals(18)){$e.preventDefault(),$e.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if($e.equals(16)){$e.preventDefault(),$e.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ne=this.B(new a.$Ii("close",(0,M.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ne,{icon:!0,label:!1});const he=this.B(new C.$sR(this.a.grab,"mousedown"));this.B(he.event($e=>{const ue=new f.$Sc,Fe=ue.add(new C.$sR((0,k.getWindow)($e),"mousemove")),ye=ue.add(new C.$sR((0,k.getWindow)($e),"mouseup")),Oe=this.m,Be=$e.pageX,Ie=this.s,Je=$e.pageY;this.a.grab.classList.add("grabbing");const et=this.a.root.style.transition;this.a.root.style.transition="unset";const Qe=x=>{const se=x.pageX-Be;this.m=Oe-se;const ge=x.pageY-Je;this.s=Ie+ge,this.layout()};ue.add(Fe.event(Qe)),ue.add(ye.event(x=>{Qe(x),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=et,ue.dispose()}))}));const ve=p.Event.chain(this.B(new C.$sR(this.a.grab,"keydown")).event,$e=>$e.map(ue=>new s.$oP(ue)));this.B(ve($e=>{let ue,Fe;if($e.keyCode===15?ue=Number.POSITIVE_INFINITY:$e.keyCode===17?ue=0:$e.keyCode===10&&(ue=this.m===0?Number.POSITIVE_INFINITY:0),$e.keyCode===16?Fe=0:$e.keyCode===18&&(Fe=Number.POSITIVE_INFINITY),ue!==void 0&&($e.preventDefault(),$e.stopPropagation(),this.m=ue,this.layout()),Fe!==void 0){$e.preventDefault(),$e.stopPropagation(),this.s=Fe;const ye=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ye},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,h.$5l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,h.$5l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,r.$5g)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,n,l,D,S,z={}){this.t=i,this.u=l,this.v=D,this.w=S,this.x=z,this.b="",this.c="",this.j=0,this.k=new p.$Td,this.onDidChangeMode=this.k.event,this.m=new p.$Td,this.onDidChangeMatchType=this.m.event,this.o=new p.$Td,this.onDidChangePattern=this.o.event,this.p=new p.$Td,this.onDidChangeOpenState=this.p.event,this.q=new f.$Sc,this.s=new f.$Sc,this.d=i.options.defaultFindMode??ee.Highlight,this.f=i.options.defaultFindMatchType??me.Fuzzy,n.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Pe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,l=>!c.FuzzyScore.isDefault(l.filterData));const n=this.t.getFocus();if(n.length>0){const l=n[0];this.t.getRelativeTop(l)===null&&this.t.reveal(l,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,M.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!c.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(m,i){return m.position===i.position&&m.node.element===i.node.element&&m.startIndex===i.startIndex&&m.height===i.height&&m.endIndex===i.endIndex}class re extends f.$Tc{constructor(i=[]){super(),this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Me)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const n=this.stickyNodes[this.count-2];return n.position+n.height!==i.position}addDisposable(i){this.B(i)}}class J extends f.$Tc{get f(){const i=this.m.firstVisibleIndex;if(!(i<0||i>=this.m.length))return this.m.element(i)}constructor(i,n,l,D,S,z={}){super(),this.g=i,this.j=n,this.m=l,this.s=S,this.b=.4;const P=this.validateStickySettings(z);this.a=P.stickyScrollMaxItemCount,this.c=this.B(new le(l.getScrollableElement(),l,n,D,S,z.accessibilityProvider)),this.onDidChangeHasFocus=this.c.onDidChangeHasFocus,this.onContextMenu=this.c.onContextMenu,this.B(l.onDidScroll(()=>this.t())),this.B(l.onDidChangeContentHeight(()=>this.t())),this.B(i.onDidChangeCollapseState(()=>this.t())),this.t()}get height(){return this.c.height}get count(){return this.c.count}getNode(i){return this.c.getNode(i)}t(){const i=this.f;if(!i||this.g.scrollTop===0){this.c.setState(void 0);return}const n=this.u(i);this.c.setState(n)}u(i){const n=[],l=this.m.renderHeight*this.b;let D=i,S=0,z=this.y(D,void 0,S);for(;z&&S+z.height<l&&(n.push(z),S+=z.height,!(n.length>=this.a||(D=this.w(D),!D)));)z=this.y(D,z.node,S);return n.length?new re(n):void 0}w(i){const n=this.I(i);return n===-1||n===this.m.length-1?void 0:this.m.element(n+1)}y(i,n,l){const D=this.D(i,n);if(D&&!(D===i&&(!this.H(i)||this.z(i,l))))return this.C(D,l)}z(i,n){const l=this.I(i),D=this.m.getElementTop(l),S=n;return this.m.scrollTop===D-S}C(i,n){const l=this.s.getHeight(i),{startIndex:D,endIndex:S}=this.J(i),z=this.F(S,n);return{node:i,position:z,height:l,startIndex:D,endIndex:S}}D(i,n=void 0){let l=i,D=this.G(l);for(;D;){if(D===n)return l;l=D,D=this.G(l)}if(n===void 0)return l}F(i,n){let l=this.m.getRelativeTop(i);if(l===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const U=this.s.getHeight(this.m.element(i)),G=this.m.getRelativeTop(i+1);l=G?G-U/this.m.renderHeight:null}if(l===null)return n;const D=this.m.element(i),S=this.s.getHeight(D),z=l*this.m.renderHeight,P=z+S;return n>z&&n<=P?z:n}G(i){const n=this.j.getNodeLocation(i),l=this.j.getParentNodeLocation(n);return l?this.j.getNode(l):void 0}H(i){const n=this.j.getNodeLocation(i);return this.j.getListRenderCount(n)>1}I(i,n){return n===void 0&&(n=this.j.getNodeLocation(i)),this.j.getListIndex(n)}J(i){const n=this.j.getNodeLocation(i),l=this.j.getListIndex(n);if(l<0)throw new Error("Node not found in tree");const D=this.j.getListRenderCount(n),S=l+D-1;return{startIndex:l,endIndex:S}}nodePositionTopBelowWidget(i){const n=[];let l=this.G(i);for(;l;)n.push(l),l=this.G(l);let D=0;for(let S=0;S<n.length&&S<this.a;S++)D+=this.s.getHeight(n[S]);return D}getFocus(){return this.c.getFocus()}domFocus(){this.c.domFocus()}focusedLast(){return this.c.focusedLast()}updateOptions(i={}){const n=this.validateStickySettings(i);this.a!==n.stickyScrollMaxItemCount&&(this.a=n.stickyScrollMaxItemCount,this.t())}validateStickySettings(i){let n=5;return typeof i.stickyScrollMaxItemCount=="number"&&(n=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:n}}}class le{constructor(i,n,l,D,S,z){this.d=n,this.f=l,this.g=D,this.j=S,this.k=z,this.a=document.createElement("div"),this.a.classList.add("monaco-tree-sticky-container"),i.appendChild(this.a),this.c=new K(this.a,n),this.onDidChangeHasFocus=this.c.onDidChangeHasFocus,this.onContextMenu=this.c.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(n=>n.node===i)}setState(i){const n=!!this.b&&this.b.count>0,l=!!i&&i.count>0;if(!n&&!l||n&&l&&this.b.equal(i)||(n!==l&&this.p(l),this.b?.dispose(),this.b=i,!l))return;const D=Array(i.count);for(let P=i.count-1;P>=0;P--){const U=i.stickyNodes[P],{element:G,disposable:ne}=this.m(U,P,i.count);D[P]=G,this.a.appendChild(G),i.addDisposable(ne)}this.c.updateElements(D,i);const S=(0,k.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(S),i.addDisposable((0,f.$Rc)(()=>S.remove()));const z=i.stickyNodes[i.count-1];this.a.style.height=`${z.position+z.height}px`}m(i,n,l){const D=this.f.getNodeLocation(i.node),S=this.f.getListIndex(D),z=document.createElement("div");z.style.top=`${i.position}px`,z.style.height=`${i.height}px`,z.style.lineHeight=`${i.height}px`,z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${S}`),z.setAttribute("data-parity",S%2===0?"even":"odd"),z.setAttribute("id",this.d.getElementID(S)),this.o(z,i.node.element,n,l);const P=this.j.getTemplateId(i.node),U=this.g.find(ve=>ve.templateId===P);if(!U)throw new Error(`No renderer found for template id ${P}`);const G=new Proxy(i.node,{}),ne=U.renderTemplate(z);U.renderElement(G,i.startIndex,ne,i.height);const he=(0,f.$Rc)(()=>{U.disposeElement(G,i.startIndex,ne,i.height),U.disposeTemplate(ne),z.remove()});return{element:z,disposable:he}}o(i,n,l,D){if(!this.k)return;this.k.getSetSize&&i.setAttribute("aria-setsize",String(this.k.getSetSize(n,l,D))),this.k.getPosInSet&&i.setAttribute("aria-posinset",String(this.k.getPosInSet(n,l))),this.k.getRole&&i.setAttribute("role",this.k.getRole(n)??"treeitem");const S=this.k.getAriaLabel(n);S&&i.setAttribute("aria-label",S);const z=this.k.getAriaLevel&&this.k.getAriaLevel(n);typeof z=="number"&&i.setAttribute("aria-level",`${z}`),i.setAttribute("aria-selected",String(!1))}p(i){this.a.style.display=i?"block":"none",i||this.c.updateElements([],void 0)}getFocus(){return this.c.getFocus()}domFocus(){this.c.domFocus()}focusedLast(){return this.c.focusedLast()}dispose(){this.c.dispose(),this.b?.dispose(),this.a.remove()}}class K extends f.$Tc{get m(){return this.j}set m(i){this.j=i,this.f.fire(i)}constructor(i,n){super(),this.s=i,this.t=n,this.a=-1,this.b=[],this.f=new p.$Td,this.onDidChangeHasFocus=this.f.event,this.g=new p.$Td,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(l=>this.w(l))),this.B(this.t.onMouseDown(l=>this.y(l))),this.B(this.t.onContextMenu(l=>this.u(l)))}u(i){const n=i.browserEvent.target;if(!(0,w.$PR)(n)&&!(0,w.$OR)(n)){this.focusedLast()&&this.t.domFocus();return}if(!(0,k.$hQ)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const z=this.c.stickyNodes.findIndex(P=>P.node.element===i.element?.element);if(z===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.H(!0),this.F(z);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const D=this.c.stickyNodes[this.a].node.element,S=this.b[this.a];this.g.fire({element:D,anchor:S,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const n=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([n]),this.C(n,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const n=i.browserEvent.target;!(0,w.$PR)(n)&&!(0,w.$OR)(n)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation(),this.s.focus())}updateElements(i,n){if(n&&n.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(n&&n.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const l=this.a;if(this.D(),this.b=i,this.c=n,n){const D=(0,h.$5l)(l,0,n.count-1);this.F(D)}else this.m&&this.t.domFocus();this.s.tabIndex=n?0:-1}z(i){const n=this.c;if(!n)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<n.count-1)&&n.lastNodePartiallyVisible()){const l=n.stickyNodes[i];this.C(l.endIndex+1,n)}}C(i,n){const l=n.stickyNodes[n.count-1],D=n.count>1?n.stickyNodes[n.count-2]:void 0,S=this.t.getElementTop(i),z=D?D.position+D.height+l.height:l.height;this.t.scrollTop=S-z}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const n=this.a;n>=0&&this.G(this.b[n],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,n){i.classList.toggle("focused",n)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function W(m){let i=o.TreeMouseEventTarget.Unknown;return(0,k.$ZP)(m.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=o.TreeMouseEventTarget.Twistie:(0,k.$ZP)(m.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=o.TreeMouseEventTarget.Element:(0,k.$ZP)(m.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=o.TreeMouseEventTarget.Filter),{browserEvent:m.browserEvent,element:m.element?m.element.element:null,target:i}}function Z(m){const i=(0,w.$PR)(m.browserEvent.target);return{element:m.element?m.element.element:null,browserEvent:m.browserEvent,anchor:m.anchor,isStickyScroll:i}}function ce(m,i){i(m),m.children.forEach(n=>ce(n,i))}class we{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,n){this.g=i,this.j=n,this.a=[],this.c=new p.$Td,this.onDidChange=this.c.event}set(i,n){!n?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,n)}k(i,n,l){if(this.a=[...i],this.b=void 0,this.d=void 0,!n){const D=this;this.c.fire({get elements(){return D.get()},browserEvent:l})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:n}){if(!this.j){const U=this.m(),G=ne=>U.delete(ne);n.forEach(ne=>ce(ne,G)),this.set([...U.values()]);return}const l=new Set,D=U=>l.add(this.j.getId(U.element).toString());n.forEach(U=>ce(U,D));const S=new Map,z=U=>S.set(this.j.getId(U.element).toString(),U);i.forEach(U=>ce(U,z));const P=[];for(const U of this.a){const G=this.j.getId(U.element).toString();if(!l.has(G))P.push(U);else{const he=S.get(G);he&&he.visible&&P.push(he)}}if(this.a.length>0&&P.length===0){const U=this.g();U&&P.push(U)}this.k(P,!0)}m(){const i=new Set;for(const n of this.a)i.add(n);return i}}class ke extends w.$UR{constructor(i,n,l){super(i),this.x=n,this.y=l}u(i){if((0,w.$QR)(i.browserEvent.target)||(0,w.$JR)(i.browserEvent.target)||(0,w.$KR)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const n=i.element;if(!n)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const l=i.browserEvent.target,D=l.classList.contains("monaco-tl-twistie")||l.classList.contains("monaco-icon-label")&&l.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,S=(0,w.$OR)(i.browserEvent.target);let z=!1;if(S?z=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?z=this.x.expandOnlyOnTwistieClick(n.element):z=!!this.x.expandOnlyOnTwistieClick,S)this.A(i,n);else{if(z&&!D&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(n.collapsible&&(!S||D)){const P=this.x.getNodeLocation(n),U=i.browserEvent.altKey;if(this.x.setFocus([P]),this.x.toggleCollapsed(P,U),z&&D){i.browserEvent.isHandledByList=!0;return}}S||super.u(i)}A(i,n){if((0,w.$LR)(i.browserEvent.target)||(0,w.$MR)(i.browserEvent.target))return;const l=this.y();if(!l)throw new Error("Sticky scroll controller not found");const D=this.k.indexOf(n),S=this.k.getElementTop(D),z=l.nodePositionTopBelowWidget(n);this.x.scrollTop=S-z,this.k.domFocus(),this.k.setFocus([D]),this.k.setSelection([D])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const n=i.browserEvent.target;if(!(0,w.$PR)(n)&&!(0,w.$OR)(n)){super.s(i);return}}t(i){const n=i.browserEvent.target;if(!(0,w.$PR)(n)&&!(0,w.$OR)(n)){super.t(i);return}}}class Ae extends w.$XR{constructor(i,n,l,D,S,z,P,U){super(i,n,l,D,U),this.p=S,this.s=z,this.K=P}D(i){return new ke(this,i.tree,i.stickyScrollProvider)}splice(i,n,l=[]){if(super.splice(i,n,l),l.length===0)return;const D=[],S=[];let z;l.forEach((P,U)=>{this.p.has(P)&&D.push(i+U),this.s.has(P)&&S.push(i+U),this.K.has(P)&&(z=i+U)}),D.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...D])),S.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...S])),typeof z=="number"&&super.setAnchor(z)}setFocus(i,n,l=!1){super.setFocus(i,n),l||this.p.set(i.map(D=>this.element(D)),n)}setSelection(i,n,l=!1){super.setSelection(i,n),l||this.s.set(i.map(D=>this.element(D)),n)}setAnchor(i,n=!1){super.setAnchor(i),n||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var Le;(function(m){m[m.Tree=0]="Tree",m[m.StickyScroll=1]="StickyScroll"})(Le||(t.AbstractTreePart=Le={}));class _{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return p.Event.map(this.j.onMouseClick,W)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.j.onMouseDblClick,W),i=>i.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return p.Event.any(p.Event.filter(p.Event.map(this.j.onContextMenu,Z),i=>!i.isStickyScroll),this.B?.onContextMenu??p.Event.None)}get onTap(){return p.Event.map(this.j.onTap,W)}get onPointer(){return p.Event.map(this.j.onPointer,W)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ee.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??me.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,n,l,D,S={}){this.G=i,this.H=S,this.y=new p.$2d,this.onDidChangeFindOpenState=p.Event.None,this.onDidChangeStickyScrollFocused=p.Event.None,this.D=new f.$Sc,this.E=new p.$Td,this.onWillRefilter=this.E.event,this.F=new p.$Td,this.onDidUpdateOptions=this.F.event,this.p=new V(l);const z=new p.$3d,P=new p.$3d,U=this.D.add(new L(P.event)),G=new u.$Gc;this.k=D.map(ue=>new B(ue,()=>this.o,z.event,U,G,S));for(const ue of this.k)this.D.add(ue);let ne;S.keyboardNavigationLabelProvider&&(ne=new X(this,S.keyboardNavigationLabelProvider,S.filter),S={...S,filter:ne},this.D.add(ne)),this.q=new we(()=>this.j.getFocusedElements()[0],S.identityProvider),this.w=new we(()=>this.j.getSelectedElements()[0],S.identityProvider),this.x=new we(()=>this.j.getAnchorElement(),S.identityProvider),this.j=new Ae(i,n,this.p,this.k,this.q,this.w,this.x,{...N(()=>this.o,S),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,S),z.input=this.o.onDidChangeCollapseState;const he=p.Event.forEach(this.o.onDidSplice,ue=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(ue),this.w.onDidModelSplice(ue)})},this.D);he(()=>null,null,this.D);const ve=this.D.add(new p.$Td),$e=this.D.add(new r.$1g(0));if(this.D.add(p.Event.any(he,this.q.onDidChange,this.w.onDidChange)(()=>{$e.trigger(()=>{const ue=new Set;for(const Fe of this.q.getNodes())ue.add(Fe);for(const Fe of this.w.getNodes())ue.add(Fe);ve.fire([...ue.values()])})})),P.input=ve.event,S.keyboardSupport!==!1){const ue=p.Event.chain(this.j.onKeyDown,Fe=>Fe.filter(ye=>!(0,w.$JR)(ye.target)).map(ye=>new s.$oP(ye)));p.Event.chain(ue,Fe=>Fe.filter(ye=>ye.keyCode===15))(this.J,this,this.D),p.Event.chain(ue,Fe=>Fe.filter(ye=>ye.keyCode===17))(this.K,this,this.D),p.Event.chain(ue,Fe=>Fe.filter(ye=>ye.keyCode===10))(this.L,this,this.D)}if((S.findWidgetEnabled??!0)&&S.keyboardNavigationLabelProvider&&S.contextViewProvider){const ue=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Te(this,this.o,this.j,ne,S.contextViewProvider,ue),this.A=Fe=>this.z.shouldAllowFocus(Fe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;S.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,S),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,k.$_P)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===T.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const n of this.k)n.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===T.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new J(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=p.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const n=this.o.getListIndex(i);n!==-1&&this.j.updateWidth(n)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,k.$5P)(this.getHTMLElement())}layout(i,n){this.j.layout(i,n),(0,F.$Kf)(n)&&this.z?.layout(n)}style(i){const n=`.${this.j.domId}`,l=[];i.treeIndentGuidesStroke&&(l.push(`.monaco-list${n}:hover .monaco-tl-indent > .indent-guide, .monaco-list${n}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),l.push(`.monaco-list${n} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(l.push(`.monaco-list${n} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),l.push(`.monaco-list${n} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(l.push(`.monaco-list${n}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),l.push(`.monaco-list${n}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const D=(0,k.$JQ)(i.listFocusAndSelectionOutline,(0,k.$JQ)(i.listSelectionOutline,i.listFocusOutline??""));D&&(l.push(`.monaco-list${n}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${D}; outline-offset: -1px;}`),l.push(`.monaco-list${n}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(l.push(`.monaco-list${n}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),l.push(`.monaco-list${n}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),l.push(`.monaco-workbench.context-menu-visible .monaco-list${n}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),l.push(`.monaco-workbench.context-menu-visible .monaco-list${n}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=l.join(`
`),this.j.style(i)}getParentElement(i){const n=this.o.getParentNodeLocation(i);return this.o.getNode(n).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,n=!1){return this.o.setCollapsed(i,!0,n)}expand(i,n=!1){return this.o.setCollapsed(i,!1,n)}toggleCollapsed(i,n=!1){return this.o.setCollapsed(i,void 0,n)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,n){return this.o.setCollapsible(i,n)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const n=this.o.getNode(i);this.x.set([n]);const l=this.o.getListIndex(i);l>-1&&this.j.setAnchor(l,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,n){this.y.bufferEvents(()=>{const l=i.map(S=>this.o.getNode(S));this.w.set(l,n);const D=i.map(S=>this.o.getListIndex(S)).filter(S=>S>-1);this.j.setSelection(D,n,!0)})}getSelection(){return this.w.get()}setFocus(i,n){this.y.bufferEvents(()=>{const l=i.map(S=>this.o.getNode(S));this.q.set(l,n);const D=i.map(S=>this.o.getListIndex(S)).filter(S=>S>-1);this.j.setFocus(D,n,!0)})}focusNext(i=1,n=!1,l,D=(0,k.$hQ)(l)&&l.altKey?void 0:this.A){this.j.focusNext(i,n,l,D)}focusPrevious(i=1,n=!1,l,D=(0,k.$hQ)(l)&&l.altKey?void 0:this.A){this.j.focusPrevious(i,n,l,D)}focusNextPage(i,n=(0,k.$hQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,n)}focusPreviousPage(i,n=(0,k.$hQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,n)}focusLast(i,n=(0,k.$hQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,n)}focusFirst(i,n=(0,k.$hQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,n)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,n){this.o.expandTo(i);const l=this.o.getListIndex(i);if(l!==-1)if(!this.B)this.j.reveal(l,n);else{const D=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(l,n,D)}}getRelativeTop(i){const n=this.o.getListIndex(i);if(n===-1)return null;const l=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(n,l?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new o.$yT(this.G,"Can't get tree view state without an identity provider");const n=z=>i.getId(z).toString(),l=H.empty(this.scrollTop);for(const z of this.getFocus())l.focus.add(n(z));for(const z of this.getSelection())l.selection.add(n(z));const D=this.o.getNode(),S=[D];for(;S.length>0;){const z=S.shift();z!==D&&z.collapsible&&(l.expanded[n(z.element)]=z.collapsed?0:1),S.push(...z.children)}return l}J(i){i.preventDefault(),i.stopPropagation();const n=this.j.getFocusedElements();if(n.length===0)return;const l=n[0],D=this.o.getNodeLocation(l);if(!this.o.setCollapsed(D,!0)){const z=this.o.getParentNodeLocation(D);if(!z)return;const P=this.o.getListIndex(z);this.j.reveal(P),this.j.setFocus([P])}}K(i){i.preventDefault(),i.stopPropagation();const n=this.j.getFocusedElements();if(n.length===0)return;const l=n[0],D=this.o.getNodeLocation(l);if(!this.o.setCollapsed(D,!1)){if(!l.children.some(U=>U.visible))return;const[z]=this.j.getFocus(),P=z+1;this.j.reveal(P),this.j.setFocus([P])}}L(i){i.preventDefault(),i.stopPropagation();const n=this.j.getFocusedElements();if(n.length===0)return;const l=n[0],D=this.o.getNodeLocation(l),S=i.browserEvent.altKey;this.o.setCollapsed(D,void 0,S)}navigate(i){return new g(this.j,this.o,i)}dispose(){(0,f.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$IT=_;class g{constructor(i,n,l){this.b=i,this.c=n,l?this.a=this.c.getListIndex(l):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],pe([1,0,132,123,26,28]),function(ie,t,k,C,s,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=void 0;class E extends k.$IT{constructor(b,w,y,I,o,a={}){super(b,w,y,I,a),this.f=b,this.g=o,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(b,w){if(w&&!this.c)throw new s.$yT(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,j.Iterable.empty());return}if(!w){this.m(b);return}const y=[],I=[],o=e=>{const r=this.c.getId(e).toString();return!w.expanded[r]},a=e=>{const r=this.c.getId(e.element).toString();w.focus.has(r)&&y.push(e.element),w.selection.has(r)&&I.push(e.element)};this.m(b,o,a),this.setFocus(y),this.setSelection(I),w&&typeof w.scrollTop=="number"&&(this.scrollTop=w.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new s.$yT(this.f,"Tree input not set");let w;this.c&&(w=y=>{const I=this.c.getId(y).toString(),o=this.d.get(I);if(o)return o.collapsed}),this.m(b,w)}resort(b=this.b,w=!0){this.o.resort(b===this.b?null:b,w)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,w,y){let I;if(this.c){const o=new Set,a=y;y=e=>{const r=this.c.getId(e.element).toString();o.add(r),this.d.set(r,e),a?.(e)},I=e=>{const r=this.c.getId(e.element).toString();o.has(r)||this.d.delete(r)}}this.o.setChildren(b===this.b?null:b,this.s(b,w).elements,{onDidCreateNode:y,onDidDeleteNode:I})}s(b,w){const y=[...this.g.getChildren(b)];return{elements:j.Iterable.map(y,o=>{const{elements:a,size:e}=this.s(o,w),r=this.g.hasChildren?this.g.hasChildren(o):void 0,d=e===0?void 0:w&&w(o);return{element:o,children:a,collapsible:r,collapsed:d}}),size:y.length}}M(b,w,y){return new C.$JT(b,w,y)}}t.$TT=E}),define(be[67],pe([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mh=t.ProxyChannel=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.RequestInitiator=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=void 0;var a;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(a||(a={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var r;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(r||(r={}));function d(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})($||($={}));function u(re){let J=0;for(let le=0;;le+=7){const K=re.read(1);if(J|=(K.buffer[0]&127)<<le,!(K.buffer[0]&128))return J}}const p=M(0);function c(re,J){if(J===0){re.write(p);return}let le=0;for(let W=J;W!==0;W=W>>>7)le++;const K=s.$he.alloc(le);for(let W=0;J!==0;W++)K.buffer[W]=J&127,J=J>>>7,J>0&&(K.buffer[W]|=128);re.write(K)}class f{constructor(J){this.b=J,this.a=0}read(J){const le=this.b.slice(this.a,this.a+J);return this.a+=le.byteLength,le}}t.$Bh=f;class h{constructor(){this.a=[]}get buffer(){return s.$he.concat(this.a)}write(J){this.a.push(J)}}t.$Ch=h;var F;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(F||(F={}));function M(re){const J=s.$he.alloc(1);return J.writeUInt8(re,0),J}const R={Undefined:M(F.Undefined),String:M(F.String),Buffer:M(F.Buffer),VSBuffer:M(F.VSBuffer),Array:M(F.Array),Object:M(F.Object),Uint:M(F.Int)},O=typeof Buffer<"u";function v(re,J){if(typeof J>"u")re.write(R.Undefined);else if(typeof J=="string"){const le=s.$he.fromString(J);re.write(R.String),c(re,le.byteLength),re.write(le)}else if(O&&Buffer.isBuffer(J)){const le=s.$he.wrap(J);re.write(R.Buffer),c(re,le.byteLength),re.write(le)}else if(J instanceof s.$he)re.write(R.VSBuffer),c(re,J.byteLength),re.write(J);else if(Array.isArray(J)){re.write(R.Array),c(re,J.length);for(const le of J)v(re,le)}else if(typeof J=="number"&&(J|0)===J)re.write(R.Uint),c(re,J);else{const le=s.$he.fromString(JSON.stringify(J));re.write(R.Object),c(re,le.byteLength),re.write(le)}}t.$Dh=v;function N(re){switch(re.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return re.read(u(re)).toString();case F.Buffer:return re.read(u(re)).buffer;case F.VSBuffer:return re.read(u(re));case F.Array:{const le=u(re),K=[];for(let W=0;W<le;W++)K.push(N(re));return K}case F.Object:return JSON.parse(re.read(u(re)).toString());case F.Int:return u(re)}}t.$Eh=N;class V{constructor(J,le,K=null,W=1e3){this.h=J,this.j=le,this.k=K,this.l=W,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:200})}registerChannel(J,le){this.b.set(J,le),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const le=this.o([J.type]);this.k?.logOutgoing(le,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const le=this.o([J.type,J.id],J.data);this.k?.logOutgoing(le,J.id,1,d(J.type),J.data);return}}}o(J,le=void 0){const K=new h;return v(K,J),v(K,le),this.p(K.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const le=new f(J),K=N(le),W=N(le),Z=K[0];switch(Z){case 100:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}: ${K[2]}.${K[3]}`,W),this.s({type:Z,id:K[1],channelName:K[2],name:K[3],arg:W});case 102:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}: ${K[2]}.${K[3]}`,W),this.t({type:Z,id:K[1],channelName:K[2],name:K[3],arg:W});case 101:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}`),this.u({type:Z,id:K[1]});case 103:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Z)}`),this.u({type:Z,id:K[1]})}}s(J){const le=this.b.get(J.channelName);if(!le){this.v(J);return}const K=new j.$4d;let W;try{W=le.call(this.j,J.name,J.arg,K.token)}catch(we){W=Promise.reject(we)}const Z=J.id;W.then(we=>{this.m({id:Z,data:we,type:201})},we=>{we instanceof Error?this.m({id:Z,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.m({id:Z,data:we,type:203})}).finally(()=>{ce.dispose(),this.d.delete(J.id)});const ce=(0,w.$Rc)(()=>K.cancel());this.d.set(J.id,ce)}t(J){const le=this.b.get(J.channelName);if(!le){this.v(J);return}const K=J.id,Z=le.listen(this.j,J.name,J.arg)(ce=>this.m({id:K,data:ce,type:204}));this.d.set(J.id,Z)}u(J){const le=this.d.get(J.id);le&&(le.dispose(),this.d.delete(J.id))}v(J){let le=this.g.get(J.channelName);le||(le=[],this.g.set(J.channelName,le));const K=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);le.push({request:J,timeoutTimer:K})}w(J){const le=this.g.get(J);if(le){for(const K of le)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Fh=V;var H;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(H||(t.RequestInitiator=H={}));class T{constructor(J,le=null){this.l=J,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Td,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=le}getChannel(J){const le=this;return{call(K,W,Z){return le.a?Promise.reject(new A.$5):le.m(J,K,W,Z)},listen(K,W){return le.a?b.Event.None:le.o(J,K,W)}}}m(J,le,K,W=j.CancellationToken.None){const Z=this.g++,we={id:Z,type:100,channelName:J,name:le,arg:K};if(W.isCancellationRequested)return Promise.reject(new A.$5);let ke;return new Promise((Le,_)=>{if(W.isCancellationRequested)return _(new A.$5);const g=()=>{const l=D=>{switch(D.type){case 201:this.f.delete(Z),Le(D.data);break;case 202:{this.f.delete(Z);const S=new Error(D.data.message);S.stack=Array.isArray(D.data.stack)?D.data.stack.join(`
`):D.data.stack,S.name=D.data.name,_(S);break}case 203:this.f.delete(Z),_(D.data);break}};this.f.set(Z,l),this.p(we)};let m=null;this.b===$.Idle?g():(m=(0,C.$Rg)(l=>this.u()),m.then(()=>{m=null,g()}));const i=()=>{m?(m.cancel(),m=null):this.p({id:Z,type:101}),_(new A.$5)},n=W.onCancellationRequested(i);ke=(0,w.$Qc)((0,w.$Rc)(i),n),this.d.add(ke)}).finally(()=>{ke.dispose(),this.d.delete(ke)})}o(J,le,K){const W=this.g++,ce={id:W,type:102,channelName:J,name:le,arg:K};let we=null;const ke=new b.$Td({onWillAddFirstListener:()=>{we=(0,C.$Rg)(Le=>this.u()),we.then(()=>{we=null,this.d.add(ke),this.p(ce)})},onDidRemoveLastListener:()=>{we?(we.cancel(),we=null):(this.d.delete(ke),this.p({id:W,type:103}))}}),Ae=Le=>ke.fire(Le.data);return this.f.set(W,Ae),ke.event}p(J){switch(J.type){case 100:case 102:{const le=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(le,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const le=this.q([J.type,J.id]);this.j?.logOutgoing(le,J.id,0,e(J.type));return}}}q(J,le=void 0){const K=new h;return v(K,J),v(K,le),this.r(K.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const le=new f(J),K=N(le),W=N(le),Z=K[0];switch(Z){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(Z)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,K[1],0,d(Z),W),this.t({type:K[0],id:K[1],data:W})}}t(J){if(J.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Gh=T,Xe([E.$vh],T.prototype,"onDidInitializePromise",null);class L{get connections(){const J=[];return this.f.forEach(le=>J.push(le)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new b.$Td,this.onDidAddConnection=this.g.event,this.h=new b.$Td,this.onDidRemoveConnection=this.h.event,this.j=new w.$Sc,this.j.add(J(({protocol:le,onDidClientDisconnect:K})=>{const W=b.Event.once(le.onMessage);this.j.add(W(Z=>{const ce=new f(Z),we=N(ce),ke=new V(le,we),Ae=new T(le);this.a.forEach((_,g)=>ke.registerChannel(g,_));const Le={channelServer:ke,channelClient:Ae,ctx:we};this.f.add(Le),this.g.fire(Le),this.j.add(K(()=>{ke.dispose(),Ae.dispose(),this.f.delete(Le),this.h.fire(Le)}))}))}))}getChannel(J,le){const K=this;return{call(W,Z,ce){let we;if((0,o.$Uf)(le)){const Ae=(0,k.$4b)(K.connections.filter(le));we=Ae?Promise.resolve(Ae):b.Event.toPromise(b.Event.filter(K.onDidAddConnection,le))}else we=le.routeCall(K,W,Z);const ke=we.then(Ae=>Ae.channelClient.getChannel(J));return X(ke).call(W,Z,ce)},listen(W,Z){if((0,o.$Uf)(le))return K.k(J,le,W,Z);const ce=le.routeEvent(K,W,Z).then(we=>we.channelClient.getChannel(J));return X(ce).listen(W,Z)}}}k(J,le,K,W){const Z=this;let ce;const we=new b.$Td({onWillAddFirstListener:()=>{ce=new w.$Sc;const ke=new b.$Zd,Ae=new Map,Le=g=>{const i=g.channelClient.getChannel(J).listen(K,W),n=ke.add(i);Ae.set(g,n)},_=g=>{const m=Ae.get(g);m&&(m.dispose(),Ae.delete(g))};Z.connections.filter(le).forEach(Le),b.Event.filter(Z.onDidAddConnection,le)(Le,void 0,ce),Z.onDidRemoveConnection(_,void 0,ce),ke.event(we.fire,we,ce),ce.add(ke)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return we.event}registerChannel(J,le){this.a.set(J,le);for(const K of this.f)K.channelServer.registerChannel(J,le)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Hh=L;class B{constructor(J,le,K=null){const W=new h;v(W,le),J.send(W.buffer),this.a=new T(J,K),this.d=new V(J,le,K)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,le){this.d.registerChannel(J,le)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Ih=B;function X(re){return{call(J,le,K){return re.then(W=>W.call(J,le,K))},listen(J,le){const K=new b.$3d;return re.then(W=>K.input=W.listen(J,le)),K.event}}}t.$Jh=X;function Y(re){let J=!1;return{call(le,K,W){return J?re.call(le,K,W):(0,C.$5g)(0).then(()=>J=!0).then(()=>re.call(le,K,W))},listen(le,K){if(J)return re.listen(le,K);const W=new b.$3d;return(0,C.$5g)(0).then(()=>J=!0).then(()=>W.input=re.listen(le,K)),W.event}}}t.$Kh=Y;class de{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const le of J.connections)if(await Promise.resolve(this.a(le.ctx)))return Promise.resolve(le);return await b.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Lh=de;var oe;(function(re){function J(Z,ce,we){const ke=Z,Ae=we&&we.disableMarshalling,Le=new Map;for(const _ in ke)K(_)&&Le.set(_,b.Event.buffer(ke[_],!0,void 0,ce));return new class{listen(_,g,m){const i=Le.get(g);if(i)return i;if(W(g)){const n=ke[g];if(typeof n=="function")return n.call(ke,m)}throw new A.$bb(`Event not found: ${g}`)}call(_,g,m){const i=ke[g];if(typeof i=="function"){if(!Ae&&Array.isArray(m))for(let l=0;l<m.length;l++)m[l]=(0,y.$Ah)(m[l]);let n=i.apply(ke,m);return n instanceof Promise||(n=Promise.resolve(n)),n}throw new A.$bb(`Method not found: ${g}`)}}}re.fromService=J;function le(Z,ce){const we=ce&&ce.disableMarshalling;return new Proxy({},{get(ke,Ae){if(typeof Ae=="string")return ce?.properties?.has(Ae)?ce.properties.get(Ae):W(Ae)?function(Le){return Z.listen(Ae,Le)}:K(Ae)?Z.listen(Ae):async function(...Le){let _;ce&&!(0,o.$Pf)(ce.context)?_=[ce.context,...Le]:_=Le;const g=await Z.call(Ae,_);return we?g:(0,y.$Ah)(g)};throw new A.$bb(`Property not found: ${String(Ae)}`)}})}re.toService=le;function K(Z){return Z[0]==="o"&&Z[1]==="n"&&I.$9e(Z.charCodeAt(2))}function W(Z){return/^onDynamic/.test(Z)&&I.$9e(Z.charCodeAt(9))}})(oe||(t.ProxyChannel=oe={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const J=re.toString();if(J!=="[object Object]")return J}return re}function Pe(re){return Array.isArray(re)?re.map(me):me(re)}function Te(re,J,le,K,W,Z,ce){ce=Pe(ce);const we=ee[W],ke=we[K%we.length];let Ae=[`%c[${re}]%c[${String(J).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${ke}`];/\($/.test(Z)?(Ae=Ae.concat(ce),Ae.push(")")):Ae.push(ce),console.log.apply(console,Ae)}class Me{constructor(J,le){this.d=J,this.f=le,this.a=0,this.b=0}logOutgoing(J,le,K,W,Z){this.b+=J,Te(this.d,this.b,J,le,K,W,Z)}logIncoming(J,le,K,W,Z){this.a+=J,Te(this.f,this.a,J,le,K,W,Z)}}t.$Mh=Me}),define(be[134],pe([1,0,33,4,67,90,30]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=void 0;class A extends s.$Ih{static f(){const w=C.Event.fromNodeEventEmitter(E.$O,"vscode:message",(y,I)=>k.$he.wrap(I));return E.$O.send("vscode:hello"),new j.$wU(E.$O,w)}constructor(w){const y=A.f();super(y,w),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}t.$AU=A}),define(be[135],pe([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(be[136],pe([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5h=t.$4h=t.$3h=t._util=void 0;var k;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function A(b){return b[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=A})(k||(t._util=k={})),t.$3h=s("instantiationService");function C(E,A,b){A[k.DI_TARGET]===A?A[k.DI_DEPENDENCIES].push({id:E,index:b}):(A[k.DI_DEPENDENCIES]=[{id:E,index:b}],A[k.DI_TARGET]=A)}function s(E){if(k.serviceIds.has(E))return k.serviceIds.get(E);const A=function(b,w,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,b,y)};return A.toString=()=>E,k.serviceIds.set(E,A),A}t.$4h=s;function j(E){return E}t.$5h=j}),define(be[137],pe([1,0,40]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Im=t.$Hm=t.$Gm=t.ID=void 0,t.ID="diagnosticsService",t.$Gm=(0,k.$4h)(t.ID);function C(j){return!!j.hostName&&!!j.errorMessage}t.$Hm=C;class s{async getPerformanceInfo(E,A){return{}}async getSystemInfo(E,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,A){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$Im=s}),define(be[138],pe([1,0,88,24,10,7,15,135,40,5,31,23]),function(ie,t,k,C,s,j,E,A,b,w,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xk=t.$Wk=t.$Vk=t.$Uk=t.$Tk=t.FileKind=t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.$Nk=t.$Mk=t.FileOperationResult=t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.FileChangeType=t.$Gk=t.FileOperation=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.FileSystemProviderErrorCode=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.$rk=t.FileSystemProviderCapabilities=t.$qk=t.FilePermission=t.FileType=t.$pk=t.$ok=void 0,t.$ok=(0,b.$4h)("fileService");function o(W){return W.create===!0}t.$pk=o;var a;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function r(W){const Z=W;return!!Z&&typeof Z.onDidChange=="function"}t.$qk=r;var d;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(d||(t.FileSystemProviderCapabilities=d={}));function $(W){return!!(W.capabilities&2)}t.$rk=$;function u(W){return!!(W.capabilities&8)}t.$sk=u;function p(W){return!!(W.capabilities&131072)}t.$tk=p;function c(W){return!!(W.capabilities&4)}t.$uk=c;function f(W){return!!(W.capabilities&16)}t.$vk=f;function h(W){return $(W)?!!(W.capabilities&16384):!1}t.$wk=h;function F(W){return $(W)?!!(W.capabilities&32768):!1}t.$xk=F;function M(W){return!!(W.capabilities&65536)}t.$yk=M;function R(W){return!!(W.capabilities&2048)}t.$zk=R;var O;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(O||(t.FileSystemProviderErrorCode=O={}));class v extends Error{static create(Z,ce){const we=new v(Z.toString(),ce);return H(we,ce),we}constructor(Z,ce){super(Z),this.code=ce}}t.$Ak=v;function N(W,Z){return v.create(W,Z)}t.$Bk=N;function V(W){return W||N((0,A.localize)(0,null),O.Unknown)}t.$Ck=V;function H(W,Z){return W.name=Z?`${Z} (FileSystemError)`:"FileSystemError",W}t.$Dk=H;function T(W){if(!W)return O.Unknown;if(W instanceof v)return W.code;const Z=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Z)return O.Unknown;switch(Z[1]){case O.FileExists:return O.FileExists;case O.FileIsADirectory:return O.FileIsADirectory;case O.FileNotADirectory:return O.FileNotADirectory;case O.FileNotFound:return O.FileNotFound;case O.FileTooLarge:return O.FileTooLarge;case O.FileWriteLocked:return O.FileWriteLocked;case O.NoPermissions:return O.NoPermissions;case O.Unavailable:return O.Unavailable}return O.Unknown}t.$Ek=T;function L(W){if(W instanceof ee)return W.fileOperationResult;switch(T(W)){case O.FileNotFound:return 1;case O.FileIsADirectory:return 0;case O.FileNotADirectory:return 9;case O.FileWriteLocked:return 5;case O.NoPermissions:return 6;case O.FileExists:return 4;case O.FileTooLarge:return 7;default:return 10}}t.$Fk=L;var B;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(B||(t.FileOperation=B={}));class X{constructor(Z,ce,we){this.resource=Z,this.operation=ce,this.target=we}isOperation(Z){return this.operation===Z}}t.$Gk=X;var Y;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class de{static{this.a=null}constructor(Z,ce){this.c=ce,this.b=void 0,this.d=new I.$V(()=>{const we=k.$0h.forUris(()=>this.c);return we.fill(this.rawAdded.map(ke=>[ke,!0])),we}),this.f=new I.$V(()=>{const we=k.$0h.forUris(()=>this.c);return we.fill(this.rawUpdated.map(ke=>[ke,!0])),we}),this.g=new I.$V(()=>{const we=k.$0h.forUris(()=>this.c);return we.fill(this.rawDeleted.map(ke=>[ke,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of Z){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==de.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(Z,...ce){return this.h(Z,{includeChildren:!1},...ce)}affects(Z,...ce){return this.h(Z,{includeChildren:!0},...ce)}h(Z,ce,...we){if(!Z)return!1;const ke=we.length>0;return!!((!ke||we.includes(1))&&(this.d.value.get(Z)||ce.includeChildren&&this.d.value.findSuperstr(Z))||(!ke||we.includes(0))&&(this.f.value.get(Z)||ce.includeChildren&&this.f.value.findSuperstr(Z))||(!ke||we.includes(2))&&(this.g.value.findSubstr(Z)||ce.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}t.$Hk=de;function oe(W,Z,ce){return!W||!Z||W===Z||Z.length>W.length?!1:(Z.charAt(Z.length-1)!==C.sep&&(Z+=C.sep),ce?(0,s.$$e)(W,Z):W.indexOf(Z)===0)}t.$Ik=oe;class ee extends Error{constructor(Z,ce,we){super(Z),this.fileOperationResult=ce,this.options=we}}t.$Jk=ee;class me extends ee{constructor(Z,ce,we,ke){super(Z,ce,ke),this.fileOperationResult=ce,this.size=we}}t.$Kk=me;class Pe extends ee{constructor(Z,ce,we){super(Z,2,we),this.stat=ce}}t.$Lk=Pe;var Te;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(t.FileOperationResult=Te={})),t.$Mk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Nk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Ok="files.associations",t.$Pk="files.exclude",t.$Qk="files.readonlyInclude",t.$Rk="files.readonlyExclude",t.$Sk="files.readonlyFromPermissions";var Me;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Me||(t.FileKind=Me={})),t.$Tk="";function re(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}t.$Uk=re;async function J(W,Z){if(!Z.hasProvider(E.URI.from({scheme:W.scheme})))return new Promise(ce=>{const we=Z.onDidChangeFileSystemProviderRegistrations(ke=>{ke.scheme===W.scheme&&ke.added&&(we.dispose(),ce())})})}t.$Vk=J;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(Z){return(0,j.$Kf)(Z)||(Z=0),Z<le.KB?(0,A.localize)(1,null,Z.toFixed(0)):Z<le.MB?(0,A.localize)(2,null,(Z/le.KB).toFixed(2)):Z<le.GB?(0,A.localize)(3,null,(Z/le.MB).toFixed(2)):Z<le.TB?(0,A.localize)(4,null,(Z/le.GB).toFixed(2)):(0,A.localize)(5,null,(Z/le.TB).toFixed(2))}}t.$Wk=le;function K(W){const Z=typeof W=="string"||W?.scheme===y.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===y.Schemas.file?1024*le.MB:Z?10*le.MB:w.$o?50*le.MB:1024*le.MB}t.$Xk=K}),define(be[139],pe([1,0,40]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N$b=t.$M$b=void 0,t.$M$b=(0,k.$4h)("mainProcessService");class C{constructor(j,E){this.a=j,this.b=E}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,E){this.a.registerChannel(j,E)}}t.$N$b=C}),define(be[140],pe([1,0,2,134]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$O$b=void 0;class s extends k.$Tc{constructor(E){super(),this.a=this.B(new C.$AU(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,A){this.a.registerChannel(E,A)}}t.$O$b=s});var Ei=this&&this.__param||function(ie,t){return function(k,C){t(k,C,ie)}};define(be[141],pe([1,0,67,139]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S$b=void 0;let s=class{constructor(E,A){return this.windowId=E,k.ProxyChannel.toService(A.getChannel("nativeHost"),{context:E,properties:(()=>{const b=new Map;return b.set("windowId",E),b})()})}};t.$S$b=s,t.$S$b=s=Xe([Ei(1,C.$M$b)],s)}),define(be[68],pe([1,0,76,7]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wn=void 0;class s{constructor(){this.a=new Map}add(E,A){k.ok(C.$Gf(E)),k.ok(C.$If(A)),k.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,A)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$wn=new s}),define(be[142],pe([1,0,4,68]),function(ie,t,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xn=void 0,t.$xn={JSONContribution:"base.contributions.json"};function s(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class j{constructor(){this.b=new k.$Td,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,w){this.a[s(b)]=w,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const E=new j;C.$wn.add(t.$xn.JSONContribution,E)}),define(be[143],pe([1,0,9,17,18,4,7,15,136,142,68]),function(ie,t,k,C,s,j,E,A,b,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uw=t.$tw=t.$sw=t.$rw=t.$qw=t.$pw=t.$ow=t.$nw=t.IconFontDefinition=t.IconContribution=t.$mw=void 0,t.$mw={IconContribution:"base.contributions.icons"};var I;(function(c){function f(h,F){let M=h.defaults;for(;s.ThemeIcon.isThemeIcon(M);){const R=e.getIcon(M.id);if(!R)return;M=R.defaults}return M}c.getDefinition=f})(I||(t.IconContribution=I={}));var o;(function(c){function f(F){return{weight:F.weight,style:F.style,src:F.src.map(M=>({format:M.format,location:M.location.toString()}))}}c.toJSONObject=f;function h(F){const M=R=>(0,E.$Gf)(R)?R:void 0;if(F&&Array.isArray(F.src)&&F.src.every(R=>(0,E.$Gf)(R.format)&&(0,E.$Gf)(R.location)))return{weight:M(F.weight),style:M(F.style),src:F.src.map(R=>({format:R.format,location:A.URI.parse(R.location)}))}}c.fromJSONObject=h})(o||(t.IconFontDefinition=o={}));class a{constructor(){this.a=new j.$Td,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${s.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,h,F,M){const R=this.b[f];if(R){if(F&&!R.description){R.description=F,this.d.properties[f].markdownDescription=`${F} $(${f})`;const N=this.e.enum.indexOf(f);N!==-1&&(this.e.enumDescriptions[N]=F),this.a.fire()}return R}const O={id:f,description:F,defaults:h,deprecationMessage:M};this.b[f]=O;const v={$ref:"#/definitions/icons"};return M&&(v.deprecationMessage=M),F&&(v.markdownDescription=`${F}: $(${f})`),this.d.properties[f]=v,this.e.enum.push(f),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const h=this.e.enum.indexOf(f);h!==-1&&(this.e.enum.splice(h,1),this.e.enumDescriptions.splice(h,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,h){const F=this.f[f];return F||(this.f[f]=h,this.a.fire(),h)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(R,O)=>R.id.localeCompare(O.id),h=R=>{for(;s.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const M=Object.keys(this.b).map(R=>this.b[R]);for(const R of M.filter(O=>!!O.description).sort(f))F.push(`|<i class="${h(R)}"></i>|${R.id}|${s.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const R of M.filter(O=>!s.ThemeIcon.isThemeIcon(O.defaults)).sort(f))F.push(`|<i class="${h(R)}"></i>|${R.id}|`);return F.join(`
`)}}const e=new a;y.$wn.add(t.$mw.IconContribution,e);function r(c,f,h,F){return e.registerIcon(c,f,h,F)}t.$nw=r;function d(){return e}t.$ow=d;function $(){const c=(0,C.$8j)();for(const f in c){const h="\\"+c[f].toString(16);e.registerIcon(f,{fontCharacter:h})}}$(),t.$pw="vscode://schemas/icons";const u=y.$wn.as(w.$xn.JSONContribution);u.registerSchema(t.$pw,e.getIconSchema());const p=new k.$dh(()=>u.notifySchemaChanged(t.$pw),200);e.onDidChange(()=>{p.isScheduled()||p.schedule()}),t.$qw=r("widget-close",C.$0j.close,(0,b.localize)(2,null)),t.$rw=r("goto-previous-location",C.$0j.arrowUp,(0,b.localize)(3,null)),t.$sw=r("goto-next-location",C.$0j.arrowDown,(0,b.localize)(4,null)),t.$tw=s.ThemeIcon.modify(C.$0j.sync,"spin"),t.$uw=s.ThemeIcon.modify(C.$0j.loading,"spin")}),define(be[144],pe([1,0,3,4,2,18,143]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MEb=t.$LEb=void 0;function A(w){const y=new s.$Sc,I=y.add(new C.$Td),o=(0,E.$ow)();return y.add(o.onDidChange(()=>I.fire())),w&&y.add(w.onDidProductIconThemeChange(()=>I.fire())),{dispose:()=>y.dispose(),onDidChange:I.event,getCSS(){const a=w?w.getProductIconTheme():new b,e={},r=$=>{const u=a.getIcon($);if(!u)return;const p=u.font;return p?(e[p.id]=p.definition,`.codicon-${$.id}:before { content: '${u.fontCharacter}'; font-family: ${(0,k.$IQ)(p.id)}; }`):`.codicon-${$.id}:before { content: '${u.fontCharacter}'; }`},d=[];for(const $ of o.getIcons()){const u=r($);u&&d.push(u)}for(const $ in e){const u=e[$],p=u.weight?`font-weight: ${u.weight};`:"",c=u.style?`font-style: ${u.style};`:"",f=u.src.map(h=>`${(0,k.$HQ)(h.location)} format('${h.format}')`).join(", ");d.push(`@font-face { src: ${f}; font-family: ${(0,k.$IQ)($)};${p}${c} font-display: block; }`)}return d.join(`
`)}}}t.$LEb=A;class b{getIcon(y){const I=(0,E.$ow)();let o=y.defaults;for(;j.ThemeIcon.isThemeIcon(o);){const a=I.getIcon(o.id);if(!a)return;o=a.defaults}return o}}t.$MEb=b}),define(be[145],pe([1,0,5]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MC=t.$LC=t.$KC=t.$JC=t.$IC=t.$HC=t.$GC=t.$FC=t.$EC=t.$DC=void 0,t.$DC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(o){return typeof o.parentId=="number"}t.$EC=C;function s(o){return!!o.workspaceUri}t.$FC=s;function j(o){return!!o.folderUri}t.$GC=j;function E(o){return!!o.fileUri}t.$HC=E;function A(o){const a=b(o),e=o.getValue("window.menuBarVisibility");return e==="default"||a==="native"&&e==="compact"||k.$j&&k.$m?"classic":e}t.$IC=A;function b(o){if(k.$o)return"custom";const a=o.getValue("window");if(a){if(k.$j&&a.nativeTabs===!0||k.$j&&a.nativeFullScreen===!1)return"native";const d=a.titleBarStyle;if(d==="native"||d==="custom")return d}return k.$k?"native":"custom"}t.$JC=b;function w(o){return!(!k.$i||k.$o||b(o)==="native")}t.$KC=w;function y(o){const a=o.getValue("window");return!a||typeof a.nativeFullScreen!="boolean"||a.nativeTabs?!0:a.nativeFullScreen!==!1}t.$LC=y;function I(o=0){return Math.pow(1.2,o)}t.$MC=I}),define(be[146],pe([1,0,16,3,21,30,145]),function(ie,t,k,C,s,j,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W$b=t.$V$b=t.$U$b=t.ApplyZoomTarget=void 0;var A;(function(o){o[o.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",o[o.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={}));function b(o,a){const e=[];a===A.ACTIVE_WINDOW?e.push((0,C.$9P)()):a===A.ALL_WINDOWS?e.push(...Array.from((0,C.getWindows)()).map(({window:r})=>r)):e.push(a);for(const r of e)w(r)?.webFrame?.setZoomLevel(o),(0,k.$6O)((0,E.$MC)(o),r),(0,k.$2O)(o,r)}t.$U$b=b;function w(o){if(o===s.$VO)return{ipcRenderer:j.$O,webFrame:j.$Q};{const a=o;if(a?.vscode?.ipcRenderer&&a?.vscode?.webFrame)return a.vscode}}function y(o){b((0,k.$3O)(typeof o=="number"?(0,C.$9P)():o)+1,o)}t.$V$b=y;function I(o){b((0,k.$3O)(typeof o=="number"?(0,C.$9P)():o)-1,o)}t.$W$b=I}),define(be[147],pe([1,0,11,3,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ie,t,k,C,s,j,E,A,b,w,y,I,o,a,e,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const d=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,$=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(T){return 22}getTemplateId(T){return O(T)?"process":M(T)?"machine":(0,b.$Hm)(T)?"error":R(T)?"header":""}}class p{hasChildren(T){return(0,b.$Hm)(T)?!1:O(T)?!!T.children?.length:!0}getChildren(T){return O(T)?T.children?T.children:[]:(0,b.$Hm)(T)?[]:R(T)?T.processRoots.length>1?T.processRoots:[T.processRoots[0].rootProcess]:M(T)?[T.rootProcess]:[T.processes]}}class c{constructor(){this.templateId="header"}renderTemplate(T){const L=(0,C.$rQ)(T,(0,C.$)(".row")),B=(0,C.$rQ)(L,(0,C.$)(".nameLabel")),X=(0,C.$rQ)(L,(0,C.$)(".cpu")),Y=(0,C.$rQ)(L,(0,C.$)(".memory")),de=(0,C.$rQ)(L,(0,C.$)(".pid"));return{name:B,CPU:X,memory:Y,PID:de}}renderElement(T,L,B,X){B.name.textContent=(0,k.localize)(0,null),B.CPU.textContent=(0,k.localize)(1,null),B.PID.textContent=(0,k.localize)(2,null),B.memory.textContent=(0,k.localize)(3,null)}disposeTemplate(T){}}class f{constructor(){this.templateId="machine"}renderTemplate(T){const L=Object.create(null),B=(0,C.$rQ)(T,(0,C.$)(".row"));return L.name=(0,C.$rQ)(B,(0,C.$)(".nameLabel")),L}renderElement(T,L,B,X){B.name.textContent=T.element.name}disposeTemplate(T){}}class h{constructor(){this.templateId="error"}renderTemplate(T){const L=Object.create(null),B=(0,C.$rQ)(T,(0,C.$)(".row"));return L.name=(0,C.$rQ)(B,(0,C.$)(".nameLabel")),L}renderElement(T,L,B,X){B.name.textContent=T.element.errorMessage}disposeTemplate(T){}}class F{constructor(T,L,B){this.a=T,this.b=L,this.c=B,this.templateId="process"}renderTemplate(T){const L=(0,C.$rQ)(T,(0,C.$)(".row")),B=(0,C.$rQ)(L,(0,C.$)(".nameLabel")),X=(0,C.$rQ)(L,(0,C.$)(".cpu")),Y=(0,C.$rQ)(L,(0,C.$)(".memory")),de=(0,C.$rQ)(L,(0,C.$)(".pid"));return{name:B,CPU:X,PID:de,memory:Y}}renderElement(T,L,B,X){const{element:Y}=T,de=Y.pid.toFixed(0);let oe=Y.name;this.c.has(Y.pid)&&(oe=this.c.get(Y.pid)),B.name.textContent=oe,B.name.title=Y.cmd,B.CPU.textContent=Y.load.toFixed(0),B.PID.textContent=de,B.PID.parentElement.id=`pid-${de}`;const ee=this.a==="win32"?Y.mem:this.b*(Y.mem/100);B.memory.textContent=(ee/w.$Wk.MB).toFixed(0)}disposeTemplate(T){}}function M(H){return!!H.name&&!!H.rootProcess}function R(H){return!!H.processRoots}function O(H){return!!H.pid}class v{constructor(T,L){this.f=L,this.b=new Map;const B=new y.$O$b(T);this.c=new I.$S$b(T,B),this.k(L.styles),this.g(L),A.$O.on("vscode:pidToNameResponse",(X,Y)=>{this.b.clear();for(const[de,oe]of Y)this.b.set(de,oe)}),A.$O.on("vscode:listProcessesResponse",async(X,Y)=>{Y.forEach((de,oe)=>{O(de.rootProcess)&&(de.rootProcess.name=oe===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Y}}),this.d.layout(r.$VO.innerHeight,r.$VO.innerWidth)):await this.h(Y),this.m(0)}),this.a=Date.now(),A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")}g(T){r.$VO.document.onkeydown=L=>{const B=T.platform==="darwin"?L.metaKey:L.ctrlKey;B&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),A.$O.send("vscode:closeProcessExplorer")),B&&L.keyCode===187&&(0,a.$V$b)(r.$VO),B&&L.keyCode===189&&(0,a.$W$b)(r.$VO)}}async h(T){const L=r.$VO.document.getElementById("process-list");if(!L)return;const{totalmem:B}=await this.c.getOSStatistics(),X=[new F(this.f.platform,B,this.b),new c,new f,new h];this.d=new s.$TT("processExplorer",L,new u,X,new p,{identityProvider:{getId:Y=>O(Y)?Y.pid.toString():(0,b.$Hm)(Y)?Y.hostName:R(Y)?"processes":M(Y)?Y.name:"header"}}),this.d.setInput({processes:{processRoots:T}}),this.d.layout(r.$VO.innerHeight,r.$VO.innerWidth),this.d.onKeyDown(Y=>{const de=new e.$oP(Y);if(de.keyCode===35&&de.altKey){const oe=this.n();Promise.all(oe.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Y=>{O(Y.element)&&this.l(Y.element,!0)}),L.style.height=`${r.$VO.innerHeight}px`,r.$VO.addEventListener("resize",()=>{L.style.height=`${r.$VO.innerHeight}px`,this.d?.layout(r.$VO.innerHeight,r.$VO.innerWidth)})}i(T){const L=d.exec(T);return L&&L.groups.port!=="0"||T.indexOf("node ")>=0||T.indexOf("node.exe")>=0}j(T){const L={type:"node",request:"attach",name:`process ${T.pid}`};let B=d.exec(T.cmd);B?L.port=Number(B.groups.port):L.processId=String(T.pid),B=$.exec(T.cmd),B&&(L.port=Number(B.groups.port)),A.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(T){const L=(0,C.$_P)(),B=[];T.listFocusBackground&&(B.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&B.push(`.monaco-list:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(B.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),B.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&B.push(`.monaco-list:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listHoverBackground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&B.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${T.listHoverForeground}; }`),T.listFocusOutline&&B.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&B.push(`.monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.scrollbarShadowColor&&B.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${T.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),T.scrollbarSliderBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${T.scrollbarSliderBackgroundColor};
				}
			`),T.scrollbarSliderHoverBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${T.scrollbarSliderHoverBackgroundColor};
				}
			`),T.scrollbarSliderActiveBackgroundColor&&B.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${T.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=B.join(`
`),T.color&&(r.$VO.document.body.style.color=T.color)}l(T,L){const B=[],X=Number(T.pid);L&&(B.push({accelerator:"Alt+E",label:(0,k.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),B.push({label:(0,k.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),B.push({type:"separator"})),B.push({label:(0,k.localize)(6,null),click:()=>{const Y=this.n();Y?.includes(X)||(Y.length=0,Y.push(X));const de=Y?.map(oe=>r.$VO.document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(de){const oe=de.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(oe.join(`
`))}}}),B.push({label:(0,k.localize)(7,null),click:()=>{const Y=r.$VO.document.getElementById("process-list");Y&&this.c.writeClipboardText(Y.innerText)}}),T&&L&&this.i(T.cmd)&&(B.push({type:"separator"}),B.push({label:(0,k.localize)(8,null),click:()=>{this.j(T)}})),(0,E.$sU)(B)}m(T){setTimeout(()=>{const L=Date.now(),B=T+L-this.a;this.a=L,B>1e3?(A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")):this.m(B)},200)}n(){return this.d?.getSelection()?.map(T=>{if(!(!T||!("pid"in T)))return T.pid}).filter(T=>!!T)}}function N(){const H=(0,C.$_P)();H.id="codiconStyles";const T=(0,o.$LEb)(void 0);function L(){H.textContent=T.getCSS()}const B=new j.$dh(L,0);T.onDidChange(()=>B.schedule()),B.schedule()}function V(H){const T=H.data.platform==="win32"?"windows":H.data.platform==="linux"?"linux":"mac";r.$VO.document.body.classList.add(T),N(),(0,a.$U$b)(H.data.zoomLevel,r.$VO),new v(H.windowId,H.data)}t.startup=V})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7452aaa51d440d39c4e6ab61970b290b8600f52f/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
