/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],se=function(X){for(var e=[],L=0,D=X.length;L<D;L++)e[L]=ie[X[L]];return e};define(ie[70],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const j=new Map,N=new Map,A=new Map,b=new Map;function u(f,E){f.has(E.detail)||f.set(E.detail,-E.timestamp)}function a(f,E){const y=f.get(E.detail);y&&(y>=0||f.set(E.detail,y+E.timestamp))}let P=[];typeof X=="function"&&typeof X.getStats=="function"&&(P=X.getStats().slice(0).sort((f,E)=>f.timestamp-E.timestamp));for(const f of P)switch(f.type){case 10:u(j,f);break;case 11:case 12:a(j,f);break;case 21:u(N,f);break;case 22:a(N,f);break;case 33:u(A,f);break;case 34:a(A,f);break;case 31:u(b,f);break;case 32:a(b,f);break}let O=0;A.forEach(f=>O+=f);function m(f){const E=[];return f.forEach((y,d)=>E.push([d,y])),E}return{amdLoad:m(j),amdInvoke:m(N),nodeRequire:m(A),nodeEval:m(b),nodeRequireTotal:O}}static toMarkdownTable(j,N){let A="";const b=[];return j.forEach((u,a)=>{b[a]=u.length}),N.forEach(u=>{u.forEach((a,P)=>{typeof a>"u"&&(a=u[P]="-");const O=a.toString().length;b[P]=Math.max(O,b[P])})}),j.forEach((u,a)=>{A+=`| ${u+" ".repeat(b[a]-u.toString().length)} `}),A+=`|
`,j.forEach((u,a)=>{A+=`| ${"-".repeat(b[a])} `}),A+=`|
`,N.forEach(u=>{u.forEach((a,P)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(b[P]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=L}),define(ie[52],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function L(A){return(b,u,a)=>{let P=null,O=null;if(typeof a.value=="function"?(P="value",O=a.value):typeof a.get=="function"&&(P="get",O=a.get),!O)throw new Error("not supported");a[P]=A(O,u)}}function D(A,b,u){let a=null,P=null;if(typeof u.value=="function"?(a="value",P=u.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",P=u.get),!P)throw new Error("not supported");const O=`$memoize$${b}`;u[a]=function(...m){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[O]}}e.$vh=D;function j(A,b,u){return L((a,P)=>{const O=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...f){this[m]||(this[m]=u?u():void 0),clearTimeout(this[O]),b&&(this[m]=b(this[m],...f),f=[this[m]]),this[O]=setTimeout(()=>{a.apply(this,f),this[m]=u?u():void 0},A)}})}e.$wh=j;function N(A,b,u){return L((a,P)=>{const O=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,E=`$throttle$pending$${P}`;return function(...y){if(this[m]||(this[m]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...y)),this[E])return;const d=this[f]+A;d<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[m]]),this[m]=u?u():void 0):(this[E]=!0,this[O]=setTimeout(()=>{this[E]=!1,this[f]=Date.now(),a.apply(this,[this[m]]),this[m]=u?u():void 0},d-Date.now()))}})}e.$xh=N}),define(ie[71],se([0,1,9]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function D(u,a){if(!u)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=D;function j(u,a="Unreachable"){throw new Error(a)}e.$6c=j;function N(u){if(!u)throw new L.$cb("Assertion Failed")}e.$7c=N;function A(u){if(!u()){debugger;u(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$8c=A;function b(u,a){let P=0;for(;P<u.length-1;){const O=u[P],m=u[P+1];if(!a(O,m))return!1;P++}return!0}e.$9c=b}),define(ie[53],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var j;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(s,o=!1){let t=0;const i=s.length;let n="",r=0,c=16,S=0;function k(re){let he=0,ce=0;for(;he<re;){const ae=s.charCodeAt(t);if(ae>=48&&ae<=57)ce=ce*16+ae-48;else if(ae>=65&&ae<=70)ce=ce*16+ae-65+10;else if(ae>=97&&ae<=102)ce=ce*16+ae-97+10;else break;t++,he++}return he<re&&(ce=-1),ce}function p(re){t=re,n="",r=0,c=16,S=0}function R(){const re=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&a(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&a(s.charCodeAt(t)))for(t++;t<s.length&&a(s.charCodeAt(t));)t++;else return S=3,s.substring(re,t);let he=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&a(s.charCodeAt(t))){for(t++;t<s.length&&a(s.charCodeAt(t));)t++;he=t}else S=3;return s.substring(re,he)}function V(){let re="",he=t;for(;;){if(t>=i){re+=s.substring(he,t),S=2;break}const ce=s.charCodeAt(t);if(ce===34){re+=s.substring(he,t),t++;break}if(ce===92){if(re+=s.substring(he,t),t++,t>=i){S=2;break}switch(s.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=k(4);B>=0?re+=String.fromCharCode(B):S=4;break}default:S=5}he=t;continue}if(ce>=0&&ce<=31)if(u(ce)){re+=s.substring(he,t),S=2;break}else S=6;t++}return re}function te(){if(n="",S=0,r=t,t>=i)return r=i,c=17;let re=s.charCodeAt(t);if(b(re)){do t++,n+=String.fromCharCode(re),re=s.charCodeAt(t);while(b(re));return c=15}if(u(re))return t++,n+=String.fromCharCode(re),re===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),c=14;switch(re){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,n=V(),c=10;case 47:{const he=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(s.charCodeAt(t));)t++;return n=s.substring(he,t),c=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let ae=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,S=1),n=s.substring(he,t),c=13}return n+=String.fromCharCode(re),t++,c=16}case 45:if(n+=String.fromCharCode(re),t++,t===i||!a(s.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),c=11;default:for(;t<i&&x(re);)t++,re=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(re),t++,c=16}}function x(re){if(b(re)||u(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=te();while(re>=12&&re<=15);return re}return{setPosition:p,getPosition:()=>t,scan:o?oe:te,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>S}}e.$$m=A;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function a(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function O(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function S(k,p,R,V){r.value=k,r.offset=p,r.length=R,r.type=V,r.colonOffset=void 0,n=r}try{I(s,{onObjectBegin:(k,p)=>{if(o<=k)throw i;n=void 0,c=o>k,t.push("")},onObjectProperty:(k,p,R)=>{if(o<p||(S(k,p,R,"property"),t[t.length-1]=k,o<=p+R))throw i},onObjectEnd:(k,p)=>{if(o<=k)throw i;n=void 0,t.pop()},onArrayBegin:(k,p)=>{if(o<=k)throw i;n=void 0,t.push(0)},onArrayEnd:(k,p)=>{if(o<=k)throw i;n=void 0,t.pop()},onLiteralValue:(k,p,R)=>{if(o<p||(S(k,p,R,w(k)),o<=p+R))throw i},onSeparator:(k,p,R)=>{if(o<=p)throw i;if(k===":"&&n&&n.type==="property")n.colonOffset=p,c=!1,n=void 0;else if(k===","){const V=t[t.length-1];typeof V=="number"?t[t.length-1]=V+1:(c=!0,t[t.length-1]=""),n=void 0}}})}catch(k){if(k!==i)throw k}return{path:t,previousNode:n,isAtPropertyKey:c,matches:k=>{let p=0;for(let R=0;p<k.length&&R<t.length;R++)if(k[p]===t[R]||k[p]==="*")p++;else if(k[p]!=="**")return!1;return p===k.length}}}e.$_m=O;function m(s,o=[],t=N.DEFAULT){let i=null,n=[];const r=[];function c(k){Array.isArray(n)?n.push(k):i!==null&&(n[i]=k)}return I(s,{onObjectBegin:()=>{const k={};c(k),r.push(n),n=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const k=[];c(k),r.push(n),n=k,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:c,onError:(k,p,R)=>{o.push({error:k,offset:p,length:R})}},t),n[0]}e.$an=m;function f(s,o=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function r(k){return i.children.push(k),k}I(s,{onObjectBegin:k=>{i=r({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,p,R)=>{i=r({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:p,length:R,parent:i})},onObjectEnd:(k,p)=>{i.length=k+p-i.offset,i=i.parent,n(k+p)},onArrayBegin:(k,p)=>{i=r({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,p)=>{i.length=k+p-i.offset,i=i.parent,n(k+p)},onLiteralValue:(k,p,R)=>{r({type:w(k),offset:p,length:R,parent:i,value:k}),n(p+R)},onSeparator:(k,p,R)=>{i.type==="property"&&(k===":"?i.colonOffset=p:k===","&&n(p))},onError:(k,p,R)=>{o.push({error:k,offset:p,length:R})}},t);const S=i.children[0];return S&&delete S.parent,S}e.$bn=f;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$cn=E;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$dn=y;function d(s){switch(s.type){case"array":return s.children.map(d);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=d(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$en=d;function l(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$fn=l;function $(s,o,t=!1){if(l(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=$(i[n],o,t);if(r)return r}return s}}e.$gn=$;function I(s,o,t=N.DEFAULT){const i=A(s,!1);function n(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Y){return Y?K=>Y(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=n(o.onObjectBegin),S=r(o.onObjectProperty),k=n(o.onObjectEnd),p=n(o.onArrayBegin),R=n(o.onArrayEnd),V=r(o.onLiteralValue),te=r(o.onSeparator),x=n(o.onComment),oe=r(o.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ce(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Y){case 12:case 13:re?ae(10):x();break;case 16:ae(1);break;case 15:case 14:break;default:return Y}}}function ae(Y,K=[],T=[]){if(oe(Y),K.length+T.length>0){let F=i.getToken();for(;F!==17;){if(K.indexOf(F)!==-1){ce();break}else if(T.indexOf(F)!==-1)break;F=ce()}}}function B(Y){const K=i.getTokenValue();return Y?V(K):S(K),ce(),!0}function Q(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(ae(2),Y=0)}catch{ae(2)}V(Y);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return ce(),!0}function M(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(te(":"),ce(),J()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function C(){c(),ce();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ae(4,[],[]),te(","),ce(),i.getToken()===2&&he)break}else Y&&ae(6,[],[]);M()||ae(4,[],[2,5]),Y=!0}return k(),i.getToken()!==2?ae(7,[2],[]):ce(),!0}function H(){p(),ce();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ae(4,[],[]),te(","),ce(),i.getToken()===4&&he)break}else Y&&ae(6,[],[]);J()||ae(4,[],[4,5]),Y=!0}return R(),i.getToken()!==4?ae(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return H();case 1:return C();case 10:return B(!0);default:return Q()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):J()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$hn=I;function g(s,o){const t=A(s),i=[];let n,r=0,c;do switch(c=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==c&&i.push(s.substring(r,c)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$in=g;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$jn=w}),define(ie[72],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.rot=e.$5l=void 0;function L(b,u,a){return Math.min(Math.max(b,u),a)}e.$5l=L;function D(b,u){return(u+b%u)%u}e.rot=D;class j{constructor(){this.a=0}getNext(){return this.a++}}e.$7l=j;class N{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$8l=N;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$9l=A}),function(){function X(j){const N=[];typeof j=="number"&&N.push("code/timeOrigin",j);function A(u){N.push(u,Date.now())}function b(){const u=[];for(let a=0;a<N.length;a+=2)u.push({name:N[a],startTime:N[a+1]});return u}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(j+A.startTime)});return N}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function L(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:X)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function L(D){if(e[D])return e[D].exports;var j=e[D]={i:D,l:!1,exports:{}};return X[D].call(j.exports,j,j.exports,L),j.l=!0,j.exports}return L.m=X,L.c=e,L.d=function(D,j,N){L.o(D,j)||Object.defineProperty(D,j,{enumerable:!0,get:N})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,j){if(1&j&&(D=L(D)),8&j||4&j&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(L.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&j&&typeof D!="string")for(var A in D)L.d(N,A,function(b){return D[b]}.bind(null,A));return N},L.n=function(D){var j=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(j,"a",j),j},L.o=function(D,j){return Object.prototype.hasOwnProperty.call(D,j)},L.p="",L(L.s=0)}([function(X,e,L){(function(D){var j;e=X.exports=T,j=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],a=0,P=a++;u[P]="0|[1-9]\\d*";var O=a++;u[O]="[0-9]+";var m=a++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;u[f]="("+u[P]+")\\.("+u[P]+")\\.("+u[P]+")";var E=a++;u[E]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var y=a++;u[y]="(?:"+u[P]+"|"+u[m]+")";var d=a++;u[d]="(?:"+u[O]+"|"+u[m]+")";var l=a++;u[l]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var $=a++;u[$]="(?:-?("+u[d]+"(?:\\."+u[d]+")*))";var I=a++;u[I]="[0-9A-Za-z-]+";var g=a++;u[g]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var w=a++,s="v?"+u[f]+u[l]+"?"+u[g]+"?";u[w]="^"+s+"$";var o="[v=\\s]*"+u[E]+u[$]+"?"+u[g]+"?",t=a++;u[t]="^"+o+"$";var i=a++;u[i]="((?:<|>)?=?)";var n=a++;u[n]=u[O]+"|x|X|\\*";var r=a++;u[r]=u[P]+"|x|X|\\*";var c=a++;u[c]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[l]+")?"+u[g]+"?)?)?";var S=a++;u[S]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[$]+")?"+u[g]+"?)?)?";var k=a++;u[k]="^"+u[i]+"\\s*"+u[c]+"$";var p=a++;u[p]="^"+u[i]+"\\s*"+u[S]+"$";var R=a++;u[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=a++;u[V]="(?:~>?)";var te=a++;u[te]="(\\s*)"+u[V]+"\\s+",b[te]=new RegExp(u[te],"g");var x=a++;u[x]="^"+u[V]+u[c]+"$";var oe=a++;u[oe]="^"+u[V]+u[S]+"$";var re=a++;u[re]="(?:\\^)";var he=a++;u[he]="(\\s*)"+u[re]+"\\s+",b[he]=new RegExp(u[he],"g");var ce=a++;u[ce]="^"+u[re]+u[c]+"$";var ae=a++;u[ae]="^"+u[re]+u[S]+"$";var B=a++;u[B]="^"+u[i]+"\\s*("+o+")$|^$";var Q=a++;u[Q]="^"+u[i]+"\\s*("+s+")$|^$";var M=a++;u[M]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[c]+")",b[M]=new RegExp(u[M],"g");var C=a++;u[C]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var H=a++;u[H]="^\\s*("+u[S]+")\\s+-\\s+("+u[S]+")\\s*$";var J=a++;u[J]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)j(Y,u[Y]),b[Y]||(b[Y]=new RegExp(u[Y]));function K(q,Z){if(q instanceof T)return q;if(typeof q!="string"||q.length>N||!(Z?b[t]:b[w]).test(q))return null;try{return new T(q,Z)}catch{return null}}function T(q,Z){if(q instanceof T){if(q.loose===Z)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof T))return new T(q,Z);j("SemVer",q,Z),this.loose=Z;var _=q.trim().match(Z?b[t]:b[w]);if(!_)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ye=+me;if(ye>=0&&ye<A)return ye}return me}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=K,e.valid=function(q,Z){var _=K(q,Z);return _?_.version:null},e.clean=function(q,Z){var _=K(q.trim().replace(/^[=v]+/,""),Z);return _?_.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(q){return j("SemVer.compare",this.version,this.loose,q),q instanceof T||(q=new T(q,this.loose)),this.compareMain(q)||this.comparePre(q)},T.prototype.compareMain=function(q){return q instanceof T||(q=new T(q,this.loose)),h(this.major,q.major)||h(this.minor,q.minor)||h(this.patch,q.patch)},T.prototype.comparePre=function(q){if(q instanceof T||(q=new T(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Z=0;do{var _=this.prerelease[Z],me=q.prerelease[Z];if(j("prerelease compare",Z,_,me),_===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(_===void 0)return-1;if(_!==me)return h(_,me)}while(++Z)},T.prototype.inc=function(q,Z){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Z,_,me){typeof _=="string"&&(me=_,_=void 0);try{return new T(q,_).inc(Z,me).version}catch{return null}},e.diff=function(q,Z){if(W(q,Z))return null;var _=K(q),me=K(Z);if(_.prerelease.length||me.prerelease.length){for(var ye in _)if((ye==="major"||ye==="minor"||ye==="patch")&&_[ye]!==me[ye])return"pre"+ye;return"prerelease"}for(var ye in _)if((ye==="major"||ye==="minor"||ye==="patch")&&_[ye]!==me[ye])return ye},e.compareIdentifiers=h;var F=/^[0-9]+$/;function h(q,Z){var _=F.test(q),me=F.test(Z);return _&&me&&(q=+q,Z=+Z),_&&!me?-1:me&&!_?1:q<Z?-1:q>Z?1:0}function v(q,Z,_){return new T(q,_).compare(new T(Z,_))}function z(q,Z,_){return v(q,Z,_)>0}function U(q,Z,_){return v(q,Z,_)<0}function W(q,Z,_){return v(q,Z,_)===0}function G(q,Z,_){return v(q,Z,_)!==0}function ee(q,Z,_){return v(q,Z,_)>=0}function ue(q,Z,_){return v(q,Z,_)<=0}function fe(q,Z,_,me){var ye;switch(Z){case"===":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),ye=q===_;break;case"!==":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),ye=q!==_;break;case"":case"=":case"==":ye=W(q,_,me);break;case"!=":ye=G(q,_,me);break;case">":ye=z(q,_,me);break;case">=":ye=ee(q,_,me);break;case"<":ye=U(q,_,me);break;case"<=":ye=ue(q,_,me);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function ge(q,Z){if(q instanceof ge){if(q.loose===Z)return q;q=q.value}if(!(this instanceof ge))return new ge(q,Z);j("comparator",q,Z),this.loose=Z,this.parse(q),this.semver===we?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(q,Z){return h(Z,q)},e.major=function(q,Z){return new T(q,Z).major},e.minor=function(q,Z){return new T(q,Z).minor},e.patch=function(q,Z){return new T(q,Z).patch},e.compare=v,e.compareLoose=function(q,Z){return v(q,Z,!0)},e.rcompare=function(q,Z,_){return v(Z,q,_)},e.sort=function(q,Z){return q.sort(function(_,me){return e.compare(_,me,Z)})},e.rsort=function(q,Z){return q.sort(function(_,me){return e.rcompare(_,me,Z)})},e.gt=z,e.lt=U,e.eq=W,e.neq=G,e.gte=ee,e.lte=ue,e.cmp=fe,e.Comparator=ge;var we={};function de(q,Z){if(q instanceof de)return q.loose===Z?q:new de(q.raw,Z);if(q instanceof ge)return new de(q.value,Z);if(!(this instanceof de))return new de(q,Z);if(this.loose=Z,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function le(q){return!q||q.toLowerCase()==="x"||q==="*"}function pe(q,Z,_,me,ye,De,Pe,ze,Ie,Ne,Ce,Oe,Ae){return((Z=le(_)?"":le(me)?">="+_+".0.0":le(ye)?">="+_+"."+me+".0":">="+Z)+" "+(ze=le(Ie)?"":le(Ne)?"<"+(+Ie+1)+".0.0":le(Ce)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Ce+"-"+Oe:"<="+ze)).trim()}function ve(q,Z){for(var _=0;_<q.length;_++)if(!q[_].test(Z))return!1;if(Z.prerelease.length){for(_=0;_<q.length;_++)if(j(q[_].semver),q[_].semver!==we&&q[_].semver.prerelease.length>0){var me=q[_].semver;if(me.major===Z.major&&me.minor===Z.minor&&me.patch===Z.patch)return!0}return!1}return!0}function ke(q,Z,_){try{Z=new de(Z,_)}catch{return!1}return Z.test(q)}function je(q,Z,_,me){var ye,De,Pe,ze,Ie;switch(q=new T(q,me),Z=new de(Z,me),_){case">":ye=z,De=ue,Pe=U,ze=">",Ie=">=";break;case"<":ye=U,De=ee,Pe=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(q,Z,me))return!1;for(var Ne=0;Ne<Z.set.length;++Ne){var Ce=Z.set[Ne],Oe=null,Ae=null;if(Ce.forEach(function(Fe){Fe.semver===we&&(Fe=new ge(">=0.0.0")),Oe=Oe||Fe,Ae=Ae||Fe,ye(Fe.semver,Oe.semver,me)?Oe=Fe:Pe(Fe.semver,Ae.semver,me)&&(Ae=Fe)}),Oe.operator===ze||Oe.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(q,Ae.semver)||Ae.operator===Ie&&Pe(q,Ae.semver))return!1}return!0}ge.prototype.parse=function(q){var Z=this.loose?b[B]:b[Q],_=q.match(Z);if(!_)throw new TypeError("Invalid comparator: "+q);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new T(_[2],this.loose):this.semver=we},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(q){return j("Comparator.test",q,this.loose),this.semver===we||(typeof q=="string"&&(q=new T(q,this.loose)),fe(q,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(q,Z){if(!(q instanceof ge))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new de(q.value,Z),ke(this.value,_,Z);if(q.operator==="")return _=new de(this.value,Z),ke(q.semver,_,Z);var me=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),De=this.semver.version===q.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),ze=fe(this.semver,"<",q.semver,Z)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ie=fe(this.semver,">",q.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return me||ye||De&&Pe||ze||Ie},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(q){var Z=this.loose;q=q.trim(),j("range",q,Z);var _=Z?b[H]:b[C];q=q.replace(_,pe),j("hyphen replace",q),q=q.replace(b[M],"$1$2$3"),j("comparator trim",q,b[M]),q=(q=(q=q.replace(b[te],"$1~")).replace(b[he],"$1^")).split(/\s+/).join(" ");var me=Z?b[B]:b[Q],ye=q.split(" ").map(function(De){return function(Pe,ze){return j("comp",Pe),Pe=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,Ae){j("caret",Oe,Ae);var Fe=Ae?b[ae]:b[ce];return Oe.replace(Fe,function(Le,be,Ee,Se,Re){var Te;return j("caret",Oe,Le,be,Ee,Se,Re),le(be)?Te="":le(Ee)?Te=">="+be+".0.0 <"+(+be+1)+".0.0":le(Se)?Te=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":Re?(j("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Se+Re+" <"+be+"."+Ee+"."+(+Se+1):">="+be+"."+Ee+"."+Se+Re+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Se+Re+" <"+(+be+1)+".0.0"):(j("no pr"),Te=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Se+" <"+be+"."+Ee+"."+(+Se+1):">="+be+"."+Ee+"."+Se+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Se+" <"+(+be+1)+".0.0"),j("caret return",Te),Te})}(Ce,Ne)}).join(" ")}(Pe,ze),j("caret",Pe),Pe=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,Ae){var Fe=Ae?b[oe]:b[x];return Oe.replace(Fe,function(Le,be,Ee,Se,Re){var Te;return j("tilde",Oe,Le,be,Ee,Se,Re),le(be)?Te="":le(Ee)?Te=">="+be+".0.0 <"+(+be+1)+".0.0":le(Se)?Te=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":Re?(j("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+be+"."+Ee+"."+Se+Re+" <"+be+"."+(+Ee+1)+".0"):Te=">="+be+"."+Ee+"."+Se+" <"+be+"."+(+Ee+1)+".0",j("tilde return",Te),Te})}(Ce,Ne)}).join(" ")}(Pe,ze),j("tildes",Pe),Pe=function(Ie,Ne){return j("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Ce){return function(Oe,Ae){Oe=Oe.trim();var Fe=Ae?b[p]:b[k];return Oe.replace(Fe,function(Le,be,Ee,Se,Re,Te){j("xRange",Oe,Le,be,Ee,Se,Re,Te);var Be=le(Ee),Ue=Be||le(Se),Me=Ue||le(Re);return be==="="&&Me&&(be=""),Be?Le=be===">"||be==="<"?"<0.0.0":"*":be&&Me?(Ue&&(Se=0),Me&&(Re=0),be===">"?(be=">=",Ue?(Ee=+Ee+1,Se=0,Re=0):Me&&(Se=+Se+1,Re=0)):be==="<="&&(be="<",Ue?Ee=+Ee+1:Se=+Se+1),Le=be+Ee+"."+Se+"."+Re):Ue?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Me&&(Le=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0"),j("xRange return",Le),Le})}(Ce,Ne)}).join(" ")}(Pe,ze),j("xrange",Pe),Pe=function(Ie,Ne){return j("replaceStars",Ie,Ne),Ie.trim().replace(b[J],"")}(Pe,ze),j("stars",Pe),Pe}(De,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(me)})),ye=ye.map(function(De){return new ge(De,Z)})},de.prototype.intersects=function(q,Z){if(!(q instanceof de))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(me){return q.set.some(function(ye){return ye.every(function(De){return me.intersects(De,Z)})})})})},e.toComparators=function(q,Z){return new de(q,Z).set.map(function(_){return _.map(function(me){return me.value}).join(" ").trim().split(" ")})},de.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new T(q,this.loose));for(var Z=0;Z<this.set.length;Z++)if(ve(this.set[Z],q))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(q,Z,_){var me=null,ye=null;try{var De=new de(Z,_)}catch{return null}return q.forEach(function(Pe){De.test(Pe)&&(me&&ye.compare(Pe)!==-1||(ye=new T(me=Pe,_)))}),me},e.minSatisfying=function(q,Z,_){var me=null,ye=null;try{var De=new de(Z,_)}catch{return null}return q.forEach(function(Pe){De.test(Pe)&&(me&&ye.compare(Pe)!==1||(ye=new T(me=Pe,_)))}),me},e.validRange=function(q,Z){try{return new de(q,Z).range||"*"}catch{return null}},e.ltr=function(q,Z,_){return je(q,Z,"<",_)},e.gtr=function(q,Z,_){return je(q,Z,">",_)},e.outside=je,e.prerelease=function(q,Z){var _=K(q,Z);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(q,Z,_){return q=new de(q,_),Z=new de(Z,_),q.intersects(Z)},e.coerce=function(q){if(q instanceof T)return q;if(typeof q!="string")return null;var Z=q.match(b[R]);return Z==null?null:K((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,L(1))},function(X,e){var L,D,j=X.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(d){if(L===setTimeout)return setTimeout(d,0);if((L===N||!L)&&setTimeout)return L=setTimeout,setTimeout(d,0);try{return L(d,0)}catch{try{return L.call(null,d,0)}catch{return L.call(this,d,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:N}catch{L=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var u,a=[],P=!1,O=-1;function m(){P&&u&&(P=!1,u.length?a=u.concat(a):O=-1,a.length&&f())}function f(){if(!P){var d=b(m);P=!0;for(var l=a.length;l;){for(u=a,a=[];++O<l;)u&&u[O].run();O=-1,l=a.length}u=null,P=!1,function($){if(D===clearTimeout)return clearTimeout($);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout($);try{D($)}catch{try{return D.call(null,$)}catch{return D.call(this,$)}}}(d)}}function E(d,l){this.fun=d,this.array=l}function y(){}j.nextTick=function(d){var l=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)l[$-1]=arguments[$];a.push(new E(d,l)),a.length!==1||P||b(f)},E.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=y,j.addListener=y,j.once=y,j.off=y,j.removeListener=y,j.removeAllListeners=y,j.emit=y,j.prependListener=y,j.prependOnceListener=y,j.listeners=function(d){return[]},j.binding=function(d){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(d){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(ie[73],se([0,1]),function(X,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;class D{constructor(b,u,a){this.level=b,this.key=u,this.value=a,this.forward=[]}}const j=void 0;class N{constructor(b,u=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,j,j)}get size(){return this.f}clear(){this.e=new D(this.c,j,j),this.f=0}has(b){return!!N.g(this,b,this.comparator)}get(b){return N.g(this,b,this.comparator)?.value}set(b,u){return N.h(this,b,u,this.comparator)&&(this.f+=1),this}delete(b){const u=N.k(this,b,this.comparator);return u&&(this.f-=1),u}forEach(b,u){let a=this.e.forward[0];for(;a;)b.call(u,a.value,a.key,this),a=a.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this.e.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static g(b,u,a){let P=b.e;for(let O=b.d-1;O>=0;O--)for(;P.forward[O]&&a(P.forward[O].key,u)<0;)P=P.forward[O];if(P=P.forward[0],P&&a(P.key,u)===0)return P}static h(b,u,a,P){const O=[];let m=b.e;for(let f=b.d-1;f>=0;f--){for(;m.forward[f]&&P(m.forward[f].key,u)<0;)m=m.forward[f];O[f]=m}if(m=m.forward[0],m&&P(m.key,u)===0)return m.value=a,!1;{const f=N.j(b);if(f>b.d){for(let E=b.d;E<f;E++)O[E]=b.e;b.d=f}m=new D(f,u,a);for(let E=0;E<f;E++)m.forward[E]=O[E].forward[E],O[E].forward[E]=m;return!0}}static j(b,u=.5){let a=1;for(;Math.random()<u&&a<b.c;)a+=1;return a}static k(b,u,a){const P=[];let O=b.e;for(let m=b.d-1;m>=0;m--){for(;O.forward[m]&&a(O.forward[m].key,u)<0;)O=O.forward[m];P[m]=O}if(O=O.forward[0],!O||a(O.key,u)!==0)return!1;for(let m=0;m<b.d&&P[m].forward[m]===O;m++)P[m].forward[m]=O.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===j;)b.d-=1;return!0}}e.$Pr=N}),define(ie[45],se([0,1,9,2]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;function j(g){const w=g;return w?typeof w.read=="function":!1}e.$5d=j;function N(g){const w=g;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.$6d=N;function A(g){const w=g;return w?N(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.$7d=A;function b(g,w){return new u(g,w)}e.$8d=b;class u{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,L.$1)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let o;switch(w){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(g,w){const s=[];let o;for(;(o=g.read())!==null;)s.push(o);return w(s)}e.$9d=a;function P(g,w,s){const o=[];let t;for(;(t=g.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?w(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}e.$0d=P;function O(g,w){return new Promise((s,o)=>{const t=[];m(g,{onData:i=>{w&&t.push(i)},onError:i=>{w?o(i):s(void 0)},onEnd:()=>{s(w?w(t):void 0)}})})}e.$$d=O;function m(g,w,s){g.on("error",o=>{s?.isCancellationRequested||w.onError(o)}),g.on("end",()=>{s?.isCancellationRequested||w.onEnd()}),g.on("data",o=>{s?.isCancellationRequested||w.onData(o)})}e.$_d=m;function f(g,w){return new Promise((s,o)=>{const t=new D.$Sc,i=[],n=S=>{if(i.push(S),i.length>w)return t.dispose(),g.pause(),s({stream:g,buffer:i,ended:!1})},r=S=>(t.dispose(),o(S)),c=()=>(t.dispose(),s({stream:g,buffer:i,ended:!0}));t.add((0,D.$Rc)(()=>g.removeListener("error",r))),g.on("error",r),t.add((0,D.$Rc)(()=>g.removeListener("end",c))),g.on("end",c),t.add((0,D.$Rc)(()=>g.removeListener("data",n))),g.on("data",n)})}e.$ae=f;function E(g,w){const s=b(w);return s.end(g),s}e.$be=E;function y(){const g=b(()=>{throw new Error("not supported")});return g.end(),g}e.$ce=y;function d(g){let w=!1;return{read:()=>w?null:(w=!0,g)}}e.$de=d;function l(g,w,s){const o=b(s);return m(g,{onData:t=>o.write(w.data(t)),onError:t=>o.error(w.error?w.error(t):t),onEnd:()=>o.end()}),o}e.$ee=l;function $(g,w,s){let o=!1;return{read:()=>{const t=w.read();return o?t:(o=!0,t!==null?s([g,t]):g)}}}e.$fe=$;function I(g,w,s){let o=!1;const t=b(s);return m(w,{onData:i=>o?t.write(i):(o=!0,t.write(s([g,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(g)),t.end()}}),t}e.$ge=I}),define(ie[14],se([0,1,164,45]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=void 0;const j=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let A,b;class u{static alloc(R){return j?new u(Buffer.allocUnsafe(R)):new u(new Uint8Array(R))}static wrap(R){return j&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new u(R)}static fromString(R,V){return!(V?.dontUseNodeBuffer||!1)&&j?new u(Buffer.from(R)):(A||(A=new TextEncoder),new u(A.encode(R)))}static fromByteArray(R){const V=u.alloc(R.length);for(let te=0,x=R.length;te<x;te++)V.buffer[te]=R[te];return V}static concat(R,V){if(typeof V>"u"){V=0;for(let oe=0,re=R.length;oe<re;oe++)V+=R[oe].byteLength}const te=u.alloc(V);let x=0;for(let oe=0,re=R.length;oe<re;oe++){const he=R[oe];te.set(he,x),x+=he.byteLength}return te}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=u.alloc(this.byteLength);return R.set(this),R}toString(){return j?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(R,V){return new u(this.buffer.subarray(R,V))}set(R,V){if(R instanceof u)this.buffer.set(R.buffer,V);else if(R instanceof Uint8Array)this.buffer.set(R,V);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),V);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),V);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return m(this.buffer,R)}writeUInt32BE(R,V){f(this.buffer,R,V)}readUInt32LE(R){return E(this.buffer,R)}writeUInt32LE(R,V){y(this.buffer,R,V)}readUInt8(R){return d(this.buffer,R)}writeUInt8(R,V){l(this.buffer,R,V)}indexOf(R,V=0){return a(this.buffer,R instanceof u?R.buffer:R,V)}}e.$he=u;function a(p,R,V=0){const te=R.byteLength,x=p.byteLength;if(te===0)return 0;if(te===1)return p.indexOf(R[0]);if(te>x-V)return-1;const oe=N.value;oe.fill(R.length);for(let ae=0;ae<R.length;ae++)oe[R[ae]]=R.length-ae-1;let re=V+R.length-1,he=re,ce=-1;for(;re<x;)if(p[re]===R[he]){if(he===0){ce=re;break}re--,he--}else re+=Math.max(R.length-he,oe[p[re]]),he=R.length-1;return ce}e.$ie=a;function P(p,R){return p[R+0]<<0>>>0|p[R+1]<<8>>>0}e.$je=P;function O(p,R,V){p[V+0]=R&255,R=R>>>8,p[V+1]=R&255}e.$ke=O;function m(p,R){return p[R]*2**24+p[R+1]*2**16+p[R+2]*2**8+p[R+3]}e.$le=m;function f(p,R,V){p[V+3]=R,R=R>>>8,p[V+2]=R,R=R>>>8,p[V+1]=R,R=R>>>8,p[V]=R}e.$me=f;function E(p,R){return p[R+0]<<0>>>0|p[R+1]<<8>>>0|p[R+2]<<16>>>0|p[R+3]<<24>>>0}e.$ne=E;function y(p,R,V){p[V+0]=R&255,R=R>>>8,p[V+1]=R&255,R=R>>>8,p[V+2]=R&255,R=R>>>8,p[V+3]=R&255}e.$oe=y;function d(p,R){return p[R]}e.$pe=d;function l(p,R,V){p[V]=R}e.$qe=l;function $(p){return D.$9d(p,R=>u.concat(R))}e.$re=$;function I(p){return D.$de(p)}e.$se=I;function g(p){return D.$$d(p,R=>u.concat(R))}e.$te=g;async function w(p){return p.ended?u.concat(p.buffer):u.concat([...p.buffer,await g(p.stream)])}e.$ue=w;function s(p){return D.$be(p,R=>u.concat(R))}e.$ve=s;function o(p){return D.$ee(p,{data:R=>typeof R=="string"?u.fromString(R):u.wrap(R)},R=>u.concat(R))}e.$we=o;function t(p){return D.$8d(R=>u.concat(R),p)}e.$xe=t;function i(p,R){return D.$fe(p,R,V=>u.concat(V))}e.$ye=i;function n(p,R){return D.$ge(p,R,V=>u.concat(V))}e.$ze=n;function r(p){let R=0,V=0,te=0;const x=new Uint8Array(Math.floor(p.length/4*3)),oe=he=>{switch(V){case 3:x[te++]=R|he,V=0;break;case 2:x[te++]=R|he>>>2,R=he<<6,V=3;break;case 1:x[te++]=R|he>>>4,R=he<<4,V=2;break;default:R=he<<2,V=1}};for(let he=0;he<p.length;he++){const ce=p.charCodeAt(he);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${p[he]}`)}}const re=te;for(;V>0;)oe(0);return u.wrap(x).slice(0,re)}e.$Ae=r;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:p},R=!0,V=!1){const te=V?S:c;let x="";const oe=p.byteLength%3;let re=0;for(;re<p.byteLength-oe;re+=3){const he=p[re+0],ce=p[re+1],ae=p[re+2];x+=te[he>>>2],x+=te[(he<<4|ce>>>4)&63],x+=te[(ce<<2|ae>>>6)&63],x+=te[ae&63]}if(oe===1){const he=p[re+0];x+=te[he>>>2],x+=te[he<<4&63],R&&(x+="==")}else if(oe===2){const he=p[re+0],ce=p[re+1];x+=te[he>>>2],x+=te[(he<<4|ce>>>4)&63],x+=te[ce<<2&63],R&&(x+="=")}return x}e.$Be=k}),define(ie[41],se([0,1,29]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=void 0;function D(l){return j(l,0)}e.$Ri=D;function j(l,$){switch(typeof l){case"object":return l===null?N(349,$):Array.isArray(l)?u(l,$):a(l,$);case"string":return b(l,$);case"boolean":return A(l,$);case"number":return N(l,$);case"undefined":return N(937,$);default:return N(617,$)}}e.$Si=j;function N(l,$){return($<<5)-$+l|0}e.$Ti=N;function A(l,$){return N(l?433:863,$)}function b(l,$){$=N(149417,$);for(let I=0,g=l.length;I<g;I++)$=N(l.charCodeAt(I),$);return $}e.$Ui=b;function u(l,$){return $=N(104579,$),l.reduce((I,g)=>j(g,I),$)}function a(l,$){return $=N(181387,$),Object.keys(l).sort().reduce((I,g)=>(I=b(g,I),j(l[g],I)),$)}class P{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=j($,this.g),this.g}}e.$Vi=P;var O;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function m(l,$,I=32){const g=I-$,w=~((1<<g)-1);return(l<<$|(w&l)>>>g)>>>0}function f(l,$=0,I=l.byteLength,g=0){for(let w=0;w<I;w++)l[$+w]=g}function E(l,$,I="0"){for(;l.length<$;)l=I+l;return l}function y(l,$=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(I=>I.toString(16).padStart(2,"0")).join(""):E((l>>>0).toString(16),$/4)}e.$Wi=y;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const I=$.length;if(I===0)return;const g=this.p;let w=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=$.charCodeAt(0),t=0);;){let i=o;if(L.$bf(o))if(t+1<I){const n=$.charCodeAt(t+1);L.$cf(n)?(t++,i=L.$df(o,n)):i=65533}else{s=o;break}else L.$cf(o)&&(i=65533);if(w=this.w(g,w,i),t++,t<I)o=$.charCodeAt(t);else break}this.r=w,this.u=s}w($,I,g){return g<128?$[I++]=g:g<2048?($[I++]=192|(g&1984)>>>6,$[I++]=128|(g&63)>>>0):g<65536?($[I++]=224|(g&61440)>>>12,$[I++]=128|(g&4032)>>>6,$[I++]=128|(g&63)>>>0):($[I++]=240|(g&1835008)>>>18,$[I++]=128|(g&258048)>>>12,$[I++]=128|(g&4032)>>>6,$[I++]=128|(g&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=d.g,I=this.q;for(let c=0;c<64;c+=4)$.setUint32(c,I.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)$.setUint32(c,m($.getUint32(c-12,!1)^$.getUint32(c-32,!1)^$.getUint32(c-56,!1)^$.getUint32(c-64,!1),1),!1);let g=this.h,w=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let c=0;c<80;c++)c<20?(i=w&s|~w&o,n=1518500249):c<40?(i=w^s^o,n=1859775393):c<60?(i=w&s|w&o|s&o,n=2400959708):(i=w^s^o,n=3395469782),r=m(g,5)+i+t+n+$.getUint32(c*4,!1)&4294967295,t=o,o=s,s=m(w,30),w=g,g=r;this.h=this.h+g&4294967295,this.l=this.l+w&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Xi=d}),define(ie[54],se([0,1,29]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(D||(D={})),function(j){const N="error",A="warning",b="warn",u="info",a="ignore";function P(m){return m?L.$0e(N,m)?j.Error:L.$0e(A,m)||L.$0e(b,m)?j.Warning:L.$0e(u,m)?j.Info:j.Ignore:j.Ignore}j.fromValue=P;function O(m){switch(m){case j.Error:return N;case j.Warning:return A;case j.Info:return u;default:return a}}j.toString=O}(D||(D={})),e.default=D}),define(ie[30],se([0,1,3]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const $=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([I,g])=>{$[I]=g&&typeof g=="object"?D(g):g}),$}e.$kn=D;function j(l){if(!l||typeof l!="object")return l;const $=[l];for(;$.length>0;){const I=$.shift();Object.freeze(I);for(const g in I)if(N.call(I,g)){const w=I[g];typeof w=="object"&&!Object.isFrozen(w)&&!(0,L.$Jf)(w)&&$.push(w)}}return l}e.$ln=j;const N=Object.prototype.hasOwnProperty;function A(l,$){return b(l,$,new Set)}e.$mn=A;function b(l,$,I){if((0,L.$Pf)(l))return l;const g=$(l);if(typeof g<"u")return g;if(Array.isArray(l)){const w=[];for(const s of l)w.push(b(s,$,I));return w}if((0,L.$If)(l)){if(I.has(l))throw new Error("Cannot clone recursive data-structure");I.add(l);const w={};for(const s in l)N.call(l,s)&&(w[s]=b(l[s],$,I));return I.delete(l),w}return l}function u(l,$,I=!0){return(0,L.$If)(l)?((0,L.$If)($)&&Object.keys($).forEach(g=>{g in l?I&&((0,L.$If)(l[g])&&(0,L.$If)($[g])?u(l[g],$[g],I):l[g]=$[g]):l[g]=$[g]}),l):$}e.$nn=u;function a(l,$){if(l===$)return!0;if(l==null||$===null||$===void 0||typeof l!=typeof $||typeof l!="object"||Array.isArray(l)!==Array.isArray($))return!1;let I,g;if(Array.isArray(l)){if(l.length!==$.length)return!1;for(I=0;I<l.length;I++)if(!a(l[I],$[I]))return!1}else{const w=[];for(g in l)w.push(g);w.sort();const s=[];for(g in $)s.push(g);if(s.sort(),!a(w,s))return!1;for(I=0;I<w.length;I++)if(!a(l[w[I]],$[w[I]]))return!1}return!0}e.$on=a;function P(l){const $=new Set;return JSON.stringify(l,(I,g)=>{if((0,L.$If)(g)||Array.isArray(g)){if($.has(g))return"[Circular]";$.add(g)}return g})}e.$pn=P;function O(l,$){const I=Object.create(null);return!l||!$||Object.keys($).forEach(w=>{const s=l[w],o=$[w];a(s,o)||(I[w]=o)}),I}e.$qn=O;function m(l,$){const I=$.toLowerCase(),g=Object.keys(l).find(w=>w.toLowerCase()===I);return g?l[g]:l[$]}e.$rn=m;function f(l,$){const I=Object.create(null);for(const[g,w]of Object.entries(l))$(g,w)&&(I[g]=w);return I}e.$sn=f;function E(l){let $=[];for(;Object.prototype!==l;)$=$.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return $}e.$tn=E;function y(l){const $=[];for(const I of E(l))typeof l[I]=="function"&&$.push(I);return $}e.$un=y;function d(l,$){const I=w=>function(){const s=Array.prototype.slice.call(arguments,0);return $(w,s)},g={};for(const w of l)g[w]=I(w);return g}e.$vn=d}),define(ie[28],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(j){return L.test(j)}e.$ng=D,e.$og=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const N=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){j(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let u=0,a="";return a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a}}()}),define(ie[74],se([0,1,33]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(A){const b=A.replace(/\-/g,":").toLowerCase();return!D.has(b)}function N(){const A=(0,L.networkInterfaces)();for(const b in A){const u=A[b];if(u){for(const{mac:a}of u)if(j(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$7m=N}),define(ie[75],se([7,5]),function(X,e){return X.create("vs/base/common/date",e)}),define(ie[76],se([0,1,75]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0;const D=60,j=D*60,N=j*24,A=N*7,b=N*30,u=N*365;function a(O,m,f,E){typeof O!="number"&&(O=O.getTime());const y=Math.round((new Date().getTime()-O)/1e3);if(y<-30)return(0,L.localize)(0,null,a(new Date().getTime()+y*1e3,!1));if(!E&&y<30)return(0,L.localize)(1,null);let d;return y<D?(d=y,m?d===1?f?(0,L.localize)(2,null,d):(0,L.localize)(3,null,d):f?(0,L.localize)(4,null,d):(0,L.localize)(5,null,d):d===1?f?(0,L.localize)(6,null,d):(0,L.localize)(7,null,d):f?(0,L.localize)(8,null,d):(0,L.localize)(9,null,d)):y<j?(d=Math.floor(y/D),m?d===1?f?(0,L.localize)(10,null,d):(0,L.localize)(11,null,d):f?(0,L.localize)(12,null,d):(0,L.localize)(13,null,d):d===1?f?(0,L.localize)(14,null,d):(0,L.localize)(15,null,d):f?(0,L.localize)(16,null,d):(0,L.localize)(17,null,d)):y<N?(d=Math.floor(y/j),m?d===1?f?(0,L.localize)(18,null,d):(0,L.localize)(19,null,d):f?(0,L.localize)(20,null,d):(0,L.localize)(21,null,d):d===1?f?(0,L.localize)(22,null,d):(0,L.localize)(23,null,d):f?(0,L.localize)(24,null,d):(0,L.localize)(25,null,d)):y<A?(d=Math.floor(y/N),m?d===1?(0,L.localize)(26,null,d):(0,L.localize)(27,null,d):d===1?(0,L.localize)(28,null,d):(0,L.localize)(29,null,d)):y<b?(d=Math.floor(y/A),m?d===1?f?(0,L.localize)(30,null,d):(0,L.localize)(31,null,d):f?(0,L.localize)(32,null,d):(0,L.localize)(33,null,d):d===1?f?(0,L.localize)(34,null,d):(0,L.localize)(35,null,d):f?(0,L.localize)(36,null,d):(0,L.localize)(37,null,d)):y<u?(d=Math.floor(y/b),m?d===1?f?(0,L.localize)(38,null,d):(0,L.localize)(39,null,d):f?(0,L.localize)(40,null,d):(0,L.localize)(41,null,d):d===1?f?(0,L.localize)(42,null,d):(0,L.localize)(43,null,d):f?(0,L.localize)(44,null,d):(0,L.localize)(45,null,d)):(d=Math.floor(y/u),m?d===1?f?(0,L.localize)(46,null,d):(0,L.localize)(47,null,d):f?(0,L.localize)(48,null,d):(0,L.localize)(49,null,d):d===1?f?(0,L.localize)(50,null,d):(0,L.localize)(51,null,d):f?(0,L.localize)(52,null,d):(0,L.localize)(53,null,d))}e.$tm=a;function P(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$um=P}),define(ie[77],se([7,5]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ie[34],se([0,1,19,3,77]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=void 0;function N(O,m){return m&&(O.stack||O.stacktrace)?j.localize(0,null,b(O),A(O.stack)||A(O.stacktrace)):b(O)}function A(O){return Array.isArray(O)?O.join(`
`):O}function b(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?j.localize(1,null,O.message):O.message||j.localize(2,null)}function u(O=null,m=!1){if(!O)return j.localize(3,null);if(Array.isArray(O)){const f=L.$Hb(O),E=u(f[0],m);return f.length>1?j.localize(4,null,E,f.length):E}if(D.$Gf(O))return O;if(O.detail){const f=O.detail;if(f.error)return N(f.error,m);if(f.exception)return N(f.exception,m)}return O.stack?N(O,m):O.message?O.message:j.localize(5,null)}e.$Oi=u;function a(O){const m=O;return m instanceof Error&&Array.isArray(m.actions)}e.$Pi=a;function P(O,m){let f;return typeof O=="string"?f=new Error(O):f=O,f.actions=m,f}e.$Qi=P}),define(ie[78],se([7,5]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ie[79],se([0,1,78]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;function D(j){switch(j){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Mp=D}),define(ie[55],se([0,1,13]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0;var D;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(D||(e.Source=D={}));var j;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function N(b,...u){const a=u.reduce((m,f)=>(m[f]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!a[m]).forEach(m=>{for(let f=0;f<P.length;f++)if(m.search(P[f])!==-1){delete b[m];break}})}e.$Pl=N;function A(b){b&&(delete b.DEBUG,L.$j&&delete b.DYLD_LIBRARY_PATH,L.$k&&delete b.LD_PRELOAD)}e.$Ql=A}),define(ie[80],se([0,1,11]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$dq=e.$cq=e.$bq=void 0;function D(a){const P=a;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$bq=D;function j(a){const P=[];let O;try{const m=JSON.parse(a.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),O=f.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",a.arguments)}return{args:P,stack:O}}e.$cq=j;function N(a){if(typeof a!="string")return N(j(a).stack);const P=a;if(P){const O=A(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$dq=N;function A(a){if(!a)return a;const P=a.indexOf(`
`);return P===-1?a:a.substring(0,P)}function b(a,P){const{args:O,stack:m}=j(a),f=typeof O[0]=="string"&&O.length===1;let E=A(m);E&&(E=`(${E.trim()})`);let y=[];if(typeof O[0]=="string"?E&&f?y=[`%c[${P}] %c${O[0]} %c${E}`,u("blue"),u(""),u("grey")]:y=[`%c[${P}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:y=[`%c[${P}]%`,u("blue"),...O],E&&!f&&y.push(E),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,y)}e.log=b;function u(a){return`color: ${a}`}}),define(ie[46],se([0,1,14,11]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function j(u){return JSON.stringify(u,A)}e.$yh=j;function N(u){let a=JSON.parse(u);return a=b(a),a}e.$zh=N;function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function b(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$he||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let P=0;P<u.length;++P)u[P]=b(u[P],a+1);else for(const P in u)Object.hasOwnProperty.call(u,P)&&(u[P]=b(u[P],a+1))}return u}e.$Ah=b}),define(ie[81],se([0,1,70,15,13,11]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=void 0;class A{constructor(m,f,E){this.id=m,this.dependencies=f,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,f,E)=>{typeof m!="string"&&(E=f,f=m,m=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new A(m,f,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const f=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!f)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(m){return new Promise((f,E)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const d=()=>{y.removeEventListener("load",l),y.removeEventListener("error",$)},l=I=>{d(),f(this.c.pop())},$=I=>{d(),E(I)};y.addEventListener("load",l),y.addEventListener("error",$),this.f&&(m=this.f.createScriptURL(m)),y.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(y)})}i(m){return new Promise((f,E)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),f(this.c.pop())}catch(y){E(y)}})}async j(m){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,d=N.URI.parse(m).fsPath,l=f.readFileSync(d).toString(),$=y.wrap(l.replace(/^#!.*/,""));return new E.Script($).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function P(O,m,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[O]&&(O=a[O]);const E=`${O}/${m}`;if(u.has(E))return u.get(E);let y;if(/^\w[\w\d+.-]*:\/\//.test(E))y=E;else{const I=`${f&&!j.$o?D.$jg:D.$ig}/${E}`;y=D.$mg.asBrowserUri(I).toString(!0)}const d=b.INSTANCE.load(y);return u.set(E,d),d}else return await new Promise((E,y)=>{X([O],E,y)})}e.$8C=P}),define(ie[82],se([0,1,33,47,28,74,13]),function(X,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=new class{c(m){return this.a||(this.a=D.$0h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,f=0;const E=(0,L.networkInterfaces)();for(const y in E){const d=E[y];if(d)for(const{mac:l,internal:$}of d)$||(f+=1,this.c(l.toUpperCase())&&(m+=1))}this.b=f>0?m/f:0}return this.b}};let b;async function u(m){return b||(b=(async()=>await a(m)||j.$og())()),b}e.$9m=u;async function a(m){try{const f=await new Promise((y,d)=>{X(["crypto"],y,d)}),E=(0,N.$7m)();return f.createHash("sha256").update(E,"utf8").digest("hex")}catch(f){m(f);return}}const P="Software\\Microsoft\\SQMClient";async function O(m){if(A.$i){const f=await new Promise((E,y)=>{X(["@vscode/windows-registry"],E,y)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(E){return m(E),""}}return""}e.$0m=O}),define(ie[83],se([0,1,33,16,24]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class O{constructor(w,s,o){this.exePath=w,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await j.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:g=!1}={}){return g?a===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:g=!1,findPreview:w=!1}={}){const s=m({useAlternateBitness:g});if(!s)return null;const o=D.$jc(s,"PowerShell");if(!await j.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const c of await j.Promises.readdir(o)){let S=-1;if(w){const p=c.indexOf("-");if(p<0)continue;const R=c.substring(0,p);if(!N.test(R)||c.substring(p+1)!=="preview")continue;S=parseInt(R,10)}else{if(!N.test(c))continue;S=parseInt(c,10)}if(S<=t)continue;const k=D.$jc(o,c,"pwsh.exe");await j.SymlinkSupport.existsFile(k)&&(i=k,t=S)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=w?" Preview":"";return new O(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const w=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await j.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=g?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await j.Promises.readdir(w))if(s.test(t)){const i=D.$jc(w,t,"pwsh.exe");return new O(i,o)}return null}function y(){const g=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new O(g,".NET Core PowerShell Global Tool")}function d(){const g=D.$jc(process.env.windir,a===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(g,"Windows PowerShell",!0)}async function*l(){let g=await f();g&&(yield g),g=await f({useAlternateBitness:!0}),g&&(yield g),g=await E(),g&&(yield g),g=y(),g&&(yield g),g=await f({findPreview:!0}),g&&(yield g),g=await E({findPreview:!0}),g&&(yield g),g=await f({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=d(),g&&(yield g)}async function*$(){for await(const g of l())await g.exists()&&(yield g)}e.$Nl=$;async function I(){for await(const g of $())return g;return null}e.$Ol=I}),define(ie[56],se([0,1,16,13,35,55,3,24]),function(X,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function u(O=j.env){return O.comspec||"cmd.exe"}e.$Rl=u;function a(O){let m=[],f=!1;const E=function(y){if(f){m.push(y);return}(!O.send(y,l=>{if(l&&console.error(l),f=!1,m.length>0){const $=m.slice(0);m=[],$.forEach(I=>E(I))}})||D.$i)&&(f=!0)};return{send:E}}e.$Sl=a;var P;(function(O){async function m(f,E,y){if(L.$ic(f))return f;if(E===void 0&&(E=j.cwd()),L.$mc(f)!=="."||(y===void 0&&A.$Gf(j.env.PATH)&&(y=j.env.PATH.split(L.$tc)),y===void 0||y.length===0))return L.$jc(E,f);async function l($){if(await b.Promises.exists($)){let I;try{I=await b.Promises.stat($)}catch(g){g.message.startsWith("EACCES")&&(I=await b.Promises.lstat($))}return I?!I.isDirectory():!1}return!1}for(const $ of y){let I;if(L.$ic($)?I=L.$jc($,f):I=L.$jc(E,$,f),await l(I))return I;let g=I+".com";if(await l(g)||(g=I+".exe",await l(g)))return g}return L.$jc(E,f)}O.findExecutable=m})(P||(e.win32=P={}))}),define(ie[84],se([0,1,33,13,83,56]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;async function A(O,m){return O===1?D.$i?P():N.$Rl(m):u(O,m)}e.$Tl=A;let b=null;function u(O,m){if(D.$k&&O===2||D.$j&&O===3)return"/bin/bash";if(!b){let f;if(D.$i)f="/bin/bash";else{if(f=m.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}b=f}return b}let a=null;async function P(){return a||(a=(await(0,j.$Ol)()).exePath),a}});var $e=this&&this.__decorate||function(X,e,L,D){var j=arguments.length,N=j<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(X,e,L,D);else for(var b=X.length-1;b>=0;b--)(A=X[b])&&(N=(j<3?A(N):j>3?A(e,L,N):A(e,L))||N);return j>3&&N&&Object.defineProperty(e,L,N),N};define(ie[57],se([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(X,e,L,D,j,N,A,b,u,a,P,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.ProxyChannel=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.RequestInitiator=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f||(f={}));function E(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(y||(y={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));function $(M){let C=0;for(let H=0;;H+=7){const J=M.read(1);if(C|=(J.buffer[0]&127)<<H,!(J.buffer[0]&128))return C}}const I=t(0);function g(M,C){if(C===0){M.write(I);return}let H=0;for(let Y=C;Y!==0;Y=Y>>>7)H++;const J=j.$he.alloc(H);for(let Y=0;C!==0;Y++)J.buffer[Y]=C&127,C=C>>>7,C>0&&(J.buffer[Y]|=128);M.write(J)}class w{constructor(C){this.b=C,this.a=0}read(C){const H=this.b.slice(this.a,this.a+C);return this.a+=H.byteLength,H}}e.$Bh=w;class s{constructor(){this.a=[]}get buffer(){return j.$he.concat(this.a)}write(C){this.a.push(C)}}e.$Ch=s;var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(o||(o={}));function t(M){const C=j.$he.alloc(1);return C.writeUInt8(M,0),C}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(M,C){if(typeof C>"u")M.write(i.Undefined);else if(typeof C=="string"){const H=j.$he.fromString(C);M.write(i.String),g(M,H.byteLength),M.write(H)}else if(n&&Buffer.isBuffer(C)){const H=j.$he.wrap(C);M.write(i.Buffer),g(M,H.byteLength),M.write(H)}else if(C instanceof j.$he)M.write(i.VSBuffer),g(M,C.byteLength),M.write(C);else if(Array.isArray(C)){M.write(i.Array),g(M,C.length);for(const H of C)r(M,H)}else if(typeof C=="number"&&(C|0)===C)M.write(i.Uint),g(M,C);else{const H=j.$he.fromString(JSON.stringify(C));M.write(i.Object),g(M,H.byteLength),M.write(H)}}e.$Dh=r;function c(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read($(M)).toString();case o.Buffer:return M.read($(M)).buffer;case o.VSBuffer:return M.read($(M));case o.Array:{const H=$(M),J=[];for(let Y=0;Y<H;Y++)J.push(c(M));return J}case o.Object:return JSON.parse(M.read($(M)).toString());case o.Int:return $(M)}}e.$Eh=c;class S{constructor(C,H,J=null,Y=1e3){this.h=C,this.j=H,this.k=J,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(C,H){this.b.set(C,H),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const H=this.o([C.type]);this.k?.logOutgoing(H,0,1,d(C.type));return}case 201:case 202:case 204:case 203:{const H=this.o([C.type,C.id],C.data);this.k?.logOutgoing(H,C.id,1,d(C.type),C.data);return}}}o(C,H=void 0){const J=new s;return r(J,C),r(J,H),this.p(J.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const H=new w(C),J=c(H),Y=c(H),K=J[0];switch(K){case 100:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}: ${J[2]}.${J[3]}`,Y),this.s({type:K,id:J[1],channelName:J[2],name:J[3],arg:Y});case 102:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}: ${J[2]}.${J[3]}`,Y),this.t({type:K,id:J[1],channelName:J[2],name:J[3],arg:Y});case 101:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}`),this.u({type:K,id:J[1]});case 103:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}`),this.u({type:K,id:J[1]})}}s(C){const H=this.b.get(C.channelName);if(!H){this.v(C);return}const J=new N.$4d;let Y;try{Y=H.call(this.j,C.name,C.arg,J.token)}catch(F){Y=Promise.reject(F)}const K=C.id;Y.then(F=>{this.m({id:K,data:F,type:201})},F=>{F instanceof Error?this.m({id:K,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:K,data:F,type:203})}).finally(()=>{T.dispose(),this.d.delete(C.id)});const T=(0,a.$Rc)(()=>J.cancel());this.d.set(C.id,T)}t(C){const H=this.b.get(C.channelName);if(!H){this.v(C);return}const J=C.id,K=H.listen(this.j,C.name,C.arg)(T=>this.m({id:J,data:T,type:204}));this.d.set(C.id,K)}u(C){const H=this.d.get(C.id);H&&(H.dispose(),this.d.delete(C.id))}v(C){let H=this.g.get(C.channelName);H||(H=[],this.g.set(C.channelName,H));const J=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:C,timeoutTimer:J})}w(C){const H=this.g.get(C);if(H){for(const J of H)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Fh=S;var k;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class p{constructor(C,H=null){this.l=C,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Td,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=H}getChannel(C){const H=this;return{call(J,Y,K){return H.a?Promise.reject(new b.$5):H.m(C,J,Y,K)},listen(J,Y){return H.a?u.Event.None:H.o(C,J,Y)}}}m(C,H,J,Y=N.CancellationToken.None){const K=this.g++,F={id:K,type:100,channelName:C,name:H,arg:J};if(Y.isCancellationRequested)return Promise.reject(new b.$5);let h;return new Promise((z,U)=>{if(Y.isCancellationRequested)return U(new b.$5);const W=()=>{const fe=ge=>{switch(ge.type){case 201:this.f.delete(K),z(ge.data);break;case 202:{this.f.delete(K);const we=new Error(ge.data.message);we.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,we.name=ge.data.name,U(we);break}case 203:this.f.delete(K),U(ge.data);break}};this.f.set(K,fe),this.p(F)};let G=null;this.b===l.Idle?W():(G=(0,D.$Rg)(fe=>this.u()),G.then(()=>{G=null,W()}));const ee=()=>{G?(G.cancel(),G=null):this.p({id:K,type:101}),U(new b.$5)},ue=Y.onCancellationRequested(ee);h=(0,a.$Qc)((0,a.$Rc)(ee),ue),this.d.add(h)}).finally(()=>{h.dispose(),this.d.delete(h)})}o(C,H,J){const Y=this.g++,T={id:Y,type:102,channelName:C,name:H,arg:J};let F=null;const h=new u.$Td({onWillAddFirstListener:()=>{F=(0,D.$Rg)(z=>this.u()),F.then(()=>{F=null,this.d.add(h),this.p(T)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(h),this.p({id:Y,type:103}))}}),v=z=>h.fire(z.data);return this.f.set(Y,v),h.event}p(C){switch(C.type){case 100:case 102:{const H=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(H,C.id,0,`${E(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const H=this.q([C.type,C.id]);this.j?.logOutgoing(H,C.id,0,E(C.type));return}}}q(C,H=void 0){const J=new s;return r(J,C),r(J,H),this.r(J.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const H=new w(C),J=c(H),Y=c(H),K=J[0];switch(K){case 200:return this.j?.logIncoming(C.byteLength,0,0,d(K)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,J[1],0,d(K),Y),this.t({type:J[0],id:J[1],data:Y})}}t(C){if(C.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=p,$e([A.$vh],p.prototype,"onDidInitializePromise",null);class R{get connections(){const C=[];return this.f.forEach(H=>C.push(H)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new u.$Td,this.onDidAddConnection=this.g.event,this.h=new u.$Td,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(C(({protocol:H,onDidClientDisconnect:J})=>{const Y=u.Event.once(H.onMessage);this.j.add(Y(K=>{const T=new w(K),F=c(T),h=new S(H,F),v=new p(H);this.a.forEach((U,W)=>h.registerChannel(W,U));const z={channelServer:h,channelClient:v,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(J(()=>{h.dispose(),v.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(C,H){const J=this;return{call(Y,K,T){let F;if((0,m.$Uf)(H)){const v=(0,L.$4b)(J.connections.filter(H));F=v?Promise.resolve(v):u.Event.toPromise(u.Event.filter(J.onDidAddConnection,H))}else F=H.routeCall(J,Y,K);const h=F.then(v=>v.channelClient.getChannel(C));return te(h).call(Y,K,T)},listen(Y,K){if((0,m.$Uf)(H))return J.k(C,H,Y,K);const T=H.routeEvent(J,Y,K).then(F=>F.channelClient.getChannel(C));return te(T).listen(Y,K)}}}k(C,H,J,Y){const K=this;let T;const F=new u.$Td({onWillAddFirstListener:()=>{T=new a.$Sc;const h=new u.$Zd,v=new Map,z=W=>{const ee=W.channelClient.getChannel(C).listen(J,Y),ue=h.add(ee);v.set(W,ue)},U=W=>{const G=v.get(W);G&&(G.dispose(),v.delete(W))};K.connections.filter(H).forEach(z),u.Event.filter(K.onDidAddConnection,H)(z,void 0,T),K.onDidRemoveConnection(U,void 0,T),h.event(F.fire,F,T),T.add(h)},onDidRemoveLastListener:()=>{T?.dispose(),T=void 0}});return F.event}registerChannel(C,H){this.a.set(C,H);for(const J of this.f)J.channelServer.registerChannel(C,H)}dispose(){this.j.dispose();for(const C of this.f)C.channelClient.dispose(),C.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Hh=R;class V{constructor(C,H,J=null){const Y=new s;r(Y,H),C.send(Y.buffer),this.a=new p(C,J),this.d=new S(C,H,J)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,H){this.d.registerChannel(C,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ih=V;function te(M){return{call(C,H,J){return M.then(Y=>Y.call(C,H,J))},listen(C,H){const J=new u.$3d;return M.then(Y=>J.input=Y.listen(C,H)),J.event}}}e.$Jh=te;function x(M){let C=!1;return{call(H,J,Y){return C?M.call(H,J,Y):(0,D.$5g)(0).then(()=>C=!0).then(()=>M.call(H,J,Y))},listen(H,J){if(C)return M.listen(H,J);const Y=new u.$3d;return(0,D.$5g)(0).then(()=>C=!0).then(()=>Y.input=M.listen(H,J)),Y.event}}}e.$Kh=x;class oe{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const H of C.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$Lh=oe;var re;(function(M){function C(K,T,F){const h=K,v=F&&F.disableMarshalling,z=new Map;for(const U in h)J(U)&&z.set(U,u.Event.buffer(h[U],!0,void 0,T));return new class{listen(U,W,G){const ee=z.get(W);if(ee)return ee;if(Y(W)){const ue=h[W];if(typeof ue=="function")return ue.call(h,G)}throw new b.$bb(`Event not found: ${W}`)}call(U,W,G){const ee=h[W];if(typeof ee=="function"){if(!v&&Array.isArray(G))for(let fe=0;fe<G.length;fe++)G[fe]=(0,P.$Ah)(G[fe]);let ue=ee.apply(h,G);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new b.$bb(`Method not found: ${W}`)}}}M.fromService=C;function H(K,T){const F=T&&T.disableMarshalling;return new Proxy({},{get(h,v){if(typeof v=="string")return T?.properties?.has(v)?T.properties.get(v):Y(v)?function(z){return K.listen(v,z)}:J(v)?K.listen(v):async function(...z){let U;T&&!(0,m.$Pf)(T.context)?U=[T.context,...z]:U=z;const W=await K.call(v,U);return F?W:(0,P.$Ah)(W)};throw new b.$bb(`Property not found: ${String(v)}`)}})}M.toService=H;function J(K){return K[0]==="o"&&K[1]==="n"&&O.$9e(K.charCodeAt(2))}function Y(K){return/^onDynamic/.test(K)&&O.$9e(K.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const C=M.toString();if(C!=="[object Object]")return C}return M}function ae(M){return Array.isArray(M)?M.map(ce):ce(M)}function B(M,C,H,J,Y,K,T){T=ae(T);const F=he[Y],h=F[J%F.length];let v=[`%c[${M}]%c[${String(C).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(K)?(v=v.concat(T),v.push(")")):v.push(T),console.log.apply(console,v)}class Q{constructor(C,H){this.d=C,this.f=H,this.a=0,this.b=0}logOutgoing(C,H,J,Y,K){this.b+=C,B(this.d,this.b,C,H,J,Y,K)}logIncoming(C,H,J,Y,K){this.a+=C,B(this.f,this.a,C,H,J,Y,K)}}e.$Mh=Q}),define(ie[85],se([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class E extends f.$Fh{constructor(l){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",$=>j.$he.wrap(Buffer.from($,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$fq=E;class y{constructor(l,$){this.i=l,this.j=$,this.c=new Set,this.g=new Map,this.h=new u.$Td,this.onDidProcessExit=this.h.event;const I=$&&$.timeout?$.timeout:6e4;this.b=new D.$1g(I),this.d=null,this.f=null}getChannel(l){const $=this;return{call(I,g,w){return $.k(l,I,g,w)},listen(I,g){return $.l(l,I,g)}}}k(l,$,I,g=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const w=this.n(l),s=(0,D.$Rg)(i=>w.call($,I,i)),o=g.onCancellationRequested(()=>s.cancel()),t=(0,a.$Rc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,$,I){if(!this.b)return u.Event.None;this.b.cancel();let g;const w=new u.$Td({onWillAddFirstListener:()=>{g=this.n(l).listen($,I)(w.fire,w),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return w.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,P.$kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,m.$Ql)($.env),this.d=(0,L.fork)(this.i,l,$);const I=new u.$Td;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$bq)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(j.$he.wrap(Buffer.from(n,"base64")))});const w=this.j.useQueue?(0,O.$Sl)(this.d):this.d,s=n=>this.d&&this.d.connected&&w.send(n.buffer.toString("base64")),o=I.event,t={send:s,onMessage:o};this.f=new f.$Gh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,a.$Oc)(c)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(l){let $=this.g.get(l);return $||($=this.m.getChannel(l),this.g.set(l,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gq=y}),define(ie[86],se([0,1,8,4,2,46,3]),function(X,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.StorageState=e.$ep=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function u(m){const f=m;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$ep=u;var a;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(a||(e.StorageState=a={}));class P extends j.$Tc{static{this.a=100}constructor(f,E=Object.create(null)){super(),this.r=f,this.s=E,this.b=this.B(new D.$Wd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new L.$2g(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((E,y)=>this.w(y,E)),f.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(f,E){if(this.c===a.Closed)return;let y=!1;(0,A.$Pf)(E)?y=this.f.delete(f):this.f.get(f)!==E&&(this.f.set(f,E),y=!0),y&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,E){const y=this.f.get(f);return(0,A.$Pf)(y)?E:y}getBoolean(f,E){const y=this.get(f);return(0,A.$Pf)(y)?E:y==="true"}getNumber(f,E){const y=this.get(f);return(0,A.$Pf)(y)?E:parseInt(y,10)}getObject(f,E){const y=this.get(f);return(0,A.$Pf)(y)?E:(0,N.$zh)(y)}async set(f,E,y=!1){if(this.c===a.Closed)return;if((0,A.$Pf)(E))return this.delete(f,y);const d=(0,A.$If)(E)||Array.isArray(E)?(0,N.$yh)(E):String(E);if(this.f.get(f)!==d)return this.f.set(f,d),this.j.set(f,d),this.h.delete(f),this.b.fire({key:f,external:y}),this.D()}async delete(f,E=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:E}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$fp=P;class O{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((E,y)=>this.a.set(y,E)),f.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$gp=O}),define(ie[87],se([7,5]),function(X,e){return X.create("vs/base/node/zip",e)}),define(ie[48],se([0,1,88,8,16,3,24,87]),function(X,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.zip=e.$Bp=e.$Ap=void 0,e.$Ap="end of central directory record signature not found";const u=new RegExp(e.$Ap);class a extends Error{constructor(w,s){let o=s.message;switch(w){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=w,this.cause=s}}e.$Bp=a;function P(g){const w=g.externalFileAttributes>>16||33188;return[448,56,7].map(s=>w&s).reduce((s,o)=>s+o,w&61440)}function O(g){if(g instanceof a)return g;let w;return u.test(g.message)&&(w="CorruptZip"),new a(w,g)}function m(g,w,s,o,t,i){const n=j.$mc(w),r=j.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(b.localize(0,null,w)));const c=j.$jc(o,w);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(A.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((k,p)=>{if(!i.isCancellationRequested)try{S=(0,L.createWriteStream)(c,{mode:s}),S.once("close",()=>k()),S.once("error",p),g.once("error",p),g.pipe(S)}catch(R){p(R)}}))}function f(g,w,s,o){let t=(0,D.$Rg)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),g.close()});return new Promise((r,c)=>{const S=new D.$Yg,k=p=>{p.isCancellationRequested||(i++,g.readEntry())};g.once("error",c),g.once("close",()=>t.then(()=>{o.isCancellationRequested||g.entryCount===i?r():c(new a("Incomplete",new Error(b.localize(1,null,i,g.entryCount))))},c)),g.readEntry(),g.on("entry",p=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(p.fileName)){k(o);return}const R=p.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(R)){const x=j.$jc(w,R);t=(0,D.$Rg)(oe=>A.Promises.mkdir(x,{recursive:!0}).then(()=>k(oe)).then(void 0,c));return}const V=y(g,p),te=P(p);t=(0,D.$Rg)(x=>S.queue(()=>V.then(oe=>m(oe,R,te,w,s,x).then(()=>k(x)))).then(null,c))})}).finally(()=>n.dispose())}async function E(g,w=!1){const{open:s}=await new Promise((o,t)=>{X(["yauzl"],o,t)});return new Promise((o,t)=>{s(g,w?{lazyEntries:!0}:void 0,(i,n)=>{i?t(O(i)):o((0,N.$Rf)(n))})})}function y(g,w){return new Promise((s,o)=>{g.openReadStream(w,(t,i)=>{t?o(O(t)):s((0,N.$Rf)(i))})})}async function d(g,w){const{ZipFile:s}=await new Promise((o,t)=>{X(["yazl"],o,t)});return new Promise((o,t)=>{const i=new s;w.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,L.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(g))})}e.zip=d;function l(g,w,s={},o){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=E(g,!0);return s.overwrite&&(i=i.then(n=>A.Promises.rm(w).then(()=>n))),i.then(n=>f(n,w,{sourcePathRegex:t},o))}e.$Dp=l;function $(g,w){return E(g).then(s=>new Promise((o,t)=>{s.on("entry",i=>{i.fileName===w&&y(s,i).then(n=>o(n),n=>t(n))}),s.once("close",()=>t(new Error(b.localize(2,null,w))))}))}function I(g,w){return $(g,w).then(s=>new Promise((o,t)=>{const i=[];s.once("error",t),s.on("data",n=>i.push(n)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$Ep=I}),define(ie[89],se([7,5]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[90],se([7,5]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[91],se([7,5]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ie[92],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[93],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[94],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[95],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[96],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[97],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[98],se([7,5]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[99],se([7,5]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[100],se([7,5]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ie[101],se([7,5]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ie[102],se([7,5]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[103],se([7,5]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[104],se([7,5]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ie[105],se([7,5]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ie[106],se([7,5]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[107],se([7,5]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[108],se([7,5]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ie[109],se([0,1,9,91]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.TokenType=void 0;var j;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(j||(e.TokenType=j={}));function N(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),b=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const O=this.d,m=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:m};this.g.push({offset:O,lexeme:m,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const O=this.c.substring(this.d,this.e),m=u.b.get(O);m?this.k(m):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,O=!1,m=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(b);return}const E=this.c.charCodeAt(P);if(O)O=!1;else if(E===47&&!m){P++;break}else E===91?m=!0:E===92?O=!0:E===93&&(m=!1);P++}for(;P<this.c.length&&u.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Yi=u}),define(ie[110],se([0,1,76,52,15,16,35,17,11]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$vm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(j.$mg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.$Fg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$Fg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$Fg)(u.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$Fg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$Fg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$Fg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.$jc)(f,"argv.json")):(0,b.$Fg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.$kc)(f):(0,N.$hc)((0,N.$jc)(j.$mg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,N.$kc)(f)):u.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.$kc)(f);const E=A.env.VSCODE_EXTENSIONS;if(E)return E;const y=A.env.VSCODE_PORTABLE;return y?(0,N.$jc)(y,"extensions"):(0,b.$Fg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(E=>/^[^:/?#]+?:\/\//.test(E)?u.URI.parse(E):u.URI.file((0,N.$hc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,N.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$vm.test(f))}get extensionLogLevel(){const f=[];for(const E of this.args.log||[]){const y=e.$vm.exec(E);y&&y[1]&&y[2]&&f.push([y[1],y[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,b.$Fg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.$jc)(f,"policy.json")):(0,b.$Fg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,E,y){this.a=f,this.b=E,this.c=y,this.editSessionId=this.args.editSessionId}}e.$wm=a,$e([D.$vh],a.prototype,"appRoot",null),$e([D.$vh],a.prototype,"userHome",null),$e([D.$vh],a.prototype,"userDataPath",null),$e([D.$vh],a.prototype,"appSettingsHome",null),$e([D.$vh],a.prototype,"tmpDir",null),$e([D.$vh],a.prototype,"cacheHome",null),$e([D.$vh],a.prototype,"stateResource",null),$e([D.$vh],a.prototype,"userRoamingDataHome",null),$e([D.$vh],a.prototype,"userDataSyncHome",null),$e([D.$vh],a.prototype,"sync",null),$e([D.$vh],a.prototype,"machineSettingsResource",null),$e([D.$vh],a.prototype,"workspaceStorageHome",null),$e([D.$vh],a.prototype,"localHistoryHome",null),$e([D.$vh],a.prototype,"keyboardLayoutResource",null),$e([D.$vh],a.prototype,"argvResource",null),$e([D.$vh],a.prototype,"isExtensionDevelopment",null),$e([D.$vh],a.prototype,"untitledWorkspacesHome",null),$e([D.$vh],a.prototype,"builtinExtensionsPath",null),$e([D.$vh],a.prototype,"extensionsPath",null),$e([D.$vh],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$vh],a.prototype,"extensionDevelopmentKind",null),$e([D.$vh],a.prototype,"extensionTestsLocationURI",null),$e([D.$vh],a.prototype,"debugExtensionHost",null),$e([D.$vh],a.prototype,"logLevel",null),$e([D.$vh],a.prototype,"extensionLogLevel",null),$e([D.$vh],a.prototype,"serviceMachineIdResource",null),$e([D.$vh],a.prototype,"disableTelemetry",null),$e([D.$vh],a.prototype,"disableWorkspaceTrust",null),$e([D.$vh],a.prototype,"useInMemorySecretStorage",null),$e([D.$vh],a.prototype,"policyFile",null);function P(m,f){return O(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.$xm=P;function O(m,f,E,y,d,l){const I=Number(f||m)||(y?null:E),g=I?!!f:!1;let w;if(l)try{w=JSON.parse(l)}catch{}return{port:I,break:g,debugId:d,env:w}}e.$ym=O}),function(){"use strict";function X(e,L,D){function j(A,b){const u=N(A,b),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function N(A,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,b);const P=A["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(O,"AppData","Roaming")}break;case"darwin":a=e.join(L.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,b)}return{getUserDataPath:j}}if(typeof define=="function")define(ie[111],se([165,33,35]),function(e,L,D){return X(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=X(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[112],se([0,1,33,110,111]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=void 0;class N extends D.$wm{constructor(a,P){super(a,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,j.getUserDataPath)(a,P.nameShort)},P)}}e.$zm=N;function A(u,a){return(0,D.$ym)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$Am=A;function b(u,a){return(0,D.$ym)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$Bm=b}),define(ie[113],se([0,1,3,95]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;function j(A,b,u,a){try{N(A,b,u,a)}catch(P){A.error(P?.message??P)}return b}e.$Np=j;function N(A,b,u,a){const P=(O,m,f)=>{const E=O[m];if((0,L.$Gf)(E)){const y=E,d=y.length;if(d>1&&y[0]==="%"&&y[d-1]==="%"){const l=y.substr(1,d-2);let $=u[l];$===void 0&&a&&($=a[l]);const I=typeof $=="string"?$:$?.message,g=a?.[l],w=typeof g=="string"?g:g?.message;if(!I){w||A.warn(`[${b.name}]: ${(0,D.localize)(0,null,l)}`);return}if(f&&(m==="title"||m==="category")&&w&&w!==I){const s={value:I,original:w};O[m]=s}else O[m]=I}}else if((0,L.$If)(E))for(const y in E)E.hasOwnProperty(y)&&(y==="commands"?P(E,y,!0):P(E,y,f));else if(Array.isArray(E))for(let y=0;y<E.length;y++)P(E,y,f)};for(const O in b)b.hasOwnProperty(O)&&P(b,O)}}),define(ie[114],se([0,1,48,98]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;function j(N){return(0,L.$Ep)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Vp=j}),define(ie[49],se([0,1,17,54,99,42]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(l){return l=l.trim(),l==="*"||A.test(l)}e.$2o=u;function a(l){if(!u(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=l.match(A);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}e.$3o=a;function P(l){if(!l)return null;const $=l.majorBase,I=l.majorMustEqual,g=l.minorBase;let w=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&($===0||(w=!1),o=!1);let t=0;if(l.preRelease){const i=b.exec(l.preRelease);if(i){const[,n,r,c]=i;t=Date.UTC(Number(n),Number(r)-1,Number(c))}}return{majorBase:$,majorMustEqual:I,minorBase:g,minorMustEqual:w,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:t}}e.$4o=P;function O(l,$,I){let g;typeof l=="string"?g=P(a(l)):g=l;let w;$ instanceof Date?w=$.getTime():typeof $=="string"&&(w=new Date($).getTime());let s;if(typeof I=="string"?s=P(a(I)):s=I,!g||!s)return!1;const o=g.majorBase,t=g.minorBase,i=g.patchBase;let n=s.majorBase,r=s.minorBase,c=s.patchBase;const S=s.notBefore;let k=s.majorMustEqual,p=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||w&&w<S?!1:i>=c:(o===1&&n===0&&(!k||!p||!R)&&(n=1,r=0,c=0,k=!0,p=!1,R=!1),o<n?!1:o>n?!k:t<r?!1:t>r?!p:i<c?!1:i>c?!R:!(w&&w<S))}e.$5o=O;function m(l,$,I,g,w){const s=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return s.push([D.default.Error,j.localize(0,null)]),s;if(typeof g.name!="string")return s.push([D.default.Error,j.localize(1,null,"name")]),s;if(typeof g.version!="string")return s.push([D.default.Error,j.localize(2,null,"version")]),s;if(!g.engines)return s.push([D.default.Error,j.localize(3,null,"engines")]),s;if(typeof g.engines.vscode!="string")return s.push([D.default.Error,j.localize(4,null,"engines.vscode")]),s;if(typeof g.extensionDependencies<"u"&&!d(g.extensionDependencies))return s.push([D.default.Error,j.localize(5,null,"extensionDependencies")]),s;if(typeof g.activationEvents<"u"){if(!d(g.activationEvents))return s.push([D.default.Error,j.localize(6,null,"activationEvents")]),s;if(typeof g.main>"u"&&typeof g.browser>"u")return s.push([D.default.Error,j.localize(7,null,"activationEvents","main","browser")]),s}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&s.push([D.default.Warning,j.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return s.push([D.default.Error,j.localize(9,null,"main")]),s;{const i=(0,L.$Fg)(I,g.main);(0,L.$zg)(i,I)||s.push([D.default.Warning,j.localize(10,null,i.path,I.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return s.push([D.default.Error,j.localize(11,null,"browser")]),s;{const i=(0,L.$Fg)(I,g.browser);(0,L.$zg)(i,I)||s.push([D.default.Warning,j.localize(12,null,i.path,I.path)])}}if(!N.valid(g.version))return s.push([D.default.Error,j.localize(13,null)]),s;const o=[];if(!f(l,$,g,w,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$6o=m;function f(l,$,I,g,w){return g||typeof I.main>"u"&&typeof I.browser>"u"?!0:y(l,$,I.engines.vscode,w)}e.$7o=f;function E(l,$,I){return l==="*"||y($,I,l)}e.$8o=E;function y(l,$,I,g=[]){const w=P(a(I));if(!w)return g.push(j.localize(14,null,I)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return g.push(j.localize(15,null,I)),!1}else if(!w.majorMustEqual)return g.push(j.localize(16,null,I)),!1;return O(l,$,w)?!0:(g.push(j.localize(17,null,l,I)),!1)}function d(l){if(!Array.isArray(l))return!1;for(let $=0,I=l.length;$<I;$++)if(typeof l[$]!="string")return!1;return!0}}),define(ie[115],se([0,1,14,28]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function j(N,A,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const P=(await A.readFile(N.serviceMachineIdResource)).value.toString();u=(0,D.$ng)(P)?P:null}catch{u=null}if(!u){u=(0,D.$og)();try{await A.writeFile(N.serviceMachineIdResource,L.$he.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.$pp=j}),define(ie[50],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class L{constructor(j,N=[],A=!1){this.ctor=j,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$1h=L}),define(ie[116],se([0,1,50]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.InstantiationType=void 0;const D=[];var j;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function N(b,u,a){u instanceof L.$1h||(u=new L.$1h(u,[],!!a)),D.push([b,u])}e.$Nr=N;function A(){return D}e.$Or=A}),define(ie[117],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;class L{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rq=L;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const b=this.lookupOrInsertNode(N),u=this.lookupOrInsertNode(A);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let b=this.a.get(A);return b||(b=new L(A,N),this.a.set(A,b)),b}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,b]of this.a)N.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const b=new Set([N]),u=this.c(A,b);if(u)return u}}c(N,A){for(const[b,u]of N.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const a=this.c(u,A);if(a)return a;A.delete(b)}}}e.$sq=D}),define(ie[25],se([0,1,3,11,10]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.ConfigurationTarget=e.$zi=e.$yi=e.$xi=void 0,e.$xi=(0,j.$4h)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.$yi=N;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}e.$zi=A;var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function u(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ai=u;function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Bi=a;function P(l,$){const I=Object.create(null);for(const g in l)O(I,g,l[g],$);return I}e.$Ci=P;function O(l,$,I,g){const w=$.split("."),s=w.pop();let o=l;for(let t=0;t<w.length;t++){const i=w[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${$} as ${w.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=I}catch{g(`Ignoring ${$} as ${w.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${$} as ${w.join(".")} is ${JSON.stringify(o)}`)}e.$Di=O;function m(l,$){const I=$.split(".");f(l,I)}e.$Ei=m;function f(l,$){const I=$.shift();if($.length===0){delete l[I];return}if(Object.keys(l).indexOf(I)!==-1){const g=l[I];typeof g=="object"&&!Array.isArray(g)&&(f(g,$),Object.keys(g).length===0&&delete l[I])}}function E(l,$,I){function g(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const w=$.split("."),s=g(l,w);return typeof s>"u"?I:s}e.$Fi=E;function y(l,$,I){Object.keys($).forEach(g=>{g!=="__proto__"&&(g in l?L.$If(l[g])&&L.$If($[g])?y(l[g],$[g],I):I&&(l[g]=$[g]):l[g]=$[g])})}e.$Gi=y;function d(l){return l.replace(/[\[\]]/g,"")}e.$Hi=d}),define(ie[118],se([0,1,13,29,109,10,90,9]),function(X,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.ContextKeyExprType=e.$Zi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function a(F,h){if(u.get(F)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,h)}e.$Zi=a;const P=Object.prototype.hasOwnProperty;var O;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const m={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),E=(0,A.localize)(1,null),y=(0,A.localize)(2,null),d=(0,A.localize)(3,null),l=(0,A.localize)(4,null),$=(0,A.localize)(5,null),I=(0,A.localize)(6,null),g=(0,A.localize)(7,null);class w{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(h=m){this.k=h,this.d=new j.$Yi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(h){if(h===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(h).scan(),this.g=0,this.h=[];try{const v=this.l();if(!this.E()){const z=this.D(),U=z.type===17?$:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:j.$Yi.getLexeme(z),additionalInfo:U}),w.c}return v}catch(v){if(v!==w.c)throw v;return}}l(){return this.m()}m(){const h=[this.o()];for(;this.y(16);){const v=this.o();h.push(v)}return h.length===1?h[0]:s.or(...h)}o(){const h=[this.s()];for(;this.y(15);){const v=this.s();h.push(v)}return h.length===1?h[0]:s.and(...h)}s(){if(this.y(2)){const h=this.D();switch(h.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const v=this.l();return this.A(1,d),v?.negate()}case 17:return this.z(),V.create(h.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",h)}}return this.t()}t(){const h=this.D();switch(h.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const v=this.l();return this.A(1,d),v}case 17:{const v=h.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const W=U.lexeme,G=W.lastIndexOf("/"),ee=G===W.length-1?void 0:this.w(W.substring(G+1));let ue;try{ue=new RegExp(W.substring(1,G),ee)}catch{throw this.B("REGEX",U)}return ce.create(v,ue)}switch(U.type){case 10:case 19:{const W=[U.lexeme];this.z();let G=this.D(),ee=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?ee++:U.lexeme.charCodeAt(de)===41&&ee--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?ee++:U.lexeme.charCodeAt(de)===41&&ee--}if(ee<0)break;W.push(j.$Yi.getLexeme(G)),this.z(),G=this.D()}const ue=W.join(""),fe=ue.lastIndexOf("/"),ge=fe===ue.length-1?void 0:this.w(ue.substring(fe+1));let we;try{we=new RegExp(ue.substring(1,fe),ge)}catch{throw this.B("REGEX",U)}return s.regex(v,we)}case 18:{const W=U.lexeme;this.z();let G=null;if(!(0,D.$He)(W)){const ee=W.indexOf("/"),ue=W.lastIndexOf("/");if(ee!==ue&&ee>=0){const fe=W.slice(ee+1,ue),ge=W[ue+1]==="i"?"i":"";try{G=new RegExp(fe,ge)}catch{throw this.B("REGEX",U)}}}if(G===null)throw this.B("REGEX",U);return ce.create(v,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const U=this.u();return s.notIn(v,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return s.equals(v,U);switch(U){case"true":return s.has(v);case"false":return s.not(v);default:return s.equals(v,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return s.notEquals(v,U);switch(U){case"true":return s.not(v);case"false":return s.has(v);default:return s.notEquals(v,U)}}case 5:return this.z(),re.create(v,this.u());case 6:return this.z(),he.create(v,this.u());case 7:return this.z(),x.create(v,this.u());case 8:return this.z(),oe.create(v,this.u());case 13:return this.z(),s.in(v,this.u());default:return s.has(v)}}case 20:throw this.h.push({message:I,offset:h.offset,lexeme:"",additionalInfo:g}),w.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const h=this.D();switch(h.type){case 17:case 18:return this.z(),h.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(h){return h.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(h){return this.C(h)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(h,v){if(this.C(h))return this.z();throw this.B(v,this.D())}B(h,v,z){const U=(0,A.localize)(8,null,h,j.$Yi.getLexeme(v)),W=v.offset,G=j.$Yi.getLexeme(v);return this.h.push({message:U,offset:W,lexeme:G,additionalInfo:z}),w.c}C(h){return this.D().type===h}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$1i=w;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(h){return c.create(h)}static equals(h,v){return S.create(h,v)}static notEquals(h,v){return R.create(h,v)}static regex(h,v){return ce.create(h,v)}static in(h,v){return k.create(h,v)}static notIn(h,v){return p.create(h,v)}static not(h){return V.create(h)}static and(...h){return Q.create(h,null,!0)}static or(...h){return M.create(h,null,!0)}static greater(h,v){return x.create(h,v)}static greaterEquals(h,v){return oe.create(h,v)}static smaller(h,v){return re.create(h,v)}static smallerEquals(h,v){return he.create(h,v)}static{this.c=new w({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this.c.parse(h)}}e.$2i=s;function o(F){const h=new w({regexParsingWithErrorRecovery:!1});return F.map(v=>(h.parse(v),h.lexingErrors.length>0?h.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$3i=o;function t(F,h){const v=F?F.substituteConstants():void 0,z=h?h.substituteConstants():void 0;return!v&&!z?!0:!v||!z?!1:v.equals(z)}e.$4i=t;function i(F,h){return F.cmp(h)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return r.INSTANCE}}e.$5i=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return n.INSTANCE}}e.$6i=r;class c{static create(h,v=null){const z=u.get(h);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new c(h,v)}constructor(h,v){this.key=h,this.c=v,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:H(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=u.get(this.key);return typeof h=="boolean"?h?r.INSTANCE:n.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.c||(this.c=V.create(this.key,this)),this.c}}e.$7i=c;class S{static create(h,v,z=null){if(typeof v=="boolean")return v?c.create(h,z):V.create(h,z);const U=u.get(h);return typeof U=="boolean"?v===(U?"true":"false")?r.INSTANCE:n.INSTANCE:new S(h,v,z)}constructor(h,v,z){this.c=h,this.d=v,this.f=z,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){const h=u.get(this.c);if(typeof h=="boolean"){const v=h?"true":"false";return this.d===v?r.INSTANCE:n.INSTANCE}return this}evaluate(h){return h.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(h){return h.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$8i=S;class k{static create(h,v){return new k(h,v)}constructor(h,v){this.d=h,this.f=v,this.type=10,this.c=null}cmp(h){return h.type!==this.type?this.type-h.type:J(this.d,this.f,h.d,h.f)}equals(h){return h.type===this.type?this.d===h.d&&this.f===h.f:!1}substituteConstants(){return this}evaluate(h){const v=h.getValue(this.f),z=h.getValue(this.d);return Array.isArray(v)?v.includes(z):typeof z=="string"&&typeof v=="object"&&v!==null?P.call(v,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(h){return h.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$9i=k;class p{static create(h,v){return new p(h,v)}constructor(h,v){this.d=h,this.f=v,this.type=11,this.c=k.create(h,v)}cmp(h){return h.type!==this.type?this.type-h.type:this.c.cmp(h.c)}equals(h){return h.type===this.type?this.c.equals(h.c):!1}substituteConstants(){return this}evaluate(h){return!this.c.evaluate(h)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(h){return h.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$0i=p;class R{static create(h,v,z=null){if(typeof v=="boolean")return v?V.create(h,z):c.create(h,z);const U=u.get(h);return typeof U=="boolean"?v===(U?"true":"false")?n.INSTANCE:r.INSTANCE:new R(h,v,z)}constructor(h,v,z){this.c=h,this.d=v,this.f=z,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){const h=u.get(this.c);if(typeof h=="boolean"){const v=h?"true":"false";return this.d===v?n.INSTANCE:r.INSTANCE}return this}evaluate(h){return h.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(h){return h.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$$i=R;class V{static create(h,v=null){const z=u.get(h);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new V(h,v)}constructor(h,v){this.c=h,this.d=v,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:H(this.c,h.c)}equals(h){return h.type===this.type?this.c===h.c:!1}substituteConstants(){const h=u.get(this.c);return typeof h=="boolean"?h?n.INSTANCE:r.INSTANCE:this}evaluate(h){return!h.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(h){return h.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$_i=V;function te(F,h){if(typeof F=="string"){const v=parseFloat(F);isNaN(v)||(F=v)}return typeof F=="string"||typeof F=="number"?h(F):n.INSTANCE}class x{static create(h,v,z=null){return te(v,U=>new x(h,U,z))}constructor(h,v,z){this.c=h,this.d=v,this.f=z,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(h){return h.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$aj=x;class oe{static create(h,v,z=null){return te(v,U=>new oe(h,U,z))}constructor(h,v,z){this.c=h,this.d=v,this.f=z,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(h){return h.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$bj=oe;class re{static create(h,v,z=null){return te(v,U=>new re(h,U,z))}constructor(h,v,z){this.c=h,this.d=v,this.f=z,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(h){return h.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$cj=re;class he{static create(h,v,z=null){return te(v,U=>new he(h,U,z))}constructor(h,v,z){this.c=h,this.d=v,this.f=z,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:J(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(h){return h.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$dj=he;class ce{static create(h,v){return new ce(h,v)}constructor(h,v){this.d=h,this.f=v,this.type=7,this.c=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.d<h.d)return-1;if(this.d>h.d)return 1;const v=this.f?this.f.source:"",z=h.f?h.f.source:"";return v<z?-1:v>z?1:0}equals(h){if(h.type===this.type){const v=this.f?this.f.source:"",z=h.f?h.f.source:"";return this.d===h.d&&v===z}return!1}substituteConstants(){return this}evaluate(h){const v=h.getValue(this.d);return this.f?this.f.test(v):!1}serialize(){const h=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${h}`}keys(){return[this.d]}map(h){return h.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$ej=ce;class ae{static create(h){return new ae(h)}constructor(h){this.c=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this.c.cmp(h.c)}equals(h){return h.type===this.type?this.c.equals(h.c):!1}substituteConstants(){return this}evaluate(h){return!this.c.evaluate(h)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(h){return new ae(this.c.map(h))}negate(){return this.c}}e.$fj=ae;function B(F){let h=null;for(let v=0,z=F.length;v<z;v++){const U=F[v].substituteConstants();if(F[v]!==U&&h===null){h=[];for(let W=0;W<v;W++)h[W]=F[W]}h!==null&&(h[v]=U)}return h===null?F:h}class Q{static create(h,v,z){return Q.d(h,v,z)}constructor(h,v){this.expr=h,this.c=v,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let v=0,z=this.expr.length;v<z;v++){const U=i(this.expr[v],h.expr[v]);if(U!==0)return U}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let v=0,z=this.expr.length;v<z;v++)if(!this.expr[v].equals(h.expr[v]))return!1;return!0}return!1}substituteConstants(){const h=B(this.expr);return h===this.expr?this:Q.create(h,this.c,!1)}evaluate(h){for(let v=0,z=this.expr.length;v<z;v++)if(!this.expr[v].evaluate(h))return!1;return!0}static d(h,v,z){const U=[];let W=!1;for(const G of h)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){U.push(...G.expr);continue}U.push(G)}if(U.length===0&&W)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];for(;U.length>1;){const G=U[U.length-1];if(G.type!==9)break;U.pop();const ee=U.pop(),ue=U.length===0,fe=M.create(G.expr.map(ge=>Q.create([ge,ee],null,z)),null,ue);fe&&(U.push(fe),U.sort(i))}if(U.length===1)return U[0];if(z){for(let G=0;G<U.length;G++)for(let ee=G+1;ee<U.length;ee++)if(U[G].negate().equals(U[ee]))return n.INSTANCE;if(U.length===1)return U[0]}return new Q(U,v)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const v of this.expr)h.push(...v.keys());return h}map(h){return new Q(this.expr.map(v=>v.map(h)),null)}negate(){if(!this.c){const h=[];for(const v of this.expr)h.push(v.negate());this.c=M.create(h,this,!0)}return this.c}}e.$gj=Q;class M{static create(h,v,z){return M.d(h,v,z)}constructor(h,v){this.expr=h,this.c=v,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let v=0,z=this.expr.length;v<z;v++){const U=i(this.expr[v],h.expr[v]);if(U!==0)return U}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let v=0,z=this.expr.length;v<z;v++)if(!this.expr[v].equals(h.expr[v]))return!1;return!0}return!1}substituteConstants(){const h=B(this.expr);return h===this.expr?this:M.create(h,this.c,!1)}evaluate(h){for(let v=0,z=this.expr.length;v<z;v++)if(this.expr[v].evaluate(h))return!0;return!1}static d(h,v,z){let U=[],W=!1;if(h){for(let G=0,ee=h.length;G<ee;G++){const ue=h[G];if(ue){if(ue.type===0){W=!0;continue}if(ue.type===1)return r.INSTANCE;if(ue.type===9){U=U.concat(ue.expr);continue}U.push(ue)}}if(U.length===0&&W)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];if(z){for(let G=0;G<U.length;G++)for(let ee=G+1;ee<U.length;ee++)if(U[G].negate().equals(U[ee]))return r.INSTANCE;if(U.length===1)return U[0]}return new M(U,v)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const v of this.expr)h.push(...v.keys());return h}map(h){return new M(this.expr.map(v=>v.map(h)),null)}negate(){if(!this.c){const h=[];for(const v of this.expr)h.push(v.negate());for(;h.length>1;){const v=h.shift(),z=h.shift(),U=[];for(const W of T(v))for(const G of T(z))U.push(Q.create([W,G],null,!1));h.unshift(M.create(U,null,!1))}this.c=M.create(h,this,!0)}return this.c}}e.$hj=M;class C extends c{static{this.d=[]}static all(){return C.d.values()}constructor(h,v,z){super(h,null),this.f=v,typeof z=="object"?C.d.push({...z,key:h}):z!==!0&&C.d.push({key:h,description:z,type:v!=null?typeof v:void 0})}bindTo(h){return h.createKey(this.key,this.f)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return S.create(this.key,h)}notEqualsTo(h){return R.create(this.key,h)}}e.$ij=C,e.$jj=(0,N.$4h)("contextKeyService");function H(F,h){return F<h?-1:F>h?1:0}function J(F,h,v,z){return F<v?-1:F>v?1:h<z?-1:h>z?1:0}function Y(F,h){if(F.type===0||h.type===1)return!0;if(F.type===9)return h.type===9?K(F.expr,h.expr):!1;if(h.type===9){for(const v of h.expr)if(Y(F,v))return!0;return!1}if(F.type===6){if(h.type===6)return K(h.expr,F.expr);for(const v of F.expr)if(Y(v,h))return!0;return!1}return F.equals(h)}e.$kj=Y;function K(F,h){let v=0,z=0;for(;v<F.length&&z<h.length;){const U=F[v].cmp(h[z]);if(U<0)return!1;U===0&&v++,z++}return v===F.length}function T(F){return F.type===9?F.expr:[F]}}),define(ie[59],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=void 0,e.$5n=(0,L.$4h)("downloadService")}),define(ie[18],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=void 0,e.$$h=(0,L.$4h)("environmentService"),e.$_h=(0,L.$5h)(e.$$h)}),define(ie[21],se([0,1,93,10]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$no=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0,e.$bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$co=new RegExp(e.$bo),e.$do="__web_extension",e.$eo="skipWalkthrough",e.$fo="extensionsSync",e.$go="dependecyOrPackExtensionInstall";function j(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ho=j;function N(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$io=N;function A(l,$){switch(l){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$jo=A;function b(l,$){return $==="web"&&!l.includes("web")}e.$ko=b;function u(l,$,I){return b($,I)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===I}e.$lo=u;function a(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$mo=a;var P;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var O;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(O||(e.SortOrder=O={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$no=(0,D.$4h)("extensionGalleryService");var E;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var y;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class d extends Error{constructor($,I){super($),this.code=I,this.name=I}}e.$oo=d,e.$po=(0,D.$4h)("extensionManagementService"),e.$qo="extensionsIdentifiers/disabled",e.$ro="extensionsIdentifiers/enabled",e.$so=(0,D.$4h)("IGlobalExtensionEnablementService"),e.$to=(0,D.$4h)("IExtensionTipsService"),e.$uo=(0,L.localize)(0,null),e.$vo={value:e.$uo,original:"Extensions"},e.$wo=(0,L.localize2)(1,"Preferences")}),define(ie[60],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=void 0,e.$up=(0,L.$4h)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((N,A)=>X(["node-vsce-sign"],async b=>N(b),A))),this.a}async verify(N,A,b){let u;try{u=await this.b()}catch{return!1}return u.verify(N,A,b)}}e.$vp=D}),define(ie[61],se([0,1,14,9,101,12]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;async function A(P,O,m,f,E,y){let d;try{await b(P,O,m,f,E,y)}catch(l){d=l}finally{d&&E.errorTransformer&&(d=E.errorTransformer(d)),typeof d<"u"&&m.error(d),m.end()}}e.$3p=A;async function b(P,O,m,f,E,y){u(y);const d=await P.open(O,{create:!1});try{u(y);let l=0,$=0,I=E&&typeof E.length=="number"?E.length:void 0,g=L.$he.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),w=E&&typeof E.position=="number"?E.position:0,s=0;do $=await P.read(d,w,g.buffer,s,g.byteLength-s),w+=$,s+=$,l+=$,typeof I=="number"&&(I-=$),s===g.byteLength&&(await m.write(f(g)),g=L.$he.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),s=0);while($>0&&(typeof I!="number"||I>0)&&u(y)&&a(l,E));if(s>0){let o=s;typeof I=="number"&&(o=Math.min(s,I)),m.write(f(g.slice(0,o)))}}catch(l){throw(0,N.$Ck)(l)}finally{await P.close(d)}}function u(P){if(P.isCancellationRequested)throw(0,D.$6)();return!0}function a(P,O){if(typeof O?.limits?.size=="number"&&P>O.limits.size)throw(0,N.$Bk)((0,j.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[119],se([0,1,4,166,2,13,167]),function(X,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class b extends j.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$Td),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Td),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(a){const P=this.j(a),O=P.filter(f=>{const E=this.c.get(f.path);return E?!(0,D.$Oj)(E.request.excludes,f.excludes)||!(0,D.$Oj)(E.request.includes,f.includes):!0}),m=Array.from(this.c.values()).filter(({request:f})=>!P.find(E=>E.path===f.path&&(0,D.$Oj)(E.excludes,f.excludes)&&(0,D.$Oj)(E.includes,f.includes))).map(({request:f})=>f.path);O.length&&this.m(`Request to start watching: ${O.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const f of m)this.h(f);for(const f of O)this.g(f)}g(a){const P=new A.$mq(a,m=>this.a.fire(m),m=>this.b.fire(m),this.f),O={request:a,instance:P};this.c.set(a.path,O)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const P=this.c.get(a);P&&(this.c.delete(a),P.instance.dispose())}j(a){const P=new Map;for(const O of a){const m=N.$k?O.path:O.path.toLowerCase();let f=P.get(O.correlationId);f||(f=new Map,P.set(O.correlationId,f)),f.set(m,O)}return Array.from(P.values()).map(O=>Array.from(O.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,P]of this.c)P.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,P){return P?`[File Watcher (node.js)] ${a} (path: ${P.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$oq=b}),define(ie[120],se([0,1,62,119]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;class j extends L.$7p{constructor(A,b,u){super(A,b,u),this.s()}r(A){return A.add(new D.$oq)}}e.$pq=j}),define(ie[121],se([0,1,15,57,85,62]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class A extends N.$8p{constructor(u,a,P){super(u,a,P),this.s()}r(u){const a=u.add(new j.$gq(L.$mg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:P,signal:O})=>this.t(`terminated by itself with code ${P}, signal: ${O}`))),D.ProxyChannel.toService((0,D.$Kh)(a.getChannel("watcher")))}}e.$hq=A}),define(ie[63],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class L{constructor(...j){this.a=new Map;for(const[N,A]of j)this.set(N,A)}set(j,N){const A=this.a.get(j);return this.a.set(j,N),A}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$2h=L}),define(ie[122],se([0,1,8,9,2,50,117,10,63,168]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0;const P=!1;class O extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class m{constructor(d=new u.$2h,l=!1,$,I=P){this.f=d,this.g=l,this.h=$,this.i=I,this.o=new Set,this.f.set(b.$3h,this),this._globalGraph=I?$?._globalGraph??new A.$sq(g=>g):void 0}createChild(d){return new m(d,this.g,this,this.i)}invokeFunction(d,...l){const $=E.traceInvocation(this.i,d);let I=!1;try{return d({get:w=>{if(I)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(w,$);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...l)}finally{I=!0,$.stop()}}createInstance(d,...l){let $,I;return d instanceof N.$1h?($=E.traceCreation(this.i,d.ctor),I=this.j(d.ctor,d.staticArguments.concat(l),$)):($=E.traceCreation(this.i,d),I=this.j(d,l,$)),$.stop(),I}j(d,l=[],$){const I=b._util.getServiceDependencies(d).sort((s,o)=>s.index-o.index),g=[];for(const s of I){const o=this.m(s.id,$);o||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${s.id}.`,!1),g.push(o)}const w=I.length>0?I[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${d.name} at position ${w+1} conflicts with ${l.length} static arguments`);const s=w-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,w)}return Reflect.construct(d,l.concat(g))}k(d,l){if(this.f.get(d)instanceof N.$1h)this.f.set(d,l);else if(this.h)this.h.k(d,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const l=this.f.get(d);return!l&&this.h?this.h.l(d):l}m(d,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const $=this.l(d);return $ instanceof N.$1h?this.q(d,$,l.branch(d,!0)):(l.branch(d,!1),$)}q(d,l,$){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,l,$)}finally{this.o.delete(d)}}r(d,l,$){const I=new A.$sq(s=>s.id.toString());let g=0;const w=[{id:d,desc:l,_trace:$}];for(;w.length;){const s=w.pop();if(I.lookupOrInsertNode(s),g++>1e3)throw new O(I);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof N.$1h){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};I.insertEdge(s,i),w.push(i)}}}for(;;){const s=I.roots();if(s.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:o}of s){if(this.l(o.id)instanceof N.$1h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}I.removeNode(o)}}return this.l(d)}s(d,l,$=[],I,g){if(this.f.get(d)instanceof N.$1h)return this.t(d,l,$,I,g);if(this.h)return this.h.s(d,l,$,I,g);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(d,l,$=[],I,g){if(I){const w=new m(void 0,this.g,this,this.i);w.c=String(d);const s=new Map,o=new L.$kh(()=>{const t=w.j(l,$,g);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const c of n)c.disposable=r.apply(t,c.listener)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=s.get(i);return c||(c=new a.$4c,s.set(i,c)),(k,p,R)=>{if(o.isInitialized)return o.value[i](k,p,R);{const V={listener:[k,p,R],disposable:void 0},te=c.push(V);return(0,j.$Rc)(()=>{te(),V.disposable?.dispose()})}}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,$,g)}u(d,l){if(l&&console.warn(d),this.g)throw new Error(d)}}e.$tq=m;var f;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(f||(f={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,l){return d?new E(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,l){return d?new E(1,l.name):E.c}static{this.f=0}constructor(d,l){this.type=d,this.name=l,this.g=Date.now(),this.h=[]}branch(d,l){const $=new E(3,d.toString());return this.h.push([d,l,$]),$}stop(){const d=Date.now()-this.g;E.f+=d;let l=!1;function $(g,w){const s=[],o=new Array(g+1).join("	");for(const[t,i,n]of w.h)if(i&&n){l=!0,s.push(`${o}CREATES -> ${t}`);const r=$(g+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||l)&&E.all.add(I.join(`
`))}}e.$uq=E});var ne=this&&this.__param||function(X,e){return function(L,D){e(L,D,X)}};define(ie[64],se([0,1,20,2,13,103,21,10]),function(X,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=void 0;function u(P){return P.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$8q=u,e.$9q=(0,b.$4h)("languagePackService");let a=class extends D.$Tc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$4d;setTimeout(()=>O.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const E=m.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(d=>d.startsWith("lp-"))).map(y=>{const d=y.properties.localizedLanguages?.[0],l=u(y);return{...this.f(l,d,y),extensionId:y.identifier.id,galleryExtension:y}});return E.push(this.f("en","English")),E}f(O,m,f){const E=m??O;let y;if(E!==O&&(y=`(${O})`),O.toLowerCase()===j.$w.toLowerCase()&&(y??="",y+=(0,N.localize)(0,null)),f?.installCount){y??="";const d=f.installCount;let l;d>1e6?l=`${Math.floor(d/1e5)/10}M`:d>1e3?l=`${Math.floor(d/1e3)}K`:l=String(d),y+=` $(cloud-download) ${l}`}return{id:O,label:E,description:y}}};e.$0q=a,e.$0q=a=$e([ne(0,A.$no)],a)}),define(ie[6],se([0,1,34,4,41,2,31,13,17,3,11,118,10]),function(X,e,L,D,j,N,A,b,u,a,P,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.log=e.$oj=e.LogLevel=e.$nj=e.$mj=e.$lj=void 0,e.$lj=(0,m.$4h)("logService"),e.$mj=(0,m.$4h)("loggerService");function f(){return new Date().toISOString()}function E(k){return(0,a.$Kf)(k)}e.$nj=E;var y;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$oj=y.Info;function d(k,p,R){switch(p){case y.Trace:k.trace(R);break;case y.Debug:k.debug(R);break;case y.Info:k.info(R);break;case y.Warning:k.warn(R);break;case y.Error:k.error(R);break;case y.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=d;function l(k,p=!1){let R="";for(let V=0;V<k.length;V++){let te=k[V];if(te instanceof Error&&(te=(0,L.$Oi)(te,p)),typeof te=="object")try{te=JSON.stringify(te)}catch{}R+=(V>0?" ":"")+te}return R}class $ extends N.$Tc{constructor(){super(...arguments),this.b=e.$oj,this.c=this.B(new D.$Td),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==y.Off&&this.b<=p}}e.$qj=$;class I extends ${constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...R){this.f(y.Trace)&&this.g(y.Trace,l([p,...R],!0))}debug(p,...R){this.f(y.Debug)&&this.g(y.Debug,l([p,...R]))}info(p,...R){this.f(y.Info)&&this.g(y.Info,l([p,...R]))}warn(p,...R){this.f(y.Warning)&&this.g(y.Warning,l([p,...R]))}error(p,...R){if(this.f(y.Error))if(p instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=p.stack,this.g(y.Error,l(V))}else this.g(y.Error,l([p,...R]))}flush(){}}e.$rj=I;class g extends ${constructor(p=e.$oj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...R){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...R):console.log(`[main ${f()}]`,p,...R))}debug(p,...R){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...R):console.log(`[main ${f()}]`,p,...R))}info(p,...R){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...R):console.log(`[main ${f()}]`,p,...R))}warn(p,...R){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,p,...R):console.warn(`[main ${f()}]`,p,...R))}error(p,...R){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,p,...R):console.error(`[main ${f()}]`,p,...R))}flush(){}}e.$sj=g;class w extends ${constructor(p=e.$oj,R=!0){super(),this.g=R,this.setLevel(p)}trace(p,...R){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...R):console.log(p,...R))}debug(p,...R){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...R):console.log(p,...R))}info(p,...R){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...R):console.log(p,...R))}warn(p,...R){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...R):console.log(p,...R))}error(p,...R){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...R):console.error(p,...R))}flush(){}}e.$tj=w;class s extends ${constructor(p,R=e.$oj){super(),this.g=p,this.setLevel(R)}trace(p,...R){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(p),...R])}debug(p,...R){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(p),...R])}info(p,...R){this.f(y.Info)&&this.g.log(y.Info,[this.h(p),...R])}warn(p,...R){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(p),...R])}error(p,...R){this.f(y.Error)&&this.g.log(y.Error,[this.h(p),...R])}h(p){return typeof p=="string"?p:(0,L.$Oi)(p,this.f(y.Trace))}flush(){}}e.$uj=s;class o extends ${constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const R of this.g)R.setLevel(p);super.setLevel(p)}trace(p,...R){for(const V of this.g)V.trace(p,...R)}debug(p,...R){for(const V of this.g)V.debug(p,...R)}info(p,...R){for(const V of this.g)V.info(p,...R)}warn(p,...R){for(const V of this.g)V.warn(p,...R)}error(p,...R){for(const V of this.g)V.error(p,...R)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose();super.dispose()}}e.$vj=o;class t extends N.$Tc{constructor(p,R,V){if(super(),this.h=p,this.j=R,this.b=new A.$Ac,this.c=this.B(new D.$Td),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Td),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Td),this.onDidChangeVisibility=this.g.event,V)for(const te of V)this.b.set(te.resource,{logger:void 0,info:te})}m(p){return(0,a.$Gf)(p)?[...this.b.values()].find(R=>R.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,R){const V=this.n(p),te=(0,a.$Gf)(p)?p:R?.id??(0,j.$Ri)(V.toString()).toString(16);let x=this.b.get(V)?.logger;const oe=R?.logLevel==="always"?y.Trace:R?.logLevel;x||(x=this.s(V,oe??this.getLogLevel(V)??this.h,{...R,id:te}));const re={logger:x,info:{resource:V,id:te,logLevel:oe,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(re.info),this.b.set(V,re),x}n(p){return(0,a.$Gf)(p)?(0,u.$Fg)(this.j,`${p}.log`):p}setLogLevel(p,R){if(P.URI.isUri(p)){const V=p,te=R,x=this.b.get(V);x&&te!==x.info.logLevel&&(x.info.logLevel=te===this.h?void 0:te,x.logger?.setLevel(te),this.b.set(x.info.resource,x),this.f.fire([V,te]))}else{this.h=p;for(const[V,te]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&te.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,R){const V=this.m(p);V&&R!==!V.info.hidden&&(V.info.hidden=!R,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,R]))}getLogLevel(p){let R;return p&&(R=this.b.get(p)?.info.logLevel),R??this.h}registerLogger(p){const R=this.b.get(p.resource);R?R.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const R=this.b.get(p);R&&(R.logger&&R.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$wj=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Td().event}setLevel(p){}getLevel(){return y.Info}trace(p,...R){}debug(p,...R){}info(p,...R){}warn(p,...R){}error(p,...R){}critical(p,...R){}dispose(){}flush(){}}e.$xj=i;class n extends i{}e.$yj=n;function r(k){if(k.verbose)return y.Trace;if(typeof k.logLevel=="string"){const p=S(k.logLevel.toLowerCase());if(p!==void 0)return p}return e.$oj}e.$zj=r;function c(k){switch(k){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$Aj=c;function S(k){switch(k){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$Bj=S,e.$Cj=new O.$ij("logLevel",c(y.Info))}),define(ie[123],se([0,1,19,8,9,4,2,16,62,6]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class P extends A.$Tc{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new N.$Td),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$Td),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$2g(0)),this.w=[],this.y=this.B(new D.$2g(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(m,f):this.z(m,f)}n(m,f){const E={path:this.H(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},y=(0,L.$Ub)(this.j,E);return this.r(),(0,A.$Rc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,j.$1)(m))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$9p)(f)),f=>this.G(f),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,u.$5p)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,u.$5p)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,f){const E={path:this.H(m),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},y=(0,L.$Ub)(this.w,E);return this.C(),(0,A.$Rc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,j.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,u.$9p)(m)),m=>this.G(m),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$aq=P}),define(ie[124],se([0,1,19,8,14,20,4,41,65,2,47,15,125,17,45,100,12,61,6,9]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;let w=class extends a.$Tc{static{g=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$Td),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Td),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Td),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Td),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Td),this.Y=this.B(new A.$Td),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Td),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$ah)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const i=new a.$Sc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new d.$Hk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,a.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Jg)(o))throw new d.$Jk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new I.$bb;throw i.message=(0,y.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,d.$uk)(t)||(0,d.$rk)(t)||(0,d.$vk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,d.$uk)(t)||(0,d.$rk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,d.$Ek)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.$Jk((0,y.localize)(2,null,this.sb(o)),1):(0,d.$Ck)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,c=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,k=await i.stat(o);let p;return this.t(i,o,k,void 0,!!S,(R,V)=>(p||(p=P.$0h.forUris(()=>!n),p.set(o,!0),r&&p.fill(!0,r)),p.get(R.resource)||p.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&c?V===1:!1))}async t(o,t,i,n,r,c){const{providerExtUri:S}=this.R(o),k={resource:t,name:S.basename(t),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&d.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Uk)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&c(k,n)){try{const p=await o.readdir(t),R=await D.Promises.settled(p.map(async([V,te])=>{try{const x=S.joinPath(t,V),oe=r?await o.stat(x):{type:te};return await this.t(o,x,oe,p.length,r,c)}catch(x){return this.b.trace(x),null}}));k.children=(0,L.$Hb)(R)}catch(p){this.b.trace(p),k.children=[]}return k}return k}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new d.$Jk((0,y.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=j.$he.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new d.$Gk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let c=i;if((0,d.$xk)(n)&&!c?.atomic){const S=n.enforceAtomicWriteFile?.(o);S&&(c={...i,atomic:S})}try{await this.w(n,o,c)||await this.U(n,r.dirname(o));let k;if((0,d.$rk)(n)&&!(t instanceof j.$he))if((0,E.$6d)(t)){const p=await(0,E.$ae)(t,3);p.ended?k=j.$he.concat(p.buffer):k=p}else k=(0,E.$0d)(t,p=>j.$he.concat(p),3);else k=t;!(0,d.$uk)(n)||(0,d.$rk)(n)&&k instanceof j.$he||(0,d.$rk)(n)&&(0,d.$xk)(n)&&c?.atomic?await this.hb(n,o,c,k):await this.db(n,o,c,k instanceof j.$he?(0,j.$se)(k):k),this.r.fire(new d.$Gk(o,4))}catch(S){throw new d.$Jk((0,y.localize)(4,null,this.sb(o),(0,d.$Ck)(S).toString()),(0,d.$Fk)(S),c)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(t)));if(n)throw new Error((0,y.localize)(8,null,this.sb(t)))}let c;try{c=await o.stat(t)}catch{return}if(c.type&d.FileType.Directory)throw new d.$Jk((0,y.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,c),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.$Tk&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==(0,d.$Uk)({mtime:i.mtime,size:c.size}))throw new d.$Jk((0,y.localize)(10,null),3,i);return c}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,c)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const S=await this.C(o,t,i,n);r(S)}catch(S){c(S)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,j.$te)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new N.$4d(n);let c=i;(0,d.$wk)(o)&&o.enforceAtomicReadFile?.(t)&&(c={...i,atomic:!0});const S=this.J(t,c).then(p=>p,p=>{throw r.dispose(!0),p});let k;try{return typeof c?.etag=="string"&&c.etag!==d.$Tk&&await S,c?.atomic&&(0,d.$wk)(o)||!((0,d.$uk)(o)||(0,d.$vk)(o))||(0,d.$rk)(o)&&c?.preferUnbuffered?k=this.I(o,t,c):(0,d.$vk)(o)?k=this.G(o,t,r.token,c):k=this.H(o,t,r.token,c),k.on("end",()=>r.dispose()),k.on("error",()=>r.dispose()),{...await S,value:k}}catch(p){throw k&&await(0,E.$$d)(k),this.F(p,t,c)}}F(o,t,i){const n=(0,y.localize)(11,null,this.sb(t),(0,d.$Ck)(o).toString());return o instanceof d.$Lk?new d.$Lk(n,o.stat,i):o instanceof d.$Kk?new d.$Kk(n,o.fileOperationResult,o.size,o.options):new d.$Jk(n,(0,d.$Fk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$ee)(r,{data:c=>c instanceof j.$he?c:j.$he.wrap(c),error:c=>this.F(c,t,n)},c=>j.$he.concat(c))}H(o,t,i,n=Object.create(null)){const r=(0,j.$xe)();return(0,l.$3p)(o,t,r,c=>c,{...n,bufferSize:this.a,errorTransformer:c=>this.F(c,t,n)},i),r}I(o,t,i){const n=(0,E.$8d)(r=>j.$he.concat(r));return(async()=>{try{let r;i?.atomic&&(0,d.$wk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(j.$he.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new d.$Jk((0,y.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==d.$Tk&&t.etag===i.etag)throw new d.$Lk((0,y.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new d.$Kk((0,y.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),c=this.qb(await this.n(t),t);await this.Q(r,o,c,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),c=await this.N(n,o,r,t,"move",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$Gk(o,c==="move"?2:3,S)),S}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),c=await this.N(n,o,r,t,"copy",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$Gk(o,c==="copy"?3:2,S)),S}async N(o,t,i,n,r,c){if(t.toString()===n.toString())return r;const{exists:S,isSameResourceWithDifferentPathCase:k}=await this.Q(o,t,i,n,r,c);if(S&&!k&&c&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,d.$sk)(o))await o.copy(t,n,{overwrite:c});else{const p=await this.resolve(t);p.isDirectory?await this.P(o,p,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:c}),r):(await this.N(o,t,i,n,"copy",c),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,d.$uk)(o)&&(0,d.$uk)(i))return this.jb(o,t,i,n);if((0,d.$uk)(o)&&(0,d.$rk)(i))return this.pb(o,t,i,n);if((0,d.$rk)(o)&&(0,d.$uk)(i))return this.nb(o,t,i,n);if((0,d.$rk)(o)&&(0,d.$rk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const c=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,c):this.O(o,r.resource,i,c)}))}async Q(o,t,i,n,r,c){let S=!1;if(o===i){const{providerExtUri:p,isPathCaseSensitive:R}=this.R(o);if(R||(S=p.isEqual(t,n)),S&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(t),this.sb(n)));if(!S&&p.isEqualOrParent(n,t))throw new Error((0,y.localize)(16,null,this.sb(t),this.sb(n)))}const k=await this.exists(n);if(k&&!S){if(!c)throw new d.$Jk((0,y.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:p}=this.R(o);if(p.isEqualOrParent(t,n))throw new Error((0,y.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:S}}R(o){const t=this.S(o);return{providerExtUri:t?f.$vg:f.$xg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$Gk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&d.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(t)));break}catch(r){if((0,d.$Ek)(r)!==d.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(c){if((0,d.$Ek)(c)!==d.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let c;try{c=await i.stat(o)}catch{}if(c)this.rb(o,c);else throw new d.$Jk((0,y.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const k=await this.resolve(o);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,d.$yk)(i)&&!n?.atomic){const k=i.enforceAtomicDelete?.(o);k&&(n={...t,atomic:k})}const r=!!n?.useTrash,c=!!n?.recursive,S=n?.atomic??!1;await i.delete(o,{recursive:c,useTrash:r,atomic:S}),this.r.fire(new d.$Gk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,d.$tk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,d.$sk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:g.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new a.$Sc;let n=!1,r=()=>{n=!0};i.add((0,a.$Rc)(()=>r())),(async()=>{try{const S=await this.bb(o,t);n?(0,a.$Oc)(S):r=()=>(0,a.$Oc)(S)}catch(S){this.b.error(S)}})();const c=t.correlationId;if(typeof c=="number"){const S=i.add(new A.$Td);return i.add(this.X.event(p=>{p.correlates(c)&&S.fire(p)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Ri)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,a.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,a.$Oc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,a.$Oc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$6d)(n)||(0,E.$7d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(c){throw(0,d.$Ck)(c)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$7d)(i)){if(i.buffer.length>0){const c=j.$he.concat(i.buffer);await this.gb(o,t,c,c.byteLength,n,0),n+=c.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((c,S)=>{(0,E.$_d)(r,{onData:async k=>{r.pause();try{await this.gb(o,t,k,k.byteLength,n,0)}catch(p){return S(p)}n+=k.byteLength,setTimeout(()=>r.resume())},onError:k=>S(k),onEnd:()=>c()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,c){let S=0;for(;S<n;){const k=await o.write(t,r+S,i.buffer,c+S,n-S);S+=k}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof j.$he?r=n:(0,E.$6d)(n)?r=await(0,j.$te)(n):(0,E.$7d)(n)?r=await(0,j.$ue)(n):r=(0,j.$re)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,c;try{r=await o.open(t,{create:!1}),c=await i.open(n,{create:!0,unlock:!1});const S=j.$he.alloc(this.a);let k=0,p=0,R=0;do R=await o.read(r,k,S.buffer,p,S.byteLength-p),await this.gb(i,c,S,R,k,p),k+=R,p+=R,p===S.byteLength&&(p=0);while(R>0)}catch(S){throw(0,d.$Ck)(S)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof c=="number"?i.close(c):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const c=await o.readFile(t);await this.gb(i,r,j.$he.wrap(c),c.byteLength,0,0)}catch(c){throw(0,d.$Ck)(c)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,j.$te)(this.H(o,t,N.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new d.$Jk((0,y.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&d.FilePermission.Readonly)throw new d.$Jk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};e.$4p=w,e.$4p=w=g=$e([ne(0,$.$lj)],w)}),define(ie[126],se([0,1,88,169,8,31,14,4,170,2,16,13,17,45,24,102,12,61,123,34,121,120]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,I.$Oi)(o)}`)}})();class s extends $.$aq{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new N.$Ac(n=>m.$wg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,O.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let c;r.isSymbolicLink()?c=(await this.stat((0,m.$Fg)(t,r.name))).type:c=this.M(r),n.push([r.name,c])}catch(c){this.a.trace(c)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=d.FileType.Unknown:t.isFile()?n=d.FileType.File:t.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new j.$3g;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$8d)(c=>A.$he.concat(c.map(S=>A.$he.wrap(S))).buffer);return(0,l.$3p)(this,t,r,c=>c.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,m.$Fg)((0,m.$Eg)(t),`${(0,m.$Cg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const c=new a.$Sc;try{c.add(await this.O(t)),c.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{c.dispose()}}async S(t,i,n,r){let c;try{const S=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(S)){if(!n.overwrite)throw(0,d.$Bk)((0,y.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$Bk)((0,y.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(c,0,i,0,i.byteLength)}catch(S){throw await this.gb(t,S)}finally{typeof c=="number"&&await this.close(c)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let c;(0,d.$pk)(i)&&!n&&(c=await this.O(t));let S;try{if((0,d.$pk)(i)&&i.unlock)try{const{stat:p}=await E.SymlinkSupport.stat(r);p.mode&128||await E.Promises.chmod(r,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let k;if((0,d.$pk)(i)){if(O.$i)try{await E.Promises.truncate(r,0),k="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}k||(k="w")}else k="r";S=await E.Promises.open(r,k)}catch(k){throw c?.dispose(),(0,d.$pk)(i)?await this.gb(t,k):this.fb(k)}if(this.U.set(S,0),(0,d.$pk)(i)&&this.X.set(S,t),c){const k=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${r})`),this.W.set(S,c),k&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${r})`),k.dispose())}return S}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,c){const S=this.Z(t,i);let k=null;try{k=(await E.Promises.read(t,n,r,c,S)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(t,S,k)}return k}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,c){return(0,j.$lh)(()=>this.ab(t,i,n,r,c),100,3)}async ab(t,i,n,r,c){const S=this.Z(t,i);let k=null;try{k=(await E.Promises.write(t,n,r,c,S)).bytesWritten}catch(p){throw await this.gb(this.X.get(t),p)}finally{this.$(t,S,k)}return k}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(n),`${(0,P.$nc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let c=!1;try{const{stat:S,symbolicLink:k}=await E.SymlinkSupport.stat(n);c=S.isDirectory()&&!k}catch{}if(c)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),c=this.H(i);if(r!==c)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,c)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,y.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(c)),S.toString()))),this.fb(S)}}async copy(t,i,n){const r=this.H(t),c=this.H(i);if(r!==c)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,c,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,y.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(c)),S.toString()))),this.fb(S)}}async bb(t,i,n,r){const c=this.H(t),S=this.H(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,u.$5f)(c,S,!0)),k){if(n==="copy")throw(0,d.$Bk)((0,y.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(t);if(!R)throw(0,d.$Bk)((0,y.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const V=await this.L(i);if(V){if(!r)throw(0,d.$Bk)((0,y.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);R.type&d.FileType.File&&V.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),c=this.H(i),S=!!(this.capabilities&1024);if((0,u.$5f)(r,c,!S))return;const k=new a.$Sc;try{k.add(await this.O(t)),k.add(await this.O(i)),n&&await E.Promises.mkdir((0,P.$mc)(c),{recursive:!0}),await E.Promises.copyFile(r,c)}catch(p){if(p.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(p)}finally{k.dispose()}}t(t,i,n){return new g.$hq(r=>t(r),r=>i(r),n)}F(t,i,n){return new w.$pq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof d.$Ak)return t;let i=t,n;switch(t.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$Bk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,d.$Bk)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$qq=s}),define(ie[127],se([0,1,2,6]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=void 0;class j extends L.$Tc{constructor(A,b=[]){super(),this.a=new D.$vj([A,...b]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$kO=j}),define(ie[128],se([0,1,12,6]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;var j;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(j||(j={}));async function N(a,P,O,m,f){try{const E=await new Promise((d,l)=>{X(["@vscode/spdlog"],d,l)});E.setFlushOn(j.Trace);const y=await E.createAsyncRotatingLogger(a,P,O,m);return f?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(E){console.error(E)}return null}function A(a,P,O){switch(P){case D.LogLevel.Trace:a.trace(O);break;case D.LogLevel.Debug:a.debug(O);break;case D.LogLevel.Info:a.info(O);break;case D.LogLevel.Warning:a.warn(O);break;case D.LogLevel.Error:a.error(O);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function b(a,P){switch(P){case D.LogLevel.Trace:a.setLevel(j.Trace);break;case D.LogLevel.Debug:a.setLevel(j.Debug);break;case D.LogLevel.Info:a.setLevel(j.Info);break;case D.LogLevel.Warning:a.setLevel(j.Warning);break;case D.LogLevel.Error:a.setLevel(j.Error);break;case D.LogLevel.Off:a.setLevel(j.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class u extends D.$rj{constructor(P,O,m,f,E){super(),this.m=[],this.setLevel(E),this.n=this.s(P,O,m,f),this.B(this.onDidChangeLogLevel(y=>{this.r&&b(this.r,y)}))}async s(P,O,m,f){const E=m?6:1,y=30/E*L.$Wk.MB,d=await N(P,O,y,E,f);if(d){this.r=d,b(this.r,this.getLevel());for(const{level:l,message:$}of this.m)A(this.r,l,$);this.m=[]}}g(P,O){this.r?A(this.r,P,O):this.getLevel()<=P&&this.m.push({level:P,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$_N=u}),define(ie[129],se([0,1,28,6,128]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=void 0;class N extends D.$wj{s(b,u,a){return new j.$_N((0,L.$og)(),b.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$aO=N}),define(ie[38],se([0,1,4,65,2,10]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0,e.$yn=(0,N.$4h)("policy");class A extends j.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Td),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const P=Object.keys(this.f).length;return this.f={...a,...this.f},P!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(O,[m,f])=>({...O,[m]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[P,O])=>({...a,[P]:{definition:O,value:this.g.get(P)}}),{})}}e.$zn=A;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$An=b}),define(ie[130],se([0,1,8,4,65,3,12,6,38]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=void 0;function a(O,m){const f=[];for(const E of new Set(j.Iterable.concat(O.keys(),m.keys())))O.get(E)!==m.get(E)&&f.push(E);return f}let P=class extends u.$zn{constructor(m,f,E){super(),this.m=m,this.n=f,this.s=E,this.c=this.B(new L.$2g(500));const y=D.Event.filter(f.onDidFilesChange,d=>d.affects(m));this.B(f.watch(m)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const f=await this.n.readFile(this.m),E=JSON.parse(f.value.toString());if(!(0,N.$If)(E))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(E))this.f[y]&&m.set(y,E[y])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return m}async w(){const m=await this.u(),f=a(this.g,m);this.g=m,f.length>0&&this.h.fire(f)}};e.$K$b=P,e.$K$b=P=$e([ne(1,A.$ok),ne(2,b.$lj)],P)}),define(ie[131],se([0,1,38,8,2,6]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0;let A=class extends L.$zn{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$Xg,this.b=this.B(new j.$Uc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((P,O)=>{X(["@vscode/policy-watcher"],P,O)});await this.a.queue(()=>new Promise((P,O)=>{try{this.b.value=a(this.n,u,m=>{this.t(m),P()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),O(m)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const P=u[a];P===void 0?this.g.delete(a):this.g.set(a,P)}this.h.fire(Object.keys(u))}};e.$J$b=A,e.$J$b=A=$e([ne(0,N.$lj)],A)}),define(ie[32],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=void 0,e.$Dj=(0,L.$4h)("productService"),e.$Ej="vscode://schemas/vscode-product"}),define(ie[36],se([0,1,71,3]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0;class j{constructor(){this.a=new Map}add(A,b){L.ok(D.$Gf(A)),L.ok(D.$If(b)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$wn=new j}),define(ie[132],se([0,1,4,36]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0,e.$xn={JSONContribution:"base.contributions.json"};function j(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class N{constructor(){this.b=new L.$Td,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[j(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$wn.add(e.$xn.JSONContribution,A)}),define(ie[43],se([0,1,19,4,3,89,25,132,36]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.ConfigurationScope=e.$Bn=e.EditPresentationTypes=void 0;var a;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$Bn={Configuration:"base.contributions.configuration"};var P;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn={properties:{},patternProperties:{}},e.$In="vscode://schemas/settings/resourceLanguage",e.$Jn="vscode://schemas/settings/configurationDefaults";const O=u.$wn.as(b.$xn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new D.$Td,this.onDidSchemaChange=this.i.event,this.j=new D.$Td,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$In,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),O.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),O.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),O.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$Ln.test(r)){const c=this.a.get(r),S=c?.valuesSources??new Map;if(n)for(const V of Object.keys(i[r]))S.set(V,n);const k={...c?.value||{},...i[r]};this.a.set(r,{source:n,value:k,valuesSources:S});const p=(0,A.$Hi)(r),R={type:"object",default:k,description:N.localize(1,null,p),$ref:e.$In,defaultDefaultValue:k,source:j.$Gf(n)?void 0:n,defaultValueSource:n};t.push(...y(r)),this.d[r]=R,this.b.properties[r]=R}else{this.a.set(r,{value:i[r],source:n});const c=this.d[r];c&&(this.w(r,c),this.r(r,c))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),c=j.$Gf(i)?i:i?.id,S=j.$Gf(r?.source)?r?.source:r?.source?.id;if(c===S)if(o.add(n),this.a.delete(n),e.$Ln.test(n))delete this.d[n],delete this.b.properties[n];else{const k=this.d[n];k&&(this.w(n,k),this.r(n,k))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=j.$Pf(s.scope)?n:s.scope;const c=s.properties;if(c)for(const k in c){const p=c[k];if(o&&I(k,p)){delete c[k];continue}if(p.source=t,p.defaultDefaultValue=c[k].default,this.w(k,p),e.$Ln.test(k)?p.scope=void 0:(p.scope=j.$Pf(p.scope)?n:p.scope,p.restricted=j.$Pf(p.restricted)?!!i?.includes(k):p.restricted),c[k].hasOwnProperty("included")&&!c[k].included){this.f[k]=c[k],delete c[k];continue}else this.d[k]=c[k],c[k].policy?.name&&this.e.set(c[k].policy.name,k);!c[k].deprecationMessage&&c[k].markdownDeprecationMessage&&(c[k].deprecationMessage=c[k].markdownDeprecationMessage),r.add(k)}const S=s.allOf;if(S)for(const k of S)this.p(k,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$Cn.properties[s]=o,o.scope){case 1:e.$Dn.properties[s]=o;break;case 2:e.$En.properties[s]=o;break;case 6:e.$Fn.properties[s]=o;break;case 3:e.$Gn.properties[s]=o;break;case 4:e.$Hn.properties[s]=o;break;case 5:e.$Hn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$Cn.properties[s],o.scope){case 1:delete e.$Dn.properties[s];break;case 2:delete e.$En.properties[s];break;case 6:delete e.$Fn.properties[s];break;case 3:delete e.$Gn.properties[s];break;case 4:case 5:delete e.$Hn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$In};this.w(o,t),e.$Cn.properties[o]=t,e.$Dn.properties[o]=t,e.$En.properties[o]=t,e.$Fn.properties[o]=t,e.$Gn.properties[o]=t,e.$Hn.properties[o]=t}}v(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$In};e.$Cn.patternProperties[e.$Kn]=s,e.$Dn.patternProperties[e.$Kn]=s,e.$En.patternProperties[e.$Kn]=s,e.$Fn.patternProperties[e.$Kn]=s,e.$Gn.patternProperties[e.$Kn]=s,e.$Hn.patternProperties[e.$Kn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;j.$Nf(i)&&(i=o.defaultDefaultValue,n=void 0),j.$Nf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",E=new RegExp(f,"g");e.$Kn=`^(${f})+$`,e.$Ln=new RegExp(e.$Kn);function y(w){const s=[];if(e.$Ln.test(w)){let o=E.exec(w);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(w)}}return(0,L.$Mb)(s)}e.$Mn=y;function d(w){return w.reduce((s,o)=>`${s}[${o}]`,"")}e.$Nn=d;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$On=l;const $=new m;u.$wn.add(e.$Bn.Configuration,$);function I(w,s){return w.trim()?e.$Ln.test(w)?N.localize(7,null,w):$.getConfigurationProperties()[w]!==void 0?N.localize(8,null,w):s.policy?.name&&$.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,w,s.policy?.name,$.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.$Pn=I;function g(){const w=[],s=$.getConfigurationProperties();for(const o of Object.keys(s))w.push([o,s[o].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.$Qn=g}),define(ie[66],se([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(X,e,L,D,j,N,A,b,u,a,P,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=void 0;function f(o){return Object.isFrozen(o)?o:b.$ln(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new y("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.$Fi)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,c=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:c}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,P.$Fi)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$kn(this.contents),n=b.$kn(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const S of t)if(c.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const k of S.overrides){const[p]=n.filter(R=>L.$ub(R.identifiers,k.identifiers));p?(this.h(p.contents,k.contents),p.keys.push(...k.keys),p.keys=L.$Mb(p.keys)):n.push(b.$kn(k))}for(const k of S.keys)r.indexOf(k)===-1&&r.push(k)}return new E(i,r,n,c.every(S=>S instanceof E)?void 0:c)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[r];const S=i[r];S&&(typeof c=="object"&&typeof S=="object"?(c=b.$kn(c),this.h(c,S)):c=S),n[r]=c}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&u.$If(t[n])&&u.$If(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$kn(i[n])}}i(t){let i=null,n=null;const r=c=>{c&&(n?this.h(n,c):n=b.$kn(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===t?i=c.contents:c.identifiers.includes(t)&&r(c.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.$Ei)(this.contents,t),O.$Ln.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,O.$Mn)(t))),1))}j(t,i,n){(0,P.$Di)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),O.$Ln.test(t)&&this.overrides.push({identifiers:(0,O.$Mn)(t),keys:Object.keys(this.contents[t]),contents:(0,P.$Ci)(this.contents[t],r=>console.error(r))})}}e.$Rn=E;class y{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$Pf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:c,restricted:S,hasExcludedProperties:k}=this.h(t,i);this.b=new E(n,r,c,k?[t]:void 0),this.c=S||[]}g(t){let i={},n=null,r=[];const c=[],S=[];function k(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}const p={onObjectBegin:()=>{const R={};k(R),c.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const R=[];k(R),c.push(r),r=R,n=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:k,onError:(R,V,te)=>{S.push({error:R,offset:V,length:te})}};if(t)try{j.$hn(t,p),i=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(t,i){const n=m.$wn.as(O.$Bn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const c=(0,P.$Ci)(t,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),S=Object.keys(t),k=this.j(t,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:c,keys:S,overrides:k,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:c};const S={},k=[];for(const p in t)if(O.$Ln.test(p)&&n){const R=this.i(t[p],i,!1,r);S[p]=R.raw,c=c||R.hasExcludedProperties,k.push(...R.restricted)}else{const R=i[p],V=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&k.push(p),!r.exclude?.includes(p)&&(r.include?.includes(p)||(V===void 0||r.scopes===void 0||r.scopes.includes(V))&&!(r.skipRestricted&&R?.restricted))?S[p]=t[p]:c=!0}return{raw:S,restricted:k,hasExcludedProperties:c}}j(t,i){const n=[];for(const r of Object.keys(t))if(O.$Ln.test(r)){const c={};for(const S in t[r])c[S]=t[r][S];n.push({identifiers:(0,O.$Mn)(r),keys:Object.keys(c),contents:(0,P.$Ci)(c,i)})}return n}}e.$Sn=y;class d extends N.$Tc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Td),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,c=>c.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&n.isEqual(c.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Tn=d;class l{constructor(t,i,n,r,c,S,k,p,R,V,te,x,oe){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=c,this.f=S,this.g=k,this.h=p,this.i=R,this.j=V,this.k=te,this.l=x,this.m=oe}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class ${constructor(t,i,n,r,c=new E,S=new E,k=new A.$Ac,p=new E,R=new A.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=c,this.i=S,this.j=k,this.l=p,this.m=R,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,i,n){return this.p(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.p(t,i,n),c=this.t(i.resource,n),S=i.resource?this.m.get(i.resource)||this.l:this.l,k=new Set;for(const p of r.overrides)for(const R of p.identifiers)r.getOverrideValue(t,R)!==void 0&&k.add(R);return new l(t,i,r.getValue(t),k.size?[...k]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,c||void 0,S)}keys(t){const i=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:c,removed:S}=w(this.c,t);i=[...r,...c,...S]}for(const r of i)for(const c of(0,O.$Mn)(r)){const S=this.c.getKeysForOverrideIdentifier(c),k=t.getKeysForOverrideIdentifier(c),p=[...k.filter(R=>S.indexOf(R)===-1),...S.filter(R=>k.indexOf(R)===-1),...S.filter(R=>!b.$on(this.c.override(c).getValue(R),t.override(c).getValue(R)))];n.push([c,p])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=w(this.d,t),c=[...i,...n,...r];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:c}=w(this.applicationConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:c}=w(this.localUserConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:c}=w(this.remoteUserConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:c}=w(this.workspaceConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:c,removed:S,overrides:k}=w(n,i),p=[...r,...c,...S];return(p.length||!n)&&this.updateFolderConfiguration(t,i),{keys:p,overrides:k}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:c,overrides:S}=w(i,void 0);return{keys:[...n,...r,...c],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,i,n){let r=this.q(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},i){let n=this.r();if(i&&t){const r=i.getFolder(t);r&&(n=this.s(r.uri)||n);const c=this.m.get(t);c&&(n=n.merge(c))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let i=this.b.get(t);if(!i){const n=this.r(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}t(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:c}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:c}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}v(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.w(t.defaults),n=this.w(t.policy),r=this.w(t.application),c=this.w(t.user),S=this.w(t.workspace),k=t.folders.reduce((p,R)=>(p.set(a.URI.revive(R[0]),this.w(R[1])),p),new A.$Ac);return new $(i,n,r,c,new E,S,k,new E,new A.$Ac)}static w(t){return new E(t.contents,t.keys,t.overrides)}}e.$Un=$;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(c=>t.add(c)),r.overrides.forEach(([c,S])=>{const k=(0,A.$xc)(i,c,new Set);S.forEach(p=>k.add(p))});const n=[];return i.forEach((r,c)=>n.push([c,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Vn=I;class g{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const S of c)this.affectedKeys.add(S);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=$.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const c=r+n.length;if(c>=this.d.length)return!1;const S=this.d.charCodeAt(c);if(S!==this.b&&S!==this.c)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,p=this.g.getValue(t,i,this.h);return!b.$on(k,p)}return!0}}e.$Wn=g;function w(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),c=[],S=o?.getAllOverrideIdentifiers()||[],k=t?.getAllOverrideIdentifiers()||[];if(t){const p=k.filter(R=>!S.includes(R));for(const R of p)c.push([R,t.getKeysForOverrideIdentifier(R)])}if(o){const p=S.filter(R=>!k.includes(R));for(const R of p)c.push([R,o.getKeysForOverrideIdentifier(R)])}if(t&&o){for(const p of S)if(k.includes(p)){const R=s({contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)},{contents:t.getOverrideValue(void 0,p)||{},keys:t.getKeysForOverrideIdentifier(p)});c.push([p,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:r,overrides:c}}function s(o,t){const i=o?t?o.keys.filter(c=>t.keys.indexOf(c)===-1):[...o.keys]:[],n=t?o?t.keys.filter(c=>o.keys.indexOf(c)===-1):[...t.keys]:[],r=[];if(o&&t){for(const c of t.keys)if(o.keys.indexOf(c)!==-1){const S=(0,P.$Fi)(t.contents,c),k=(0,P.$Fi)(o.contents,c);b.$on(S,k)||r.push(c)}}return{added:i,removed:n,updated:r}}}),define(ie[133],se([0,1,19,4,2,30,3,66,43,6,38,36]),function(X,e,L,D,j,N,A,b,u,a,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=e.$Yn=e.$Xn=void 0;class m extends j.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Rn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$wn.as(u.$Bn.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:l})=>this.c(Array.from(d),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,l){this.h(d,O.$wn.as(u.$Bn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new b.$Rn;const d=O.$wn.as(u.$Bn.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,l){const $=this.f();for(const I of d){const g=$[I],w=l[I];g!==void 0?this.b.addValue(I,g):w?this.b.addValue(I,w.default):this.b.removeValue(I)}}}e.$Xn=m;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new b.$Rn}async initialize(){return this.configurationModel}}e.$Yn=f;let E=class extends j.$Tc{get configurationModel(){return this.b}constructor(d,l,$){super(),this.c=d,this.f=l,this.g=$,this.a=this.B(new D.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Rn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const l={},$=[],I=O.$wn.as(u.$Bn.Configuration).getConfigurationProperties();for(const g of d){const w=I[g];if(!w){$.push(g);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.g.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}$.push(g),l[w.policy.name]={type:w.type}}}return(0,A.$Tf)(l)||await this.f.updatePolicyDefinitions(l),$}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const l=O.$wn.as(u.$Bn.Configuration).getPolicyConfigurations(),$=(0,L.$Hb)(d.map(I=>l.get(I)));this.m($,!0)}m(d,l){this.g.trace("PolicyConfiguration#update",d);const $=O.$wn.as(u.$Bn.Configuration).getConfigurationProperties(),I=[],g=this.b.isEmpty();for(const w of d){const s=$[w]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(g?o!==void 0:!(0,N.$on)(this.b.getValue(w),o))&&I.push([w,o])}else this.b.getValue(w)!==void 0&&I.push([w,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const w=this.b;this.b=new b.$Rn;for(const s of w.keys)this.b.setValue(s,w.getValue(s));for(const[s,o]of I)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);l&&this.a.fire(this.b)}}};e.$Zn=E,e.$Zn=E=$e([ne(1,P.$yn),ne(2,a.$lj)],E)}),define(ie[134],se([0,1,8,4,2,17,25,66,133,38]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class P extends j.$Tc{constructor(m,f,E,y){super(),this.j=m,this.h=this.B(new D.$Td),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Xn),this.c=E instanceof a.$An?new u.$Yn:this.B(new u.$Zn(this.b,E,y)),this.f=this.B(new b.$Tn(this.j,{},N.$wg,f)),this.a=new b.$Un(this.b.configurationModel,this.c.configurationModel,new b.$Rn,new b.$Rn),this.g=this.B(new L.$dh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:l})=>this.n(d,l))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,f,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$Un(m,f,new b.$Rn,E)}getConfigurationData(){return this.a.toData()}getValue(m,f){const E=typeof m=="string"?m:void 0,y=(0,A.$yi)(m)?m:(0,A.$yi)(f)?f:{};return this.a.getValue(E,y,void 0)}updateValue(m,f,E,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.m(m)}m(m){const f=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(m);this.s(E,f,2)}n(m,f){const E=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(m,f);this.s(y,E,7)}r(m){const f=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(m);this.s(E,f,7)}s(m,f,E){const y=new b.$Wn(m,{data:f},this.a);y.source=E,y.sourceConfig=this.t(E),this.h.fire(y)}t(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$1n=P}),define(ie[67],se([0,1,15]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0;function D(a){return a.scheme===L.Schemas.vscodeRemote?a.authority:void 0}e.$$k=D;function j(a){if(!a)return;const P=a.indexOf("+");return P<0?a:a.substr(0,P)}e.$_k=j;function N(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$al=N;function A(a){const{host:P,port:O}=u(a);if(typeof O>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:O}}e.$bl=A;function b(a,P){let{host:O,port:m}=u(a);return typeof m>"u"&&(m=P),{host:O,port:m}}e.$cl=b;function u(a){const P=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const O=a.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const m=a.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:a,port:void 0}}}),define(ie[37],se([0,1,29,10,67]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.TargetPlatform=e.ExtensionType=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=void 0,e.$dm="extensions.user.cache",e.$em="extensions.builtin.cache",e.$fm="undefined_publisher",e.$gm=["ui","workspace","web"];function N(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$hm=N,e.$im=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class u{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,l){if(typeof d>"u"||d===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof d=="string"||typeof l=="string"){const $=typeof d=="string"?d:d.value,I=typeof l=="string"?l:l.value;return L.$0e($,I)}return d._lower===l._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$jm=u;class a{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const l of d)this.add(l)}add(d){this.c.add(u.toKey(d))}delete(d){return this.c.delete(u.toKey(d))}has(d){return this.c.has(u.toKey(d))}}e.$km=a;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(u.toKey(d))}get(d){return this.c.get(u.toKey(d))}has(d){return this.c.has(u.toKey(d))}set(d,l){this.c.set(u.toKey(d),l)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$lm=P;function O(y){return m(y)}e.$mm=O;function m(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$nm=m;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$om=f;function E(y,d){if(d){const l=`onResolveRemoteAuthority:${(0,j.$_k)(d)}`;return!!y.activationEvents?.includes(l)}return!1}e.$pm=E,e.$qm=(0,D.$4h)("IBuiltinExtensionsScannerService")}),define(ie[135],se([0,1,2,37,12]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class N extends L.$Tc{constructor(b,u,a,P,O){super(),this.a=b,this.b=u,this.c=a,this.f=O,this.B(P.onDidInstallExtensions(m=>this.g(m))),this.B(P.onDidUninstallExtension(m=>this.h(m)))}g(b){for(const u of b)u.local&&this.invalidate(u.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,b)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,D.$dm))}catch(u){(0,j.$Fk)(u)!==1&&this.f.error(u)}}}e.$Wp=N}),define(ie[44],se([0,1,14,9,2,104,43,10,6,36]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$9o=(0,b.$4h)("requestService");class P{constructor(w){this.b=w}toJSON(){if(!this.a){const w=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?w[s]="*****":w[s]=this.b[s];this.a=w}return this.a}}class O extends j.$Tc{constructor(w){super(),this.b=0,this.a=w.createLogger("network",{name:(0,N.localize)(0,null),when:u.$Cj.isEqualTo((0,u.$Aj)(u.LogLevel.Trace)).serialize()})}async c(w,s,o){const t=`${w} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$0)(i)),i}}}e.$0o=O;function m(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.$$o=m;function f(g){return g.res.statusCode===204}e.$_o=f;async function E(g){return f(g)?null:(await(0,L.$te)(g.stream)).toString()}e.$ap=E;async function y(g){if(!m(g))throw new Error("Server returned "+g.res.statusCode);return E(g)}e.$bp=y;async function d(g){if(!m(g))throw new Error("Server returned "+g.res.statusCode);if(f(g))return null;const s=(await(0,L.$te)(g.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$cp=d;function l(g){I(g)}e.$dp=l;let $;function I(g){const w=a.$wn.as(A.$Bn.Configuration),s=$;$={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},w.updateConfigurations({add:[$],remove:s?[s]:[]})}I(1)}),define(ie[136],se([0,1,20,15,12,44]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,P=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const O={type:"GET",url:u.toString(!0)},m=await this.a.request(O,P);if(m.res.statusCode===200)await this.b.writeFile(a,m.stream);else{const f=await(0,N.$bp)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};e.$zO=A,e.$zO=A=$e([ne(0,N.$9o),ne(1,j.$ok)],A)}),define(ie[137],se([0,1,138,3]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;function j(A,b){return A.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:A.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function N(A,b,u={}){const a=(0,L.parse)(A),P=u.proxyUrl||j(a,b);if(!P)return null;const O=(0,L.parse)(P);if(!/^https?:$/.test(O.protocol||""))return null;const m={host:O.hostname||"",port:(O.port?+O.port:0)||(O.protocol==="https"?443:80),auth:O.auth,rejectUnauthorized:(0,D.$Mf)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,E)=>{X(["http-proxy-agent"],f,E)})).HttpProxyAgent(P,m):new(await new Promise((f,E)=>{X(["https-proxy-agent"],f,E)})).HttpsProxyAgent(P,m)}e.$br=N}),define(ie[139],se([0,1,58,16,105,20,34,9,13,28,84,171,8,72]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0;let E;async function y(l,$,I,g){return I["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$4l)(g)&&!I["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$4l)(g)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=m.Promises.withAsyncBody(async(w,s)=>{const o=new N.$4d;let t=1e4;const i=l.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$5l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,j.localize)(0,null)))},t);try{w(await d($,o.token))}catch(r){!(0,b.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,j.localize)(1,null,(0,A.$Oi)(r)))):w({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$0l=y;async function d(l,$){const I=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",I);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",g);const w=(0,a.$og)().replace(/-/g,"").substr(0,12),s=new RegExp(w+"({.*})"+w),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",o);const t=await(0,P.$Tl)(u.OS,o);return l.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if($.isCancellationRequested)return n(new b.$5);const r=(0,D.$nc)(t);let c,S;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(c=`& '${process.execPath}' ${k} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,S=["-Login","-Command"]):r==="nu"?(c=`^'${process.execPath}' ${k} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,S=["-i","-l","-c"]):r==="xonsh"?(c=`import os, json; print("${w}", json.dumps(dict(os.environ)), "${w}")`,S=["-i","-l","-c"]):(c=`'${process.execPath}' ${k} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,r==="tcsh"||r==="csh"?S=["-ic"]:S=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),c);const p=(0,L.spawn)(t,[...S,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});$.onCancellationRequested(()=>(p.kill(),n(new b.$5))),p.on("error",te=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Oi)(te)),n(te)});const R=[];p.stdout.on("data",te=>R.push(te));const V=[];p.stderr.on("data",te=>V.push(te)),p.on("close",(te,x)=>{const oe=Buffer.concat(R).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(V).toString("utf8");if(re.trim()&&l.trace("getUnixShellEnvironment#stderr",re),te||x)return n(new Error((0,j.localize)(2,null,te,x)));const he=s.exec(oe),ce=he?he[1]:"{}";try{const ae=JSON.parse(ce);I?ae.ELECTRON_RUN_AS_NODE=I:delete ae.ELECTRON_RUN_AS_NODE,g?ae.ELECTRON_NO_ATTACH_CONSOLE=g:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){l.error("getUnixShellEnvironment#errorCaught",(0,A.$Oi)(ae)),n(ae)}})})}}),define(ie[140],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=void 0,e.$bO=(0,L.$4h)("stateReadService"),e.$cO=(0,L.$4h)("stateService")}),define(ie[68],se([0,1,8,14,2,3,18,12,6]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=e.$eO=e.$dO=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class P extends j.$Tc{constructor(E,y,d,l){super(),this.h=E,this.j=y,this.m=d,this.n=l,this.a=Object.create(null),this.b="",this.c=this.B(new L.$2g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.m.error(E)}}getItem(E,y){const d=this.a[E];return(0,N.$Pf)(d)?y:d}setItem(E,y){this.setItems([{key:E,data:y}])}setItems(E){let y=!1;for(const{key:d,data:l}of E)this.a[d]!==l&&((0,N.$Pf)(l)?(0,N.$Nf)(this.a[d])||(this.a[d]=void 0,y=!0):(this.a[d]=l,y=!0));y&&this.s()}removeItem(E){(0,N.$Nf)(this.a[E])||(this.a[E]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.n.writeFile(this.h,D.$he.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$dO=P;let O=class extends j.$Tc{constructor(E,y,d,l){super(),this.a=this.B(new P(y.stateResource,E,d,l))}async init(){await this.a.init()}getItem(E,y){return this.a.getItem(E,y)}};e.$eO=O,e.$eO=O=$e([ne(1,A.$$h),ne(2,u.$lj),ne(3,b.$ok)],O);class m extends O{setItem(E,y){this.a.setItem(E,y)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$fO=m}),define(ie[69],se([0,1,13,35,28]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=void 0;function N(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,P,O,m,f,E,y,d){const l=Object.create(null);l["common.machineId"]=f,l["common.sqmId"]=E,l.sessionID=(0,j.$og)()+Date.now(),l.commitHash=O,l.version=m,l["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,L.$h)(L.$u),l["common.nodePlatform"]=D.$dc,l["common.nodeArch"]=P,l["common.product"]=d||"desktop",y&&(l["common.msftInternal"]=y);let $=0;const I=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),L.$l&&(l["common.snap"]="true");const g=N(a);return g&&(l["common.platformDetail"]=g),l}e.$xo=A;function b(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const P=a.toLowerCase();return u.some(O=>P===O)}e.$yo=b}),define(ie[26],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=void 0,e.$sl=(0,L.$4h)("telemetryService"),e.$tl=(0,L.$4h)("customEndpointTelemetryService"),e.$ul="telemetry.currentSessionDate",e.$vl="telemetry.firstSessionDate",e.$wl="telemetry.lastSessionDate",e.$xl="telemetry.machineId",e.$yl="telemetry.sqmId",e.$zl="telemetry",e.$Al="telemetry.telemetryLevel",e.$Bl="telemetry.enableCrashReporter",e.$Cl="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var j;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(ie[39],se([0,1,30,3,4,25,67,69,26]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$zo=a;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ao=P,e.$Bo=new P;class O{async publicLog(n,r,c){}async publicLogError(n,r,c){}}e.$Co=O,e.$Do="telemetry",e.$Eo="extensionTelemetryLog",e.$Fo={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,n){return j.Event.debounce(n.onDidChangeConfiguration,(c,S)=>{const k=c?new Set([...c.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:k}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.$Ai)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.$Go=m;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Ho=f;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Io=E;function y(i){const n=i.getValue(u.$Al),r=i.getValue(u.$Bl);if(i.getValue(u.$Cl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Jo=y;function d(i){const n={},r={},c={};I(i,c);for(let S in c){S=S.length>150?S.substr(S.length-149):S;const k=c[S];typeof k=="number"?r[S]=k:typeof k=="boolean"?r[S]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${k.length}`),n[S]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(n[S]=k)}return{properties:n,measurements:r}}e.$Ko=d;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function $(i){if(!i)return"none";const n=(0,A.$_k)(i);return l.has(n)?n:"other"}e.$Lo=$;function I(i,n,r=0,c){if(i)for(const S of Object.getOwnPropertyNames(i)){const k=i[S],p=c?c+S:S;Array.isArray(k)?n[p]=(0,L.$pn)(k):k instanceof Date?n[p]=k.toISOString():(0,D.$If)(k)?r<2?I(k,n,r+1,p+"."):n[p]=(0,L.$pn)(k):n[p]=k}}function g(i,n){const r=i.msftInternalDomains||[],c=n.getValue("telemetry.internalTesting");return(0,b.$yo)(r)||c}e.$Mo=g;function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$No=w;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const c=[];for(const R of n)for(;;){const V=R.exec(i);if(!V)break;c.push([V.index,R.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(r="";;){const R=k.exec(i);if(!R)break;const V=c.some(([te,x])=>R.index<x&&te<k.lastIndex);!S.test(R[0])&&!V&&(r+=i.substring(p,R.index)+"<REDACTED: user-file-path>",p=k.lastIndex)}return p<i.length&&(r+=i.substr(p)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$mn)(i,r=>{if(r instanceof a||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let c=r.replaceAll("%20"," ");c=s(c,n);for(const S of n)c=c.replace(S,"");return c=o(c),c}})}e.$Oo=t}),define(ie[27],se([0,1,29,21,37,13,11,9,35,39]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$5e)(t.id,i.id)===0}e.$Po=P;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,n,r)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new m({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Qo=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=f.exec(t);return i&&i[1]?[d(i[1]),i[2]]:[d(t),void 0]}e.$Ro=E;function y(t,i){return`${t}.${i}`}e.$So=y;function d(t){return t.toLowerCase()}e.$To=d;function l(t,i){return d(y(t??j.$fm,i))}e.$Uo=l;function $(t,i){const n=[],r=c=>{for(const S of n)if(S.some(k=>P(i(k),i(c))))return S;return null};for(const c of t){const S=r(c);S?S.push(c):n.push([c])}return n}e.$Vo=$;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Wo=I;function g(t){return{id:new a.$zo(t.identifier.id),name:new a.$zo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Xo=g,e.$Yo=new j.$jm("pprice.better-merge");function w(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&n.every(S=>!P(S.identifier,{id:c}))){const S=t.filter(k=>P(k.identifier,{id:c}));S.length===1&&(n.push(S[0]),r.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Zo=w;async function s(t,i){if(!N.$k)return!1;let n;try{n=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,b.$0)(c))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$jo)(n?"alpine":N.$u,u.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$1o=o}),define(ie[141],se([0,1,20,9,15,17,42,11,94,21,27,37]),function(X,e,L,D,j,N,A,b,u,a,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;const m=y=>(0,u.localize)(0,null,y),f=(0,u.localize)(1,null,"ms-dotnettools.csharp");let E=class{constructor(d,l,$){this.a=d,this.b=l,this.d=$}get f(){}async listExtensions(d,l,$){let I=await this.b.getInstalled(1,$);const g=O.$im.map(s=>s.toLowerCase());if(l&&l!==""){if(g.indexOf(l.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}I=I.filter(s=>s.manifest.categories?s.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.a.info("Possible Categories: "),g.forEach(s=>{this.a.info(s)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),I=I.sort((s,o)=>s.identifier.id.localeCompare(o.identifier.id));let w;for(const s of I)w!==s.identifier.id&&(w=s.identifier.id,this.a.info(d?`${w}@${s.manifest.version}`:w))}async installExtensions(d,l,$,I){const g=[];try{const w=[];d.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const s=[];let o=[];const t=(n,r,c)=>{o.push({id:n,version:r!=="prerelease"?r:void 0,installOptions:{...$,isBuiltin:c,installPreReleaseVersion:r==="prerelease"||$.installPreReleaseVersion}})};for(const n of d)if(n instanceof b.URI)s.push({vsix:n,installOptions:$});else{const[r,c]=(0,P.$Ro)(n);t(r,c,!1)}for(const n of l)if(n instanceof b.URI)s.push({vsix:n,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,c]=(0,P.$Ro)(n);t(r,c,!0)}const i=await this.b.getInstalled(1,$.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:n,installOptions:r})=>{try{const c=await this.g(n,r,I,i);c&&w.push(c)}catch(c){this.a.error(c),g.push(n.toString())}})),o.length&&(o=o.filter(({id:n,version:r})=>{const c=i.find(S=>(0,P.$Po)(S.identifier,{id:n}));if(c){if(!I&&(!r||r==="prerelease"&&c.preRelease))return this.a.info((0,u.localize)(5,null,n,c.manifest.version,n)),!1;if(r&&c.manifest.version===r)return this.a.info((0,u.localize)(6,null,`${n}@${r}`)),!1}return!0}),o.length)){const n=await this.h(o);await Promise.all(o.map(async r=>{const c=n.get(r.id.toLowerCase());if(c)try{const S=await this.j(r,c,i);S&&w.push(S)}catch(S){this.a.error(S.message||S.stack||S),g.push(r.id)}else this.a.error(`${m(r.version?`${r.id}@${r.version}`:r.id)}
${f}`),g.push(r.id)}))}}catch(w){throw this.a.error((0,u.localize)(7,null,(0,D.$0)(w))),w}if(g.length)throw new Error((0,u.localize)(8,null,g.join(", ")))}async updateExtensions(d){const l=await this.b.getInstalled(1,d),$=[];for(const s of l)s.identifier.uuid&&$.push({...s.identifier,preRelease:s.preRelease});this.a.trace((0,u.localize)(9,null,$.length));const I=await this.d.getExtensions($,{compatible:!0},L.CancellationToken.None),g=[];for(const s of I)for(const o of l)(0,P.$Po)(o.identifier,s.identifier)&&(0,A.gt)(s.version,o.manifest.version)&&g.push({extension:s,options:{operation:3,installPreReleaseVersion:o.isPreReleaseVersion}});if(!g.length){this.a.info((0,u.localize)(10,null));return}this.a.info((0,u.localize)(11,null,g.map(s=>s.extension.identifier.id).join(", ")));const w=await this.b.installGalleryExtensions(g);for(const s of w)s.error?this.a.error((0,u.localize)(12,null,s.identifier.id,(0,D.$0)(s.error))):this.a.info((0,u.localize)(13,null,s.identifier.id,s.local?.manifest.version))}async g(d,l,$,I){const g=await this.b.getManifest(d);if(!g)throw new Error("Invalid vsix");if(await this.l(g,$,l.profileLocation,I))try{return await this.b.install(d,l),this.a.info((0,u.localize)(14,null,(0,N.$Cg)(d))),g}catch(s){if((0,D.$4)(s))return this.a.info((0,u.localize)(15,null,(0,N.$Cg)(d))),null;throw s}return null}async h(d){const l=new Map,$=d.some(w=>w.installOptions.installPreReleaseVersion),I=await this.b.getTargetPlatform(),g=[];for(const w of d)a.$co.test(w.id)&&g.push({...w,preRelease:$});if(g.length){const w=await this.d.getExtensions(g,{targetPlatform:I},L.CancellationToken.None);for(const s of w)l.set(s.identifier.id.toLowerCase(),s)}return l}async j({id:d,version:l,installOptions:$},I,g){const w=await this.d.getManifest(I,L.CancellationToken.None);if(w&&!this.k(w))return null;const s=g.find(o=>(0,P.$Po)(o.identifier,I.identifier));if(s){if(I.version===s.manifest.version)return this.a.info((0,u.localize)(16,null,l?`${d}@${l}`:d)),null;this.a.info((0,u.localize)(17,null,d,I.version))}try{$.isBuiltin?this.a.info(l?(0,u.localize)(18,null,d,l):(0,u.localize)(19,null,d)):this.a.info(l?(0,u.localize)(20,null,d,l):(0,u.localize)(21,null,d));const o=await this.b.installFromGallery(I,{...$,installGivenVersion:!!l});return this.a.info((0,u.localize)(22,null,d,o.manifest.version)),w}catch(o){if((0,D.$4)(o))return this.a.info((0,u.localize)(23,null,d)),null;throw o}}k(d){return!0}async l(d,l,$,I){if(!l){const g={id:(0,P.$Uo)(d.publisher,d.name)},w=I.find(s=>(0,P.$Po)(g,s.identifier)&&(0,A.gt)(s.manifest.version,d.version));if(w)return this.a.info((0,u.localize)(24,null,w.identifier.id,w.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,l,$){const I=async w=>{if(w instanceof b.URI){const s=await this.b.getManifest(w);return(0,P.$So)(s.publisher,s.name)}return w},g=[];for(const w of d){const s=await I(w),t=(await this.b.getInstalled(void 0,$)).filter(i=>(0,P.$Po)(i.identifier,{id:s}));if(!t.length)throw new Error(`${this.m(s)}
${f}`);if(t.some(i=>i.type===0)){this.a.info((0,u.localize)(25,null,s));return}if(!l&&t.some(i=>i.isBuiltin)){this.a.info((0,u.localize)(26,null,s));return}this.a.info((0,u.localize)(27,null,s));for(const i of t)await this.b.uninstall(i,{profileLocation:$}),g.push(i);this.f?this.a.info((0,u.localize)(28,null,s,this.f)):this.a.info((0,u.localize)(29,null,s))}}async locateExtension(d){const l=await this.b.getInstalled();d.forEach($=>{l.forEach(I=>{if(I.identifier.id===$&&I.location.scheme===j.Schemas.file){this.a.info(I.location.fsPath);return}})})}m(d){return this.f?(0,u.localize)(30,null,d,this.f):(0,u.localize)(31,null,d)}};e.$wp=E,e.$wp=E=$e([ne(1,a.$po),ne(2,a.$no)],E)}),define(ie[142],se([0,1,8,9,2,15,17,42,3,28,24,48,25,18,21,27,60,12,6]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let g=class extends j.$Tc{static{I=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,A.$Fg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$oo(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===$.LogLevel.Trace)}catch(c){const S=c;if(n=S.code,S.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${S.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(k){this.r.error(k)}throw new E.$oo(O.$Ap,E.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(c){this.r.error(c)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,u.$Mf)(o)?o:!0}async u(s){await this.g;const o=(0,A.$Fg)(this.extensionsDownloadDir,`${this.z(s)}${I.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==N.Schemas.file){await t(o);return}const i=(0,A.$Fg)(this.extensionsDownloadDir,`.${(0,a.$og)()}`);await this.h.exists(i)||await t(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const c of s.children)if(c.name.endsWith(I.c))i.push(c.resource);else{const S=y.$Qo.parse(c.name);S&&t.push([S,c])}const n=(0,y.$Vo)(t,([c])=>c),r=[];for(const c of n)c.sort((S,k)=>b.rcompare(S[0].version,k[0].version)),o.push(...c.slice(1).map(S=>S[1].resource)),r.push(c[0][1]);r.sort((c,S)=>c.mtime-S.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(c=>c.resource)),o.push(...i),await L.Promises.settled(o.map(c=>(this.r.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Qo.create(s).toString().toLowerCase():(0,a.$og)()}};e.$Tp=g,e.$Tp=g=I=$e([ne(0,f.$_h),ne(1,l.$ok),ne(2,E.$no),ne(3,m.$xi),ne(4,d.$up),ne(5,$.$lj)],g)}),define(ie[143],se([0,1,4,2,31,27,37]),function(X,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class b extends D.$Tc{constructor(a,P,O,m,f,E,y){super(),this.f=a,this.g=P,this.h=O,this.j=m,this.m=f,this.n=E,this.r=y,this.a=this.B(new L.$Td),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,d=>y.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(P=>(this.c.set(P.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(a){for(const P of a.extensions)this.I(this.L(P.identifier,P.version),a.profileLocation)}async y(a){for(const P of a.extensions){const O=this.L(P.identifier,P.version);a.error?this.J(O,a.profileLocation):this.I(O,a.profileLocation)}}async z(a){for(const P of a.extensions)this.J(this.L(P.identifier,P.version),a.profileLocation)}async C(a){const P=[],O=[];for(const m of a.extensions){const f=this.L(m.identifier,m.version);a.error?this.I(f,a.profileLocation):(this.J(f,a.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),O.push(this.f.scanInstalledExtensionAtLocation(m.location).then(E=>{E?P.push(E):this.r.info("Extension not found at the location",m.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(O),P.length&&await this.H(P)}catch(m){this.r.error(m)}}D(a){for(const P of this.h.profiles)a.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(a){const P=[],O=[],m=await this.j.scanProfileExtensions(a),f=new Set,E=new Set;for(const[y,d]of this.b)d.has(a)&&E.add(y);for(const y of m){const d=this.L(y.identifier,y.version);f.add(d),E.has(d)||(P.push(y.identifier),this.I(d,a))}for(const y of E)if(!f.has(y)){const d=this.M(y);d&&(O.push(d.identifier),this.J(y,a))}(P.length||O.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:a}:void 0,removed:O.length?{extensions:O,profileLocation:a}:void 0})}async G(a){const P=await this.j.scanProfileExtensions(a);for(const O of P)this.I(this.L(O.identifier,O.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,P){let O=this.b.get(a);O||this.b.set(a,O=new j.$Bc(m=>this.m.extUri.getComparisonKey(m))),O.add(P)}J(a,P){const O=this.b.get(a);O&&O.delete(P),O?.size||this.b.delete(a)}L(a,P){return`${A.$jm.toKey(a.id)}@${P}`}M(a){const[P,O]=(0,N.$Ro)(a);return O?{identifier:{id:P},version:O}:void 0}}e.$Xp=b}),define(ie[144],se([0,1,115,39]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;async function j(N,A,b,u,a,P,O){const m={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$Ho)(A,b)&&(0,D.$Jo)(u)===3){const f=await(0,L.$pp)(b,a,P);m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=O.machineId||f}return m}e.$qp=j}),define(ie[145],se([0,1,172,19,8,2,15,16,24,18,21,27,6,64,11]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let y=class extends f.$0q{constructor(I,g,w,s){super(w),this.h=I,this.j=s,this.g=this.B(new d(g,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(I,g){const s=(await this.g.getLanguagePacks())[g];if(!s){this.j.warn(`No language pack found for ${g}`);return}const o=s.translations[I];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),g=Object.keys(I).map(w=>{const s=I[w];return{...this.f(w,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((w,s)=>w.label.localeCompare(s.label)),g}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const g=await this.g.getLanguagePacks();Object.keys(g).some(w=>g[w]&&g[w].extensions.some(s=>(0,O.$Po)(s.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),w=await this.g.update(g);return!(0,D.$ub)(Object.keys(I),Object.keys(w))}};e.$$q=y,e.$$q=y=$e([ne(0,P.$po),ne(1,a.$_h),ne(2,P.$no),ne(3,m.$lj)],y);let d=class extends N.$Tc{constructor(I,g){super(),this.j=g,this.c={},this.f=(0,b.$jc)(I.userDataPath,"languagepacks.json"),this.g=new j.$$g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(g=>{Object.keys(g).forEach(w=>delete g[w]),this.m(g,...I)}).then(()=>this.c)}m(I,...g){for(const w of g)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.n(I,w);Object.keys(I).forEach(w=>this.r(I[w]))}n(I,g){const w=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const o of s)if(g.location.scheme===A.Schemas.file&&l(o)){let t=I[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},I[o.languageId]=t);const i=t.extensions.filter(n=>(0,O.$Po)(n.extensionIdentifier,w))[0];i?i.version=g.manifest.version:t.extensions.push({extensionIdentifier:w,version:g.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$jc)(g.location.fsPath,n.path)}}r(I){if(I){const g=(0,L.createHash)("md5");for(const w of I.extensions)g.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);I.hash=g.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let g=null;return u.Promises.readFile(this.f,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(g=I(w),w)).then(w=>{for(const o of Object.keys(w))w[o]||delete w[o];this.c=w,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),u.Promises.writeFile(this.f,s)}).then(()=>g,w=>this.j.error(w))})}};d=$e([ne(0,a.$_h),ne(1,m.$lj)],d);function l($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const I of $.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(ie[146],se([0,1,81,9,30,39]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function u(P,O,m){const f=await(0,L.$8C)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$8C)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new f.AppInsightsCore,d=new E.PostChannel,l={instrumentationKey:P,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(m){l.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};l.extensionConfig[d.identifier]=$}return y.initialize(l,[]),y.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',O&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),y}class a{constructor(O,m,f,E,y){this.e=O,this.f=m,this.g=f,this.h=y,this.c=A,this.d=b,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{O(m)},m=>{(0,D.$1)(m),console.error(m)})}}log(O,m){if(!this.a)return;m=(0,j.$nn)(m,this.g),m=(0,N.$Ko)(m);const f=this.f+"/"+O;try{this.i(E=>{E.pluginVersionString=m?.properties.version??"Unknown",E.track({name:f,baseData:{name:f,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$0N=a}),define(ie[147],se([0,1,2,30,13,29,106,25,43,148,32,36,26,39]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,$,I){this.k=$,this.l=I,this.d={},this.i=new L.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,N.$Me)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Me)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(m.$Al)||g.affectsConfiguration(m.$Cl)||g.affectsConfiguration(m.$Bl))&&this.m()}))}setExperimentProperty(l,$){this.d[l]=$}m(){let l=(0,f.$Jo)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const I=$.usage?3:$.error?2:0;l=Math.min(l,I)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,$,I){this.g<$||(I=(0,D.$nn)(I,this.d),I=(0,f.$Oo)(I,this.j),I=(0,D.$nn)(I,this.c),this.b.forEach(g=>g.log(l,I)))}publicLog(l,$){this.n(l,3,$)}publicLog2(l,$){this.publicLog(l,$)}publicLogError(l,$){this.h&&this.n(l,2,$)}publicLogError2(l,$){this.publicLogError(l,$)}};e.$er=E,e.$er=E=$e([ne(1,b.$xi),ne(2,P.$Dj)],E);function y(){const d=(0,A.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=j.$o?"":(0,A.localize)(3,null),I=(0,A.localize)(4,null),g=(0,A.localize)(5,null),w=(0,A.localize)(6,null),s=(0,A.localize)(7,null),o=`
|       | ${I} | ${g} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${d} ${l} ${$}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}O.$wn.as(u.$Bn.Configuration).registerConfiguration({id:m.$zl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[m.$Al]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$wn.as(u.$Bn.Configuration).registerConfiguration({id:m.$zl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[m.$Cl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${m.$Al}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[149],se([0,1,14,20,173,146]),function(X,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;async function A(P,O){const m=await O.request(P,D.CancellationToken.None),f=(await(0,L.$te)(m.stream)).toString(),E=m.res.statusCode??200;return{headers:m.res.headers,statusCode:E,responseData:f}}async function b(P){const O={method:P.type,headers:P.headers};return new Promise((f,E)=>{const y=j.request(P.url??"",O,d=>{d.on("data",function(l){f({headers:d.headers,statusCode:d.statusCode??200,responseData:l.toString()})}),d.on("error",function(l){E(l)})});y.write(P.data,d=>{d&&E(d)}),y.end()})}async function u(P,O,m){const f=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),E={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:f};try{const y=P?await A(E,P):await b(E);m(y.statusCode,y.headers,y.responseData)}catch{m(0,{})}}class a extends N.$0N{constructor(O,m,f,E,y){const d={sendPOST:(l,$)=>{u(O,l,$)}};super(m,f,E,y,d)}}e.$$N=a}),define(ie[150],se([0,1,16,24]),function(X,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;async function j(N,A){const b=Object.create(null),u=(P,O)=>{const m=JSON.parse(P);b[O]=m};if(A){const P=[],O=await D.Promises.readdir(A);for(const f of O)try{(await D.Promises.stat((0,L.$jc)(A,f))).isDirectory()&&P.push(f)}catch{}const m=[];for(const f of P)(await D.Promises.readdir((0,L.$jc)(A,f))).filter(y=>y==="telemetry.json").length===1&&m.push(f);for(const f of m){const E=(await D.Promises.readFile((0,L.$jc)(A,f,"telemetry.json"))).toString();u(E,f)}}let a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(b,null,4)}e.$8$b=j}),define(ie[151],se([0,1,13,82,26]),function(X,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$b=e.$n$b=void 0;async function N(b,u){let a=b.getItem(j.$xl);return(typeof a!="string"||L.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$9m)(u.error.bind(u))),a}e.$n$b=N;async function A(b,u){let a=b.getItem(j.$yl);return typeof a!="string"&&(a=await(0,D.$0m)(u.error.bind(u))),a}e.$o$b=A}),define(ie[22],se([0,1,10]),function(X,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=void 0,e.$Yk=(0,L.$4h)("IUriIdentityService")}),define(ie[152],se([0,1,22,116,12,17,73,4,2]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;class a{static{this._clock=0}constructor(m){this.uri=m,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let P=class{constructor(m){this.g=m,this.c=new u.$Sc,this.f=2**16;const f=new Map,E=y=>{let d=f.get(y.scheme);return d===void 0&&(d=m.hasProvider(y)&&!this.g.hasCapability(y,1024),f.set(y.scheme,d)),d};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new N.$ug(E),this.d=new A.$Pr((y,d)=>this.extUri.compare(y,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,N.$Gg)(m));const f=this.d.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new a(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((E,y)=>E[1].time<y[1].time?1:E[1].time>y[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let E=0;E<f;E++)this.d.set(m[E][0],m[E][1].touch())}};e.$Qr=P,e.$Qr=P=$e([ne(0,j.$ok)],P),(0,D.$Nr)(L.$Yk,P,1)}),define(ie[153],se([0,1,4,2,12,47,31]),function(X,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;class b extends D.$Tc{constructor(a,P,O,m,f,E){super(),this.f=a,this.g=P,this.h=O,this.j=m,this.m=f,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Td),this.onDidChangeFile=this.a.event,this.b=N.$0h.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,P){return this.g.open(this.t(a),P)}close(a){return this.g.close(a)}read(a,P,O,m,f){return this.g.read(a,P,O,m,f)}write(a,P,O,m,f){return this.g.write(a,P,O,m,f)}watch(a,P){this.b.set(a,a);const O=this.g.watch(this.t(a),P);return(0,D.$Rc)(()=>{this.b.delete(a),O.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,P,O){return this.g.rename(this.t(a),this.t(P),O)}readFile(a,P){return this.g.readFile(this.t(a),P)}readFileStream(a,P,O){return this.g.readFileStream(this.t(a),P,O)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,P,O){return this.g.writeFile(this.t(a),P,O)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,P){return this.g.delete(this.t(a),P)}copy(a,P,O){if((0,j.$sk)(this.g))return this.g.copy(this.t(a),this.t(P),O);throw new Error("copy not supported")}cloneFile(a,P){if((0,j.$tk)(this.g))return this.g.cloneFile(this.t(a),this.t(P));throw new Error("clone not supported")}s(a){const P=[];for(const O of a){if(O.resource.scheme!==this.f)continue;const m=this.u(O.resource);this.b.findSubstr(m)&&P.push({resource:m,type:O.type,cId:O.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$L$b=b}),define(ie[154],se([0,1,108,16,47,17,11,10,15]),function(X,e,L,D,j,N,A,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.WorkbenchState=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=void 0,e.$ai=(0,b.$4h)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$bi=a;function P(i){return typeof i?.id=="string"&&!a(i)&&!m(i)}e.$ci=P,e.$di={id:"ext-dev"},e.$ei={id:"empty-window"};function O(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:n?e.$di:e.$ei;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$fi=O;function m(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$gi=m;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$hi=f;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ii=y;function d(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ji=d;class l{constructor(n,r,c,S,k){this.h=n,this.j=c,this.k=S,this.l=k,this.c=j.$0h.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=j.$0h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ki=l;class ${constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,N.$Fg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$li=$;function I(i){return new $({uri:i,index:0,name:(0,N.$Bg)(i)},{uri:i.toString()})}e.$mi=I,e.$ni="code-workspace",e.$oi=`.${e.$ni}`,e.$pi=[{name:(0,L.localize)(0,null),extensions:[e.$ni]}],e.$qi="workspace.json";function g(i,n){return N.$wg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ri=g;function w(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$si=w,e.$ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ti}e.$ui=s;function o(i,n){return!g(i,n)&&!w(i)}e.$vi=o;function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,N.$Dg)(i))===e.$oi}e.$wi=t}),define(ie[23],se([0,1,41,4,2,17,11,107,18,12,10,6,154,31,22,8,28,29,3]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.ProfileResourceType=void 0;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Zk=g,e.$1k=(0,P.$4h)("IUserDataProfilesService");function w(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$2k=w;function s(i,n,r,c,S,k){return{id:i,name:n,location:r,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:k&&S?.useDefaultFlags?.globalState?k.globalStorageHome:(0,N.$Fg)(r,"globalStorage"),settingsResource:k&&S?.useDefaultFlags?.settings?k.settingsResource:(0,N.$Fg)(r,"settings.json"),keybindingsResource:k&&S?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,N.$Fg)(r,"keybindings.json"),tasksResource:k&&S?.useDefaultFlags?.tasks?k.tasksResource:(0,N.$Fg)(r,"tasks.json"),snippetsHome:k&&S?.useDefaultFlags?.snippets?k.snippetsHome:(0,N.$Fg)(r,"snippets"),extensionsResource:k&&S?.useDefaultFlags?.extensions?k.extensionsResource:(0,N.$Fg)(r,"extensions.json"),cacheHome:(0,N.$Fg)(c,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$3k=s;let o=class extends j.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,c,S){super(),this.t=n,this.u=r,this.w=c,this.y=S,this.f=!0,this.h=this.B(new D.$Td),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Td),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Td),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Td),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$Fg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$Fg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,$.$Gf)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}r.push(s((0,N.$Cg)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},n))}}catch(k){this.y.error(k)}const c=new f.$Ac,S=new Map;if(r.length)try{const k=this.Q();if(k.workspaces)for(const[p,R]of Object.entries(k.workspaces)){const V=A.URI.parse(p),te=r.find(x=>x.id===R);te&&c.set(V,te)}if(k.emptyWindows)for(const[p,R]of Object.entries(k.emptyWindows)){const V=r.find(te=>te.id===R);V&&S.set(p,V)}}catch(k){this.y.error(k)}this.z={profiles:r,workspaces:c,emptyWindows:S}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",c=new RegExp(`${(0,l.$Me)(r)}\\s(\\d+)`);let S=0;for(const p of this.profiles){const R=c.exec(p.name),V=R?parseInt(R[1]):0;S=V>S?V:S}const k=`${r} ${S+1}`;return this.createProfile((0,L.$Ri)((0,d.$og)()).toString(16),k,{transient:!0},n)}async createNamedProfile(n,r,c){return this.createProfile((0,L.$Ri)((0,d.$og)()).toString(16),n,r,c)}async createProfile(n,r,c,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(n,r,c);return S&&await this.setProfileForWorkspace(S,k),k}async F(n,r,c){if(!(0,$.$Gf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(r);return S||(S=(async()=>{try{const k=this.profiles.find(V=>V.name===r||V.id===n);if(k)return k;const p=s(n,r,(0,N.$Fg)(this.profilesHome,n),this.g,c,this.defaultProfile);await this.u.createFolder(p.location);const R=[];return this.j.fire({profile:p,join(V){R.push(V)}}),await y.Promises.settled(R),this.I([p],[],[]),p}finally{this.r.delete(r)}})(),this.r.set(r,S)),S}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(S=>S.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);return c=s(c.id,r.name??c.name,c.location,this.g,{shortName:r.shortName??c.shortName,icon:r.icon===null?void 0:r.icon??c.icon,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(S=>S.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const c=[];this.m.fire({profile:r,join(S){c.push(S)}});try{await Promise.allSettled(c)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(S){(0,a.$Fk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(S=>S.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,c)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,m.$bi)(n)?n.uri:(0,m.$gi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,c){const S=[...this.profiles,...n],k=[];this.s.profiles=[];for(let p of S)p.isDefault||r.some(R=>p.id===R.id)||(p=c.find(R=>p.id===R.id)??p,p.isTransient?this.s.profiles.push(p):k.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(k),this.z=void 0,this.J(n,r,c)}J(n,r,c){this.h.fire({added:n,removed:r,updated:c,all:this.profiles})}L(n,r,c){c=r?.isTransient?!0:c,c||this.L(n,void 0,!0);const S=this.G(n),k=c?this.s:this.C;A.URI.isUri(S)?(k.workspaces.delete(S),r&&k.workspaces.set(S,r)):(k.emptyWindows.delete(S),r&&k.emptyWindows.set(S,r)),c||this.M()}M(){const n={};for(const[c,S]of this.C.workspaces.entries())n[c.toString()]=S.id;const r={};for(const[c,S]of this.C.emptyWindows.entries())r[c.toString()]=S.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},c=this.D();if(n.workspaces)for(const[k,p]of Object.entries(n.workspaces)){const R=A.URI.parse(p);r[k]=this.w.extUri.isEqual(R,c.location)?c.id:this.w.extUri.basename(R)}const S={};if(n.emptyWindows)for(const[k,p]of Object.entries(n.emptyWindows)){const R=A.URI.parse(p);S[k]=this.w.extUri.isEqual(R,c.location)?c.id:this.w.extUri.basename(R)}return{workspaces:r,emptyWindows:S}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$4k=o,e.$4k=o=$e([ne(0,u.$$h),ne(1,a.$ok),ne(2,E.$Yk),ne(3,O.$lj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$5k=t}),define(ie[155],se([0,1,19,8,20,9,4,2,13,3,11,92,21,27,37,6,32,26,22,23]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;let g=class extends b.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,c,S,k,p){super(),this.z=n,this.C=r,this.D=c,this.F=S,this.G=k,this.H=p,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Td),this.s=this.B(new A.$Td),this.t=this.B(new A.$Td),this.u=this.B(new A.$Td),this.w=this.B(new A.$Td),this.y=[],this.B((0,b.$Rc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(c=>(0,m.$lo)(c,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const S=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:k})=>(0,f.$Po)(k,n.identifier));if(S?.local)return S?.local;throw S?.error?S.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(c){throw s(c)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new m.$oo(O.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],c=[];await Promise.allSettled(n.map(async({extension:S,options:k})=>{try{const p=await this.O(S,!!k?.installGivenVersion,!!k?.installPreReleaseVersion);c.push({...p,options:k})}catch(p){r.push({identifier:S.identifier,operation:2,source:S,error:p})}})),c.length&&r.push(...await this.I(c));for(const S of r)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!P.URI.isUri(S.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Xo)(S.source),error:S.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$mm)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let c=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(c=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const S of this.H.profiles){const k=(await this.getInstalled(1,S.extensionsResource)).find(p=>(0,f.$Po)(p.identifier,n.identifier));k?this.w.fire(k):this.u.fire({identifier:n.identifier,profileLocation:S.extensionsResource})}return c}else{const c=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async c=>{try{const S=await this.J(c,(k,p)=>n.some(R=>(0,f.$To)(p.identifier.id)===(0,f.$Uo)(R.manifest.publisher,R.manifest.name))?!1:this.L(k,p));r.push(...S)}catch(S){r.push({identifier:{id:(0,f.$Uo)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:S})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:c},S){const k=c.isApplicationScoped||c.isBuiltin||(0,E.$mm)(n),p={...c,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:c.profileLocation??this.Y()},R=he=>`${f.$Qo.create(he).toString()}${p.profileLocation?`-${p.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const he=this.j.get(R(r));if(he)return this.F.info("Extensions is already requested to install",r.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const V=[],te=[],x=[],oe=this.Z(n,r,p);P.URI.isUri(r)||this.j.set(R(r),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:r,profileLocation:p.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),V.push({task:oe,manifest:n});let re=!1;try{if(p.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,n,!!p.installOnlyNewlyAddedFromExtensionPack,!!p.installPreReleaseVersion,p.profileLocation),ae=await this.getInstalled(void 0,p.profileLocation),B={...p,donotIncludePackAndDependencies:!0,context:{...p.context,[m.$go]:!0}};for(const{gallery:Q,manifest:M}of(0,L.$Mb)(ce,({gallery:C})=>C.identifier.id)){re=re||!!M.extensionDependencies?.some(J=>(0,f.$Po)({id:J},oe.identifier));const C=R(Q),H=this.j.get(C);if(H){if(S(oe,H.task)){const J=H.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,oe.identifier.id),H.waitingTasks.push(oe),te.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Y=>Y.some(K=>(0,f.$Po)(K.identifier,J)))).then(Y=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,oe.identifier.id),!Y.find(T=>(0,f.$Po)(T.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!ae.some(({identifier:J})=>(0,f.$Po)(J,Q.identifier))){const J=this.Z(M,Q,B);this.j.set(C,{task:J,waitingTasks:[oe]}),this.n.fire({identifier:J.identifier,source:Q,profileLocation:p.profileLocation}),this.F.info("Installing extension:",J.identifier.id,oe.identifier.id),V.push({task:J,manifest:M})}}}catch(ce){if(P.URI.isUri(oe.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const he=V.reduce((ce,{task:ae,manifest:B})=>(ce.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:B}),ce),new Map);for(;he.size;){let ce;const ae=[...he.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(Q=>he.has(Q.toLowerCase())));ae.length?ce=he.size===1?ae:ae.filter(({task:B})=>!(B===oe&&!re)):(this.F.info("Found extensions with circular dependencies",ae.map(({task:B})=>B.identifier.id)),ce=[...he.values()]),await this.M(ce.map(async({task:B})=>{const Q=new Date().getTime();try{const M=await B.run();if(await this.M(this.y.map(C=>C.postInstall(M,B.source,p,j.CancellationToken.None))),!P.URI.isUri(B.source)){const C=B.operation===3,H=C?void 0:(new Date().getTime()-B.source.lastUpdated)/1e3;if(o(this.C,C?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Xo)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:H}),u.$o&&B.operation!==3)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}x.push({local:M,identifier:B.identifier,operation:B.operation,source:B.source,context:B.options.context,profileLocation:B.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw P.URI.isUri(B.source)||o(this.C,B.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Xo)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-Q,error:M}),this.F.error("Error while installing the extension",B.identifier.id,(0,N.$0)(M)),M}finally{he.delete(B.identifier.id.toLowerCase())}}))}return te.length&&await this.M(te),x.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),x}catch(he){if(V.forEach(({task:ce})=>ce.cancel()),x.length)try{const ce=await Promise.allSettled(x.map(({local:ae})=>this.$(ae,{versionOnly:!0,profileLocation:p.profileLocation}).run()));for(let ae=0;ae<ce.length;ae++){const B=ce[ae],{identifier:Q}=x[ae];B.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,N.$0)(B.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,N.$0)(ce),x.map(({identifier:ae})=>ae.id))}return V.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:p.context,profileLocation:p.profileLocation,error:he}))}finally{for(const{task:he}of V)he.source&&!P.URI.isUri(he.source)&&this.j.delete(R(he.source))}}L(n,r){for(const[,{task:c,waitingTasks:S}]of this.j.entries())if(c===n&&(S.includes(r)||S.some(k=>this.L(k,r)))||c===r&&S[0]&&!this.L(n,S[0]))return!1;return!0}async M(n){const r=[],c=[],S=await Promise.allSettled(n);for(const k of S)k.status==="fulfilled"?r.push(k.value):c.push(k.reason);if(c.length)throw w(c);return r}async N(n,r,c,S,k){if(!this.z.isEnabled())return[];const p=await this.getInstalled(void 0,k),R=[],V=[],te=async(x,oe)=>{R.push(x);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const ce=c?p.find(ae=>(0,f.$Po)(ae.identifier,x)):void 0;for(const ae of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(B=>(0,f.$Po)({id:B},{id:ae}))||he.every(B=>!(0,f.$Po)({id:B},{id:ae}))&&he.push(ae)}if(he.length){const ce=he.filter(ae=>R.every(B=>!(0,f.$Po)(B,{id:ae})));if(ce.length){const ae=await this.z.getExtensions(ce.map(B=>({id:B,preRelease:S})),j.CancellationToken.None);for(const B of ae){if(R.find(C=>(0,f.$Po)(C,B.identifier)))continue;const Q=re.some(C=>(0,f.$Po)({id:C},B.identifier));let M;try{M=await this.O(B,!1,S)}catch(C){if(Q)throw C;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,N.$0)(C));continue}V.push({gallery:M.extension,manifest:M.manifest}),await te(M.extension.identifier,M.manifest)}}}};return await te(n,r),V}async O(n,r,c){let S;const k=await this.getExtensionsControlManifest();if(k.malicious.some(V=>(0,f.$Po)(n.identifier,V)))throw new m.$oo(O.localize(1,null,n.identifier.id),m.ExtensionManagementErrorCode.Malicious);const p=k.deprecated[n.identifier.id.toLowerCase()];if(p?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${p.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:p.extension.id,preRelease:p.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!S)throw new m.$oo(O.localize(2,null,n.identifier.id,p.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const V=await this.getTargetPlatform();throw new m.$oo(O.localize(3,null,n.identifier.id,this.G.nameLong,(0,m.$ho)(V)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.P(n,r,c),!S)throw!c&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],j.CancellationToken.None))[0]?new m.$oo(O.localize(4,null,n.displayName??n.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$oo(O.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const R=await this.z.getManifest(S,j.CancellationToken.None);if(R===null)throw new m.$oo(`Missing manifest for extension ${S.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(R.version!==S.version)throw new m.$oo(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:R}}async P(n,r,c){const S=await this.getTargetPlatform();let k=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==c&&(k=(await this.z.getExtensions([{...n.identifier,preRelease:c}],{targetPlatform:S,compatible:!0},j.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(n,c,S)&&(k=n),k||(r?k=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:S,compatible:!0},j.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(n,c,S)),k}async Q(n,r){const c={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},S=x=>`${x.id.toLowerCase()}${c.versionOnly?`-${n.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,k=this.m.get(S(n.identifier));if(k)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),k.waitUntilTaskIsFinished();const p=x=>{const oe=this.$(x,c);return this.m.set(S(oe.extension.identifier),oe),c.profileLocation?this.F.info("Uninstalling extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString()):this.F.info("Uninstalling extension:",`${x.identifier.id}@${x.manifest.version}`),this.t.fire({identifier:x.identifier,profileLocation:c.profileLocation,applicationScoped:x.isApplicationScoped}),oe},R=(x,oe)=>{oe?c.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${x.identifier.id}@${x.manifest.version}`,oe.message):c.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${x.identifier.id}@${x.manifest.version}`,c.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${x.identifier.id}@${x.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Wo)(x),error:oe}),this.u.fire({identifier:x.identifier,error:oe?.code,profileLocation:c.profileLocation,applicationScoped:x.isApplicationScoped})},V=[],te=[];try{V.push(p(n));const x=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const oe=this.U(n,x);for(const re of oe)this.m.has(S(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):V.push(p(re))}c.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(V.map(oe=>oe.extension),x,n),await this.M(V.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(re=>re.postUninstall(oe.extension,c,j.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}R(oe.extension)}catch(re){const he=re instanceof m.$oo?re:new m.$oo((0,N.$0)(re),m.ExtensionManagementErrorCode.Internal);throw R(oe.extension,he),he}finally{te.push(oe)}}))}catch(x){const oe=x instanceof m.$oo?x:new m.$oo((0,N.$0)(x),m.ExtensionManagementErrorCode.Internal);for(const re of V){try{re.cancel()}catch{}te.includes(re)||R(re.extension,oe)}throw oe}finally{for(const x of V)this.m.delete(S(x.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",x.extension.identifier.id)}}R(n,r,c){for(const S of n){const k=this.W(S,r);if(k.length){const p=k.filter(R=>!n.some(V=>(0,f.$Po)(V.identifier,R.identifier)));if(p.length)throw new Error(this.S(S,p,c))}}}S(n,r,c){return c===n?r.length===1?O.localize(6,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,c.manifest.displayName||c.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,c=[]){if(c.indexOf(n)!==-1)return[];c.push(n);const S=n.manifest.extensionPack?n.manifest.extensionPack:[];if(S.length){const k=r.filter(R=>!R.isBuiltin&&S.some(V=>(0,f.$Po)({id:V},R.identifier))),p=[];for(const R of k)p.push(...this.U(R,r,c));return[...k,...p]}return[]}W(n,r){return r.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(S=>(0,f.$Po)({id:S},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Fp=g,e.$Fp=g=$e([ne(0,m.$no),ne(1,l.$sl),ne(2,$.$Yk),ne(3,y.$lj),ne(4,d.$Dj),ne(5,I.$1k)],g);function w(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,c)=>new Error(`${r.message}${r.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$Gp=w;function s(i){if(i instanceof m.$oo)return i;const n=new m.$oo(i.message,m.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$Hp=s;function o(i,n,{extensionData:r,verificationStatus:c,duration:S,error:k,durationSinceUpdate:p}){let R,V;(0,a.$Of)(c)&&(c===!0?c="Verified":(c===!1||(R=m.ExtensionManagementErrorCode.Signature,V=c),c="Unverified")),k&&(k instanceof m.$oo?(R=k.code,k.code===m.ExtensionManagementErrorCode.Signature&&(V=k.message)):R=m.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:c,success:!k,duration:S,errorcode:R,errorcodeDetail:V,durationSinceUpdate:p})}class t{constructor(){this.d=new D.$3g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Rg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Rg)(n=>new Promise((r,c)=>{const S=n.onCancellationRequested(()=>{S.dispose(),c(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$Ip=t}),define(ie[40],se([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class I extends Error{constructor(t,i){super(t),this.code=i}}e.$Jp=I,e.$Kp=(0,O.$4h)("IExtensionsProfileScannerService");let g=class extends j.$Tc{constructor(t,i,n,r,c,S){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=c,this.t=S,this.b=this.B(new N.$Td),this.onAddExtensions=this.b.event,this.c=this.B(new N.$Td),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$Td),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$Td),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,c=>{const S=[];for(const k of c)t.some(([p])=>(0,a.$Po)(p.identifier,k.identifier)&&p.manifest.version!==k.version)?n.push(k):S.push(k);for(const[k,p]of t){const R=S.findIndex(te=>(0,a.$Po)(te.identifier,k.identifier)&&te.version===k.manifest.version),V={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:p};R===-1?(r.push(V),S.push(V)):S.splice(R,1,V)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),S}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(c){throw r.length&&this.c.fire({extensions:r,error:c,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:c,profileLocation:i}),c}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const c=[];for(const S of r){const k=t.find(([p])=>(0,a.$Po)(p.identifier,S.identifier)&&p.manifest.version===S.version);k&&(S.metadata={...S.metadata,...k[1]},n.push(S)),c.push(S)}return c}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const c=[];for(const S of r)(0,a.$Po)(S.identifier,t.identifier)?n.push(S):c.push(S);return n.length&&this.f.fire({extensions:n,profileLocation:i}),c}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],c;try{const S=await this.m.readFile(t);c=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,P.$Fk)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&n?.bailOutWhenFileNotFound)throw new I((0,d.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.w(t);let S=!1;for(const k of c){w(k)||this.w(t);let p;if((0,y.$Gf)(k.relativeLocation)&&k.relativeLocation)p=this.z(k.relativeLocation);else if((0,y.$Gf)(k.location))p=this.z(k.location),S=!0,k.relativeLocation=k.location,k.location=p.toJSON();else{p=b.URI.revive(k.location);const R=this.y(p);R&&(S=!0,k.relativeLocation=R)}r.push({identifier:k.identifier,location:p,version:k.version,metadata:k.metadata})}S&&await this.m.writeFile(t,D.$he.fromString(JSON.stringify(c)))}if(i){r=i(r);const S=r.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(t,D.$he.fromString(JSON.stringify(S)))}return r})}w(t){const i=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(c){if((0,P.$Fk)(c)===1)return;throw c}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const c=JSON.parse(n);Array.isArray(c)&&c.every(S=>w(S))?r=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$he.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,P.$Fk)(c)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(t)}catch(c){(0,P.$Fk)(c)!==1&&this.t.error(c)}try{await this.m.del(i)}catch(c){(0,P.$Fk)(c)!==1&&this.t.error(c)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$$g,this.h.set(t,i)),i}};e.$Lp=g,e.$Lp=g=$e([ne(1,P.$ok),ne(2,f.$1k),ne(3,E.$Yk),ne(4,l.$sl),ne(5,m.$lj)],g);function w(o){return(0,y.$If)(o)&&(0,u.$mo)(o.identifier)&&(s(o.location)||(0,y.$Gf)(o.location)&&o.location)&&((0,y.$Nf)(o.relativeLocation)||(0,y.$Gf)(o.relativeLocation))&&o.version&&(0,y.$Gf)(o.version)}function s(o){return o?(0,y.$Gf)(o.path)&&(0,y.$Gf)(o.scheme):!1}}),define(ie[51],se([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,96,18,27,37,49,12,10,6,32,4,46,40,23,22,113]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I,g,w,s,o,t,i,n,r,c,S,k,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.Translations=void 0;var V;(function(ae){function B(Q,M){if(Q===M)return!0;const C=Object.keys(Q),H=new Set;for(const J of Object.keys(M))H.add(J);if(C.length!==H.size)return!1;for(const J of C){if(Q[J]!==M[J])return!1;H.delete(J)}return H.size===0}ae.equals=B})(V||(e.Translations=V={})),e.$Op=(0,t.$4h)("IExtensionsScannerService");let te=class extends a.$Tc{constructor(B,Q,M,C,H,J,Y,K,T,F,h,v){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Q,this.r=M,this.s=C,this.t=H,this.u=J,this.w=Y,this.y=K,this.z=T,this.C=F,this.D=h,this.F=v,this.g=this.B(new r.$Td),this.onDidChangeCache=this.g.event,this.h=(0,f.$Fg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$1o)(this.w,this.y)),this.G}async scanAllExtensions(B,Q,M){const[C,H]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Q)]),J=M?await this.scanExtensionsUnderDevelopment(B,[...C,...H]):[];return this.L(C,H,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Q=[];Q.push(this.M(!!B.useCache,B.language)),Q.push(this.N(B.language,!!B.checkControlFile));const[M,C]=await Promise.all(Q);return this.J([...M,...C],0,B,!1)}async scanUserExtensions(B){const Q=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const M=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.P(Q,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),H=B.useCache&&!C.devMode&&C.excludeObsolete?this.m:this.n;let J;try{J=await H.scanExtensions(C)}catch(Y){if(Y instanceof S.$Jp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),J=await H.scanExtensions(C);else throw Y}return J=await this.J(J,1,B,!0),this.y.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(B,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(C=>C.scheme===P.Schemas.file).map(async C=>{const H=await this.P(C,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Y=>(Y.type=Q.find(K=>(0,g.$Po)(K.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,H)))}))).flat();return this.J(M,"development",B,!0)}return[]}async scanExistingExtension(B,Q,M){const C=await this.P(B,!1,Q,!0,M.language,!0,void 0),H=await this.n.scanExtension(C);return!H||!M.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(B,Q,M){const C=await this.P(B,!1,Q,!0,M.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(C);return this.J(H,Q,M,!0)}async scanMetadata(B){const Q=(0,f.$Fg)(B,"package.json"),M=(await this.w.readFile(Q)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,Q){const M=(0,f.$Fg)(B,"package.json"),C=(await this.w.readFile(M)).value.toString(),H=JSON.parse(C);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,H.__metadata={...H.__metadata,...Q},await this.w.writeFile((0,f.$Fg)(B,"package.json"),N.$he.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof S.$Jp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$he.fromString(JSON.stringify([])))}catch(Q){(0,o.$Fk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Q,M,C){return M.includeAllVersions||(B=this.L(Q===0?B:void 0,Q===1?B:void 0,Q==="development"?B:void 0,await this.getTargetPlatform(),C)),M.includeInvalid||(B=B.filter(H=>H.isValid)),B.sort((H,J)=>{const Y=O.$nc(H.location.fsPath),K=O.$nc(J.location.fsPath);return Y<K?-1:Y>K?1:0})}L(B,Q,M,C,H){const J=(K,T,F)=>{if(K.isValid&&!T.isValid)return!1;if(K.isValid===T.isValid){if(H&&E.gt(K.manifest.version,T.manifest.version))return this.y.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,T.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${T.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===C)return this.y.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${K.location.path} with ${T.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${T.location.path}.`),!0},Y=new w.$lm;return B?.forEach(K=>{const T=Y.get(K.identifier.id);(!T||J(T,K,!1))&&Y.set(K.identifier.id,K)}),Q?.forEach(K=>{const T=Y.get(K.identifier.id);if(!T&&B&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!T||J(T,K,!1))&&Y.set(K.identifier.id,K)}),M?.forEach(K=>{const T=Y.get(K.identifier.id);(!T||J(T,K,!0))&&Y.set(K.identifier.id,K),Y.set(K.identifier.id,K)}),[...Y.values()]}async M(B,Q){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),H=await(B&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",H.length),H}async N(B,Q){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const C=Q?await this.O():{},H=[],J=l.URI.file(O.$hc(O.$jc(P.$mg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of M){const T=C[K.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":H.push((0,f.$Fg)(J,K.name));break;default:H.push(l.URI.file(T));break}}const Y=await Promise.all(H.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,L.$Hb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Q,M,C,H,J,Y){const K=await this.f(H??m.$w),T=await this.Q(B),F=Q&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,h=F?await this.Q(F):void 0;return new x(B,T,F,h,Q,Y,M,C,J,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,K)}async Q(B){try{const Q=await this.w.stat(B);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Pp=te,e.$Pp=te=$e([ne(4,k.$1k),ne(5,S.$Kp),ne(6,o.$ok),ne(7,i.$lj),ne(8,I.$$h),ne(9,n.$Dj),ne(10,p.$Yk),ne(11,t.$3h)],te);class x{constructor(B,Q,M,C,H,J,Y,K,T,F,h,v,z,U,W){this.location=B,this.mtime=Q,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=C,this.profile=H,this.profileScanOptions=J,this.type=Y,this.excludeObsolete=K,this.validate=T,this.productVersion=F,this.productDate=h,this.productCommit=v,this.devMode=z,this.language=U,this.translations=W}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Q){return(0,f.$yg)(B.location,Q.location)&&B.mtime===Q.mtime&&(0,f.$yg)(B.applicationExtensionslocation,Q.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&B.profile===Q.profile&&j.$on(B.profileScanOptions,Q.profileScanOptions)&&B.type===Q.type&&B.excludeObsolete===Q.excludeObsolete&&B.validate===Q.validate&&B.productVersion===Q.productVersion&&B.productDate===Q.productDate&&B.productCommit===Q.productCommit&&B.devMode===Q.devMode&&B.language===Q.language&&V.equals(B.translations,Q.translations)}}e.$Qp=x;let oe=class extends a.$Tc{constructor(B,Q,M,C,H){super(),this.f=B,this.g=Q,this.h=M,this.j=C,this.m=H}async scanExtensions(B){const Q=B.profile?await this.r(B):await this.n(B);let M={};if(B.excludeObsolete&&B.type===1)try{const C=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(C)}catch{}return(0,d.$Tf)(M)?Q:Q.filter(C=>!M[g.$Qo.create(C).toString()])}async n(B){const Q=await this.j.resolve(B.location);if(!Q.children?.length)return[];const M=await Promise.all(Q.children.map(async C=>{if(!C.isDirectory||B.type===1&&(0,f.$Cg)(C.resource).indexOf(".")===0)return null;const H=new x(C.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(H)}));return(0,L.$Hb)(M).sort((C,H)=>C.location.path<H.location.path?-1:1)}async r(B){let Q=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){Q=Q.filter(C=>!C.metadata?.isApplicationScoped);const M=await this.s(B.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,B);Q.push(...M)}return Q}async s(B,Q,M){const C=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!C.length)return[];const H=await Promise.all(C.map(async J=>{if(Q(J)){const Y=new x(J.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Y,J.metadata)}return null}));return(0,L.$Hb)(H)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,f.$Fg)(B.location,"package.json"))){const Q=await this.scanExtension(B);return Q?[Q]:[]}else return await this.scanExtensions(B)}catch(Q){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(Q)),[]}}async scanExtension(B,Q){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=w.$fm),Q=Q??M.__metadata,delete M.__metadata;const C=(0,g.$Uo)(M.publisher,M.name),H=Q?.id?{id:C,uuid:Q.id}:{id:C},J=Q?.isSystem?0:B.type,Y=J===0||!!Q?.isBuiltin;M=await this.t(B.location,M,x.createNlsConfiguration(B));const K={type:J,identifier:H,manifest:M,location:B.location,isBuiltin:Y,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return B.validate?this.validate(K,B):K}}catch(M){B.type!==0&&this.m.error(M)}return null}validate(B,Q){let M=!0;const C=(0,s.$6o)(Q.productVersion,Q.productDate,Q.location,B.manifest,B.isBuiltin);for(const[H,J]of C)H===y.default.Error&&(M=!1,this.m.error(this.z(Q.location,J)));return B.isValid=M,B.validations=C,B}async scanExtensionManifest(B){const Q=(0,f.$Fg)(B,"package.json");let M;try{M=(await this.j.readFile(Q)).value.toString()}catch(H){return(0,o.$Fk)(H)!==1&&this.m.error(this.z(B,(0,$.localize)(0,null,Q.path,H.message))),null}let C;try{C=JSON.parse(M)}catch{const J=[];(0,b.$an)(M,J);for(const Y of J)this.m.error(this.z(B,(0,$.localize)(1,null,Q.path,Y.offset,Y.length,(0,u.$Mp)(Y.error))));return null}return(0,b.$jn)(C)!=="object"?(this.m.error(this.z(B,(0,$.localize)(2,null,Q.path))),null):C}async t(B,Q,M){const C=await this.u(B,Q,M);if(C)try{const H=[],J=await this.w(C.default,H);if(H.length>0)return H.forEach(K=>{this.m.error(this.z(B,(0,$.localize)(3,null,C.default?.path,(0,u.$Mp)(K.error))))}),Q;if((0,b.$jn)(C)!=="object")return this.m.error(this.z(B,(0,$.localize)(4,null,C.default?.path))),Q;const Y=C.values||Object.create(null);return(0,R.$Np)(this.m,Q,Y,J)}catch{}return Q}async u(B,Q,M){const C=(0,f.$Fg)(B,"package.nls.json"),H=(T,F)=>{F.forEach(h=>{this.m.error(this.z(B,(0,$.localize)(5,null,T?.path,(0,u.$Mp)(h.error))))})},J=T=>{this.m.error(this.z(B,(0,$.localize)(6,null,T?.path)))},Y=`${Q.publisher}.${Q.name}`,K=M.translations[Y];if(K)try{const T=l.URI.file(K),F=(await this.j.readFile(T)).value.toString(),h=[],v=(0,b.$an)(F,h);return h.length>0?(H(T,h),{values:void 0,default:C}):(0,b.$jn)(v)!=="object"?(J(T),{values:void 0,default:C}):{values:v.contents?v.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.j.exists(C))return;let F;try{F=await this.y(B,M)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const h=(await this.j.readFile(F.localized)).value.toString(),v=[],z=(0,b.$an)(h,v);return v.length>0?(H(F.localized,v),{values:void 0,default:F.original}):(0,b.$jn)(z)!=="object"?(J(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,Q){if(B)try{const M=(await this.j.readFile(B)).value.toString();return(0,b.$an)(M,Q)}catch{}}y(B,Q){return new Promise((M,C)=>{const H=J=>{const Y=(0,f.$Fg)(B,`package.nls.${J}.json`);this.j.exists(Y).then(K=>{K&&M({localized:Y,original:(0,f.$Fg)(B,"package.nls.json")});const T=J.lastIndexOf("-");T===-1?M({localized:(0,f.$Fg)(B,"package.nls.json"),original:null}):(J=J.substring(0,T),H(J))})};if(Q.devMode||Q.pseudo||!Q.language)return M({localized:(0,f.$Fg)(B,"package.nls.json"),original:null});H(Q.language)})}z(B,Q){return`[${B.path}]: ${Q}`}};oe=$e([ne(1,S.$Kp),ne(2,p.$Yk),ne(3,o.$ok),ne(4,i.$lj)],oe);let re=class extends oe{constructor(B,Q,M,C,H,J,Y){super(Q,C,H,J,Y),this.G=B,this.H=M,this.D=this.B(new D.$2g(3e3)),this.F=this.B(new r.$Td),this.onDidChangeCache=this.F.event}async scanExtensions(B){const Q=this.M(B),M=await this.I(Q);if(this.C=B,M&&M.input&&x.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),M.result.map(H=>(H.location=l.URI.revive(H.location),H));const C=await super.scanExtensions(B);return await this.J(Q,{input:B,result:C}),C}async I(B){try{const Q=await this.j.readFile(B),M=JSON.parse(Q.value.toString());return{result:M.result,input:(0,c.$Ah)(M.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(Q))}return null}async J(B,Q){try{await this.j.writeFile(B,N.$he.fromString(JSON.stringify(Q)))}catch(M){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(M))}}async L(){if(!this.C)return;const B=this.M(this.C),Q=await this.I(B);if(!Q)return;const M=Q.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$on(C,M))try{this.m.info("Invalidating Cache",M,C),await this.j.del(B),this.F.fire()}catch(H){this.m.error(H)}}M(B){const Q=this.N(B);return this.h.extUri.joinPath(Q.cacheHome,B.type===0?w.$em:w.$dm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(B.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};re=$e([ne(2,k.$1k),ne(3,S.$Kp),ne(4,p.$Yk),ne(5,o.$ok),ne(6,i.$lj)],re);function he(ae,B){const Q=(0,g.$So)(ae.manifest.publisher,ae.manifest.name);return{id:Q,identifier:new w.$jm(Q),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$Rp=he;class ce extends te{constructor(B,Q,M,C,H,J,Y,K,T,F,h,v){super(B,Q,(0,f.$Fg)(M,".vscode-oss-dev","extensions","control.json"),C,H,J,Y,K,T,F,h,v),this.R=(async()=>{if(m.$z)try{const z=await this.w.readFile(l.URI.file(m.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$Sp=ce}),define(ie[156],se([0,1,58,8,34,4,2,15,16,24,6,23]),function(X,e,L,D,j,N,A,b,u,a,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;let m=class extends A.$Tc{constructor(E,y){super(),this.b=E,this.f=y,this.a=new D.$0g(5)}async postUninstall(E){const y=this.g(E,"uninstall");y&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(d)}}));try{await a.Promises.rm(this.m(E))}catch(d){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(d)}}g(E,y){const d=`vscode:${y}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[d]=="string"){const l=E.manifest.scripts[d].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${d} should be a node script`),null):{script:(0,u.$jc)(E.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(E,y,d,l,$){return new Promise((I,g)=>{const w=this.j(E,y,d,$);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?g(t):I(void 0)};w.on("error",t=>{o((0,j.$Oi)(t)||"Unknown")}),w.on("exit",(t,i)=>{o(t?`post-${y} process exited with code ${t}`:void 0)}),l&&(s=setTimeout(()=>{s=null,w.kill(),g("timed out")},5e3))})}j(E,y,d,l){const $={silent:!0,execArgv:void 0},I=(0,L.fork)(E,[`--type=extension-post-${y}`,...d],$);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const g=N.Event.fromNodeEventEmitter(I.stdout,"data"),w=N.Event.fromNodeEventEmitter(I.stderr,"data");g(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,t)),w(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,t));const s=N.Event.any(N.Event.map(g,t=>({data:`%c${t}`,format:[""]})),N.Event.map(w,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}m(E){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Up=m,e.$Up=m=$e([ne(0,O.$1k),ne(1,P.$lj)],m)}),define(ie[157],se([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,48,97,59,18,155,21,27,40,51,142,156,114,135,143,49,12,10,6,32,26,22,23]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I,g,w,s,o,t,i,n,r,c,S,k,p,R,V,te,x,oe,re,he,ce,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=void 0,e.$Yp=(0,x.$5h)(t.$po);const B=".vsctmp";let Q=class extends o.$Fp{constructor(T,F,h,v,z,U,W,G,ee,ue,fe,ge){super(T,F,fe,h,ue,ge),this.fb=z,this.gb=U,this.hb=W,this.ib=ee,this.eb=new Map,this.rb=new P.$Bc;const we=this.B(G.createInstance(S.$Up));this.bb=this.B(G.createInstance(M,le=>we.postUninstall(le))),this.cb=this.B(new p.$Wp(ge,ee,fe,this,this.F)),this.db=this.B(G.createInstance(c.$Tp));const de=this.B(new R.$Xp(this,this.fb,ge,U,fe,ee,h));this.B(de.onDidChangeExtensionsByAnotherSource(le=>this.qb(le))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$1o)(this.ib,this.F)),this.jb}async zip(T){this.F.trace("ExtensionManagementService#zip",T.identifier.id);const F=await this.pb(T),h=await(0,I.zip)((0,f.$Fg)(this.db.extensionsDownloadDir,(0,l.$og)()).fsPath,F);return d.URI.file(h)}async unzip(T){return this.F.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:F,cleanup:h}=await this.lb(T),v=m.$kc(F.fsPath);try{return await(0,k.$Vp)(v)}finally{await h()}}getInstalled(T,F=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(T??null,F)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(T){return this.bb.scanUserExtensionAtLocation(T)}async install(T,F={}){this.F.trace("ExtensionManagementService#install",T.toString());const{location:h,cleanup:v}=await this.lb(T);try{const z=await(0,k.$Vp)(m.$kc(h.fsPath)),U=(0,i.$Uo)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,V.$8o)(z.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,U,this.G.version));const G=(await this.I([{manifest:z,extension:h,options:F}])).find(({identifier:ee})=>(0,i.$Po)(ee,{id:U}));if(G?.local)return G.local;throw G?.error?G.error:(0,o.$Hp)(new Error(`Unknown error while installing extension ${U}`))}finally{await v()}}async installFromLocation(T,F){this.F.trace("ExtensionManagementService#installFromLocation",T.toString());const h=await this.bb.scanUserExtensionAtLocation(T);if(!h)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.ub([[h,void 0]],F),this.F.info("Successfully installed extension",h.identifier.id,F.toString()),h}async installExtensionsFromProfile(T,F,h){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",T,F.toString(),h.toString());const v=(await this.bb.scanExtensions(1,F)).filter(z=>T.some(U=>(0,i.$Po)(U,z.identifier)));if(v.length){const z=await Promise.all(v.map(U=>this.bb.scanMetadata(U,F)));await this.ub(v.map((U,W)=>[U,z[W]]),h),this.F.info("Successfully installed extensions",v.map(U=>U.identifier.id),h.toString())}return v}async updateMetadata(T,F,h=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",T.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),T=await this.bb.updateMetadata(T,F,h),this.cb.invalidate(h),this.w.fire(T),T}async reinstallFromGallery(T){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const F=await this.getTargetPlatform(),[h]=await this.z.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:F,compatible:!0},j.CancellationToken.None);if(!h)throw new Error(g.localize(2,null));await this.bb.setUninstalled(T);try{await this.bb.removeUninstalledExtension(T)}catch(v){throw new Error(g.localize(3,null,(0,N.$Oi)(v)))}return this.installFromGallery(h)}ab(T,F,h,v){return this.bb.copyExtension(T,F,h,v)}copyExtensions(T,F){return this.bb.copyExtensions(T,F)}markAsUninstalled(...T){return this.bb.setUninstalled(...T)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(T){this.F.error(T)}}async download(T,F,h){const{location:v}=await this.db.download(T,F,!h);return v}async lb(T){if(T.scheme===O.Schemas.file)return{location:T,async cleanup(){}};this.F.trace("Downloading extension from",T.toString());const F=(0,f.$Fg)(this.db.extensionsDownloadDir,(0,l.$og)());return await this.hb.download(T,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.ib.del(F)}catch(v){this.F.error(v)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(T,F,h){if(d.URI.isUri(F))return new J(T,F,h,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const v=i.$Qo.create(F).toString();let z=this.eb.get(v);return z||(this.eb.set(v,z=new H(T,F,h,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(v))),z}$(T,F){return new Y(T,F.profileLocation,this.gb)}async pb(T){const F=async v=>{let z=await $.Promises.readdir(v);z=z.map(G=>m.$jc(v,G));const U=await Promise.all(z.map(G=>$.Promises.stat(G)));let W=Promise.resolve([]);return U.forEach((G,ee)=>{const ue=z[ee];G.isFile()&&(W=W.then(fe=>[...fe,ue])),G.isDirectory()&&(W=W.then(fe=>F(ue).then(ge=>[...fe,...ge])))}),W};return(await F(T.location.fsPath)).map(v=>({path:`extension/${m.$lc(T.location.fsPath,v)}`,localPath:v}))}async qb({added:T,removed:F}){if(F){const h=T&&this.D.extUri.isEqual(F.profileLocation,T.profileLocation)?F.extensions.filter(v=>T.extensions.every(z=>!(0,i.$Po)(z,v))):F.extensions;for(const v of h)this.F.info("Extensions removed from another source",v.id,F.profileLocation.toString()),this.u.fire({identifier:v,profileLocation:F.profileLocation})}if(T){const v=(await this.bb.scanExtensions(1,T.profileLocation)).filter(z=>T.extensions.some(U=>(0,i.$Po)(U,z.identifier)));this.s.fire(v.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,T.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:T.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(F=>this.rb.add(F)));const T=await this.ib.resolve(this.fb.userExtensionsLocation);for(const F of T.children??[])F.isDirectory&&this.rb.add(F.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(F=>this.tb(F)))}async tb(T){if(!T.affects(this.fb.userExtensionsLocation,1))return;const F=[];for(const h of T.rawAdded){if(this.rb.has(h)||!this.D.extUri.isEqual(this.D.extUri.dirname(h),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(h,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(h).startsWith(".")||!(await this.ib.stat(h)).isDirectory)continue;const v=await this.bb.scanUserExtensionAtLocation(h);v&&v.installedTimestamp===void 0&&(this.rb.add(h),F.push(v))}F.length&&(await this.ub(F.map(h=>[h,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(h=>h.identifier.id)))}async ub(T,F){const h=T.map(v=>v[0]);await this.vb(h),await this.gb.addExtensionsToProfile(T,F),this.s.fire(h.map(v=>({local:v,identifier:v.identifier,operation:1,profileLocation:F})))}async vb(T){const F=await this.bb.getUninstalledExtensions();for(const h of T){const v=i.$Qo.create(h);F[v.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",v.id),await this.bb.setInstalled(v),this.F.info("Removed the extension from uninstalled list:",v.id))}}};e.$Zp=Q,e.$Zp=Q=$e([ne(0,t.$no),ne(1,he.$sl),ne(2,oe.$lj),ne(3,s.$_h),ne(4,r.$Op),ne(5,n.$Kp),ne(6,w.$5n),ne(7,x.$3h),ne(8,te.$ok),ne(9,re.$Dj),ne(10,ce.$Yk),ne(11,ae.$1k)],Q);let M=class extends a.$Tc{constructor(T,F,h,v,z,U){super(),this.j=T,this.m=F,this.n=h,this.s=v,this.t=z,this.u=U,this.h=this.B(new b.$Td),this.onExtract=this.h.event,this.c=(0,f.$Fg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$$g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(T,F){const h={includeInvalid:!0,profileLocation:F};let v=[];return T===null||T===0?v.push(...await this.n.scanAllExtensions({includeInvalid:!0},h,!1)):T===1&&v.push(...await this.n.scanUserExtensions(h)),v=T!==null?v.filter(z=>z.type===T):v,Promise.all(v.map(z=>this.F(z)))}async scanAllUserExtensions(T){const F=await this.n.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(F.map(h=>this.F(h)))}async scanUserExtensionAtLocation(T){try{const F=await this.n.scanExistingExtension(T,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(T,F,h,v,z){const U=T.toString(),W=d.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$og)()}`)),G=d.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,U));let ee=await this.m.exists(G);if(ee&&v){try{await this.y(T.id,G,"removeExisting")}catch{throw new t.$oo(g.localize(4,null,G.fsPath,T.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(!ee)try{try{this.u.trace(`Started extracting the extension from ${F} to ${G.fsPath}`),await(0,I.$Dp)(F,W.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,T.id)}catch(ue){let fe=t.ExtensionManagementErrorCode.Extract;throw ue instanceof I.$Bp&&(ue.type==="CorruptZip"?fe=t.ExtensionManagementErrorCode.CorruptZip:ue.type==="Incomplete"&&(fe=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$oo(ue.message,fe)}await this.n.updateMetadata(W,h);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ue){if(ue.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ue)}. Deleted from extracted location`,W),ue}this.h.fire(G)}catch(ue){try{await this.m.del(W,{recursive:!0})}catch{}throw ue}return this.D(G,1)}async scanMetadata(T,F){return F?(await this.w(T,F))?.metadata:this.n.scanMetadata(T.location)}async w(T,F){return(await this.s.scanProfileExtensions(F)).find(v=>(0,i.$Po)(v.identifier,T.identifier))}async updateMetadata(T,F,h){return h?await this.s.updateMetadata([[T,F]],h):await this.n.updateMetadata(T.location,F),this.D(T.location,T.type,h)}getUninstalledExtensions(){return this.z()}async setUninstalled(...T){const F=T.map(h=>i.$Qo.create(h));await this.z(h=>F.forEach(v=>{h[v.toString()]=!0,this.u.info("Marked extension as uninstalled",v.toString())}))}async setInstalled(T){await this.z(F=>delete F[T.toString()])}async removeExtension(T,F){if(this.t.extUri.isEqualOrParent(T.location,this.n.userExtensionsLocation))return this.y(T.identifier.id,T.location,F)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.z(F=>delete F[i.$Qo.create(T).toString()])}async copyExtension(T,F,h,v){const z=await this.w(T,F),U=await this.w(T,h);return v={...z?.metadata,...v},U?await this.s.updateMetadata([[T,{...U.metadata,...v}]],h):await this.s.addExtensionsToProfile([[T,v]],h),this.D(T.location,T.type,h)}async copyExtensions(T,F){const h=await this.scanExtensions(1,T),v=await Promise.all(h.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,T)]));await this.s.addExtensionsToProfile(v,F)}async y(T,F,h){this.u.trace(`Deleting ${h} extension from disk`,T,F.fsPath);const v=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,u.$Ri)((0,l.$og)()).toString(16)}${B}`);await this.C(F.fsPath,v.fsPath),await this.m.del(v,{recursive:!0}),this.u.info(`Deleted ${h} extension from disk`,T,F.fsPath)}async z(T){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(v){if((0,te.$Fk)(v)!==1)throw v}let h={};if(F)try{h=JSON.parse(F)}catch{}return T&&(T(h),Object.keys(h).length?await this.m.writeFile(this.c,D.$he.fromString(JSON.stringify(h))):await this.m.del(this.c)),h})}async C(T,F){try{await $.Promises.rename(T,F,2*60*1e3)}catch(h){throw new t.$oo(h.message||g.localize(5,null,T,F),h.code||t.ExtensionManagementErrorCode.Rename)}}async D(T,F,h){if(h){const z=(await this.n.scanUserExtensions({profileLocation:h})).find(U=>this.t.extUri.isEqual(U.location,T));if(z)return this.F(z)}else{const v=await this.n.scanExistingExtension(T,F,{includeInvalid:!0});if(v)return this.F(v)}throw new Error(g.localize(6,null,T.path))}async F(T){const F=await this.m.resolve(T.location);let h,v;return F.children&&(h=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,v=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:h,changelogUrl:v,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated,pinned:!!T.metadata?.pinned}}async G(){const T=await this.getUninstalledExtensions();if(Object.keys(T).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(T));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),h=new Set;for(const z of F)T[i.$Qo.create(z).toString()]||h.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Vo)(F,U=>U.identifier);await L.Promises.settled(z.map(async U=>{const W=U.sort((G,ee)=>E.rcompare(G.manifest.version,ee.manifest.version))[0];h.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(z){this.u.error(z)}const v=F.filter(z=>z.metadata&&T[i.$Qo.create(z).toString()]);await Promise.allSettled(v.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let T;try{T=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,te.$Fk)(F)!==1&&this.u.error(F);return}if(T?.children)try{await Promise.allSettled(T.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(h){(0,te.$Fk)(h)!==1&&this.u.error(h)}}}))}catch{}}};e.$1p=M,e.$1p=M=$e([ne(1,te.$ok),ne(2,r.$Op),ne(3,n.$Kp),ne(4,ce.$Yk),ne(5,oe.$lj)],M);class C extends o.$Ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Nf)(this.options.operation)?this.l:this.options.operation}constructor(T,F,h,v,z,U,W,G,ee){super(),this.identifier=T,this.source=F,this.options=h,this.m=v,this.n=z,this.o=U,this.p=W,this.q=G,this.s=ee,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(T){const[F,h]=await this.x(T);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,h]],this.j),F}async u({zipPath:T,key:F,metadata:h},v,z){let U=await this.v(F);return U||(this.s.trace("Extracting extension...",F.id),U=await this.m.extractUserExtension(F,T,h,v,z),this.s.info("Extracting extension completed.",F.id)),U}async v(T){return await this.w(T)?(this.s.trace("Removing the extension from uninstalled list:",T.id),await this.m.setInstalled(T),this.s.info("Removed the extension from uninstalled list:",T.id),(await this.m.scanAllUserExtensions(!0)).find(v=>i.$Qo.create(v).equals(T))):void 0}async w(T){return!!(await this.m.getUninstalledExtensions())[T.toString()]}}class H extends C{constructor(T,F,h,v,z,U,W,G,ee,ue){super(F.identifier,F,h,z,U,W,G,ee,ue),this.y=F,this.z=v}async x(T){const h=(await this.m.scanExtensions(null,this.options.profileLocation)).find(W=>(0,i.$Po)(W.identifier,this.y.identifier));h&&(this.l=3);const v={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||h?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||h?.isMachineScoped,isBuiltin:this.options.isBuiltin||h?.isBuiltin,isSystem:h?.type===0?!0:void 0,updated:!!h,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??h?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Mf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:h?.preRelease)};if(h?.manifest.version===this.y.version)return[await this.m.updateMetadata(h,v),v];const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Qo.create(this.y),metadata:v},!1,T),v]}catch(W){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw W}}async B(T){try{await(0,k.$Vp)(T)}catch(F){throw new t.$oo((0,o.$Gp)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$2p=H;class J extends C{constructor(T,F,h,v,z,U,W,G,ee,ue){super({id:(0,i.$Uo)(T.publisher,T.name)},F,h,z,U,W,G,ee,ue),this.y=T,this.z=F,this.A=v}async h(T){const F=await super.h(T);return this.D(F,T),F}async x(T){const F=new i.$Qo(this.identifier,this.y.version),v=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,i.$Po)(this.identifier,W.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||v?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||v?.isMachineScoped,isBuiltin:this.options.isBuiltin||v?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??v?.pinned};if(v)if(this.l=3,F.equals(new i.$Qo(v.identifier,v.manifest.version)))try{await this.m.removeExtension(v,"existing")}catch{throw new Error(g.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(v.manifest.version,this.y.version)&&await this.m.setUninstalled(v);else{const W=await this.v(F);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(g.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:F,metadata:z},!0,T),z]}async D(T,F){try{let[h]=await this.A.getExtensions([{id:T.identifier.id,version:T.manifest.version}],F);if(h||([h]=await this.A.getExtensions([{id:T.identifier.id}],F)),h){const v={id:h.identifier.uuid,publisherDisplayName:h.publisherDisplayName,publisherId:h.publisherId,isPreReleaseVersion:h.properties.isPreReleaseVersion,preRelease:h.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(T,v,this.options.profileLocation)}}catch{}}}class Y extends o.$Ip{constructor(T,F,h){super(),this.extension=T,this.j=F,this.k=h}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[158],se([0,1,6,23,22,26,40,12,18,11]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;let P=class extends A.$Lp{constructor(m,f,E,y,d,l){super(a.URI.file(m.extensionsPath),f,E,y,d,l)}};e.$jO=P,e.$jO=P=$e([ne(0,u.$_h),ne(1,b.$ok),ne(2,D.$1k),ne(3,j.$Yk),ne(4,N.$sl),ne(5,L.$lj)],P)}),define(ie[159],se([0,1,11,18,40,51,12,10,6,32,22,23]),function(X,e,L,D,j,N,A,b,u,a,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k$b=void 0;let m=class extends N.$Sp{constructor(E,y,d,l,$,I,g,w){super(L.URI.file($.builtinExtensionsPath),L.URI.file($.extensionsPath),$.userHome,E.defaultProfile,E,y,d,l,$,I,g,w)}};e.$k$b=m,e.$k$b=m=$e([ne(0,O.$1k),ne(1,j.$Kp),ne(2,A.$ok),ne(3,u.$lj),ne(4,D.$_h),ne(5,a.$Dj),ne(6,P.$Yk),ne(7,b.$3h)],m)}),define(ie[160],se([0,1,8,4,2,125,3,86,10,23]),function(X,e,L,D,j,N,A,b,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jp=e.$ip=e.$hp=void 0,e.$hp="__$__isNewStorageMarker",e.$ip="__$__targetStorageMarker",e.$jp=(0,u.$4h)("storageService");var P;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var O;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var m;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function f($){const I=$.get(e.$ip);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$kp=f;class E extends j.$Tc{static{this.a=60*1e3}constructor(I={flushInterval:E.a}){super(),this.m=I,this.b=this.B(new D.$Wd),this.c=this.B(new D.$Wd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Td),this.onWillSaveState=this.f.event,this.h=this.B(new L.$dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,g,w){return D.Event.filter(this.b.event,s=>s.scope===I&&(g===void 0||s.key===g),w)}n(){this.j.value=(0,L.$hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,g){const{key:w,external:s}=g;if(w===e.$ip){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:w,target:this.J(I)[w],external:s})}w(I){this.f.fire({reason:I})}get(I,g,w){return this.P(g)?.get(I,w)}getBoolean(I,g,w){return this.P(g)?.getBoolean(I,w)}getNumber(I,g,w){return this.P(g)?.getNumber(I,w)}getObject(I,g,w){return this.P(g)?.getObject(I,w)}storeAll(I,g){this.y(()=>{for(const w of I)this.store(w.key,w.value,w.scope,w.target,g)})}store(I,g,w,s,o=!1){if((0,A.$Pf)(g)){this.remove(I,w,o);return}this.y(()=>{this.z(I,w,s),this.P(w)?.set(I,g,o)})}remove(I,g,w=!1){this.y(()=>{this.z(I,g,void 0),this.P(g)?.delete(I,w)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,g){const w=[],s=this.J(I);for(const o of Object.keys(s))s[o]===g&&w.push(o);return w}z(I,g,w,s=!1){const o=this.J(g);typeof w=="number"?o[I]!==w&&(o[I]=w,this.P(g)?.set(e.$ip,JSON.stringify(o),s)):typeof o[I]=="number"&&(delete o[I],this.P(g)?.set(e.$ip,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const g=this.P(I);return g?f(g):Object.create(null)}isNew(I){return this.getBoolean(e.$hp,I)===!0}async flush(I=P.NONE){this.f.fire({reason:I});const g=this.P(-1),w=this.P(0),s=this.P(1);switch(I){case P.NONE:await L.Promises.settled([g?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([g?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,w=this.P(1)?.items??new Map;return l(I,g,w,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,g){return this.w(P.NONE),(0,a.$Zk)(I)?this.R(I,g):this.S(I,g)}M(I,g){return!(I.id===g.id||y(g)&&y(I))}N(I,g,w){this.y(()=>{const s=new Set;for(const[o,t]of I)s.add(o),g.get(o)!==t&&this.u(w,{key:o,external:!0});for(const[o]of g.items)s.has(o)||this.u(w,{key:o,external:!0})})}}e.$lp=E;function y($){return $.isDefault||!!$.useDefaultFlags?.globalState}e.$mp=y;class d extends E{constructor(){super(),this.U=this.B(new b.$fp(new b.$gp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$fp(new b.$gp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$fp(new b.$gp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$np=d;async function l($,I,g,w,s,o){const t=V=>{try{return JSON.parse(V)}catch{return V}},i=new Map,n=new Map;$.forEach((V,te)=>{i.set(te,V),n.set(te,t(V))});const r=new Map,c=new Map;I.forEach((V,te)=>{r.set(te,V),c.set(te,t(V))});const S=new Map,k=new Map;g.forEach((V,te)=>{S.set(te,V),k.set(te,t(V))}),console.group(w!==s?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const p=[];if(i.forEach((V,te)=>{p.push({key:te,value:V})}),console.table(p),console.groupEnd(),console.log(n),w!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const V=[];r.forEach((te,x)=>{V.push({key:x,value:te})}),console.table(V),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${o})`);const R=[];S.forEach((V,te)=>{R.push({key:te,value:V})}),console.table(R),console.groupEnd(),console.log(k)}e.$op=l}),define(ie[161],se([0,1,19,20,9,13,35,3,11,25,18,21,27,49,12,6,32,44,144,160,26,174]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=void 0;const s=N.$o?"web":(0,O.$jo)(N.$u,A.$ec),o="X-Market-Search-Activity-Id";var t;(function(v){v[v.None=0]="None",v[v.IncludeVersions=1]="IncludeVersions",v[v.IncludeFiles=2]="IncludeFiles",v[v.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",v[v.IncludeSharedAccounts=8]="IncludeSharedAccounts",v[v.IncludeVersionProperties=16]="IncludeVersionProperties",v[v.ExcludeNonValidated=32]="ExcludeNonValidated",v[v.IncludeInstallationTargets=64]="IncludeInstallationTargets",v[v.IncludeAssetUri=128]="IncludeAssetUri",v[v.IncludeStatistics=256]="IncludeStatistics",v[v.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",v[v.Unpublished=4096]="Unpublished",v[v.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...v){return String(v.reduce((z,U)=>z|U,0))}var n;(function(v){v[v.Tag=1]="Tag",v[v.ExtensionId=4]="ExtensionId",v[v.Category=5]="Category",v[v.ExtensionName=7]="ExtensionName",v[v.Target=8]="Target",v[v.Featured=9]="Featured",v[v.SearchText=10]="SearchText",v[v.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class p{constructor(z=k){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,U=this.d.pageSize){return new p({...this.d,pageNumber:z,pageSize:U})}withFilter(z,...U){const W=[...this.d.criteria,...U.length?U.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new p({...this.d,criteria:W})}withSortBy(z){return new p({...this.d,sortBy:z})}withSortOrder(z){return new p({...this.d,sortOrder:z})}withFlags(...z){return new p({...this.d,flags:z.reduce((U,W)=>U|W,0)})}withAssetTypes(...z){return new p({...this.d,assetTypes:z})}withSource(z){return new p({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:U,pageSize:W,sortBy:G,sortOrder:ee,flags:ue,assetTypes:fe}=this.d;return{filters:[{criteria:z,pageNumber:U,pageSize:W,sortBy:G,sortOrder:ee}],assetTypes:fe,flags:ue}}get searchText(){const z=this.d.criteria.filter(U=>U.filterType===n.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(v,z){const U=(v||[]).filter(W=>W.statisticName===z)[0];return U?U.value:0}function V(v){const z="Microsoft.VisualStudio.Code.Translation.";return v.files.filter(W=>W.assetType.indexOf(z)===0).reduce((W,G)=>{const ee=oe(v,G.assetType);return ee&&W.push([G.assetType.substring(z.length),ee]),W},[])}function te(v){if(v.properties){const z=v.properties.filter(G=>G.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=z.filter(G=>U.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(v,r.Repository)}function x(v){return{uri:`${v.fallbackAssetUri}/${r.VSIX}?redirect=true${v.targetPlatform?`&targetPlatform=${v.targetPlatform}`:""}`,fallbackUri:`${v.fallbackAssetUri}/${r.VSIX}${v.targetPlatform?`?targetPlatform=${v.targetPlatform}`:""}`}}function oe(v,z){return v.files.filter(W=>W.assetType===z)[0]?{uri:`${v.assetUri}/${z}${v.targetPlatform?`?targetPlatform=${v.targetPlatform}`:""}`,fallbackUri:`${v.fallbackAssetUri}/${z}${v.targetPlatform?`?targetPlatform=${v.targetPlatform}`:""}`}:null}function re(v,z){const U=v.properties?v.properties.filter(G=>G.key===z):[],W=U.length>0&&U[0].value;return W?W.split(",").map(G=>(0,m.$To)(G)):[]}function he(v){const z=v.properties?v.properties.filter(U=>U.key===c.Engine):[];return z.length>0&&z[0].value||""}function ce(v){const z=v.properties?v.properties.filter(U=>U.key===c.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(v){const z=v.properties?v.properties.filter(W=>W.key===c.LocalizedLanguages):[],U=z.length>0&&z[0].value||"";return U?U.split(","):[]}function B(v){return v.properties?.find(z=>z.key===c.SponsorLink)?.value}function Q(v){return v.properties?.find(z=>z.key===c.SupportLink)?.value}function M(v){return v.indexOf("preview")!==-1}function C(v){return v.targetPlatform?(0,O.$io)(v.targetPlatform):"undefined"}function H(v){const z=(0,L.$Mb)(v.versions.map(C)),U=!!v.tags?.includes(O.$do),W=z.indexOf("web");return U?W===-1&&z.push("web"):W!==-1&&z.splice(W,1),z}function J(v,z){for(let U=0;U<v.length;U++){const W=v[U];if(W.version===v[U-1]?.version){let G=U;if(C(W)===z)for(;G>0&&v[G-1].version===W.version;)G--;G!==U&&(v.splice(U,1),v.splice(G,0,W))}}return v}e.$rp=J;function Y(v,z,U){v.telemetryData={index:z,querySource:U,queryActivityId:v.queryContext?.[o]}}function K(v,z,U,W){const G=v.versions[0],ee={manifest:oe(z,r.Manifest),readme:oe(z,r.Details),changelog:oe(z,r.Changelog),license:oe(z,r.License),repository:te(z),download:x(z),icon:oe(z,r.Icon),signature:oe(z,r.Signature),coreTranslations:V(z)};return{identifier:{id:(0,m.$Uo)(v.publisher.publisherName,v.extensionName),uuid:v.extensionId},name:v.extensionName,version:z.version,displayName:v.displayName,publisherId:v.publisher.publisherId,publisher:v.publisher.publisherName,publisherDisplayName:v.publisher.displayName,publisherDomain:v.publisher.domain?{link:v.publisher.domain,verified:!!v.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:v.shortDescription||"",installCount:R(v.statistics,"install"),rating:R(v.statistics,"averagerating"),ratingCount:R(v.statistics,"ratingcount"),categories:v.categories||[],tags:v.tags||[],releaseDate:Date.parse(v.releaseDate),lastUpdated:Date.parse(v.lastUpdated),allTargetPlatforms:U,assets:ee,properties:{dependencies:re(z,c.Dependency),extensionPack:re(z,c.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:C(z),isPreReleaseVersion:ce(z)},hasPreReleaseVersion:ce(G),hasReleaseVersion:!0,preview:M(v.flags),isSigned:!!ee.signature,queryContext:W,supportLink:Q(G)}}let T=class{constructor(z,U,W,G,ee,ue,fe,ge){this.k=U,this.l=W,this.n=G,this.o=ee,this.q=ue,this.u=fe,this.w=ge;const we=fe.extensionsGallery,de=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=de?we.servicePPEUrl:we?.serviceUrl,this.g=de?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,$.$qp)(fe.version,fe,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,U,W){const G=D.CancellationToken.isCancellationToken(U)?{}:U,ee=D.CancellationToken.isCancellationToken(U)?U:W,ue=[],fe=[],ge=[],we=[];let de=!0;for(const ve of z){ve.uuid?fe.push(ve.uuid):ue.push(ve.id);const ke=!!(ve.version||ve.preRelease);ge.push({id:ve.id,uuid:ve.uuid,includePreRelease:ke}),ve.version&&we.push({id:ve.id,uuid:ve.uuid,version:ve.version}),de=de&&!!ve.hasPreRelease&&!ke}if(!fe.length&&!ue.length)return[];let le=new p().withPage(1,z.length);fe.length&&(le=le.withFilter(n.ExtensionId,...fe)),ue.length&&(le=le.withFilter(n.ExtensionName,...ue)),(G.queryAllVersions||de)&&(le=le.withFlags(le.flags,t.IncludeVersions)),G.source&&(le=le.withSource(G.source));const{extensions:pe}=await this.z(le,{targetPlatform:G.targetPlatform??s,includePreRelease:ge,versions:we,compatible:!!G.compatible},ee);return G.source&&pe.forEach((ve,ke)=>Y(ve,ke,G.source)),pe}async getCompatibleExtension(z,U,W){if((0,O.$ko)(z.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(z,U,W))return z;const G=new p().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,z.identifier.uuid),{extensions:ee}=await this.z(G,{targetPlatform:W,compatible:!0,includePreRelease:U},D.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(z,U,W){if(!(0,O.$lo)(z.properties.targetPlatform,z.allTargetPlatforms,W)||!U&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const ee=await this.getManifest(z,D.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return(0,f.$8o)(G,this.u.version,this.u.date)}async y(z,U,W,G,ee){if(!(0,O.$lo)(C(z),G,ee)||U!=="any"&&ce(z)!==(U==="prerelease"))return!1;if(W)try{const ue=await this.E(z);if(!(0,f.$8o)(ue,this.u.version,this.u.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,j.$0)(ue)),!1}return!0}async query(z,U){let W=z.text||"";const G=z.pageSize??50;let ee=new p().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(n.Category,pe||le),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(n.Tag,pe||le),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(n.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),ee=ee.withFilter(n.SearchText,W)),ee=ee.withSortBy(0)):z.ids?ee=ee.withFilter(n.ExtensionId,...z.ids):z.names?ee=ee.withFilter(n.ExtensionName,...z.names):ee=ee.withSortBy(4),typeof z.sortBy=="number"&&(ee=ee.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(ee=ee.withSortOrder(z.sortOrder)),z.source&&(ee=ee.withSource(z.source));const ue=async(de,le)=>{const{extensions:pe,total:ve}=await this.z(de,{targetPlatform:s,compatible:!1,includePreRelease:!!z.includePreRelease},le);return pe.forEach((ke,je)=>Y(ke,(de.pageNumber-1)*de.pageSize+je,z.source)),{extensions:pe,total:ve}},{extensions:fe,total:ge}=await ue(ee,U),we=async(de,le)=>{if(le.isCancellationRequested)throw new j.$5;const{extensions:pe}=await ue(ee.withPage(de+1),le);return pe};return{firstPage:fe,total:ge,pageSize:ee.pageSize,getPage:we}}async z(z,U,W){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ee,total:ue,context:fe}=await this.B(z,W);if(!(z.flags&t.IncludeLatestVersionOnly)){const le=[];for(const pe of ee){const ve=await this.A(pe,U,fe);ve&&le.push(ve)}return{extensions:le,total:ue}}const we=[],de=new Map;for(let le=0;le<ee.length;le++){const pe=ee[le],ve={id:(0,m.$Uo)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},ke=(0,b.$Mf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(q=>(0,m.$Po)(q,ve))?.includePreRelease;if(U.compatible&&(0,O.$ko)(H(pe),U.targetPlatform))continue;const je=await this.A(pe,U,fe);!je||je.properties.isPreReleaseVersion&&(!ke||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==U.targetPlatform&&je.hasPreReleaseVersion?de.set(pe.extensionId,le):we.push([le,je])}if(de.size){const le=new w.$Pd,pe=new p().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,de.size).withFilter(n.ExtensionId,...de.keys()),{extensions:ve}=await this.z(pe,U,W);this.o.publicLog2("galleryService:additionalQuery",{duration:le.elapsed(),count:de.size});for(const ke of ve){const je=de.get(ke.identifier.uuid);we.push([je,ke])}}return{extensions:we.sort((le,pe)=>le[0]-pe[0]).map(([,le])=>le),total:ue}}async A(z,U,W){const G={id:(0,m.$Uo)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},ee=U.versions?.find(we=>(0,m.$Po)(we,G))?.version,ue=(0,b.$Mf)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(we=>(0,m.$Po)(we,G))?.includePreRelease,fe=H(z),ge=J(z.versions,U.targetPlatform);if(U.compatible&&(0,O.$ko)(fe,U.targetPlatform))return null;for(let we=0;we<ge.length;we++){const de=ge[we];if(!(ee&&de.version!==ee)){if(await this.y(de,ue?"any":"release",U.compatible,fe,U.targetPlatform))return K(z,de,fe,W);if(ee&&de.version===ee)return null}}return ee||U.compatible?null:K(z,z.versions[0],fe)}async B(z,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const W=await this.j,G=JSON.stringify(z.raw),ee={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ue=new w.$Pd;let fe,ge,we=0;try{if(fe=await this.k.request({type:"POST",url:this.g&&z.criteria.some(le=>le.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:ee},U),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:we};const de=await(0,l.$cp)(fe);if(de){const le=de.results[0],pe=le.extensions,ve=le.resultMetadata&&le.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return we=ve&&ve.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[o]:fe.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(de){throw ge=de,de}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:ue.elapsed(),success:!!fe&&(0,l.$$o)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:ge?(0,j.$4)(ge)?"canceled":(0,j.$0)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(z,U,W,G){if(!this.isEnabled())return;const ee=N.$o?this.x(`/itemName/${z}.${U}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${U}/${W}/stats?statType=${G}`),ue=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ue};try{await this.k.request({type:"POST",url:ee,headers:ge},D.CancellationToken.None)}catch{}}async download(z,U,W){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,m.$Xo)(z),ee=new Date().getTime(),ue=le=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:le}),fe=W===2?"install":W===3?"update":"",ge=fe?{uri:`${z.assets.download.uri}${u.URI.parse(z.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${z.assets.download.fallbackUri}${u.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:z.assets.download,we=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,de=await this.D(ge,we?{headers:we}:void 0);await this.q.writeFile(U,de.stream),ue(new Date().getTime()-ee)}async downloadSignatureArchive(z,U){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const W=await this.D(z.assets.signature);await this.q.writeFile(U,W.stream)}async getReadme(z,U){if(z.assets.readme){const W=await this.D(z.assets.readme,{},U);return await(0,l.$bp)(W)||""}return""}async getManifest(z,U){if(z.assets.manifest){const W=await this.D(z.assets.manifest,{},U),G=await(0,l.$bp)(W);return G?JSON.parse(G):null}return null}async C(z,U){const W=oe(z,r.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},ee=await this.D(W,{headers:G});return await(0,l.$cp)(ee)}async getCoreTranslation(z,U){const W=z.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(W){const G=await this.D(W[1]),ee=await(0,l.$bp)(G);return ee?JSON.parse(ee):null}return null}async getChangelog(z,U){if(z.assets.changelog){const W=await this.D(z.assets.changelog,{},U);return await(0,l.$bp)(W)||""}return""}async getAllCompatibleVersions(z,U,W){let G=new p().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(n.ExtensionId,z.identifier.uuid):G=G.withFilter(n.ExtensionName,z.identifier.id);const{galleryExtensions:ee}=await this.B(G,D.CancellationToken.None);if(!ee.length)return[];const ue=H(ee[0]);if((0,O.$ko)(ue,W))return[];const fe=[];await Promise.all(ee[0].versions.map(async de=>{try{await this.y(de,U?"any":"release",!0,ue,W)&&fe.push(de)}catch{}}));const ge=[],we=new Set;for(const de of J(fe,W))we.has(de.version)||(we.add(de.version),ge.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:ce(de)}));return ge}async D(z,U={},W=D.CancellationToken.None){const G=await this.j,ee={type:"GET"},ue={...G,...U.headers||{}};U={...U,...ee,headers:ue};const fe=z.uri,ge=z.fallbackUri,we={...U,url:fe};try{const de=await this.k.request(we,W);if(de.res.statusCode===200)return de;const le=await(0,l.$bp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${le}`)}catch(de){if((0,j.$4)(de))throw de;const le=(0,j.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:fe,message:le});const pe={...U,url:ge};return this.k.request(pe,W)}}async E(z){let U=he(z);if(!U){const W=await this.C(z,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");U=W.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.$cp)(z),W=[],G={},ee=[];if(U){for(const ue of U.malicious)W.push({id:ue});if(U.migrateToPreRelease)for(const[ue,fe]of Object.entries(U.migrateToPreRelease))(!fe.engine||(0,f.$8o)(fe.engine,this.u.version,this.u.date))&&(G[ue.toLowerCase()]={disallowInstall:!0,extension:{id:fe.id,displayName:fe.displayName,autoMigrate:{storage:!!fe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ue,fe]of Object.entries(U.deprecated))fe&&(G[ue.toLowerCase()]=(0,b.$Mf)(fe)?{}:fe);if(U.search)for(const ue of U.search)ee.push(ue)}return{malicious:W,deprecated:G,search:ee}}};T=$e([ne(1,l.$9o),ne(2,y.$lj),ne(3,P.$$h),ne(4,g.$sl),ne(5,E.$ok),ne(6,d.$Dj),ne(7,a.$xi)],T);let F=class extends T{constructor(z,U,W,G,ee,ue,fe,ge){super(z,U,W,G,ee,ue,fe,ge)}};e.$sp=F,e.$sp=F=$e([ne(0,I.$jp),ne(1,l.$9o),ne(2,y.$lj),ne(3,P.$$h),ne(4,g.$sl),ne(5,E.$ok),ne(6,d.$Dj),ne(7,a.$xi)],F);let h=class extends T{constructor(z,U,W,G,ee,ue,fe){super(void 0,z,U,W,G,ee,ue,fe)}};e.$tp=h,e.$tp=h=$e([ne(0,l.$9o),ne(1,y.$lj),ne(2,P.$$h),ne(3,g.$sl),ne(4,E.$ok),ne(5,d.$Dj),ne(6,a.$xi)],h)}),define(ie[162],se([0,1,11,18,12,6,140,22,23,3,68]),function(X,e,L,D,j,N,A,b,u,a,P){"use strict";var O,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=e.$gO=void 0;let f=class extends u.$4k{static{O=this}static{this.a="profileAssociationsMigration"}constructor(l,$,I,g,w){super(I,g,$,w),this.U=l,this.W=I}O(){return this.U.getItem(O.b,[]).map($=>({...$,location:(0,a.$Gf)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):L.URI.revive($.location)}))}Q(){const l=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?l:this.N(l)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$gO=f,e.$gO=f=O=$e([ne(0,A.$bO),ne(1,b.$Yk),ne(2,D.$_h),ne(3,j.$ok),ne(4,N.$lj)],f);let E=m=class extends f{constructor(l,$,I,g,w){super(l,$,I,g,w),this.$=l}P(l){l.length?this.$.setItem(m.b,l.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(m.b)}O(){const l=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(l),this.$.setItem("userDataProfilesMigration",!0)),l}R(l){l.emptyWindows||l.workspaces?this.$.setItem(m.c,l):this.$.removeItem(m.c)}Q(){const l="workspaceAndProfileInfo",$=this.$.getItem(l,void 0);if($){this.$.removeItem(l);const g=$.reduce((w,{workspace:s,profile:o})=>(w[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),w),{});this.$.setItem(m.c,{workspaces:g})}const I=super.Q();return this.$.getItem(m.a,!1)||(this.R(I),this.$.setItem(m.a,!0)),I}};e.$hO=E,e.$hO=E=m=$e([ne(0,A.$cO),ne(1,b.$Yk),ne(2,D.$_h),ne(3,j.$ok),ne(4,N.$lj)],E);let y=class extends E{constructor(l,$,I,g){super(new P.$fO(0,$,g,I),l,$,I,g)}async init(){return await this.$.init(),super.init()}};e.$iO=y,e.$iO=y=$e([ne(0,b.$Yk),ne(1,D.$_h),ne(2,j.$ok),ne(3,N.$lj)],y)}),define(ie[163],se([0,1,138,8,14,9,3,25,18,139,6,44,137,175]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;let E=class extends O.$0o{constructor($,I,g,w){super(w),this.m=$,this.n=I,this.r=g,this.s(),this.B($.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,I){const{f:g,g:w}=this;let s;try{s=await(0,a.$0l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const o={...process.env,...s},t=$.agent?$.agent:await(0,m.$br)($.url||"",o,{proxyUrl:g,strictSSL:w});return $.agent=t,$.strictSSL=w,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>d($,I))}async resolveProxy($){}async loadCertificates(){return(await new Promise((I,g)=>{X(["@vscode/proxy-agent"],I,g)})).loadSystemCertificates({log:this.r})}};e.$cr=E,e.$cr=E=$e([ne(0,b.$xi),ne(1,u.$_h),ne(2,P.$lj),ne(3,P.$mj)],E);async function y(l){return((0,L.parse)(l.url).protocol==="https:"?await new Promise((g,w)=>{X(["https"],g,w)}):await new Promise((g,w)=>{X(["http"],g,w)})).request}async function d(l,$){return D.Promises.withAsyncBody(async(I,g)=>{const w=(0,L.parse)(l.url),s=l.getRawRequest?l.getRawRequest(l):await y(l),o={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,A.$Mf)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(o.auth=l.user+":"+l.password);const t=s(o,i=>{const n=(0,A.$Kf)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)d({...l,url:i.headers.location,followRedirects:n-1},$).then(I,g);else{let r=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),I({res:i,stream:(0,j.$we)(r)})}});t.on("error",g),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),$.onCancellationRequested(()=>{t.abort(),g(new N.$5)})})}e.$dr=d}),define(ie[176],se([0,1,33,8,34,9,2,15,16,13,35,11,24,25,134,59,136,18,112,161,21,60,141,40,51,157,159,12,124,126,50,122,63,64,145,6,130,38,131,148,32,44,163,68,69,26,147,39,149,150,22,152,23,162,151,158,127,129,5,153]),function(X,e,L,D,j,N,A,b,u,a,P,O,m,f,E,y,d,l,$,I,g,w,s,o,t,i,n,r,c,S,k,p,R,V,te,x,oe,re,he,ce,ae,B,Q,M,C,H,J,Y,K,T,F,h,v,z,U,W,G,ee,ue,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ge extends A.$Tc{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,pe]=await this.f();return le.invokeFunction(async ve=>{const ke=ve.get(x.$lj),je=ve.get(r.$ok),q=ve.get(l.$_h),Z=ve.get(v.$1k);ke.info("CLI main",this.b),this.g(ke),await this.h(q,je,Z,le),await Promise.all(pe.map(_=>{(0,D.$Vg)(_.flush(),1e3)}))})}async f(){const le=new R.$2h,pe={_serviceBrand:void 0,...ce.default};le.set(ae.$Dj,pe);const ve=new $.$zm(this.b,pe);le.set(l.$_h,ve),await Promise.all([ve.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,ve.extensionsPath].map(Le=>Le?m.Promises.mkdir(Le,{recursive:!0}):void 0));const ke=new ee.$aO((0,x.$zj)(ve),ve.logsHome);le.set(x.$mj,ke);const je=this.B(ke.createLogger("cli",{name:(0,ue.localize)(0,null)})),q=[];ke.getLogLevel()===x.LogLevel.Trace&&q.push(new x.$tj(ke.getLogLevel()));const Z=this.B(new G.$kO(je,q));le.set(x.$lj,Z);const _=this.B(new c.$4p(Z));le.set(r.$ok,_);const me=this.B(new S.$qq(Z));_.registerProvider(b.Schemas.file,me);const ye=new h.$Qr(_);le.set(F.$Yk,ye);const De=new M.$eO(1,ve,Z,_),Pe=new z.$gO(De,ye,ve,_,Z);le.set(v.$1k,Pe),_.registerProvider(b.Schemas.vscodeUserData,new fe.$L$b(b.Schemas.file,me,b.Schemas.vscodeUserData,Pe,ye,Z));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$J$b(Z,pe.win32RegValueName)):ve.policyFile?this.B(new oe.$K$b(ve.policyFile,_,Z)):new re.$An;le.set(re.$yn,ze);const Ie=this.B(new E.$1n(Pe.defaultProfile.settingsResource,_,ze,Z));le.set(f.$xi,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,U.$n$b)(De,Z)}catch(Le){Le.code!=="ENOENT"&&Z.error(Le)}const Ce=await(0,U.$o$b)(De,Z);Pe.init(),le.set(F.$Yk,new h.$Qr(_));const Oe=new Q.$cr(Ie,ve,Z,ke);le.set(B.$9o,Oe),le.set(y.$5n,new k.$1h(d.$zO,void 0,!0)),le.set(o.$Kp,new k.$1h(W.$jO,void 0,!0)),le.set(t.$Op,new k.$1h(n.$k$b,void 0,!0)),le.set(w.$up,new k.$1h(w.$vp,void 0,!0)),le.set(i.$Yp,new k.$1h(i.$Zp,void 0,!0)),le.set(g.$no,new k.$1h(I.$tp,void 0,!0)),le.set(V.$9q,new k.$1h(te.$$q,void 0,!1));const Ae=[],Fe=(0,Y.$Mo)(pe,Ie);if((0,Y.$Ho)(pe,ve)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new K.$$N(Oe,Fe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Le={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,C.$xo)((0,L.release)(),(0,L.hostname)(),process.arch,pe.commit,pe.version,Ne,Ce,Fe),piiPaths:(0,Y.$No)(ve)};le.set(H.$sl,new k.$1h(J.$er,[Le],!1))}else le.set(H.$sl,Y.$Bo);return[new p.$tq(le),Ae]}g(le){(0,N.setUnexpectedErrorHandler)(pe=>{const ve=(0,j.$Oi)(pe,!0);ve&&le.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",pe=>{(0,N.$Z)(pe)||(0,N.$1)(pe)}),process.on("unhandledRejection",pe=>(0,N.$1)(pe))}async h(le,pe,ve,ke){let je;if(le.args.profile&&(je=ve.profiles.find(Z=>Z.name===le.args.profile),!je))throw new Error(`Profile '${le.args.profile}' not found.`);const q=(je??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$wp,new x.$tj(x.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,q);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:q};return ke.createInstance(s.$wp,new x.$tj(x.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Z,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$wp,new x.$tj(x.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,q);if(this.b["update-extensions"])return ke.createInstance(s.$wp,new x.$tj(x.LogLevel.Info,!1)).updateExtensions(q);if(this.b["locate-extension"])return ke.createInstance(s.$wp,new x.$tj(x.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.$8$b)(le.appRoot,le.extensionsPath))}}j(le){return le.map(pe=>/\.vsix$/i.test(pe)?O.URI.file((0,u.$ic)(pe)?pe:(0,u.$jc)((0,P.cwd)(),pe)):pe)}}async function we(de){const le=new ge(de);try{await le.run()}finally{le.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7452aaa51d440d39c4e6ab61970b290b8600f52f/core/vs/code/node/cliProcessMain.js.map
